/* arc.c generated by valac 0.22.0, the Vala compiler
 * generated from arc.vala, do not modify */

/*  Mutiara motif designer.
Copyright (C) 2011  Nor Jaidi Tuah

This file is part of Mutiara.

Mutiara is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <glib.h>
#include <glib-object.h>
#include <float.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <cairo.h>


#define TYPE_SEED (seed_get_type ())
#define SEED(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SEED, Seed))
#define SEED_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SEED, SeedClass))
#define IS_SEED(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SEED))
#define IS_SEED_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SEED))
#define SEED_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SEED, SeedClass))

typedef struct _Seed Seed;
typedef struct _SeedClass SeedClass;
typedef struct _SeedPrivate SeedPrivate;

#define TYPE_POINT (point_get_type ())
typedef struct _Point Point;

#define TYPE_ROLE (role_get_type ())

#define TYPE_FLIP (flip_get_type ())

#define TYPE_TWEAK (tweak_get_type ())
typedef struct _Tweak Tweak;

#define TYPE_RGBA (rgba_get_type ())
typedef struct _RGBA RGBA;

#define TYPE_RENDER_STYLE (render_style_get_type ())

#define TYPE_PROJECTION (projection_get_type ())
#define PROJECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PROJECTION, Projection))
#define PROJECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PROJECTION, ProjectionClass))
#define IS_PROJECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PROJECTION))
#define IS_PROJECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PROJECTION))
#define PROJECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PROJECTION, ProjectionClass))

typedef struct _Projection Projection;
typedef struct _ProjectionClass ProjectionClass;

#define TYPE_ARC (arc_get_type ())
#define ARC(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ARC, Arc))
#define ARC_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ARC, ArcClass))
#define IS_ARC(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ARC))
#define IS_ARC_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ARC))
#define ARC_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ARC, ArcClass))

typedef struct _Arc Arc;
typedef struct _ArcClass ArcClass;
typedef struct _ArcPrivate ArcPrivate;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _Point {
	gdouble x;
	gdouble y;
};

typedef enum  {
	ROLE_DUAL = 0,
	ROLE_MOTIF = 1,
	ROLE_BASE = 2
} Role;

typedef enum  {
	FLIP_NONE = 0,
	FLIP_Y = 1,
	FLIP_X = 2,
	FLIP_XY = 3
} Flip;

struct _Tweak {
	gdouble scale_x;
	gdouble scale_y;
	gdouble rotate;
	gdouble move_x;
	gdouble move_y;
};

struct _RGBA {
	gdouble r;
	gdouble g;
	gdouble b;
	gdouble a;
};

typedef enum  {
	RENDER_STYLE_THIN = 0,
	RENDER_STYLE_THICK = 1,
	RENDER_STYLE_HOLLOW = 2,
	RENDER_STYLE_FILLED = 3,
	RENDER_STYLE_CLOSED = 4,
	RENDER_STYLE_NONE = 5
} RenderStyle;

struct _Seed {
	GObject parent_instance;
	SeedPrivate * priv;
	gboolean debug;
	gboolean is_affine;
	Role role;
	gdouble base_offset;
	Flip flip_even;
	Flip flip_odd;
	Tweak tweak;
	gdouble width0;
	gdouble width1;
	gint num_segment;
	gint level_of_detail;
	RGBA color;
	gdouble color_mix;
	RenderStyle render_style;
	Projection** projection;
	gint projection_length1;
	gint selected_control;
	Point pressed_point;
};

struct _SeedClass {
	GObjectClass parent_class;
	void (*init_default_sub) (Seed* self, Point* p);
	void (*init_full_sub) (Seed* self, gdouble* args, int args_length1);
	gchar* (*serialize_sub) (Seed* self);
	void (*point_raw) (Seed* self, gdouble t, Point* result);
	void (*init_distance_to_parametric) (Seed* self);
	void (*distant_point) (Seed* self, gdouble x_distance, gdouble y_distance, Point* result);
	void (*draw_direct) (Seed* self, cairo_t* cr, gdouble scale);
	void (*draw_controls) (Seed* self, cairo_t* cr, gdouble scale);
	gint (*pressed_control) (Seed* self, Point* p, gdouble scale);
	void (*save_drag_context) (Seed* self);
	void (*move_shape) (Seed* self, gdouble delta_x, gdouble delta_y);
	void (*drag_control) (Seed* self, Point* p, gdouble scale, gboolean snap_on, gdouble grid_size, gdouble snap_angle);
	Point* (*points_to_snap) (Seed* self, int* result_length1);
	void (*draw_icon) (Seed* self, cairo_t* cr, gdouble width, gdouble height);
};

struct _Arc {
	Seed parent_instance;
	ArcPrivate * priv;
};

struct _ArcClass {
	SeedClass parent_class;
};

struct _ArcPrivate {
	Point centre;
	gdouble angle0;
	gdouble angle1;
	gdouble radius_x;
	gdouble radius_y;
	gdouble rotation;
	gdouble sin_rotation;
	gdouble cos_rotation;
	Point centre_save;
	Point topleft_save;
};


static gpointer arc_parent_class = NULL;

GType seed_get_type (void) G_GNUC_CONST;
GType point_get_type (void) G_GNUC_CONST;
Point* point_dup (const Point* self);
void point_free (Point* self);
GType role_get_type (void) G_GNUC_CONST;
GType flip_get_type (void) G_GNUC_CONST;
GType tweak_get_type (void) G_GNUC_CONST;
Tweak* tweak_dup (const Tweak* self);
void tweak_free (Tweak* self);
GType rgba_get_type (void) G_GNUC_CONST;
RGBA* rgba_dup (const RGBA* self);
void rgba_free (RGBA* self);
GType render_style_get_type (void) G_GNUC_CONST;
gpointer projection_ref (gpointer instance);
void projection_unref (gpointer instance);
GParamSpec* param_spec_projection (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_projection (GValue* value, gpointer v_object);
void value_take_projection (GValue* value, gpointer v_object);
gpointer value_get_projection (const GValue* value);
GType projection_get_type (void) G_GNUC_CONST;
GType arc_get_type (void) G_GNUC_CONST;
#define ARC_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_ARC, ArcPrivate))
enum  {
	ARC_DUMMY_PROPERTY
};
static void arc_real_init_default_sub (Seed* base, Point* p);
static void arc_set_rotation (Arc* self, gdouble rot);
static void arc_real_init_full_sub (Seed* base, gdouble* args, int args_length1);
static gchar* arc_real_serialize_sub (Seed* base);
gchar* util_format (gdouble n, gint decimal_places);
static void arc_real_init_distance_to_parametric (Seed* base);
void seed_init_distance_to_parametric (Seed* self);
static void arc_real_point_raw (Seed* base, gdouble t, Point* result);
static void arc_real_distant_point (Seed* base, gdouble x_distance, gdouble y_distance, Point* result);
gdouble seed_parameter (Seed* self, gdouble distance);
static void arc_real_draw_direct (Seed* base, cairo_t* cr, gdouble scale);
static void arc_draw_small_arc (Arc* self, cairo_t* cr, gdouble scale, gdouble a0, gdouble sweep);
void point_scale (Point *self, gdouble sx, gdouble sy, Point* result);
void point_rotate (Point *self, gdouble angle, Point* result);
void point_move (Point *self, Point* new_origin, Point* result);
static void arc_real_draw_controls (Seed* base, cairo_t* cr, gdouble scale);
void seed_draw_line_control (Seed* self, cairo_t* cr, Point* p0, Point* p1);
void seed_draw_square_control (Seed* self, cairo_t* cr, Point* p);
void seed_draw_circle_control (Seed* self, cairo_t* cr, Point* p);
void seed_point (Seed* self, gdouble distance, Point* result);
static gint arc_real_pressed_control (Seed* base, Point* p, gdouble scale);
gboolean seed_within_touch_range (Seed* self, Point* p0, Point* p1, gdouble scale);
static void arc_real_save_drag_context (Seed* base);
static void arc_real_drag_control (Seed* base, Point* p, gdouble scale, gboolean snap_on, gdouble grid_size, gdouble snap_angle);
gboolean seed_snap (Seed* self, Point* p, gdouble scale, gdouble grid_size);
gboolean seed_within_snap_range (Seed* self, Point* p0, Point* p1, gdouble scale);
static void arc_normalize_angles (Arc* self);
static void arc_real_move_shape (Seed* base, gdouble delta_x, gdouble delta_y);
void point_move_xy (Point *self, gdouble x, gdouble y, Point* result);
static Point* arc_real_points_to_snap (Seed* base, int* result_length1);
static void arc_real_draw_icon (Seed* base, cairo_t* cr, gdouble width, gdouble height);
void seed_init_full (Seed* self, gdouble* args, int args_length1);
void seed_draw_direct (Seed* self, cairo_t* cr, gdouble scale);
Arc* arc_new (void);
Arc* arc_construct (GType object_type);
Seed* seed_construct (GType object_type);
static void arc_finalize (GObject* obj);


static void arc_real_init_default_sub (Seed* base, Point* p) {
	Arc * self;
	Point _tmp0_ = {0};
#line 36 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	self = (Arc*) base;
#line 36 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	g_return_if_fail (p != NULL);
#line 37 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp0_ = *p;
#line 37 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	self->priv->centre = _tmp0_;
#line 38 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	self->priv->radius_x = (gdouble) 0;
#line 39 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	self->priv->radius_y = (gdouble) 0;
#line 40 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	self->priv->angle0 = (gdouble) 0;
#line 41 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	self->priv->angle1 = G_PI * 2;
#line 42 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	arc_set_rotation (self, (gdouble) 0);
#line 275 "arc.c"
}


static void arc_real_init_full_sub (Seed* base, gdouble* args, int args_length1) {
	Arc * self;
	gdouble* _tmp0_ = NULL;
	gint _tmp0__length1 = 0;
	gdouble* _tmp1_ = NULL;
	gint _tmp1__length1 = 0;
	gdouble _tmp2_ = 0.0;
	gdouble* _tmp3_ = NULL;
	gint _tmp3__length1 = 0;
	gdouble _tmp4_ = 0.0;
	Point _tmp5_ = {0};
	Point _tmp6_ = {0};
	gdouble* _tmp7_ = NULL;
	gint _tmp7__length1 = 0;
	gdouble _tmp8_ = 0.0;
	gdouble* _tmp9_ = NULL;
	gint _tmp9__length1 = 0;
	gdouble _tmp10_ = 0.0;
	gdouble* _tmp11_ = NULL;
	gint _tmp11__length1 = 0;
	gdouble _tmp12_ = 0.0;
	gdouble* _tmp13_ = NULL;
	gint _tmp13__length1 = 0;
	gdouble _tmp14_ = 0.0;
	gdouble* _tmp15_ = NULL;
	gint _tmp15__length1 = 0;
	gdouble _tmp16_ = 0.0;
#line 45 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	self = (Arc*) base;
#line 46 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp0_ = args;
#line 46 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp0__length1 = args_length1;
#line 46 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_vala_assert (_tmp0__length1 >= 7, "args.length >= 7");
#line 47 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp1_ = args;
#line 47 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp1__length1 = args_length1;
#line 47 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp2_ = _tmp1_[0];
#line 47 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp3_ = args;
#line 47 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp3__length1 = args_length1;
#line 47 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp4_ = _tmp3_[1];
#line 47 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	memset (&_tmp5_, 0, sizeof (Point));
#line 47 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp5_.x = _tmp2_;
#line 47 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp5_.y = _tmp4_;
#line 47 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	self->priv->centre = _tmp5_;
#line 47 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp6_ = self->priv->centre;
#line 48 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp7_ = args;
#line 48 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp7__length1 = args_length1;
#line 48 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp8_ = _tmp7_[2];
#line 48 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	self->priv->radius_x = _tmp8_;
#line 49 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp9_ = args;
#line 49 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp9__length1 = args_length1;
#line 49 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp10_ = _tmp9_[3];
#line 49 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	self->priv->radius_y = _tmp10_;
#line 50 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp11_ = args;
#line 50 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp11__length1 = args_length1;
#line 50 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp12_ = _tmp11_[4];
#line 50 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	self->priv->angle0 = _tmp12_;
#line 51 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp13_ = args;
#line 51 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp13__length1 = args_length1;
#line 51 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp14_ = _tmp13_[5];
#line 51 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	self->priv->angle1 = _tmp14_;
#line 52 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp15_ = args;
#line 52 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp15__length1 = args_length1;
#line 52 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp16_ = _tmp15_[6];
#line 52 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	arc_set_rotation (self, _tmp16_);
#line 376 "arc.c"
}


static gchar* arc_real_serialize_sub (Seed* base) {
	Arc * self;
	gchar* result = NULL;
	Point _tmp0_ = {0};
	gdouble _tmp1_ = 0.0;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	Point _tmp4_ = {0};
	gdouble _tmp5_ = 0.0;
	gchar* _tmp6_ = NULL;
	gchar* _tmp7_ = NULL;
	gdouble _tmp8_ = 0.0;
	gchar* _tmp9_ = NULL;
	gchar* _tmp10_ = NULL;
	gdouble _tmp11_ = 0.0;
	gchar* _tmp12_ = NULL;
	gchar* _tmp13_ = NULL;
	gdouble _tmp14_ = 0.0;
	gchar* _tmp15_ = NULL;
	gchar* _tmp16_ = NULL;
	gdouble _tmp17_ = 0.0;
	gchar* _tmp18_ = NULL;
	gchar* _tmp19_ = NULL;
	gdouble _tmp20_ = 0.0;
	gchar* _tmp21_ = NULL;
	gchar* _tmp22_ = NULL;
	gchar* _tmp23_ = NULL;
	gchar* _tmp24_ = NULL;
#line 55 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	self = (Arc*) base;
#line 56 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp0_ = self->priv->centre;
#line 56 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp1_ = _tmp0_.x;
#line 56 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp2_ = util_format (_tmp1_, 4);
#line 56 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp3_ = _tmp2_;
#line 56 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp4_ = self->priv->centre;
#line 56 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp5_ = _tmp4_.y;
#line 56 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp6_ = util_format (_tmp5_, 4);
#line 56 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp7_ = _tmp6_;
#line 56 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp8_ = self->priv->radius_x;
#line 56 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp9_ = util_format (_tmp8_, 4);
#line 56 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp10_ = _tmp9_;
#line 56 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp11_ = self->priv->radius_y;
#line 56 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp12_ = util_format (_tmp11_, 4);
#line 56 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp13_ = _tmp12_;
#line 56 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp14_ = self->priv->angle0;
#line 56 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp15_ = util_format (_tmp14_, 4);
#line 56 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp16_ = _tmp15_;
#line 56 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp17_ = self->priv->angle1;
#line 56 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp18_ = util_format (_tmp17_, 4);
#line 56 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp19_ = _tmp18_;
#line 56 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp20_ = self->priv->rotation;
#line 56 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp21_ = util_format (_tmp20_, 4);
#line 56 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp22_ = _tmp21_;
#line 56 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp23_ = g_strdup_printf ("Arc (%s, %s) (%s, %s) (%s, %s) %s", _tmp3_, _tmp7_, _tmp10_, _tmp13_, _tmp16_, _tmp19_, _tmp22_);
#line 56 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp24_ = _tmp23_;
#line 56 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_g_free0 (_tmp22_);
#line 56 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_g_free0 (_tmp19_);
#line 56 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_g_free0 (_tmp16_);
#line 56 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_g_free0 (_tmp13_);
#line 56 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_g_free0 (_tmp10_);
#line 56 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_g_free0 (_tmp7_);
#line 56 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_g_free0 (_tmp3_);
#line 56 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	result = _tmp24_;
#line 56 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	return result;
#line 478 "arc.c"
}


static void arc_set_rotation (Arc* self, gdouble rot) {
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
#line 63 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	g_return_if_fail (self != NULL);
#line 64 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp0_ = rot;
#line 64 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	self->priv->rotation = _tmp0_;
#line 65 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp1_ = self->priv->rotation;
#line 65 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	sincos (_tmp1_, &_tmp2_, &_tmp3_);
#line 65 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	self->priv->sin_rotation = _tmp2_;
#line 65 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	self->priv->cos_rotation = _tmp3_;
#line 501 "arc.c"
}


/**
 * For an approximately circular arc, don't use distance_to_param. Use raw t directly.
 */
static void arc_real_init_distance_to_parametric (Seed* base) {
	Arc * self;
	gboolean _tmp0_ = FALSE;
	gdouble _tmp1_ = 0.0;
	gboolean _tmp3_ = FALSE;
#line 71 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	self = (Arc*) base;
#line 72 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp1_ = self->priv->radius_x;
#line 72 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	if (_tmp1_ == ((gdouble) 0)) {
#line 519 "arc.c"
		gdouble _tmp2_ = 0.0;
#line 72 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
		_tmp2_ = self->priv->radius_y;
#line 72 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
		_tmp0_ = _tmp2_ == ((gdouble) 0);
#line 525 "arc.c"
	} else {
#line 72 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
		_tmp0_ = FALSE;
#line 529 "arc.c"
	}
#line 72 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp3_ = _tmp0_;
#line 72 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	if (_tmp3_) {
#line 72 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
		return;
#line 537 "arc.c"
	}
#line 75 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	SEED_CLASS (arc_parent_class)->init_distance_to_parametric (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_SEED, Seed));
#line 541 "arc.c"
}


static void arc_real_point_raw (Seed* base, gdouble t, Point* result) {
	Arc * self;
	gdouble sin = 0.0;
	gdouble cos = 0.0;
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
	gdouble x = 0.0;
	gdouble _tmp6_ = 0.0;
	gdouble y = 0.0;
	gdouble _tmp7_ = 0.0;
	Point _tmp8_ = {0};
	gdouble _tmp9_ = 0.0;
	gdouble _tmp10_ = 0.0;
	gdouble _tmp11_ = 0.0;
	Point _tmp12_ = {0};
	gdouble _tmp13_ = 0.0;
	gdouble _tmp14_ = 0.0;
	gdouble _tmp15_ = 0.0;
	Point _tmp16_ = {0};
#line 78 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	self = (Arc*) base;
#line 81 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp0_ = t;
#line 81 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp1_ = self->priv->angle0;
#line 81 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp2_ = t;
#line 81 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp3_ = self->priv->angle1;
#line 81 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	sincos (((1.0 - _tmp0_) * _tmp1_) + (_tmp2_ * _tmp3_), &_tmp4_, &_tmp5_);
#line 81 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	sin = _tmp4_;
#line 81 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	cos = _tmp5_;
#line 83 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp6_ = self->priv->radius_x;
#line 83 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	x = _tmp6_ * cos;
#line 84 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp7_ = self->priv->radius_y;
#line 84 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	y = _tmp7_ * sin;
#line 85 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp8_ = self->priv->centre;
#line 85 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp9_ = _tmp8_.x;
#line 85 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp10_ = self->priv->cos_rotation;
#line 85 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp11_ = self->priv->sin_rotation;
#line 85 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp12_ = self->priv->centre;
#line 85 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp13_ = _tmp12_.y;
#line 85 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp14_ = self->priv->sin_rotation;
#line 85 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp15_ = self->priv->cos_rotation;
#line 85 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	memset (&_tmp16_, 0, sizeof (Point));
#line 85 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp16_.x = (_tmp9_ + (x * _tmp10_)) - (y * _tmp11_);
#line 85 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp16_.y = (_tmp13_ + (x * _tmp14_)) + (y * _tmp15_);
#line 85 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	*result = _tmp16_;
#line 85 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	return;
#line 618 "arc.c"
}


static void arc_real_distant_point (Seed* base, gdouble x_distance, gdouble y_distance, Point* result) {
	Arc * self;
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	gdouble t = 0.0;
	gdouble _tmp5_ = 0.0;
	gdouble _tmp6_ = 0.0;
	gdouble angle = 0.0;
	gdouble _tmp7_ = 0.0;
	gdouble _tmp8_ = 0.0;
	gdouble sin_angle = 0.0;
	gdouble cos_angle = 0.0;
	gdouble _tmp9_ = 0.0;
	gdouble _tmp10_ = 0.0;
	gdouble sin = 0.0;
	gdouble _tmp11_ = 0.0;
	gdouble _tmp12_ = 0.0;
	gdouble cos = 0.0;
	gdouble _tmp13_ = 0.0;
	gdouble _tmp14_ = 0.0;
	gdouble x = 0.0;
	gdouble _tmp15_ = 0.0;
	gdouble y = 0.0;
	gdouble _tmp16_ = 0.0;
	gdouble _tmp17_ = 0.0;
	gdouble _tmp18_ = 0.0;
	Point _tmp19_ = {0};
	gdouble _tmp20_ = 0.0;
	gdouble _tmp21_ = 0.0;
	gdouble _tmp22_ = 0.0;
	gdouble _tmp23_ = 0.0;
	Point _tmp24_ = {0};
	gdouble _tmp25_ = 0.0;
	gdouble _tmp26_ = 0.0;
	Point _tmp27_ = {0};
#line 90 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	self = (Arc*) base;
#line 92 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp0_ = y_distance;
#line 92 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp1_ = x_distance;
#line 92 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp2_ = ((Seed*) self)->width0;
#line 92 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp3_ = x_distance;
#line 92 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp4_ = ((Seed*) self)->width1;
#line 92 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	y_distance = _tmp0_ * (((1 - _tmp1_) * _tmp2_) + (_tmp3_ * _tmp4_));
#line 95 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp5_ = x_distance;
#line 95 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp6_ = seed_parameter ((Seed*) self, _tmp5_);
#line 95 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	t = _tmp6_;
#line 96 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp7_ = self->priv->angle0;
#line 96 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp8_ = self->priv->angle1;
#line 96 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	angle = ((1.0 - t) * _tmp7_) + (t * _tmp8_);
#line 99 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	sincos (angle, &_tmp9_, &_tmp10_);
#line 99 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	sin_angle = _tmp9_;
#line 99 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	cos_angle = _tmp10_;
#line 102 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp11_ = self->priv->cos_rotation;
#line 102 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp12_ = self->priv->sin_rotation;
#line 102 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	sin = (sin_angle * _tmp11_) + (cos_angle * _tmp12_);
#line 103 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp13_ = self->priv->cos_rotation;
#line 103 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp14_ = self->priv->sin_rotation;
#line 103 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	cos = (cos_angle * _tmp13_) - (sin_angle * _tmp14_);
#line 109 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp15_ = self->priv->radius_x;
#line 109 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	x = _tmp15_ * cos_angle;
#line 110 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp16_ = self->priv->radius_y;
#line 110 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	y = _tmp16_ * sin_angle;
#line 111 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp17_ = self->priv->cos_rotation;
#line 111 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp18_ = self->priv->sin_rotation;
#line 111 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp19_ = self->priv->centre;
#line 111 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp20_ = _tmp19_.x;
#line 111 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp21_ = y_distance;
#line 111 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp22_ = self->priv->sin_rotation;
#line 111 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp23_ = self->priv->cos_rotation;
#line 111 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp24_ = self->priv->centre;
#line 111 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp25_ = _tmp24_.y;
#line 111 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp26_ = y_distance;
#line 111 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	memset (&_tmp27_, 0, sizeof (Point));
#line 111 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp27_.x = (((x * _tmp17_) - (y * _tmp18_)) + _tmp20_) + (_tmp21_ * cos);
#line 111 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp27_.y = (((x * _tmp22_) + (y * _tmp23_)) + _tmp25_) + (_tmp26_ * sin);
#line 111 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	*result = _tmp27_;
#line 111 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	return;
#line 742 "arc.c"
}


static void arc_real_draw_direct (Seed* base, cairo_t* cr, gdouble scale) {
	Arc * self;
	gdouble a0 = 0.0;
	gdouble _tmp0_ = 0.0;
#line 116 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	self = (Arc*) base;
#line 116 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	g_return_if_fail (cr != NULL);
#line 117 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp0_ = self->priv->angle0;
#line 117 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	a0 = _tmp0_;
#line 758 "arc.c"
	{
		gboolean _tmp1_ = FALSE;
#line 118 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
		_tmp1_ = TRUE;
#line 118 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
		while (TRUE) {
#line 765 "arc.c"
			gboolean _tmp2_ = FALSE;
			gdouble a1 = 0.0;
			gdouble _tmp5_ = 0.0;
			gdouble _tmp6_ = 0.0;
			gdouble _tmp7_ = 0.0;
			cairo_t* _tmp8_ = NULL;
			gdouble _tmp9_ = 0.0;
			gdouble _tmp10_ = 0.0;
			gdouble _tmp11_ = 0.0;
			gdouble _tmp12_ = 0.0;
#line 118 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
			_tmp2_ = _tmp1_;
#line 118 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
			if (!_tmp2_) {
#line 780 "arc.c"
				gdouble _tmp3_ = 0.0;
				gdouble _tmp4_ = 0.0;
#line 122 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
				_tmp3_ = a0;
#line 122 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
				_tmp4_ = self->priv->angle1;
#line 122 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
				if (!(_tmp3_ < _tmp4_)) {
#line 122 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
					break;
#line 791 "arc.c"
				}
			}
#line 118 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
			_tmp1_ = FALSE;
#line 119 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
			_tmp5_ = self->priv->angle1;
#line 119 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
			_tmp6_ = a0;
#line 119 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
			_tmp7_ = MIN (G_PI / 2, _tmp5_ - _tmp6_);
#line 119 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
			a1 = _tmp7_;
#line 120 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
			_tmp8_ = cr;
#line 120 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
			_tmp9_ = scale;
#line 120 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
			_tmp10_ = a0;
#line 120 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
			_tmp11_ = a1;
#line 120 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
			arc_draw_small_arc (self, _tmp8_, _tmp9_, _tmp10_, _tmp11_);
#line 121 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
			_tmp12_ = a0;
#line 121 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
			a0 = _tmp12_ + (G_PI / 2);
#line 818 "arc.c"
		}
	}
}


/**
 * Draw arc subtending an angle of less than 90 degrees.
 *
 * Reference: Richard DeVeneza's "How to determine the control points of a Bezier
 * curve that approximates a small circular arc", Nov 2004
 */
static void arc_draw_small_arc (Arc* self, cairo_t* cr, gdouble scale, gdouble a0, gdouble sweep) {
	Point p0 = {0};
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	Point _tmp4_ = {0};
	Point p1 = {0};
	Point _tmp5_ = {0};
	gdouble _tmp6_ = 0.0;
	Point _tmp7_ = {0};
	gdouble _tmp8_ = 0.0;
	Point _tmp9_ = {0};
	gdouble _tmp10_ = 0.0;
	Point _tmp11_ = {0};
	gdouble _tmp12_ = 0.0;
	Point _tmp13_ = {0};
	Point p2 = {0};
	Point _tmp14_ = {0};
	Point p3 = {0};
	Point _tmp15_ = {0};
	gdouble rot = 0.0;
	gdouble _tmp16_ = 0.0;
	gdouble _tmp17_ = 0.0;
	Point _tmp18_ = {0};
	gdouble _tmp19_ = 0.0;
	gdouble _tmp20_ = 0.0;
	Point _tmp21_ = {0};
	gdouble _tmp22_ = 0.0;
	Point _tmp23_ = {0};
	Point _tmp24_ = {0};
	Point _tmp25_ = {0};
	gdouble _tmp26_ = 0.0;
	gdouble _tmp27_ = 0.0;
	Point _tmp28_ = {0};
	Point _tmp29_ = {0};
	gdouble _tmp30_ = 0.0;
	gdouble _tmp31_ = 0.0;
	Point _tmp32_ = {0};
	gdouble _tmp33_ = 0.0;
	Point _tmp34_ = {0};
	Point _tmp35_ = {0};
	Point _tmp36_ = {0};
	gdouble _tmp37_ = 0.0;
	gdouble _tmp38_ = 0.0;
	Point _tmp39_ = {0};
	Point _tmp40_ = {0};
	gdouble _tmp41_ = 0.0;
	gdouble _tmp42_ = 0.0;
	Point _tmp43_ = {0};
	gdouble _tmp44_ = 0.0;
	Point _tmp45_ = {0};
	Point _tmp46_ = {0};
	Point _tmp47_ = {0};
	gdouble _tmp48_ = 0.0;
	gdouble _tmp49_ = 0.0;
	Point _tmp50_ = {0};
	Point _tmp51_ = {0};
	gdouble _tmp52_ = 0.0;
	gdouble _tmp53_ = 0.0;
	Point _tmp54_ = {0};
	gdouble _tmp55_ = 0.0;
	Point _tmp56_ = {0};
	Point _tmp57_ = {0};
	Point _tmp58_ = {0};
	gdouble _tmp59_ = 0.0;
	gdouble _tmp60_ = 0.0;
	Point _tmp61_ = {0};
	cairo_t* _tmp62_ = NULL;
	Point _tmp63_ = {0};
	gdouble _tmp64_ = 0.0;
	Point _tmp65_ = {0};
	gdouble _tmp66_ = 0.0;
	cairo_t* _tmp67_ = NULL;
	Point _tmp68_ = {0};
	gdouble _tmp69_ = 0.0;
	Point _tmp70_ = {0};
	gdouble _tmp71_ = 0.0;
	Point _tmp72_ = {0};
	gdouble _tmp73_ = 0.0;
	Point _tmp74_ = {0};
	gdouble _tmp75_ = 0.0;
	Point _tmp76_ = {0};
	gdouble _tmp77_ = 0.0;
	Point _tmp78_ = {0};
	gdouble _tmp79_ = 0.0;
	cairo_t* _tmp80_ = NULL;
#line 131 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	g_return_if_fail (self != NULL);
#line 131 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	g_return_if_fail (cr != NULL);
#line 133 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp0_ = sweep;
#line 133 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp1_ = cos (_tmp0_ / 2);
#line 133 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp2_ = sweep;
#line 133 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp3_ = sin (_tmp2_ / 2);
#line 133 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	memset (&_tmp4_, 0, sizeof (Point));
#line 133 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp4_.x = _tmp1_;
#line 133 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp4_.y = _tmp3_;
#line 133 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	p0 = _tmp4_;
#line 134 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp5_ = p0;
#line 134 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp6_ = _tmp5_.x;
#line 134 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp7_ = p0;
#line 134 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp8_ = _tmp7_.x;
#line 134 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp9_ = p0;
#line 134 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp10_ = _tmp9_.x;
#line 134 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp11_ = p0;
#line 134 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp12_ = _tmp11_.y;
#line 134 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	memset (&_tmp13_, 0, sizeof (Point));
#line 134 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp13_.x = (4 - _tmp6_) / 3;
#line 134 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp13_.y = ((1 - _tmp8_) * (3 - _tmp10_)) / (3 * _tmp12_);
#line 134 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	p1 = _tmp13_;
#line 135 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	point_scale (&p1, (gdouble) 1, (gdouble) (-1), &_tmp14_);
#line 135 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	p2 = _tmp14_;
#line 136 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	point_scale (&p0, (gdouble) 1, (gdouble) (-1), &_tmp15_);
#line 136 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	p3 = _tmp15_;
#line 142 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp16_ = a0;
#line 142 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp17_ = sweep;
#line 142 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	rot = _tmp16_ + (_tmp17_ / 2);
#line 143 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	point_rotate (&p0, rot, &_tmp18_);
#line 143 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp19_ = self->priv->radius_x;
#line 143 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp20_ = self->priv->radius_y;
#line 143 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	point_scale (&_tmp18_, _tmp19_, _tmp20_, &_tmp21_);
#line 143 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp22_ = self->priv->rotation;
#line 143 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	point_rotate (&_tmp21_, _tmp22_, &_tmp23_);
#line 143 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp24_ = self->priv->centre;
#line 143 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	point_move (&_tmp23_, &_tmp24_, &_tmp25_);
#line 143 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp26_ = scale;
#line 143 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp27_ = scale;
#line 143 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	point_scale (&_tmp25_, _tmp26_, _tmp27_, &_tmp28_);
#line 143 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	p0 = _tmp28_;
#line 144 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	point_rotate (&p1, rot, &_tmp29_);
#line 144 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp30_ = self->priv->radius_x;
#line 144 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp31_ = self->priv->radius_y;
#line 144 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	point_scale (&_tmp29_, _tmp30_, _tmp31_, &_tmp32_);
#line 144 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp33_ = self->priv->rotation;
#line 144 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	point_rotate (&_tmp32_, _tmp33_, &_tmp34_);
#line 144 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp35_ = self->priv->centre;
#line 144 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	point_move (&_tmp34_, &_tmp35_, &_tmp36_);
#line 144 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp37_ = scale;
#line 144 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp38_ = scale;
#line 144 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	point_scale (&_tmp36_, _tmp37_, _tmp38_, &_tmp39_);
#line 144 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	p1 = _tmp39_;
#line 145 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	point_rotate (&p2, rot, &_tmp40_);
#line 145 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp41_ = self->priv->radius_x;
#line 145 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp42_ = self->priv->radius_y;
#line 145 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	point_scale (&_tmp40_, _tmp41_, _tmp42_, &_tmp43_);
#line 145 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp44_ = self->priv->rotation;
#line 145 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	point_rotate (&_tmp43_, _tmp44_, &_tmp45_);
#line 145 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp46_ = self->priv->centre;
#line 145 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	point_move (&_tmp45_, &_tmp46_, &_tmp47_);
#line 145 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp48_ = scale;
#line 145 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp49_ = scale;
#line 145 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	point_scale (&_tmp47_, _tmp48_, _tmp49_, &_tmp50_);
#line 145 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	p2 = _tmp50_;
#line 146 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	point_rotate (&p3, rot, &_tmp51_);
#line 146 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp52_ = self->priv->radius_x;
#line 146 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp53_ = self->priv->radius_y;
#line 146 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	point_scale (&_tmp51_, _tmp52_, _tmp53_, &_tmp54_);
#line 146 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp55_ = self->priv->rotation;
#line 146 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	point_rotate (&_tmp54_, _tmp55_, &_tmp56_);
#line 146 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp57_ = self->priv->centre;
#line 146 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	point_move (&_tmp56_, &_tmp57_, &_tmp58_);
#line 146 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp59_ = scale;
#line 146 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp60_ = scale;
#line 146 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	point_scale (&_tmp58_, _tmp59_, _tmp60_, &_tmp61_);
#line 146 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	p3 = _tmp61_;
#line 148 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp62_ = cr;
#line 148 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp63_ = p0;
#line 148 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp64_ = _tmp63_.x;
#line 148 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp65_ = p0;
#line 148 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp66_ = _tmp65_.y;
#line 148 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	cairo_move_to (_tmp62_, _tmp64_, _tmp66_);
#line 149 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp67_ = cr;
#line 149 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp68_ = p1;
#line 149 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp69_ = _tmp68_.x;
#line 149 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp70_ = p1;
#line 149 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp71_ = _tmp70_.y;
#line 149 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp72_ = p2;
#line 149 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp73_ = _tmp72_.x;
#line 149 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp74_ = p2;
#line 149 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp75_ = _tmp74_.y;
#line 149 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp76_ = p3;
#line 149 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp77_ = _tmp76_.x;
#line 149 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp78_ = p3;
#line 149 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp79_ = _tmp78_.y;
#line 149 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	cairo_curve_to (_tmp67_, _tmp69_, _tmp71_, _tmp73_, _tmp75_, _tmp77_, _tmp79_);
#line 150 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp80_ = cr;
#line 150 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	cairo_stroke (_tmp80_);
#line 1115 "arc.c"
}


static void arc_real_draw_controls (Seed* base, cairo_t* cr, gdouble scale) {
	Arc * self;
	Point corner0 = {0};
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	Point _tmp2_ = {0};
	gdouble _tmp3_ = 0.0;
	Point _tmp4_ = {0};
	Point _tmp5_ = {0};
	Point _tmp6_ = {0};
	gdouble _tmp7_ = 0.0;
	gdouble _tmp8_ = 0.0;
	Point _tmp9_ = {0};
	Point corner1 = {0};
	gdouble _tmp10_ = 0.0;
	gdouble _tmp11_ = 0.0;
	Point _tmp12_ = {0};
	gdouble _tmp13_ = 0.0;
	Point _tmp14_ = {0};
	Point _tmp15_ = {0};
	Point _tmp16_ = {0};
	gdouble _tmp17_ = 0.0;
	gdouble _tmp18_ = 0.0;
	Point _tmp19_ = {0};
	Point corner2 = {0};
	gdouble _tmp20_ = 0.0;
	gdouble _tmp21_ = 0.0;
	Point _tmp22_ = {0};
	gdouble _tmp23_ = 0.0;
	Point _tmp24_ = {0};
	Point _tmp25_ = {0};
	Point _tmp26_ = {0};
	gdouble _tmp27_ = 0.0;
	gdouble _tmp28_ = 0.0;
	Point _tmp29_ = {0};
	Point corner3 = {0};
	gdouble _tmp30_ = 0.0;
	gdouble _tmp31_ = 0.0;
	Point _tmp32_ = {0};
	gdouble _tmp33_ = 0.0;
	Point _tmp34_ = {0};
	Point _tmp35_ = {0};
	Point _tmp36_ = {0};
	gdouble _tmp37_ = 0.0;
	gdouble _tmp38_ = 0.0;
	Point _tmp39_ = {0};
	cairo_t* _tmp40_ = NULL;
	Point _tmp41_ = {0};
	Point _tmp42_ = {0};
	cairo_t* _tmp43_ = NULL;
	Point _tmp44_ = {0};
	Point _tmp45_ = {0};
	cairo_t* _tmp46_ = NULL;
	Point _tmp47_ = {0};
	Point _tmp48_ = {0};
	cairo_t* _tmp49_ = NULL;
	Point _tmp50_ = {0};
	Point _tmp51_ = {0};
	cairo_t* _tmp52_ = NULL;
	Point _tmp53_ = {0};
	cairo_t* _tmp54_ = NULL;
	Point _tmp55_ = {0};
	cairo_t* _tmp56_ = NULL;
	Point _tmp57_ = {0};
	gdouble _tmp58_ = 0.0;
	gdouble _tmp59_ = 0.0;
	Point _tmp60_ = {0};
	cairo_t* _tmp61_ = NULL;
	Point _tmp62_ = {0};
	gdouble _tmp63_ = 0.0;
	gdouble _tmp64_ = 0.0;
	Point _tmp65_ = {0};
#line 153 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	self = (Arc*) base;
#line 153 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	g_return_if_fail (cr != NULL);
#line 154 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp0_ = self->priv->radius_x;
#line 154 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp1_ = self->priv->radius_y;
#line 154 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	memset (&_tmp2_, 0, sizeof (Point));
#line 154 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp2_.x = -_tmp0_;
#line 154 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp2_.y = -_tmp1_;
#line 154 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp3_ = self->priv->rotation;
#line 154 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	point_rotate (&_tmp2_, _tmp3_, &_tmp4_);
#line 154 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp5_ = self->priv->centre;
#line 154 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	point_move (&_tmp4_, &_tmp5_, &_tmp6_);
#line 154 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp7_ = scale;
#line 154 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp8_ = scale;
#line 154 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	point_scale (&_tmp6_, _tmp7_, _tmp8_, &_tmp9_);
#line 154 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	corner0 = _tmp9_;
#line 155 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp10_ = self->priv->radius_x;
#line 155 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp11_ = self->priv->radius_y;
#line 155 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	memset (&_tmp12_, 0, sizeof (Point));
#line 155 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp12_.x = +_tmp10_;
#line 155 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp12_.y = -_tmp11_;
#line 155 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp13_ = self->priv->rotation;
#line 155 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	point_rotate (&_tmp12_, _tmp13_, &_tmp14_);
#line 155 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp15_ = self->priv->centre;
#line 155 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	point_move (&_tmp14_, &_tmp15_, &_tmp16_);
#line 155 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp17_ = scale;
#line 155 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp18_ = scale;
#line 155 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	point_scale (&_tmp16_, _tmp17_, _tmp18_, &_tmp19_);
#line 155 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	corner1 = _tmp19_;
#line 156 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp20_ = self->priv->radius_x;
#line 156 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp21_ = self->priv->radius_y;
#line 156 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	memset (&_tmp22_, 0, sizeof (Point));
#line 156 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp22_.x = +_tmp20_;
#line 156 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp22_.y = +_tmp21_;
#line 156 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp23_ = self->priv->rotation;
#line 156 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	point_rotate (&_tmp22_, _tmp23_, &_tmp24_);
#line 156 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp25_ = self->priv->centre;
#line 156 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	point_move (&_tmp24_, &_tmp25_, &_tmp26_);
#line 156 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp27_ = scale;
#line 156 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp28_ = scale;
#line 156 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	point_scale (&_tmp26_, _tmp27_, _tmp28_, &_tmp29_);
#line 156 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	corner2 = _tmp29_;
#line 157 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp30_ = self->priv->radius_x;
#line 157 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp31_ = self->priv->radius_y;
#line 157 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	memset (&_tmp32_, 0, sizeof (Point));
#line 157 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp32_.x = -_tmp30_;
#line 157 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp32_.y = +_tmp31_;
#line 157 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp33_ = self->priv->rotation;
#line 157 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	point_rotate (&_tmp32_, _tmp33_, &_tmp34_);
#line 157 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp35_ = self->priv->centre;
#line 157 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	point_move (&_tmp34_, &_tmp35_, &_tmp36_);
#line 157 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp37_ = scale;
#line 157 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp38_ = scale;
#line 157 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	point_scale (&_tmp36_, _tmp37_, _tmp38_, &_tmp39_);
#line 157 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	corner3 = _tmp39_;
#line 158 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp40_ = cr;
#line 158 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp41_ = corner0;
#line 158 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp42_ = corner1;
#line 158 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	seed_draw_line_control ((Seed*) self, _tmp40_, &_tmp41_, &_tmp42_);
#line 159 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp43_ = cr;
#line 159 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp44_ = corner1;
#line 159 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp45_ = corner2;
#line 159 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	seed_draw_line_control ((Seed*) self, _tmp43_, &_tmp44_, &_tmp45_);
#line 160 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp46_ = cr;
#line 160 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp47_ = corner2;
#line 160 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp48_ = corner3;
#line 160 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	seed_draw_line_control ((Seed*) self, _tmp46_, &_tmp47_, &_tmp48_);
#line 161 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp49_ = cr;
#line 161 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp50_ = corner3;
#line 161 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp51_ = corner0;
#line 161 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	seed_draw_line_control ((Seed*) self, _tmp49_, &_tmp50_, &_tmp51_);
#line 162 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp52_ = cr;
#line 162 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp53_ = corner2;
#line 162 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	seed_draw_square_control ((Seed*) self, _tmp52_, &_tmp53_);
#line 163 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp54_ = cr;
#line 163 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp55_ = corner1;
#line 163 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	seed_draw_circle_control ((Seed*) self, _tmp54_, &_tmp55_);
#line 164 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp56_ = cr;
#line 164 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	seed_point ((Seed*) self, (gdouble) 0, &_tmp57_);
#line 164 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp58_ = scale;
#line 164 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp59_ = scale;
#line 164 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	point_scale (&_tmp57_, _tmp58_, _tmp59_, &_tmp60_);
#line 164 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	seed_draw_circle_control ((Seed*) self, _tmp56_, &_tmp60_);
#line 165 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp61_ = cr;
#line 165 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	seed_point ((Seed*) self, (gdouble) 1, &_tmp62_);
#line 165 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp63_ = scale;
#line 165 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp64_ = scale;
#line 165 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	point_scale (&_tmp62_, _tmp63_, _tmp64_, &_tmp65_);
#line 165 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	seed_draw_circle_control ((Seed*) self, _tmp61_, &_tmp65_);
#line 1367 "arc.c"
}


static gint arc_real_pressed_control (Seed* base, Point* p, gdouble scale) {
	Arc * self;
	gint result = 0;
	Point corner1 = {0};
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	Point _tmp2_ = {0};
	gdouble _tmp3_ = 0.0;
	Point _tmp4_ = {0};
	Point _tmp5_ = {0};
	Point _tmp6_ = {0};
	Point corner2 = {0};
	gdouble _tmp7_ = 0.0;
	gdouble _tmp8_ = 0.0;
	Point _tmp9_ = {0};
	gdouble _tmp10_ = 0.0;
	Point _tmp11_ = {0};
	Point _tmp12_ = {0};
	Point _tmp13_ = {0};
	gint _tmp14_ = 0;
	Point _tmp15_ = {0};
	Point _tmp16_ = {0};
	gdouble _tmp17_ = 0.0;
	gboolean _tmp18_ = FALSE;
	gint _tmp37_ = 0;
#line 178 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	self = (Arc*) base;
#line 178 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	g_return_val_if_fail (p != NULL, 0);
#line 179 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp0_ = self->priv->radius_x;
#line 179 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp1_ = self->priv->radius_y;
#line 179 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	memset (&_tmp2_, 0, sizeof (Point));
#line 179 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp2_.x = +_tmp0_;
#line 179 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp2_.y = -_tmp1_;
#line 179 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp3_ = self->priv->rotation;
#line 179 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	point_rotate (&_tmp2_, _tmp3_, &_tmp4_);
#line 179 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp5_ = self->priv->centre;
#line 179 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	point_move (&_tmp4_, &_tmp5_, &_tmp6_);
#line 179 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	corner1 = _tmp6_;
#line 180 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp7_ = self->priv->radius_x;
#line 180 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp8_ = self->priv->radius_y;
#line 180 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	memset (&_tmp9_, 0, sizeof (Point));
#line 180 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp9_.x = +_tmp7_;
#line 180 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp9_.y = +_tmp8_;
#line 180 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp10_ = self->priv->rotation;
#line 180 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	point_rotate (&_tmp9_, _tmp10_, &_tmp11_);
#line 180 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp12_ = self->priv->centre;
#line 180 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	point_move (&_tmp11_, &_tmp12_, &_tmp13_);
#line 180 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	corner2 = _tmp13_;
#line 181 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp15_ = *p;
#line 181 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp16_ = corner2;
#line 181 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp17_ = scale;
#line 181 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp18_ = seed_within_touch_range ((Seed*) self, &_tmp15_, &_tmp16_, _tmp17_);
#line 181 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	if (_tmp18_) {
#line 181 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
		_tmp14_ = 0;
#line 1452 "arc.c"
	} else {
		gint _tmp19_ = 0;
		Point _tmp20_ = {0};
		Point _tmp21_ = {0};
		gdouble _tmp22_ = 0.0;
		gboolean _tmp23_ = FALSE;
		gint _tmp36_ = 0;
#line 182 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
		_tmp20_ = *p;
#line 182 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
		_tmp21_ = corner1;
#line 182 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
		_tmp22_ = scale;
#line 182 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
		_tmp23_ = seed_within_touch_range ((Seed*) self, &_tmp20_, &_tmp21_, _tmp22_);
#line 182 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
		if (_tmp23_) {
#line 182 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
			_tmp19_ = 1;
#line 1472 "arc.c"
		} else {
			gint _tmp24_ = 0;
			Point _tmp25_ = {0};
			Point _tmp26_ = {0};
			gdouble _tmp27_ = 0.0;
			gboolean _tmp28_ = FALSE;
			gint _tmp35_ = 0;
#line 183 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
			_tmp25_ = *p;
#line 183 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
			seed_point ((Seed*) self, (gdouble) 0, &_tmp26_);
#line 183 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
			_tmp27_ = scale;
#line 183 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
			_tmp28_ = seed_within_touch_range ((Seed*) self, &_tmp25_, &_tmp26_, _tmp27_);
#line 183 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
			if (_tmp28_) {
#line 183 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
				_tmp24_ = 2;
#line 1492 "arc.c"
			} else {
				gint _tmp29_ = 0;
				Point _tmp30_ = {0};
				Point _tmp31_ = {0};
				gdouble _tmp32_ = 0.0;
				gboolean _tmp33_ = FALSE;
				gint _tmp34_ = 0;
#line 184 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
				_tmp30_ = *p;
#line 184 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
				seed_point ((Seed*) self, (gdouble) 1, &_tmp31_);
#line 184 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
				_tmp32_ = scale;
#line 184 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
				_tmp33_ = seed_within_touch_range ((Seed*) self, &_tmp30_, &_tmp31_, _tmp32_);
#line 184 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
				if (_tmp33_) {
#line 184 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
					_tmp29_ = 3;
#line 1512 "arc.c"
				} else {
#line 184 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
					_tmp29_ = -1;
#line 1516 "arc.c"
				}
#line 184 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
				_tmp34_ = _tmp29_;
#line 184 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
				_tmp24_ = _tmp34_;
#line 1522 "arc.c"
			}
#line 183 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
			_tmp35_ = _tmp24_;
#line 183 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
			_tmp19_ = _tmp35_;
#line 1528 "arc.c"
		}
#line 182 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
		_tmp36_ = _tmp19_;
#line 182 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
		_tmp14_ = _tmp36_;
#line 1534 "arc.c"
	}
#line 181 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp37_ = _tmp14_;
#line 181 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	result = _tmp37_;
#line 181 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	return result;
#line 1542 "arc.c"
}


static void arc_real_save_drag_context (Seed* base) {
	Arc * self;
	Point _tmp0_ = {0};
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	Point _tmp3_ = {0};
	gdouble _tmp4_ = 0.0;
	Point _tmp5_ = {0};
	Point _tmp6_ = {0};
	Point _tmp7_ = {0};
#line 187 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	self = (Arc*) base;
#line 188 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp0_ = self->priv->centre;
#line 188 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	self->priv->centre_save = _tmp0_;
#line 189 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp1_ = self->priv->radius_x;
#line 189 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp2_ = self->priv->radius_y;
#line 189 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	memset (&_tmp3_, 0, sizeof (Point));
#line 189 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp3_.x = -_tmp1_;
#line 189 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp3_.y = -_tmp2_;
#line 189 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp4_ = self->priv->rotation;
#line 189 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	point_rotate (&_tmp3_, _tmp4_, &_tmp5_);
#line 189 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp6_ = self->priv->centre;
#line 189 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	point_move (&_tmp5_, &_tmp6_, &_tmp7_);
#line 189 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	self->priv->topleft_save = _tmp7_;
#line 1582 "arc.c"
}


static void arc_real_drag_control (Seed* base, Point* p, gdouble scale, gboolean snap_on, gdouble grid_size, gdouble snap_angle) {
	Arc * self;
	gdouble _tmp0_ = 0.0;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp4_ = FALSE;
	Point canonical_p = {0};
	Point _tmp7_ = {0};
	gdouble _tmp8_ = 0.0;
	Point _tmp9_ = {0};
	gdouble _tmp10_ = 0.0;
	Point _tmp11_ = {0};
	gdouble _tmp12_ = 0.0;
	Point _tmp13_ = {0};
	gdouble _tmp14_ = 0.0;
	Point _tmp15_ = {0};
	gdouble _tmp16_ = 0.0;
	Point _tmp17_ = {0};
	gdouble rx = 0.0;
	Point _tmp18_ = {0};
	gdouble _tmp19_ = 0.0;
	gdouble ry = 0.0;
	Point _tmp20_ = {0};
	gdouble _tmp21_ = 0.0;
	gint _tmp22_ = 0;
#line 192 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	self = (Arc*) base;
#line 192 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	g_return_if_fail (p != NULL);
#line 194 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp0_ = snap_angle;
#line 194 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	snap_angle = (G_PI * _tmp0_) / 180;
#line 195 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp2_ = snap_on;
#line 195 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	if (_tmp2_) {
#line 1623 "arc.c"
		gint _tmp3_ = 0;
#line 195 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
		_tmp3_ = ((Seed*) self)->selected_control;
#line 195 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
		_tmp1_ = _tmp3_ == 0;
#line 1629 "arc.c"
	} else {
#line 195 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
		_tmp1_ = FALSE;
#line 1633 "arc.c"
	}
#line 195 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp4_ = _tmp1_;
#line 195 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	if (_tmp4_) {
#line 1639 "arc.c"
		gdouble _tmp5_ = 0.0;
		gdouble _tmp6_ = 0.0;
#line 195 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
		_tmp5_ = scale;
#line 195 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
		_tmp6_ = grid_size;
#line 195 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
		seed_snap ((Seed*) self, p, _tmp5_, _tmp6_);
#line 1648 "arc.c"
	}
#line 196 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp7_ = *p;
#line 196 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp8_ = _tmp7_.x;
#line 196 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp9_ = self->priv->centre;
#line 196 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp10_ = _tmp9_.x;
#line 196 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp11_ = *p;
#line 196 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp12_ = _tmp11_.y;
#line 196 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp13_ = self->priv->centre;
#line 196 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp14_ = _tmp13_.y;
#line 196 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	memset (&_tmp15_, 0, sizeof (Point));
#line 196 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp15_.x = _tmp8_ - _tmp10_;
#line 196 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp15_.y = _tmp12_ - _tmp14_;
#line 196 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp16_ = self->priv->rotation;
#line 196 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	point_rotate (&_tmp15_, -_tmp16_, &_tmp17_);
#line 196 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	canonical_p = _tmp17_;
#line 197 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp18_ = canonical_p;
#line 197 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp19_ = _tmp18_.x;
#line 197 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	rx = _tmp19_;
#line 198 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp20_ = canonical_p;
#line 198 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp21_ = _tmp20_.y;
#line 198 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	ry = _tmp21_;
#line 199 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp22_ = ((Seed*) self)->selected_control;
#line 199 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	if (_tmp22_ == 0) {
#line 1694 "arc.c"
		Point size = {0};
		Point _tmp23_ = {0};
		gdouble _tmp24_ = 0.0;
		Point _tmp25_ = {0};
		gdouble _tmp26_ = 0.0;
		Point _tmp27_ = {0};
		gdouble _tmp28_ = 0.0;
		Point _tmp29_ = {0};
		gdouble _tmp30_ = 0.0;
		Point _tmp31_ = {0};
		gdouble _tmp32_ = 0.0;
		Point _tmp33_ = {0};
		Point _tmp34_ = {0};
		gdouble _tmp35_ = 0.0;
		gdouble _tmp36_ = 0.0;
		Point _tmp37_ = {0};
		gdouble _tmp38_ = 0.0;
		gdouble _tmp39_ = 0.0;
		gdouble _tmp40_ = 0.0;
		gdouble _tmp41_ = 0.0;
		Point _tmp42_ = {0};
		gdouble _tmp43_ = 0.0;
		Point _tmp44_ = {0};
		Point _tmp45_ = {0};
		Point _tmp46_ = {0};
#line 200 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
		_tmp23_ = *p;
#line 200 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
		_tmp24_ = _tmp23_.x;
#line 200 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
		_tmp25_ = self->priv->topleft_save;
#line 200 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
		_tmp26_ = _tmp25_.x;
#line 200 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
		_tmp27_ = *p;
#line 200 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
		_tmp28_ = _tmp27_.y;
#line 200 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
		_tmp29_ = self->priv->topleft_save;
#line 200 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
		_tmp30_ = _tmp29_.y;
#line 200 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
		memset (&_tmp31_, 0, sizeof (Point));
#line 200 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
		_tmp31_.x = _tmp24_ - _tmp26_;
#line 200 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
		_tmp31_.y = _tmp28_ - _tmp30_;
#line 200 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
		_tmp32_ = self->priv->rotation;
#line 200 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
		point_rotate (&_tmp31_, -_tmp32_, &_tmp33_);
#line 200 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
		size = _tmp33_;
#line 201 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
		_tmp34_ = size;
#line 201 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
		_tmp35_ = _tmp34_.x;
#line 201 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
		_tmp36_ = MAX ((gdouble) 0, _tmp35_ / 2);
#line 201 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
		self->priv->radius_x = _tmp36_;
#line 202 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
		_tmp37_ = size;
#line 202 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
		_tmp38_ = _tmp37_.y;
#line 202 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
		_tmp39_ = MAX ((gdouble) 0, _tmp38_ / 2);
#line 202 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
		self->priv->radius_y = _tmp39_;
#line 203 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
		_tmp40_ = self->priv->radius_x;
#line 203 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
		_tmp41_ = self->priv->radius_y;
#line 203 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
		memset (&_tmp42_, 0, sizeof (Point));
#line 203 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
		_tmp42_.x = _tmp40_;
#line 203 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
		_tmp42_.y = _tmp41_;
#line 203 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
		_tmp43_ = self->priv->rotation;
#line 203 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
		point_rotate (&_tmp42_, _tmp43_, &_tmp44_);
#line 203 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
		_tmp45_ = self->priv->topleft_save;
#line 203 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
		point_move (&_tmp44_, &_tmp45_, &_tmp46_);
#line 203 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
		self->priv->centre = _tmp46_;
#line 1784 "arc.c"
	} else {
		gint _tmp47_ = 0;
#line 205 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
		_tmp47_ = ((Seed*) self)->selected_control;
#line 205 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
		if (_tmp47_ == 1) {
#line 1791 "arc.c"
			Point _tmp48_ = {0};
			gdouble _tmp49_ = 0.0;
			Point _tmp50_ = {0};
			gdouble _tmp51_ = 0.0;
			Point _tmp52_ = {0};
			gdouble _tmp53_ = 0.0;
			Point _tmp54_ = {0};
			gdouble _tmp55_ = 0.0;
			gdouble _tmp56_ = 0.0;
			gdouble _tmp57_ = 0.0;
			gdouble _tmp58_ = 0.0;
			gdouble _tmp59_ = 0.0;
			gboolean _tmp60_ = FALSE;
#line 207 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
			_tmp48_ = *p;
#line 207 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
			_tmp49_ = _tmp48_.y;
#line 207 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
			_tmp50_ = self->priv->centre;
#line 207 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
			_tmp51_ = _tmp50_.y;
#line 207 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
			_tmp52_ = *p;
#line 207 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
			_tmp53_ = _tmp52_.x;
#line 207 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
			_tmp54_ = self->priv->centre;
#line 207 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
			_tmp55_ = _tmp54_.x;
#line 207 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
			_tmp56_ = atan2 (_tmp49_ - _tmp51_, _tmp53_ - _tmp55_);
#line 207 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
			_tmp57_ = self->priv->radius_y;
#line 207 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
			_tmp58_ = self->priv->radius_x;
#line 207 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
			_tmp59_ = atan2 (_tmp57_, _tmp58_);
#line 207 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
			arc_set_rotation (self, _tmp56_ + _tmp59_);
#line 208 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
			_tmp60_ = snap_on;
#line 208 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
			if (_tmp60_) {
#line 1835 "arc.c"
				gdouble _tmp61_ = 0.0;
				gdouble _tmp62_ = 0.0;
				gdouble _tmp63_ = 0.0;
				gdouble _tmp64_ = 0.0;
#line 208 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
				_tmp61_ = self->priv->rotation;
#line 208 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
				_tmp62_ = snap_angle;
#line 208 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
				_tmp63_ = round (_tmp61_ / _tmp62_);
#line 208 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
				_tmp64_ = snap_angle;
#line 208 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
				self->priv->rotation = _tmp63_ * _tmp64_;
#line 1850 "arc.c"
			}
		} else {
			gint _tmp65_ = 0;
#line 210 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
			_tmp65_ = ((Seed*) self)->selected_control;
#line 210 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
			if (_tmp65_ == 2) {
#line 1858 "arc.c"
				gboolean _tmp66_ = FALSE;
				gboolean _tmp67_ = FALSE;
				gboolean _tmp72_ = FALSE;
#line 211 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
				_tmp67_ = snap_on;
#line 211 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
				if (_tmp67_) {
#line 1866 "arc.c"
					Point _tmp68_ = {0};
					Point _tmp69_ = {0};
					gdouble _tmp70_ = 0.0;
					gboolean _tmp71_ = FALSE;
#line 211 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
					_tmp68_ = *p;
#line 211 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
					seed_point ((Seed*) self, (gdouble) 1, &_tmp69_);
#line 211 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
					_tmp70_ = scale;
#line 211 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
					_tmp71_ = seed_within_snap_range ((Seed*) self, &_tmp68_, &_tmp69_, _tmp70_);
#line 211 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
					_tmp66_ = _tmp71_;
#line 1881 "arc.c"
				} else {
#line 211 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
					_tmp66_ = FALSE;
#line 1885 "arc.c"
				}
#line 211 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
				_tmp72_ = _tmp66_;
#line 211 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
				if (_tmp72_) {
#line 1891 "arc.c"
					gdouble _tmp73_ = 0.0;
					gdouble _tmp74_ = 0.0;
#line 213 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
					_tmp73_ = self->priv->angle1;
#line 213 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
					self->priv->angle0 = _tmp73_;
#line 214 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
					_tmp74_ = self->priv->angle1;
#line 214 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
					self->priv->angle1 = _tmp74_ + (2 * G_PI);
#line 1902 "arc.c"
				} else {
					gdouble _tmp75_ = 0.0;
					gdouble _tmp76_ = 0.0;
					gdouble _tmp77_ = 0.0;
					gdouble _tmp78_ = 0.0;
					gdouble _tmp79_ = 0.0;
					gboolean _tmp80_ = FALSE;
#line 218 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
					_tmp75_ = self->priv->radius_x;
#line 218 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
					_tmp76_ = ry;
#line 218 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
					_tmp77_ = self->priv->radius_y;
#line 218 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
					_tmp78_ = rx;
#line 218 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
					_tmp79_ = atan2 (_tmp75_ * _tmp76_, _tmp77_ * _tmp78_);
#line 218 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
					self->priv->angle0 = _tmp79_;
#line 219 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
					_tmp80_ = snap_on;
#line 219 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
					if (_tmp80_) {
#line 1926 "arc.c"
						gdouble _tmp81_ = 0.0;
						gdouble _tmp82_ = 0.0;
						gdouble _tmp83_ = 0.0;
						gdouble _tmp84_ = 0.0;
#line 219 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
						_tmp81_ = self->priv->angle0;
#line 219 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
						_tmp82_ = snap_angle;
#line 219 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
						_tmp83_ = round (_tmp81_ / _tmp82_);
#line 219 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
						_tmp84_ = snap_angle;
#line 219 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
						self->priv->angle0 = _tmp83_ * _tmp84_;
#line 1941 "arc.c"
					}
#line 220 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
					arc_normalize_angles (self);
#line 1945 "arc.c"
				}
			} else {
				gint _tmp85_ = 0;
#line 223 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
				_tmp85_ = ((Seed*) self)->selected_control;
#line 223 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
				if (_tmp85_ == 3) {
#line 1953 "arc.c"
					gboolean _tmp86_ = FALSE;
					gboolean _tmp87_ = FALSE;
					gboolean _tmp92_ = FALSE;
#line 224 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
					_tmp87_ = snap_on;
#line 224 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
					if (_tmp87_) {
#line 1961 "arc.c"
						Point _tmp88_ = {0};
						Point _tmp89_ = {0};
						gdouble _tmp90_ = 0.0;
						gboolean _tmp91_ = FALSE;
#line 224 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
						_tmp88_ = *p;
#line 224 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
						seed_point ((Seed*) self, (gdouble) 0, &_tmp89_);
#line 224 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
						_tmp90_ = scale;
#line 224 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
						_tmp91_ = seed_within_snap_range ((Seed*) self, &_tmp88_, &_tmp89_, _tmp90_);
#line 224 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
						_tmp86_ = _tmp91_;
#line 1976 "arc.c"
					} else {
#line 224 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
						_tmp86_ = FALSE;
#line 1980 "arc.c"
					}
#line 224 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
					_tmp92_ = _tmp86_;
#line 224 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
					if (_tmp92_) {
#line 1986 "arc.c"
						gdouble _tmp93_ = 0.0;
#line 226 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
						_tmp93_ = self->priv->angle0;
#line 226 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
						self->priv->angle1 = _tmp93_ + (2 * G_PI);
#line 1992 "arc.c"
					} else {
						gdouble _tmp94_ = 0.0;
						gdouble _tmp95_ = 0.0;
						gdouble _tmp96_ = 0.0;
						gdouble _tmp97_ = 0.0;
						gdouble _tmp98_ = 0.0;
						gboolean _tmp99_ = FALSE;
#line 230 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
						_tmp94_ = self->priv->radius_x;
#line 230 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
						_tmp95_ = ry;
#line 230 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
						_tmp96_ = self->priv->radius_y;
#line 230 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
						_tmp97_ = rx;
#line 230 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
						_tmp98_ = atan2 (_tmp94_ * _tmp95_, _tmp96_ * _tmp97_);
#line 230 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
						self->priv->angle1 = _tmp98_;
#line 231 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
						_tmp99_ = snap_on;
#line 231 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
						if (_tmp99_) {
#line 2016 "arc.c"
							gdouble _tmp100_ = 0.0;
							gdouble _tmp101_ = 0.0;
							gdouble _tmp102_ = 0.0;
							gdouble _tmp103_ = 0.0;
#line 231 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
							_tmp100_ = self->priv->angle1;
#line 231 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
							_tmp101_ = snap_angle;
#line 231 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
							_tmp102_ = round (_tmp100_ / _tmp101_);
#line 231 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
							_tmp103_ = snap_angle;
#line 231 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
							self->priv->angle1 = _tmp102_ * _tmp103_;
#line 2031 "arc.c"
						}
#line 232 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
						arc_normalize_angles (self);
#line 2035 "arc.c"
					}
				} else {
#line 235 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
					g_assert_not_reached ();
#line 2040 "arc.c"
				}
			}
		}
	}
}


static void arc_real_move_shape (Seed* base, gdouble delta_x, gdouble delta_y) {
	Arc * self;
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	Point _tmp2_ = {0};
#line 238 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	self = (Arc*) base;
#line 239 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp0_ = delta_x;
#line 239 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp1_ = delta_y;
#line 239 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	point_move_xy (&self->priv->centre_save, _tmp0_, _tmp1_, &_tmp2_);
#line 239 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	self->priv->centre = _tmp2_;
#line 2063 "arc.c"
}


static Point* arc_real_points_to_snap (Seed* base, int* result_length1) {
	Arc * self;
	Point* result = NULL;
	Point _tmp0_ = {0};
	gdouble _tmp1_ = 0.0;
	Point _tmp2_ = {0};
	gdouble _tmp3_ = 0.0;
	Point _tmp4_ = {0};
	Point _tmp5_ = {0};
	Point _tmp6_ = {0};
	gdouble _tmp7_ = 0.0;
	Point _tmp8_ = {0};
	gdouble _tmp9_ = 0.0;
	Point _tmp10_ = {0};
	Point _tmp11_ = {0};
	Point _tmp12_ = {0};
	gdouble _tmp13_ = 0.0;
	Point _tmp14_ = {0};
	gdouble _tmp15_ = 0.0;
	Point _tmp16_ = {0};
	Point _tmp17_ = {0};
	Point _tmp18_ = {0};
	gdouble _tmp19_ = 0.0;
	Point _tmp20_ = {0};
	gdouble _tmp21_ = 0.0;
	Point _tmp22_ = {0};
	Point _tmp23_ = {0};
	Point _tmp24_ = {0};
	Point* _tmp25_ = NULL;
	Point* _tmp26_ = NULL;
	gint _tmp26__length1 = 0;
#line 242 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	self = (Arc*) base;
#line 243 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp0_ = self->priv->centre;
#line 243 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp1_ = self->priv->radius_x;
#line 243 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	memset (&_tmp2_, 0, sizeof (Point));
#line 243 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp2_.x = -_tmp1_;
#line 243 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp2_.y = (gdouble) 0;
#line 243 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp3_ = self->priv->rotation;
#line 243 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	point_rotate (&_tmp2_, _tmp3_, &_tmp4_);
#line 243 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp5_ = self->priv->centre;
#line 243 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	point_move (&_tmp4_, &_tmp5_, &_tmp6_);
#line 243 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp7_ = self->priv->radius_x;
#line 243 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	memset (&_tmp8_, 0, sizeof (Point));
#line 243 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp8_.x = _tmp7_;
#line 243 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp8_.y = (gdouble) 0;
#line 243 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp9_ = self->priv->rotation;
#line 243 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	point_rotate (&_tmp8_, _tmp9_, &_tmp10_);
#line 243 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp11_ = self->priv->centre;
#line 243 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	point_move (&_tmp10_, &_tmp11_, &_tmp12_);
#line 243 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp13_ = self->priv->radius_y;
#line 243 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	memset (&_tmp14_, 0, sizeof (Point));
#line 243 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp14_.x = (gdouble) 0;
#line 243 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp14_.y = -_tmp13_;
#line 243 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp15_ = self->priv->rotation;
#line 243 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	point_rotate (&_tmp14_, _tmp15_, &_tmp16_);
#line 243 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp17_ = self->priv->centre;
#line 243 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	point_move (&_tmp16_, &_tmp17_, &_tmp18_);
#line 243 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp19_ = self->priv->radius_y;
#line 243 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	memset (&_tmp20_, 0, sizeof (Point));
#line 243 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp20_.x = (gdouble) 0;
#line 243 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp20_.y = _tmp19_;
#line 243 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp21_ = self->priv->rotation;
#line 243 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	point_rotate (&_tmp20_, _tmp21_, &_tmp22_);
#line 243 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp23_ = self->priv->centre;
#line 243 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	point_move (&_tmp22_, &_tmp23_, &_tmp24_);
#line 243 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp25_ = g_new0 (Point, 5);
#line 243 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp25_[0] = _tmp0_;
#line 243 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp25_[1] = _tmp6_;
#line 243 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp25_[2] = _tmp12_;
#line 243 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp25_[3] = _tmp18_;
#line 243 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp25_[4] = _tmp24_;
#line 243 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp26_ = _tmp25_;
#line 243 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp26__length1 = 5;
#line 243 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	if (result_length1) {
#line 243 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
		*result_length1 = _tmp26__length1;
#line 2186 "arc.c"
	}
#line 243 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	result = _tmp26_;
#line 243 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	return result;
#line 2192 "arc.c"
}


static void arc_normalize_angles (Arc* self) {
	gdouble _tmp8_ = 0.0;
	gdouble _tmp9_ = 0.0;
#line 251 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	g_return_if_fail (self != NULL);
#line 252 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	while (TRUE) {
#line 2203 "arc.c"
		gdouble _tmp0_ = 0.0;
		gdouble _tmp1_ = 0.0;
#line 252 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
		_tmp0_ = self->priv->angle0;
#line 252 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
		if (!(_tmp0_ < ((gdouble) 0))) {
#line 252 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
			break;
#line 2212 "arc.c"
		}
#line 252 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
		_tmp1_ = self->priv->angle0;
#line 252 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
		self->priv->angle0 = _tmp1_ + (2 * G_PI);
#line 2218 "arc.c"
	}
#line 253 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	while (TRUE) {
#line 2222 "arc.c"
		gdouble _tmp2_ = 0.0;
		gdouble _tmp3_ = 0.0;
#line 253 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
		_tmp2_ = self->priv->angle0;
#line 253 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
		if (!(_tmp2_ > (2 * G_PI))) {
#line 253 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
			break;
#line 2231 "arc.c"
		}
#line 253 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
		_tmp3_ = self->priv->angle0;
#line 253 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
		self->priv->angle0 = _tmp3_ - (2 * G_PI);
#line 2237 "arc.c"
	}
#line 254 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	while (TRUE) {
#line 2241 "arc.c"
		gdouble _tmp4_ = 0.0;
		gdouble _tmp5_ = 0.0;
#line 254 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
		_tmp4_ = self->priv->angle1;
#line 254 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
		if (!(_tmp4_ < ((gdouble) 0))) {
#line 254 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
			break;
#line 2250 "arc.c"
		}
#line 254 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
		_tmp5_ = self->priv->angle1;
#line 254 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
		self->priv->angle1 = _tmp5_ + (2 * G_PI);
#line 2256 "arc.c"
	}
#line 255 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	while (TRUE) {
#line 2260 "arc.c"
		gdouble _tmp6_ = 0.0;
		gdouble _tmp7_ = 0.0;
#line 255 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
		_tmp6_ = self->priv->angle1;
#line 255 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
		if (!(_tmp6_ > (2 * G_PI))) {
#line 255 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
			break;
#line 2269 "arc.c"
		}
#line 255 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
		_tmp7_ = self->priv->angle1;
#line 255 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
		self->priv->angle1 = _tmp7_ - (2 * G_PI);
#line 2275 "arc.c"
	}
#line 257 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp8_ = self->priv->angle0;
#line 257 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp9_ = self->priv->angle1;
#line 257 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	if (_tmp8_ > _tmp9_) {
#line 2283 "arc.c"
		gdouble _tmp10_ = 0.0;
#line 257 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
		_tmp10_ = self->priv->angle1;
#line 257 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
		self->priv->angle1 = _tmp10_ + (2 * G_PI);
#line 2289 "arc.c"
	}
}


static void arc_real_draw_icon (Seed* base, cairo_t* cr, gdouble width, gdouble height) {
	Arc * self;
	gdouble* args = NULL;
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	gdouble* _tmp4_ = NULL;
	gint args_length1 = 0;
	gint _args_size_ = 0;
	cairo_t* _tmp5_ = NULL;
#line 260 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	self = (Arc*) base;
#line 260 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	g_return_if_fail (cr != NULL);
#line 261 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp0_ = width;
#line 261 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp1_ = height;
#line 261 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp2_ = width;
#line 261 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp3_ = height;
#line 261 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp4_ = g_new0 (gdouble, 7);
#line 261 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp4_[0] = _tmp0_ / 2;
#line 261 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp4_[1] = _tmp1_ / 2;
#line 261 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp4_[2] = _tmp2_ / 2.3;
#line 261 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp4_[3] = _tmp3_ / 2.3;
#line 261 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp4_[4] = (gdouble) 0;
#line 261 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp4_[5] = 1.4 * G_PI;
#line 261 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp4_[6] = (gdouble) 0;
#line 261 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	args = _tmp4_;
#line 261 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	args_length1 = 7;
#line 261 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_args_size_ = args_length1;
#line 262 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	seed_init_full ((Seed*) self, args, args_length1);
#line 263 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	_tmp5_ = cr;
#line 263 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	seed_draw_direct ((Seed*) self, _tmp5_, (gdouble) 1);
#line 260 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	args = (g_free (args), NULL);
#line 2347 "arc.c"
}


Arc* arc_construct (GType object_type) {
	Arc * self = NULL;
#line 19 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	self = (Arc*) seed_construct (object_type);
#line 19 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	return self;
#line 2357 "arc.c"
}


Arc* arc_new (void) {
#line 19 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	return arc_construct (TYPE_ARC);
#line 2364 "arc.c"
}


static void arc_class_init (ArcClass * klass) {
#line 19 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	arc_parent_class = g_type_class_peek_parent (klass);
#line 19 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	g_type_class_add_private (klass, sizeof (ArcPrivate));
#line 19 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	SEED_CLASS (klass)->init_default_sub = arc_real_init_default_sub;
#line 19 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	SEED_CLASS (klass)->init_full_sub = arc_real_init_full_sub;
#line 19 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	SEED_CLASS (klass)->serialize_sub = arc_real_serialize_sub;
#line 19 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	SEED_CLASS (klass)->init_distance_to_parametric = arc_real_init_distance_to_parametric;
#line 19 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	SEED_CLASS (klass)->point_raw = arc_real_point_raw;
#line 19 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	SEED_CLASS (klass)->distant_point = arc_real_distant_point;
#line 19 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	SEED_CLASS (klass)->draw_direct = arc_real_draw_direct;
#line 19 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	SEED_CLASS (klass)->draw_controls = arc_real_draw_controls;
#line 19 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	SEED_CLASS (klass)->pressed_control = arc_real_pressed_control;
#line 19 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	SEED_CLASS (klass)->save_drag_context = arc_real_save_drag_context;
#line 19 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	SEED_CLASS (klass)->drag_control = arc_real_drag_control;
#line 19 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	SEED_CLASS (klass)->move_shape = arc_real_move_shape;
#line 19 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	SEED_CLASS (klass)->points_to_snap = arc_real_points_to_snap;
#line 19 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	SEED_CLASS (klass)->draw_icon = arc_real_draw_icon;
#line 19 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	G_OBJECT_CLASS (klass)->finalize = arc_finalize;
#line 2403 "arc.c"
}


static void arc_instance_init (Arc * self) {
#line 19 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	self->priv = ARC_GET_PRIVATE (self);
#line 2410 "arc.c"
}


static void arc_finalize (GObject* obj) {
	Arc * self;
#line 19 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_ARC, Arc);
#line 19 "/home/jaidi/project/mutiara/mutiara-code/src/arc.vala"
	G_OBJECT_CLASS (arc_parent_class)->finalize (obj);
#line 2420 "arc.c"
}


GType arc_get_type (void) {
	static volatile gsize arc_type_id__volatile = 0;
	if (g_once_init_enter (&arc_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ArcClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) arc_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Arc), 0, (GInstanceInitFunc) arc_instance_init, NULL };
		GType arc_type_id;
		arc_type_id = g_type_register_static (TYPE_SEED, "Arc", &g_define_type_info, 0);
		g_once_init_leave (&arc_type_id__volatile, arc_type_id);
	}
	return arc_type_id__volatile;
}



