/* border.c generated by valac 0.22.0, the Vala compiler
 * generated from border.vala, do not modify */

/*  Mutiara motif designer.
Copyright (C) 2011  Nor Jaidi Tuah

This file is part of Mutiara.

Mutiara is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>
#include <gee.h>


#define TYPE_POD (pod_get_type ())
#define POD(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_POD, Pod))
#define POD_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_POD, PodClass))
#define IS_POD(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_POD))
#define IS_POD_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_POD))
#define POD_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_POD, PodClass))

typedef struct _Pod Pod;
typedef struct _PodClass PodClass;
typedef struct _PodPrivate PodPrivate;

#define TYPE_POINT (point_get_type ())
typedef struct _Point Point;

#define TYPE_SEED (seed_get_type ())
#define SEED(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SEED, Seed))
#define SEED_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SEED, SeedClass))
#define IS_SEED(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SEED))
#define IS_SEED_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SEED))
#define SEED_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SEED, SeedClass))

typedef struct _Seed Seed;
typedef struct _SeedClass SeedClass;

#define TYPE_FLIP (flip_get_type ())

#define TYPE_TWEAK (tweak_get_type ())
typedef struct _Tweak Tweak;

#define TYPE_BORDER (border_get_type ())
#define BORDER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BORDER, Border))
#define BORDER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BORDER, BorderClass))
#define IS_BORDER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BORDER))
#define IS_BORDER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BORDER))
#define BORDER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BORDER, BorderClass))

typedef struct _Border Border;
typedef struct _BorderClass BorderClass;
typedef struct _BorderPrivate BorderPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _Point {
	gdouble x;
	gdouble y;
};

typedef enum  {
	FLIP_NONE = 0,
	FLIP_Y = 1,
	FLIP_X = 2,
	FLIP_XY = 3
} Flip;

struct _Tweak {
	gdouble scale_x;
	gdouble scale_y;
	gdouble rotate;
	gdouble move_x;
	gdouble move_y;
};

struct _Pod {
	GObject parent_instance;
	PodPrivate * priv;
	gboolean test;
	Flip flip_even;
	Flip flip_odd;
	Tweak tweak;
	gint level_of_detail;
};

struct _PodClass {
	GObjectClass parent_class;
	gchar* (*serialize_aux) (Pod* self);
	void (*compile) (Pod* self, const gchar* s);
	Seed* (*add_seed_at_point) (Pod* self, GType type, Point* p);
	void (*remove) (Pod* self, Seed* seed);
	void (*add) (Pod* self, Seed* seed);
	void (*clear) (Pod* self);
	void (*swap) (Pod* self, gint i, gint j);
};

struct _Border {
	Pod parent_instance;
	BorderPrivate * priv;
	GeeArrayList* motifs;
	Pod* default_motif;
};

struct _BorderClass {
	PodClass parent_class;
};


static gpointer border_parent_class = NULL;

GType pod_get_type (void) G_GNUC_CONST;
GType point_get_type (void) G_GNUC_CONST;
Point* point_dup (const Point* self);
void point_free (Point* self);
GType seed_get_type (void) G_GNUC_CONST;
GType flip_get_type (void) G_GNUC_CONST;
GType tweak_get_type (void) G_GNUC_CONST;
Tweak* tweak_dup (const Tweak* self);
void tweak_free (Tweak* self);
GType border_get_type (void) G_GNUC_CONST;
enum  {
	BORDER_DUMMY_PROPERTY
};
Border* border_new (Pod* motif);
Border* border_construct (GType object_type, Pod* motif);
Pod* pod_new (void);
Pod* pod_construct (GType object_type);
static gchar* border_real_serialize_aux (Pod* base);
gchar* pod_serialize_aux (Pod* self);
gint pod_search (GeeArrayList* pods, Pod* pod);
gint pod_get_size (Pod* self);
Seed* pod_get (Pod* self, gint n);
gchar* seed_serialize (Seed* self, gboolean for_border);
static void border_real_compile (Pod* base, const gchar* s);
void pod_compile (Pod* self, const gchar* s);
static Seed* border_real_add_seed_at_point (Pod* base, GType type, Point* p);
Seed* pod_add_seed_at_point (Pod* self, GType type, Point* p);
Pod* border_get_motif (Border* self, gint n);
static void border_real_remove (Pod* base, Seed* seed);
gint pod_index_of (Pod* self, Seed* seed);
void pod_remove (Pod* self, Seed* seed);
static void border_real_add (Pod* base, Seed* seed);
void pod_add (Pod* self, Seed* seed);
static void border_real_clear (Pod* base);
void pod_clear (Pod* self);
static void border_real_swap (Pod* base, gint i, gint j);
void pod_swap (Pod* self, gint i, gint j);
static void border_finalize (GObject* obj);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);


static gpointer _g_object_ref0 (gpointer self) {
#line 30 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	return self ? g_object_ref (self) : NULL;
#line 177 "border.c"
}


Border* border_construct (GType object_type, Pod* motif) {
	Border * self = NULL;
	Pod* _tmp0_ = NULL;
	Pod* _tmp1_ = NULL;
#line 28 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	g_return_val_if_fail (motif != NULL, NULL);
#line 29 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	self = (Border*) pod_construct (object_type);
#line 30 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	_tmp0_ = motif;
#line 30 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 30 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	_g_object_unref0 (self->default_motif);
#line 30 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	self->default_motif = _tmp1_;
#line 28 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	return self;
#line 199 "border.c"
}


Border* border_new (Pod* motif) {
#line 28 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	return border_construct (TYPE_BORDER, motif);
#line 206 "border.c"
}


static gchar* border_real_serialize_aux (Pod* base) {
	Border * self;
	gchar* result = NULL;
	gchar* s = NULL;
	gchar* _tmp0_ = NULL;
	GeeArrayList* unique_list = NULL;
	GeeArrayList* _tmp1_ = NULL;
	GeeArrayList* _tmp2_ = NULL;
	Pod* _tmp3_ = NULL;
	const gchar* _tmp4_ = NULL;
	Pod* _tmp5_ = NULL;
	gchar* _tmp6_ = NULL;
	gchar* _tmp7_ = NULL;
	gchar* _tmp8_ = NULL;
	gchar* _tmp9_ = NULL;
	gchar* _tmp10_ = NULL;
	const gchar* _tmp34_ = NULL;
	gchar* _tmp35_ = NULL;
	const gchar* _tmp51_ = NULL;
	gchar* _tmp52_ = NULL;
#line 33 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	self = (Border*) base;
#line 34 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	_tmp0_ = g_strdup ("");
#line 34 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	s = _tmp0_;
#line 36 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	_tmp1_ = gee_array_list_new (TYPE_POD, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
#line 36 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	unique_list = _tmp1_;
#line 37 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	_tmp2_ = unique_list;
#line 37 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	_tmp3_ = self->default_motif;
#line 37 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp2_, _tmp3_);
#line 38 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	_tmp4_ = s;
#line 38 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	_tmp5_ = self->default_motif;
#line 38 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	_tmp6_ = pod_serialize_aux (_tmp5_);
#line 38 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	_tmp7_ = _tmp6_;
#line 38 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	_tmp8_ = g_strconcat ("\nMotif\n", _tmp7_, NULL);
#line 38 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	_tmp9_ = _tmp8_;
#line 38 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	_tmp10_ = g_strconcat (_tmp4_, _tmp9_, NULL);
#line 38 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	_g_free0 (s);
#line 38 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	s = _tmp10_;
#line 38 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	_g_free0 (_tmp9_);
#line 38 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	_g_free0 (_tmp7_);
#line 268 "border.c"
	{
		GeeArrayList* _motif_list = NULL;
		GeeArrayList* _tmp11_ = NULL;
		GeeArrayList* _tmp12_ = NULL;
		gint _motif_size = 0;
		GeeArrayList* _tmp13_ = NULL;
		gint _tmp14_ = 0;
		gint _tmp15_ = 0;
		gint _motif_index = 0;
#line 39 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
		_tmp11_ = self->motifs;
#line 39 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
		_tmp12_ = _g_object_ref0 (_tmp11_);
#line 39 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
		_motif_list = _tmp12_;
#line 39 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
		_tmp13_ = _motif_list;
#line 39 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
		_tmp14_ = gee_abstract_collection_get_size ((GeeCollection*) _tmp13_);
#line 39 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
		_tmp15_ = _tmp14_;
#line 39 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
		_motif_size = _tmp15_;
#line 39 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
		_motif_index = -1;
#line 39 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
		while (TRUE) {
#line 296 "border.c"
			gint _tmp16_ = 0;
			gint _tmp17_ = 0;
			gint _tmp18_ = 0;
			Pod* motif = NULL;
			GeeArrayList* _tmp19_ = NULL;
			gint _tmp20_ = 0;
			gpointer _tmp21_ = NULL;
			GeeArrayList* _tmp22_ = NULL;
			Pod* _tmp23_ = NULL;
			gint _tmp24_ = 0;
#line 39 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
			_tmp16_ = _motif_index;
#line 39 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
			_motif_index = _tmp16_ + 1;
#line 39 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
			_tmp17_ = _motif_index;
#line 39 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
			_tmp18_ = _motif_size;
#line 39 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
			if (!(_tmp17_ < _tmp18_)) {
#line 39 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
				break;
#line 319 "border.c"
			}
#line 39 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
			_tmp19_ = _motif_list;
#line 39 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
			_tmp20_ = _motif_index;
#line 39 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
			_tmp21_ = gee_abstract_list_get ((GeeAbstractList*) _tmp19_, _tmp20_);
#line 39 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
			motif = (Pod*) _tmp21_;
#line 40 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
			_tmp22_ = unique_list;
#line 40 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
			_tmp23_ = motif;
#line 40 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
			_tmp24_ = pod_search (_tmp22_, _tmp23_);
#line 40 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
			if (_tmp24_ == (-1)) {
#line 337 "border.c"
				GeeArrayList* _tmp25_ = NULL;
				Pod* _tmp26_ = NULL;
				const gchar* _tmp27_ = NULL;
				Pod* _tmp28_ = NULL;
				gchar* _tmp29_ = NULL;
				gchar* _tmp30_ = NULL;
				gchar* _tmp31_ = NULL;
				gchar* _tmp32_ = NULL;
				gchar* _tmp33_ = NULL;
#line 41 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
				_tmp25_ = unique_list;
#line 41 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
				_tmp26_ = motif;
#line 41 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp25_, _tmp26_);
#line 42 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
				_tmp27_ = s;
#line 42 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
				_tmp28_ = motif;
#line 42 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
				_tmp29_ = pod_serialize_aux (_tmp28_);
#line 42 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
				_tmp30_ = _tmp29_;
#line 42 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
				_tmp31_ = g_strconcat ("\nMotif\n", _tmp30_, NULL);
#line 42 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
				_tmp32_ = _tmp31_;
#line 42 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
				_tmp33_ = g_strconcat (_tmp27_, _tmp32_, NULL);
#line 42 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
				_g_free0 (s);
#line 42 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
				s = _tmp33_;
#line 42 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
				_g_free0 (_tmp32_);
#line 42 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
				_g_free0 (_tmp30_);
#line 375 "border.c"
			}
#line 39 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
			_g_object_unref0 (motif);
#line 379 "border.c"
		}
#line 39 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
		_g_object_unref0 (_motif_list);
#line 383 "border.c"
	}
#line 46 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	_tmp34_ = s;
#line 46 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	_tmp35_ = g_strconcat (_tmp34_, "\nBorder\n", NULL);
#line 46 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	_g_free0 (s);
#line 46 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	s = _tmp35_;
#line 393 "border.c"
	{
		Border* _seed_list = NULL;
		Border* _tmp36_ = NULL;
		gint _seed_size = 0;
		Border* _tmp37_ = NULL;
		gint _tmp38_ = 0;
		gint _tmp39_ = 0;
		gint _seed_index = 0;
#line 47 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
		_tmp36_ = _g_object_ref0 (self);
#line 47 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
		_seed_list = _tmp36_;
#line 47 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
		_tmp37_ = _seed_list;
#line 47 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
		_tmp38_ = pod_get_size ((Pod*) _tmp37_);
#line 47 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
		_tmp39_ = _tmp38_;
#line 47 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
		_seed_size = _tmp39_;
#line 47 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
		_seed_index = -1;
#line 47 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
		while (TRUE) {
#line 418 "border.c"
			gint _tmp40_ = 0;
			gint _tmp41_ = 0;
			gint _tmp42_ = 0;
			Seed* seed = NULL;
			Border* _tmp43_ = NULL;
			gint _tmp44_ = 0;
			Seed* _tmp45_ = NULL;
			const gchar* _tmp46_ = NULL;
			Seed* _tmp47_ = NULL;
			gchar* _tmp48_ = NULL;
			gchar* _tmp49_ = NULL;
			gchar* _tmp50_ = NULL;
#line 47 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
			_tmp40_ = _seed_index;
#line 47 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
			_seed_index = _tmp40_ + 1;
#line 47 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
			_tmp41_ = _seed_index;
#line 47 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
			_tmp42_ = _seed_size;
#line 47 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
			if (!(_tmp41_ < _tmp42_)) {
#line 47 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
				break;
#line 443 "border.c"
			}
#line 47 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
			_tmp43_ = _seed_list;
#line 47 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
			_tmp44_ = _seed_index;
#line 47 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
			_tmp45_ = pod_get ((Pod*) _tmp43_, _tmp44_);
#line 47 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
			seed = _tmp45_;
#line 47 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
			_tmp46_ = s;
#line 47 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
			_tmp47_ = seed;
#line 47 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
			_tmp48_ = seed_serialize (_tmp47_, TRUE);
#line 47 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
			_tmp49_ = _tmp48_;
#line 47 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
			_tmp50_ = g_strconcat (_tmp46_, _tmp49_, NULL);
#line 47 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
			_g_free0 (s);
#line 47 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
			s = _tmp50_;
#line 47 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
			_g_free0 (_tmp49_);
#line 47 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
			_g_object_unref0 (seed);
#line 471 "border.c"
		}
#line 47 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
		_g_object_unref0 (_seed_list);
#line 475 "border.c"
	}
#line 48 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	_tmp51_ = s;
#line 48 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	_tmp52_ = g_strconcat (_tmp51_, "\nMotifs", NULL);
#line 48 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	_g_free0 (s);
#line 48 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	s = _tmp52_;
#line 485 "border.c"
	{
		GeeArrayList* _motif_list = NULL;
		GeeArrayList* _tmp53_ = NULL;
		GeeArrayList* _tmp54_ = NULL;
		gint _motif_size = 0;
		GeeArrayList* _tmp55_ = NULL;
		gint _tmp56_ = 0;
		gint _tmp57_ = 0;
		gint _motif_index = 0;
#line 49 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
		_tmp53_ = self->motifs;
#line 49 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
		_tmp54_ = _g_object_ref0 (_tmp53_);
#line 49 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
		_motif_list = _tmp54_;
#line 49 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
		_tmp55_ = _motif_list;
#line 49 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
		_tmp56_ = gee_abstract_collection_get_size ((GeeCollection*) _tmp55_);
#line 49 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
		_tmp57_ = _tmp56_;
#line 49 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
		_motif_size = _tmp57_;
#line 49 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
		_motif_index = -1;
#line 49 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
		while (TRUE) {
#line 513 "border.c"
			gint _tmp58_ = 0;
			gint _tmp59_ = 0;
			gint _tmp60_ = 0;
			Pod* motif = NULL;
			GeeArrayList* _tmp61_ = NULL;
			gint _tmp62_ = 0;
			gpointer _tmp63_ = NULL;
			const gchar* _tmp64_ = NULL;
			GeeArrayList* _tmp65_ = NULL;
			Pod* _tmp66_ = NULL;
			gint _tmp67_ = 0;
			gchar* _tmp68_ = NULL;
			gchar* _tmp69_ = NULL;
			gchar* _tmp70_ = NULL;
#line 49 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
			_tmp58_ = _motif_index;
#line 49 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
			_motif_index = _tmp58_ + 1;
#line 49 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
			_tmp59_ = _motif_index;
#line 49 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
			_tmp60_ = _motif_size;
#line 49 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
			if (!(_tmp59_ < _tmp60_)) {
#line 49 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
				break;
#line 540 "border.c"
			}
#line 49 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
			_tmp61_ = _motif_list;
#line 49 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
			_tmp62_ = _motif_index;
#line 49 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
			_tmp63_ = gee_abstract_list_get ((GeeAbstractList*) _tmp61_, _tmp62_);
#line 49 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
			motif = (Pod*) _tmp63_;
#line 50 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
			_tmp64_ = s;
#line 50 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
			_tmp65_ = unique_list;
#line 50 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
			_tmp66_ = motif;
#line 50 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
			_tmp67_ = pod_search (_tmp65_, _tmp66_);
#line 50 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
			_tmp68_ = g_strdup_printf (" %d", _tmp67_);
#line 50 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
			_tmp69_ = _tmp68_;
#line 50 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
			_tmp70_ = g_strconcat (_tmp64_, _tmp69_, NULL);
#line 50 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
			_g_free0 (s);
#line 50 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
			s = _tmp70_;
#line 50 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
			_g_free0 (_tmp69_);
#line 49 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
			_g_object_unref0 (motif);
#line 572 "border.c"
		}
#line 49 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
		_g_object_unref0 (_motif_list);
#line 576 "border.c"
	}
#line 52 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	result = s;
#line 52 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	_g_object_unref0 (unique_list);
#line 52 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	return result;
#line 584 "border.c"
}


static gchar* string_strip (const gchar* self) {
	gchar* result = NULL;
	gchar* _result_ = NULL;
	gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
#line 1084 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1085 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1085 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1086 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1086 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	g_strstrip (_tmp1_);
#line 1087 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	result = _result_;
#line 1087 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	return result;
#line 607 "border.c"
}


static void border_real_compile (Pod* base, const gchar* s) {
	Border * self;
	gchar** ss = NULL;
	const gchar* _tmp0_ = NULL;
	gchar** _tmp1_ = NULL;
	gchar** _tmp2_ = NULL;
	gint ss_length1 = 0;
	gint _ss_size_ = 0;
	gchar** _tmp3_ = NULL;
	gint _tmp3__length1 = 0;
	GeeArrayList* unique_list = NULL;
	GeeArrayList* _tmp4_ = NULL;
	gchar** ms = NULL;
	gchar** _tmp5_ = NULL;
	gint _tmp5__length1 = 0;
	const gchar* _tmp6_ = NULL;
	gchar** _tmp7_ = NULL;
	gchar** _tmp8_ = NULL;
	gint ms_length1 = 0;
	gint _ms_size_ = 0;
	gchar** _tmp9_ = NULL;
	gint _tmp9__length1 = 0;
	GeeArrayList* _tmp22_ = NULL;
	gpointer _tmp23_ = NULL;
	gchar** bs = NULL;
	gchar** _tmp24_ = NULL;
	gint _tmp24__length1 = 0;
	const gchar* _tmp25_ = NULL;
	gchar** _tmp26_ = NULL;
	gchar** _tmp27_ = NULL;
	gint bs_length1 = 0;
	gint _bs_size_ = 0;
	gchar** _tmp28_ = NULL;
	gint _tmp28__length1 = 0;
	gchar** _tmp29_ = NULL;
	gint _tmp29__length1 = 0;
	const gchar* _tmp30_ = NULL;
	GeeArrayList* _tmp31_ = NULL;
	gchar** _tmp32_ = NULL;
	gint _tmp32__length1 = 0;
	const gchar* _tmp33_ = NULL;
	gchar* _tmp34_ = NULL;
	gchar* _tmp35_ = NULL;
	gchar** _tmp36_ = NULL;
	gchar** _tmp37_ = NULL;
	gchar** _tmp38_ = NULL;
	gint _tmp38__length1 = 0;
#line 55 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	self = (Border*) base;
#line 55 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	g_return_if_fail (s != NULL);
#line 57 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	_tmp0_ = s;
#line 57 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	_tmp2_ = _tmp1_ = g_strsplit (_tmp0_, "\nBorder\n", 0);
#line 57 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	ss = _tmp2_;
#line 57 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	ss_length1 = _vala_array_length (_tmp1_);
#line 57 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	_ss_size_ = ss_length1;
#line 58 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	_tmp3_ = ss;
#line 58 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	_tmp3__length1 = ss_length1;
#line 58 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	if (_tmp3__length1 < 2) {
#line 58 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
		ss = (_vala_array_free (ss, ss_length1, (GDestroyNotify) g_free), NULL);
#line 58 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
		return;
#line 682 "border.c"
	}
#line 59 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	_tmp4_ = gee_array_list_new (TYPE_POD, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
#line 59 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	unique_list = _tmp4_;
#line 61 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	_tmp5_ = ss;
#line 61 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	_tmp5__length1 = ss_length1;
#line 61 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	_tmp6_ = _tmp5_[0];
#line 61 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	_tmp8_ = _tmp7_ = g_strsplit (_tmp6_, "\nMotif\n", 0);
#line 61 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	ms = _tmp8_;
#line 61 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	ms_length1 = _vala_array_length (_tmp7_);
#line 61 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	_ms_size_ = ms_length1;
#line 62 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	_tmp9_ = ms;
#line 62 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	_tmp9__length1 = ms_length1;
#line 62 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	if (_tmp9__length1 < 2) {
#line 62 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
		ms = (_vala_array_free (ms, ms_length1, (GDestroyNotify) g_free), NULL);
#line 62 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
		_g_object_unref0 (unique_list);
#line 62 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
		ss = (_vala_array_free (ss, ss_length1, (GDestroyNotify) g_free), NULL);
#line 62 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
		return;
#line 716 "border.c"
	}
	{
		gint i = 0;
#line 63 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
		i = 1;
#line 722 "border.c"
		{
			gboolean _tmp10_ = FALSE;
#line 63 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
			_tmp10_ = TRUE;
#line 63 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
			while (TRUE) {
#line 729 "border.c"
				gboolean _tmp11_ = FALSE;
				gint _tmp13_ = 0;
				gchar** _tmp14_ = NULL;
				gint _tmp14__length1 = 0;
				Pod* motif = NULL;
				Pod* _tmp15_ = NULL;
				Pod* _tmp16_ = NULL;
				gchar** _tmp17_ = NULL;
				gint _tmp17__length1 = 0;
				gint _tmp18_ = 0;
				const gchar* _tmp19_ = NULL;
				GeeArrayList* _tmp20_ = NULL;
				Pod* _tmp21_ = NULL;
#line 63 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
				_tmp11_ = _tmp10_;
#line 63 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
				if (!_tmp11_) {
#line 747 "border.c"
					gint _tmp12_ = 0;
#line 63 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
					_tmp12_ = i;
#line 63 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
					i = _tmp12_ + 1;
#line 753 "border.c"
				}
#line 63 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
				_tmp10_ = FALSE;
#line 63 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
				_tmp13_ = i;
#line 63 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
				_tmp14_ = ms;
#line 63 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
				_tmp14__length1 = ms_length1;
#line 63 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
				if (!(_tmp13_ < _tmp14__length1)) {
#line 63 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
					break;
#line 767 "border.c"
				}
#line 64 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
				_tmp15_ = pod_new ();
#line 64 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
				motif = _tmp15_;
#line 65 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
				_tmp16_ = motif;
#line 65 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
				_tmp17_ = ms;
#line 65 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
				_tmp17__length1 = ms_length1;
#line 65 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
				_tmp18_ = i;
#line 65 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
				_tmp19_ = _tmp17_[_tmp18_];
#line 65 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
				pod_compile (_tmp16_, _tmp19_);
#line 66 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
				_tmp20_ = unique_list;
#line 66 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
				_tmp21_ = motif;
#line 66 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp20_, _tmp21_);
#line 63 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
				_g_object_unref0 (motif);
#line 793 "border.c"
			}
		}
	}
#line 68 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	_tmp22_ = unique_list;
#line 68 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	_tmp23_ = gee_abstract_list_get ((GeeAbstractList*) _tmp22_, 0);
#line 68 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	_g_object_unref0 (self->default_motif);
#line 68 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	self->default_motif = (Pod*) _tmp23_;
#line 70 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	_tmp24_ = ss;
#line 70 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	_tmp24__length1 = ss_length1;
#line 70 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	_tmp25_ = _tmp24_[1];
#line 70 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	_tmp27_ = _tmp26_ = g_strsplit (_tmp25_, "\nMotifs", 0);
#line 70 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	bs = _tmp27_;
#line 70 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	bs_length1 = _vala_array_length (_tmp26_);
#line 70 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	_bs_size_ = bs_length1;
#line 71 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	_tmp28_ = bs;
#line 71 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	_tmp28__length1 = bs_length1;
#line 71 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	if (_tmp28__length1 < 2) {
#line 71 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
		bs = (_vala_array_free (bs, bs_length1, (GDestroyNotify) g_free), NULL);
#line 71 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
		ms = (_vala_array_free (ms, ms_length1, (GDestroyNotify) g_free), NULL);
#line 71 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
		_g_object_unref0 (unique_list);
#line 71 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
		ss = (_vala_array_free (ss, ss_length1, (GDestroyNotify) g_free), NULL);
#line 71 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
		return;
#line 835 "border.c"
	}
#line 72 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	_tmp29_ = bs;
#line 72 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	_tmp29__length1 = bs_length1;
#line 72 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	_tmp30_ = _tmp29_[0];
#line 72 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	POD_CLASS (border_parent_class)->compile (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_POD, Pod), _tmp30_);
#line 74 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	_tmp31_ = self->motifs;
#line 74 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp31_);
#line 75 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	_tmp32_ = bs;
#line 75 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	_tmp32__length1 = bs_length1;
#line 75 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	_tmp33_ = _tmp32_[1];
#line 75 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	_tmp34_ = string_strip (_tmp33_);
#line 75 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	_tmp35_ = _tmp34_;
#line 75 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	_tmp37_ = _tmp36_ = g_strsplit (_tmp35_, " ", 0);
#line 75 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	_tmp38_ = _tmp37_;
#line 75 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	_tmp38__length1 = _vala_array_length (_tmp36_);
#line 75 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	_g_free0 (_tmp35_);
#line 867 "border.c"
	{
		gchar** idx_collection = NULL;
		gint idx_collection_length1 = 0;
		gint _idx_collection_size_ = 0;
		gint idx_it = 0;
#line 75 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
		idx_collection = _tmp38_;
#line 75 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
		idx_collection_length1 = _tmp38__length1;
#line 75 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
		for (idx_it = 0; idx_it < _tmp38__length1; idx_it = idx_it + 1) {
#line 879 "border.c"
			gchar* _tmp39_ = NULL;
			gchar* idx = NULL;
#line 75 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
			_tmp39_ = g_strdup (idx_collection[idx_it]);
#line 75 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
			idx = _tmp39_;
#line 886 "border.c"
			{
				gint n = 0;
				const gchar* _tmp40_ = NULL;
				gint _tmp41_ = 0;
				gboolean _tmp42_ = FALSE;
				gint _tmp43_ = 0;
				gboolean _tmp48_ = FALSE;
				GeeArrayList* _tmp49_ = NULL;
				GeeArrayList* _tmp50_ = NULL;
				gint _tmp51_ = 0;
				gpointer _tmp52_ = NULL;
				Pod* _tmp53_ = NULL;
				GeeArrayList* _tmp54_ = NULL;
				gint _tmp55_ = 0;
				gint _tmp56_ = 0;
				gint _tmp57_ = 0;
				gint _tmp58_ = 0;
#line 76 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
				_tmp40_ = idx;
#line 76 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
				_tmp41_ = atoi (_tmp40_);
#line 76 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
				n = _tmp41_;
#line 77 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
				_tmp43_ = n;
#line 77 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
				if (_tmp43_ < 0) {
#line 77 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
					_tmp42_ = TRUE;
#line 916 "border.c"
				} else {
					gint _tmp44_ = 0;
					GeeArrayList* _tmp45_ = NULL;
					gint _tmp46_ = 0;
					gint _tmp47_ = 0;
#line 77 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
					_tmp44_ = n;
#line 77 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
					_tmp45_ = unique_list;
#line 77 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
					_tmp46_ = gee_abstract_collection_get_size ((GeeCollection*) _tmp45_);
#line 77 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
					_tmp47_ = _tmp46_;
#line 77 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
					_tmp42_ = _tmp44_ >= _tmp47_;
#line 932 "border.c"
				}
#line 77 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
				_tmp48_ = _tmp42_;
#line 77 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
				if (_tmp48_) {
#line 77 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
					n = 0;
#line 940 "border.c"
				}
#line 78 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
				_tmp49_ = self->motifs;
#line 78 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
				_tmp50_ = unique_list;
#line 78 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
				_tmp51_ = n;
#line 78 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
				_tmp52_ = gee_abstract_list_get ((GeeAbstractList*) _tmp50_, _tmp51_);
#line 78 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
				_tmp53_ = (Pod*) _tmp52_;
#line 78 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp49_, _tmp53_);
#line 78 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
				_g_object_unref0 (_tmp53_);
#line 79 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
				_tmp54_ = self->motifs;
#line 79 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
				_tmp55_ = gee_abstract_collection_get_size ((GeeCollection*) _tmp54_);
#line 79 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
				_tmp56_ = _tmp55_;
#line 79 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
				_tmp57_ = pod_get_size ((Pod*) self);
#line 79 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
				_tmp58_ = _tmp57_;
#line 79 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
				if (_tmp56_ == _tmp58_) {
#line 79 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
					_g_free0 (idx);
#line 79 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
					idx_collection = (_vala_array_free (idx_collection, idx_collection_length1, (GDestroyNotify) g_free), NULL);
#line 79 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
					bs = (_vala_array_free (bs, bs_length1, (GDestroyNotify) g_free), NULL);
#line 79 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
					ms = (_vala_array_free (ms, ms_length1, (GDestroyNotify) g_free), NULL);
#line 79 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
					_g_object_unref0 (unique_list);
#line 79 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
					ss = (_vala_array_free (ss, ss_length1, (GDestroyNotify) g_free), NULL);
#line 79 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
					return;
#line 982 "border.c"
				}
#line 75 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
				_g_free0 (idx);
#line 986 "border.c"
			}
		}
#line 75 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
		idx_collection = (_vala_array_free (idx_collection, idx_collection_length1, (GDestroyNotify) g_free), NULL);
#line 991 "border.c"
	}
	{
		gint i = 0;
		GeeArrayList* _tmp59_ = NULL;
		gint _tmp60_ = 0;
		gint _tmp61_ = 0;
#line 82 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
		_tmp59_ = self->motifs;
#line 82 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
		_tmp60_ = gee_abstract_collection_get_size ((GeeCollection*) _tmp59_);
#line 82 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
		_tmp61_ = _tmp60_;
#line 82 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
		i = _tmp61_;
#line 1006 "border.c"
		{
			gboolean _tmp62_ = FALSE;
#line 82 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
			_tmp62_ = TRUE;
#line 82 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
			while (TRUE) {
#line 1013 "border.c"
				gboolean _tmp63_ = FALSE;
				gint _tmp65_ = 0;
				gint _tmp66_ = 0;
				gint _tmp67_ = 0;
				GeeArrayList* _tmp68_ = NULL;
				GeeArrayList* _tmp69_ = NULL;
				gpointer _tmp70_ = NULL;
				Pod* _tmp71_ = NULL;
#line 82 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
				_tmp63_ = _tmp62_;
#line 82 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
				if (!_tmp63_) {
#line 1026 "border.c"
					gint _tmp64_ = 0;
#line 82 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
					_tmp64_ = i;
#line 82 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
					i = _tmp64_ + 1;
#line 1032 "border.c"
				}
#line 82 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
				_tmp62_ = FALSE;
#line 82 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
				_tmp65_ = i;
#line 82 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
				_tmp66_ = pod_get_size ((Pod*) self);
#line 82 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
				_tmp67_ = _tmp66_;
#line 82 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
				if (!(_tmp65_ < _tmp67_)) {
#line 82 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
					break;
#line 1046 "border.c"
				}
#line 83 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
				_tmp68_ = self->motifs;
#line 83 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
				_tmp69_ = unique_list;
#line 83 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
				_tmp70_ = gee_abstract_list_get ((GeeAbstractList*) _tmp69_, 0);
#line 83 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
				_tmp71_ = (Pod*) _tmp70_;
#line 83 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp68_, _tmp71_);
#line 83 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
				_g_object_unref0 (_tmp71_);
#line 1060 "border.c"
			}
		}
	}
#line 55 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	bs = (_vala_array_free (bs, bs_length1, (GDestroyNotify) g_free), NULL);
#line 55 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	ms = (_vala_array_free (ms, ms_length1, (GDestroyNotify) g_free), NULL);
#line 55 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	_g_object_unref0 (unique_list);
#line 55 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	ss = (_vala_array_free (ss, ss_length1, (GDestroyNotify) g_free), NULL);
#line 1072 "border.c"
}


static Seed* border_real_add_seed_at_point (Pod* base, GType type, Point* p) {
	Border * self;
	Seed* result = NULL;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	GeeArrayList* _tmp2_ = NULL;
	gint _tmp3_ = 0;
	gint _tmp4_ = 0;
	GeeArrayList* _tmp5_ = NULL;
	Pod* _tmp6_ = NULL;
	GType _tmp7_ = 0UL;
	Point _tmp8_ = {0};
	Seed* _tmp9_ = NULL;
#line 87 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	self = (Border*) base;
#line 87 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	g_return_val_if_fail (p != NULL, NULL);
#line 88 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	_tmp0_ = pod_get_size ((Pod*) self);
#line 88 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	_tmp1_ = _tmp0_;
#line 88 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	_tmp2_ = self->motifs;
#line 88 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	_tmp3_ = gee_abstract_collection_get_size ((GeeCollection*) _tmp2_);
#line 88 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	_tmp4_ = _tmp3_;
#line 88 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	_vala_assert (_tmp1_ == _tmp4_, "size == motifs.size");
#line 89 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	_tmp5_ = self->motifs;
#line 89 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	_tmp6_ = self->default_motif;
#line 89 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp5_, _tmp6_);
#line 90 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	_tmp7_ = type;
#line 90 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	_tmp8_ = *p;
#line 90 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	_tmp9_ = POD_CLASS (border_parent_class)->add_seed_at_point (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_POD, Pod), _tmp7_, &_tmp8_);
#line 90 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	result = _tmp9_;
#line 90 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	return result;
#line 1121 "border.c"
}


Pod* border_get_motif (Border* self, gint n) {
	Pod* result = NULL;
	GeeArrayList* _tmp0_ = NULL;
	gint _tmp1_ = 0;
	gpointer _tmp2_ = NULL;
#line 93 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 94 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	_tmp0_ = self->motifs;
#line 94 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	_tmp1_ = n;
#line 94 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	_tmp2_ = gee_abstract_list_get ((GeeAbstractList*) _tmp0_, _tmp1_);
#line 94 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	result = (Pod*) _tmp2_;
#line 94 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	return result;
#line 1142 "border.c"
}


static void border_real_remove (Pod* base, Seed* seed) {
	Border * self;
	gint n = 0;
	Seed* _tmp0_ = NULL;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
#line 97 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	self = (Border*) base;
#line 97 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	g_return_if_fail (seed != NULL);
#line 98 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	_tmp0_ = seed;
#line 98 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	_tmp1_ = pod_index_of ((Pod*) self, _tmp0_);
#line 98 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	n = _tmp1_;
#line 99 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	_tmp2_ = n;
#line 99 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	if (_tmp2_ >= 0) {
#line 1166 "border.c"
		Seed* _tmp3_ = NULL;
		GeeArrayList* _tmp4_ = NULL;
		gint _tmp5_ = 0;
		gpointer _tmp6_ = NULL;
		Pod* _tmp7_ = NULL;
#line 100 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
		_tmp3_ = seed;
#line 100 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
		POD_CLASS (border_parent_class)->remove (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_POD, Pod), _tmp3_);
#line 101 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
		_tmp4_ = self->motifs;
#line 101 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
		_tmp5_ = n;
#line 101 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
		_tmp6_ = gee_abstract_list_remove_at ((GeeAbstractList*) _tmp4_, _tmp5_);
#line 101 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
		_tmp7_ = (Pod*) _tmp6_;
#line 101 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
		_g_object_unref0 (_tmp7_);
#line 1186 "border.c"
	}
}


static void border_real_add (Pod* base, Seed* seed) {
	Border * self;
	Seed* _tmp0_ = NULL;
	GeeArrayList* _tmp1_ = NULL;
	Pod* _tmp2_ = NULL;
#line 105 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	self = (Border*) base;
#line 105 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	g_return_if_fail (seed != NULL);
#line 106 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	_tmp0_ = seed;
#line 106 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	POD_CLASS (border_parent_class)->add (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_POD, Pod), _tmp0_);
#line 107 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	_tmp1_ = self->motifs;
#line 107 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	_tmp2_ = self->default_motif;
#line 107 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, _tmp2_);
#line 1210 "border.c"
}


static void border_real_clear (Pod* base) {
	Border * self;
	GeeArrayList* _tmp0_ = NULL;
#line 110 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	self = (Border*) base;
#line 111 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	POD_CLASS (border_parent_class)->clear (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_POD, Pod));
#line 112 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	_tmp0_ = self->motifs;
#line 112 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp0_);
#line 1225 "border.c"
}


/**
 * Swap seed positions
 */
static void border_real_swap (Pod* base, gint i, gint j) {
	Border * self;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	Pod* t = NULL;
	GeeArrayList* _tmp2_ = NULL;
	gint _tmp3_ = 0;
	gpointer _tmp4_ = NULL;
	GeeArrayList* _tmp5_ = NULL;
	gint _tmp6_ = 0;
	GeeArrayList* _tmp7_ = NULL;
	gint _tmp8_ = 0;
	gpointer _tmp9_ = NULL;
	Pod* _tmp10_ = NULL;
	GeeArrayList* _tmp11_ = NULL;
	gint _tmp12_ = 0;
#line 118 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	self = (Border*) base;
#line 119 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	_tmp0_ = i;
#line 119 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	_tmp1_ = j;
#line 119 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	POD_CLASS (border_parent_class)->swap (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_POD, Pod), _tmp0_, _tmp1_);
#line 120 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	_tmp2_ = self->motifs;
#line 120 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	_tmp3_ = i;
#line 120 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	_tmp4_ = gee_abstract_list_get ((GeeAbstractList*) _tmp2_, _tmp3_);
#line 120 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	t = (Pod*) _tmp4_;
#line 121 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	_tmp5_ = self->motifs;
#line 121 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	_tmp6_ = i;
#line 121 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	_tmp7_ = self->motifs;
#line 121 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	_tmp8_ = j;
#line 121 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	_tmp9_ = gee_abstract_list_get ((GeeAbstractList*) _tmp7_, _tmp8_);
#line 121 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	_tmp10_ = (Pod*) _tmp9_;
#line 121 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	gee_abstract_list_set ((GeeAbstractList*) _tmp5_, _tmp6_, _tmp10_);
#line 121 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	_g_object_unref0 (_tmp10_);
#line 122 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	_tmp11_ = self->motifs;
#line 122 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	_tmp12_ = j;
#line 122 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	gee_abstract_list_set ((GeeAbstractList*) _tmp11_, _tmp12_, t);
#line 118 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	_g_object_unref0 (t);
#line 1288 "border.c"
}


static void border_class_init (BorderClass * klass) {
#line 21 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	border_parent_class = g_type_class_peek_parent (klass);
#line 21 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	POD_CLASS (klass)->serialize_aux = border_real_serialize_aux;
#line 21 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	POD_CLASS (klass)->compile = border_real_compile;
#line 21 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	POD_CLASS (klass)->add_seed_at_point = border_real_add_seed_at_point;
#line 21 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	POD_CLASS (klass)->remove = border_real_remove;
#line 21 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	POD_CLASS (klass)->add = border_real_add;
#line 21 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	POD_CLASS (klass)->clear = border_real_clear;
#line 21 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	POD_CLASS (klass)->swap = border_real_swap;
#line 21 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	G_OBJECT_CLASS (klass)->finalize = border_finalize;
#line 1311 "border.c"
}


static void border_instance_init (Border * self) {
	GeeArrayList* _tmp0_ = NULL;
#line 25 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	_tmp0_ = gee_array_list_new (TYPE_POD, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
#line 25 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	self->motifs = _tmp0_;
#line 1321 "border.c"
}


static void border_finalize (GObject* obj) {
	Border * self;
#line 21 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_BORDER, Border);
#line 25 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	_g_object_unref0 (self->motifs);
#line 26 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	_g_object_unref0 (self->default_motif);
#line 21 "/home/jaidi/project/mutiara/mutiara-code/src/border.vala"
	G_OBJECT_CLASS (border_parent_class)->finalize (obj);
#line 1335 "border.c"
}


GType border_get_type (void) {
	static volatile gsize border_type_id__volatile = 0;
	if (g_once_init_enter (&border_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (BorderClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) border_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Border), 0, (GInstanceInitFunc) border_instance_init, NULL };
		GType border_type_id;
		border_type_id = g_type_register_static (TYPE_POD, "Border", &g_define_type_info, 0);
		g_once_init_leave (&border_type_id__volatile, border_type_id);
	}
	return border_type_id__volatile;
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint _vala_array_length (gpointer array) {
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



