/* curve.c generated by valac 0.22.0, the Vala compiler
 * generated from curve.vala, do not modify */

/*  Mutiara motif designer.
Copyright (C) 2011  Nor Jaidi Tuah

This file is part of Mutiara.

Mutiara is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <glib.h>
#include <glib-object.h>
#include <float.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <cairo.h>


#define TYPE_SEED (seed_get_type ())
#define SEED(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SEED, Seed))
#define SEED_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SEED, SeedClass))
#define IS_SEED(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SEED))
#define IS_SEED_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SEED))
#define SEED_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SEED, SeedClass))

typedef struct _Seed Seed;
typedef struct _SeedClass SeedClass;
typedef struct _SeedPrivate SeedPrivate;

#define TYPE_POINT (point_get_type ())
typedef struct _Point Point;

#define TYPE_ROLE (role_get_type ())

#define TYPE_FLIP (flip_get_type ())

#define TYPE_TWEAK (tweak_get_type ())
typedef struct _Tweak Tweak;

#define TYPE_RGBA (rgba_get_type ())
typedef struct _RGBA RGBA;

#define TYPE_RENDER_STYLE (render_style_get_type ())

#define TYPE_PROJECTION (projection_get_type ())
#define PROJECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PROJECTION, Projection))
#define PROJECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PROJECTION, ProjectionClass))
#define IS_PROJECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PROJECTION))
#define IS_PROJECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PROJECTION))
#define PROJECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PROJECTION, ProjectionClass))

typedef struct _Projection Projection;
typedef struct _ProjectionClass ProjectionClass;

#define TYPE_CURVE (curve_get_type ())
#define CURVE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CURVE, Curve))
#define CURVE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CURVE, CurveClass))
#define IS_CURVE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CURVE))
#define IS_CURVE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CURVE))
#define CURVE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CURVE, CurveClass))

typedef struct _Curve Curve;
typedef struct _CurveClass CurveClass;
typedef struct _CurvePrivate CurvePrivate;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _Point {
	gdouble x;
	gdouble y;
};

typedef enum  {
	ROLE_DUAL = 0,
	ROLE_MOTIF = 1,
	ROLE_BASE = 2
} Role;

typedef enum  {
	FLIP_NONE = 0,
	FLIP_Y = 1,
	FLIP_X = 2,
	FLIP_XY = 3
} Flip;

struct _Tweak {
	gdouble scale_x;
	gdouble scale_y;
	gdouble rotate;
	gdouble move_x;
	gdouble move_y;
};

struct _RGBA {
	gdouble r;
	gdouble g;
	gdouble b;
	gdouble a;
};

typedef enum  {
	RENDER_STYLE_THIN = 0,
	RENDER_STYLE_THICK = 1,
	RENDER_STYLE_HOLLOW = 2,
	RENDER_STYLE_FILLED = 3,
	RENDER_STYLE_CLOSED = 4,
	RENDER_STYLE_NONE = 5
} RenderStyle;

struct _Seed {
	GObject parent_instance;
	SeedPrivate * priv;
	gboolean debug;
	gboolean is_affine;
	Role role;
	gdouble base_offset;
	Flip flip_even;
	Flip flip_odd;
	Tweak tweak;
	gdouble width0;
	gdouble width1;
	gint num_segment;
	gint level_of_detail;
	RGBA color;
	gdouble color_mix;
	RenderStyle render_style;
	Projection** projection;
	gint projection_length1;
	gint selected_control;
	Point pressed_point;
};

struct _SeedClass {
	GObjectClass parent_class;
	void (*init_default_sub) (Seed* self, Point* p);
	void (*init_full_sub) (Seed* self, gdouble* args, int args_length1);
	gchar* (*serialize_sub) (Seed* self);
	void (*point_raw) (Seed* self, gdouble t, Point* result);
	void (*init_distance_to_parametric) (Seed* self);
	void (*distant_point) (Seed* self, gdouble x_distance, gdouble y_distance, Point* result);
	void (*draw_direct) (Seed* self, cairo_t* cr, gdouble scale);
	void (*draw_controls) (Seed* self, cairo_t* cr, gdouble scale);
	gint (*pressed_control) (Seed* self, Point* p, gdouble scale);
	void (*save_drag_context) (Seed* self);
	void (*move_shape) (Seed* self, gdouble delta_x, gdouble delta_y);
	void (*drag_control) (Seed* self, Point* p, gdouble scale, gboolean snap_on, gdouble grid_size, gdouble snap_angle);
	Point* (*points_to_snap) (Seed* self, int* result_length1);
	void (*draw_icon) (Seed* self, cairo_t* cr, gdouble width, gdouble height);
};

struct _Curve {
	Seed parent_instance;
	CurvePrivate * priv;
};

struct _CurveClass {
	SeedClass parent_class;
};

struct _CurvePrivate {
	Point p0;
	Point p1;
	Point p2;
	Point p3;
	Point p0_save;
	Point p1_save;
	Point p2_save;
	Point p3_save;
};


static gpointer curve_parent_class = NULL;

GType seed_get_type (void) G_GNUC_CONST;
GType point_get_type (void) G_GNUC_CONST;
Point* point_dup (const Point* self);
void point_free (Point* self);
GType role_get_type (void) G_GNUC_CONST;
GType flip_get_type (void) G_GNUC_CONST;
GType tweak_get_type (void) G_GNUC_CONST;
Tweak* tweak_dup (const Tweak* self);
void tweak_free (Tweak* self);
GType rgba_get_type (void) G_GNUC_CONST;
RGBA* rgba_dup (const RGBA* self);
void rgba_free (RGBA* self);
GType render_style_get_type (void) G_GNUC_CONST;
gpointer projection_ref (gpointer instance);
void projection_unref (gpointer instance);
GParamSpec* param_spec_projection (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_projection (GValue* value, gpointer v_object);
void value_take_projection (GValue* value, gpointer v_object);
gpointer value_get_projection (const GValue* value);
GType projection_get_type (void) G_GNUC_CONST;
GType curve_get_type (void) G_GNUC_CONST;
#define CURVE_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_CURVE, CurvePrivate))
enum  {
	CURVE_DUMMY_PROPERTY
};
static void curve_real_init_default_sub (Seed* base, Point* p);
void point_move_xy (Point *self, gdouble x, gdouble y, Point* result);
static void curve_real_init_full_sub (Seed* base, gdouble* args, int args_length1);
static gchar* curve_real_serialize_sub (Seed* base);
gchar* util_format (gdouble n, gint decimal_places);
static void curve_real_point_raw (Seed* base, gdouble t, Point* result);
static void curve_real_distant_point (Seed* base, gdouble x_distance, gdouble y_distance, Point* result);
gdouble seed_parameter (Seed* self, gdouble distance);
void seed_point_raw (Seed* self, gdouble t, Point* result);
static void curve_real_draw_direct (Seed* base, cairo_t* cr, gdouble scale);
void point_scale (Point *self, gdouble sx, gdouble sy, Point* result);
static void curve_real_draw_controls (Seed* base, cairo_t* cr, gdouble scale);
void seed_draw_line_control (Seed* self, cairo_t* cr, Point* p0, Point* p1);
void seed_draw_square_control (Seed* self, cairo_t* cr, Point* p);
static gint curve_real_pressed_control (Seed* base, Point* p, gdouble scale);
gboolean seed_within_touch_range (Seed* self, Point* p0, Point* p1, gdouble scale);
static void curve_real_save_drag_context (Seed* base);
static void curve_real_drag_control (Seed* base, Point* p, gdouble scale, gboolean snap_on, gdouble grid_size, gdouble snap_angle);
gboolean seed_snap (Seed* self, Point* p, gdouble scale, gdouble grid_size);
gboolean seed_within_snap_range (Seed* self, Point* p0, Point* p1, gdouble scale);
static void curve_real_move_shape (Seed* base, gdouble delta_x, gdouble delta_y);
static Point* curve_real_points_to_snap (Seed* base, int* result_length1);
static void curve_real_draw_icon (Seed* base, cairo_t* cr, gdouble width, gdouble height);
void seed_init_full (Seed* self, gdouble* args, int args_length1);
void seed_draw_direct (Seed* self, cairo_t* cr, gdouble scale);
Curve* curve_new (void);
Curve* curve_construct (GType object_type);
Seed* seed_construct (GType object_type);
static void curve_finalize (GObject* obj);


static void curve_real_init_default_sub (Seed* base, Point* p) {
	Curve * self;
	gint _tmp0_ = 0;
	Point _tmp1_ = {0};
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	gint disp = 0;
	gint _tmp4_ = 0;
	Point _tmp5_ = {0};
	Point _tmp6_ = {0};
	Point _tmp7_ = {0};
	Point _tmp8_ = {0};
#line 25 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	self = (Curve*) base;
#line 25 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	g_return_if_fail (p != NULL);
#line 26 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp1_ = *p;
#line 26 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp2_ = _tmp1_.x;
#line 26 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp3_ = fabs (_tmp2_);
#line 26 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	if (_tmp3_ < 1.5) {
#line 26 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
		_tmp0_ = 1;
#line 270 "curve.c"
	} else {
#line 26 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
		_tmp0_ = 500;
#line 274 "curve.c"
	}
#line 26 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp4_ = _tmp0_;
#line 26 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	disp = _tmp4_;
#line 27 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp5_ = *p;
#line 27 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	self->priv->p0 = _tmp5_;
#line 28 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	point_move_xy (p, (gdouble) 0, (-0.2) * disp, &_tmp6_);
#line 28 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	self->priv->p1 = _tmp6_;
#line 29 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	point_move_xy (p, (gdouble) 0, (-0.2) * disp, &_tmp7_);
#line 29 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	self->priv->p2 = _tmp7_;
#line 30 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp8_ = *p;
#line 30 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	self->priv->p3 = _tmp8_;
#line 296 "curve.c"
}


static void curve_real_init_full_sub (Seed* base, gdouble* args, int args_length1) {
	Curve * self;
	gdouble* _tmp0_ = NULL;
	gint _tmp0__length1 = 0;
	gdouble* _tmp1_ = NULL;
	gint _tmp1__length1 = 0;
	gdouble _tmp2_ = 0.0;
	gdouble* _tmp3_ = NULL;
	gint _tmp3__length1 = 0;
	gdouble _tmp4_ = 0.0;
	Point _tmp5_ = {0};
	Point _tmp6_ = {0};
	gdouble* _tmp7_ = NULL;
	gint _tmp7__length1 = 0;
	gdouble _tmp8_ = 0.0;
	gdouble* _tmp9_ = NULL;
	gint _tmp9__length1 = 0;
	gdouble _tmp10_ = 0.0;
	Point _tmp11_ = {0};
	Point _tmp12_ = {0};
	gdouble* _tmp13_ = NULL;
	gint _tmp13__length1 = 0;
	gdouble _tmp14_ = 0.0;
	gdouble* _tmp15_ = NULL;
	gint _tmp15__length1 = 0;
	gdouble _tmp16_ = 0.0;
	Point _tmp17_ = {0};
	Point _tmp18_ = {0};
	gdouble* _tmp19_ = NULL;
	gint _tmp19__length1 = 0;
	gdouble _tmp20_ = 0.0;
	gdouble* _tmp21_ = NULL;
	gint _tmp21__length1 = 0;
	gdouble _tmp22_ = 0.0;
	Point _tmp23_ = {0};
	Point _tmp24_ = {0};
#line 33 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	self = (Curve*) base;
#line 34 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp0_ = args;
#line 34 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp0__length1 = args_length1;
#line 34 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_vala_assert (_tmp0__length1 >= 8, "args.length >= 8");
#line 35 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp1_ = args;
#line 35 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp1__length1 = args_length1;
#line 35 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp2_ = _tmp1_[0];
#line 35 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp3_ = args;
#line 35 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp3__length1 = args_length1;
#line 35 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp4_ = _tmp3_[1];
#line 35 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	memset (&_tmp5_, 0, sizeof (Point));
#line 35 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp5_.x = _tmp2_;
#line 35 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp5_.y = _tmp4_;
#line 35 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	self->priv->p0 = _tmp5_;
#line 35 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp6_ = self->priv->p0;
#line 36 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp7_ = args;
#line 36 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp7__length1 = args_length1;
#line 36 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp8_ = _tmp7_[2];
#line 36 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp9_ = args;
#line 36 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp9__length1 = args_length1;
#line 36 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp10_ = _tmp9_[3];
#line 36 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	memset (&_tmp11_, 0, sizeof (Point));
#line 36 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp11_.x = _tmp8_;
#line 36 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp11_.y = _tmp10_;
#line 36 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	self->priv->p1 = _tmp11_;
#line 36 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp12_ = self->priv->p1;
#line 37 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp13_ = args;
#line 37 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp13__length1 = args_length1;
#line 37 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp14_ = _tmp13_[4];
#line 37 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp15_ = args;
#line 37 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp15__length1 = args_length1;
#line 37 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp16_ = _tmp15_[5];
#line 37 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	memset (&_tmp17_, 0, sizeof (Point));
#line 37 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp17_.x = _tmp14_;
#line 37 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp17_.y = _tmp16_;
#line 37 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	self->priv->p2 = _tmp17_;
#line 37 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp18_ = self->priv->p2;
#line 38 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp19_ = args;
#line 38 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp19__length1 = args_length1;
#line 38 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp20_ = _tmp19_[6];
#line 38 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp21_ = args;
#line 38 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp21__length1 = args_length1;
#line 38 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp22_ = _tmp21_[7];
#line 38 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	memset (&_tmp23_, 0, sizeof (Point));
#line 38 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp23_.x = _tmp20_;
#line 38 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp23_.y = _tmp22_;
#line 38 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	self->priv->p3 = _tmp23_;
#line 38 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp24_ = self->priv->p3;
#line 432 "curve.c"
}


static gchar* curve_real_serialize_sub (Seed* base) {
	Curve * self;
	gchar* result = NULL;
	Point _tmp0_ = {0};
	gdouble _tmp1_ = 0.0;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	Point _tmp4_ = {0};
	gdouble _tmp5_ = 0.0;
	gchar* _tmp6_ = NULL;
	gchar* _tmp7_ = NULL;
	Point _tmp8_ = {0};
	gdouble _tmp9_ = 0.0;
	gchar* _tmp10_ = NULL;
	gchar* _tmp11_ = NULL;
	Point _tmp12_ = {0};
	gdouble _tmp13_ = 0.0;
	gchar* _tmp14_ = NULL;
	gchar* _tmp15_ = NULL;
	Point _tmp16_ = {0};
	gdouble _tmp17_ = 0.0;
	gchar* _tmp18_ = NULL;
	gchar* _tmp19_ = NULL;
	Point _tmp20_ = {0};
	gdouble _tmp21_ = 0.0;
	gchar* _tmp22_ = NULL;
	gchar* _tmp23_ = NULL;
	Point _tmp24_ = {0};
	gdouble _tmp25_ = 0.0;
	gchar* _tmp26_ = NULL;
	gchar* _tmp27_ = NULL;
	Point _tmp28_ = {0};
	gdouble _tmp29_ = 0.0;
	gchar* _tmp30_ = NULL;
	gchar* _tmp31_ = NULL;
	gchar* _tmp32_ = NULL;
	gchar* _tmp33_ = NULL;
#line 41 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	self = (Curve*) base;
#line 42 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp0_ = self->priv->p0;
#line 42 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp1_ = _tmp0_.x;
#line 42 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp2_ = util_format (_tmp1_, 4);
#line 42 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp3_ = _tmp2_;
#line 42 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp4_ = self->priv->p0;
#line 42 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp5_ = _tmp4_.y;
#line 42 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp6_ = util_format (_tmp5_, 4);
#line 42 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp7_ = _tmp6_;
#line 42 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp8_ = self->priv->p1;
#line 42 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp9_ = _tmp8_.x;
#line 42 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp10_ = util_format (_tmp9_, 4);
#line 42 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp11_ = _tmp10_;
#line 42 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp12_ = self->priv->p1;
#line 42 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp13_ = _tmp12_.y;
#line 42 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp14_ = util_format (_tmp13_, 4);
#line 42 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp15_ = _tmp14_;
#line 42 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp16_ = self->priv->p2;
#line 42 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp17_ = _tmp16_.x;
#line 42 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp18_ = util_format (_tmp17_, 4);
#line 42 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp19_ = _tmp18_;
#line 42 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp20_ = self->priv->p2;
#line 42 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp21_ = _tmp20_.y;
#line 42 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp22_ = util_format (_tmp21_, 4);
#line 42 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp23_ = _tmp22_;
#line 42 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp24_ = self->priv->p3;
#line 42 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp25_ = _tmp24_.x;
#line 42 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp26_ = util_format (_tmp25_, 4);
#line 42 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp27_ = _tmp26_;
#line 42 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp28_ = self->priv->p3;
#line 42 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp29_ = _tmp28_.y;
#line 42 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp30_ = util_format (_tmp29_, 4);
#line 42 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp31_ = _tmp30_;
#line 42 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp32_ = g_strdup_printf ("Curve (%s, %s) (%s, %s) (%s, %s) (%s, %s)", _tmp3_, _tmp7_, _tmp11_, _tmp15_, _tmp19_, _tmp23_, _tmp27_, _tmp31_);
#line 42 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp33_ = _tmp32_;
#line 42 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_g_free0 (_tmp31_);
#line 42 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_g_free0 (_tmp27_);
#line 42 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_g_free0 (_tmp23_);
#line 42 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_g_free0 (_tmp19_);
#line 42 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_g_free0 (_tmp15_);
#line 42 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_g_free0 (_tmp11_);
#line 42 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_g_free0 (_tmp7_);
#line 42 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_g_free0 (_tmp3_);
#line 42 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	result = _tmp33_;
#line 42 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	return result;
#line 563 "curve.c"
}


static void curve_real_point_raw (Seed* base, gdouble t, Point* result) {
	Curve * self;
	gdouble s = 0.0;
	gdouble _tmp0_ = 0.0;
	gdouble a = 0.0;
	gdouble b = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble c = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	gdouble d = 0.0;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
	gdouble _tmp6_ = 0.0;
	gdouble x = 0.0;
	Point _tmp7_ = {0};
	gdouble _tmp8_ = 0.0;
	Point _tmp9_ = {0};
	gdouble _tmp10_ = 0.0;
	Point _tmp11_ = {0};
	gdouble _tmp12_ = 0.0;
	Point _tmp13_ = {0};
	gdouble _tmp14_ = 0.0;
	gdouble y = 0.0;
	Point _tmp15_ = {0};
	gdouble _tmp16_ = 0.0;
	Point _tmp17_ = {0};
	gdouble _tmp18_ = 0.0;
	Point _tmp19_ = {0};
	gdouble _tmp20_ = 0.0;
	Point _tmp21_ = {0};
	gdouble _tmp22_ = 0.0;
	Point _tmp23_ = {0};
#line 49 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	self = (Curve*) base;
#line 51 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp0_ = t;
#line 51 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	s = 1.0 - _tmp0_;
#line 52 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	a = (s * s) * s;
#line 53 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp1_ = t;
#line 53 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	b = ((3 * s) * s) * _tmp1_;
#line 54 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp2_ = t;
#line 54 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp3_ = t;
#line 54 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	c = ((3 * s) * _tmp2_) * _tmp3_;
#line 55 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp4_ = t;
#line 55 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp5_ = t;
#line 55 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp6_ = t;
#line 55 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	d = (_tmp4_ * _tmp5_) * _tmp6_;
#line 56 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp7_ = self->priv->p0;
#line 56 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp8_ = _tmp7_.x;
#line 56 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp9_ = self->priv->p1;
#line 56 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp10_ = _tmp9_.x;
#line 56 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp11_ = self->priv->p2;
#line 56 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp12_ = _tmp11_.x;
#line 56 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp13_ = self->priv->p3;
#line 56 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp14_ = _tmp13_.x;
#line 56 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	x = (((a * _tmp8_) + (b * _tmp10_)) + (c * _tmp12_)) + (d * _tmp14_);
#line 57 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp15_ = self->priv->p0;
#line 57 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp16_ = _tmp15_.y;
#line 57 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp17_ = self->priv->p1;
#line 57 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp18_ = _tmp17_.y;
#line 57 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp19_ = self->priv->p2;
#line 57 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp20_ = _tmp19_.y;
#line 57 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp21_ = self->priv->p3;
#line 57 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp22_ = _tmp21_.y;
#line 57 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	y = (((a * _tmp16_) + (b * _tmp18_)) + (c * _tmp20_)) + (d * _tmp22_);
#line 58 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	memset (&_tmp23_, 0, sizeof (Point));
#line 58 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp23_.x = x;
#line 58 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp23_.y = y;
#line 58 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	*result = _tmp23_;
#line 58 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	return;
#line 672 "curve.c"
}


static void curve_real_distant_point (Seed* base, gdouble x_distance, gdouble y_distance, Point* result) {
	Curve * self;
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	gdouble t = 0.0;
	gdouble _tmp5_ = 0.0;
	gdouble _tmp6_ = 0.0;
	Point p = {0};
	Point _tmp7_ = {0};
	gdouble s = 0.0;
	gdouble a = 0.0;
	gdouble b = 0.0;
	gdouble c = 0.0;
	gdouble d = 0.0;
	gdouble x = 0.0;
	Point _tmp8_ = {0};
	gdouble _tmp9_ = 0.0;
	Point _tmp10_ = {0};
	gdouble _tmp11_ = 0.0;
	Point _tmp12_ = {0};
	gdouble _tmp13_ = 0.0;
	Point _tmp14_ = {0};
	gdouble _tmp15_ = 0.0;
	gdouble y = 0.0;
	Point _tmp16_ = {0};
	gdouble _tmp17_ = 0.0;
	Point _tmp18_ = {0};
	gdouble _tmp19_ = 0.0;
	Point _tmp20_ = {0};
	gdouble _tmp21_ = 0.0;
	Point _tmp22_ = {0};
	gdouble _tmp23_ = 0.0;
	gdouble sin = 0.0;
	gdouble cos = 0.0;
	gdouble _tmp24_ = 0.0;
	gdouble _tmp25_ = 0.0;
	gdouble _tmp26_ = 0.0;
	gdouble _tmp27_ = 0.0;
	gdouble _tmp28_ = 0.0;
	gdouble _tmp29_ = 0.0;
	gdouble _tmp30_ = 0.0;
#line 61 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	self = (Curve*) base;
#line 63 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp0_ = y_distance;
#line 63 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp1_ = x_distance;
#line 63 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp2_ = ((Seed*) self)->width0;
#line 63 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp3_ = x_distance;
#line 63 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp4_ = ((Seed*) self)->width1;
#line 63 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	y_distance = _tmp0_ * (((1 - _tmp1_) * _tmp2_) + (_tmp3_ * _tmp4_));
#line 64 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp5_ = x_distance;
#line 64 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp6_ = seed_parameter ((Seed*) self, _tmp5_);
#line 64 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	t = _tmp6_;
#line 65 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	seed_point_raw ((Seed*) self, t, &_tmp7_);
#line 65 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	p = _tmp7_;
#line 67 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	s = 1.0 - t;
#line 68 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	a = ((-3) * s) * s;
#line 69 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	b = (((-6) * s) * t) + ((3 * s) * s);
#line 70 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	c = (((-3) * t) * t) + ((6 * s) * t);
#line 71 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	d = (3 * t) * t;
#line 73 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp8_ = self->priv->p0;
#line 73 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp9_ = _tmp8_.x;
#line 73 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp10_ = self->priv->p1;
#line 73 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp11_ = _tmp10_.x;
#line 73 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp12_ = self->priv->p2;
#line 73 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp13_ = _tmp12_.x;
#line 73 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp14_ = self->priv->p3;
#line 73 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp15_ = _tmp14_.x;
#line 73 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	x = (((a * _tmp9_) + (b * _tmp11_)) + (c * _tmp13_)) + (d * _tmp15_);
#line 74 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp16_ = self->priv->p0;
#line 74 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp17_ = _tmp16_.y;
#line 74 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp18_ = self->priv->p1;
#line 74 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp19_ = _tmp18_.y;
#line 74 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp20_ = self->priv->p2;
#line 74 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp21_ = _tmp20_.y;
#line 74 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp22_ = self->priv->p3;
#line 74 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp23_ = _tmp22_.y;
#line 74 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	y = (((a * _tmp17_) + (b * _tmp19_)) + (c * _tmp21_)) + (d * _tmp23_);
#line 78 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp24_ = atan2 (-x, y);
#line 78 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	sincos (_tmp24_, &_tmp25_, &_tmp26_);
#line 78 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	sin = _tmp25_;
#line 78 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	cos = _tmp26_;
#line 80 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp27_ = p.x;
#line 80 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp28_ = y_distance;
#line 80 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	p.x = _tmp27_ + (_tmp28_ * cos);
#line 81 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp29_ = p.y;
#line 81 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp30_ = y_distance;
#line 81 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	p.y = _tmp29_ + (_tmp30_ * sin);
#line 82 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	*result = p;
#line 82 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	return;
#line 814 "curve.c"
}


static void curve_real_draw_direct (Seed* base, cairo_t* cr, gdouble scale) {
	Curve * self;
	Point c0 = {0};
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	Point _tmp2_ = {0};
	Point c1 = {0};
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	Point _tmp5_ = {0};
	Point c2 = {0};
	gdouble _tmp6_ = 0.0;
	gdouble _tmp7_ = 0.0;
	Point _tmp8_ = {0};
	Point c3 = {0};
	gdouble _tmp9_ = 0.0;
	gdouble _tmp10_ = 0.0;
	Point _tmp11_ = {0};
	cairo_t* _tmp12_ = NULL;
	Point _tmp13_ = {0};
	gdouble _tmp14_ = 0.0;
	Point _tmp15_ = {0};
	gdouble _tmp16_ = 0.0;
	cairo_t* _tmp17_ = NULL;
	Point _tmp18_ = {0};
	gdouble _tmp19_ = 0.0;
	Point _tmp20_ = {0};
	gdouble _tmp21_ = 0.0;
	Point _tmp22_ = {0};
	gdouble _tmp23_ = 0.0;
	Point _tmp24_ = {0};
	gdouble _tmp25_ = 0.0;
	Point _tmp26_ = {0};
	gdouble _tmp27_ = 0.0;
	Point _tmp28_ = {0};
	gdouble _tmp29_ = 0.0;
	cairo_t* _tmp30_ = NULL;
#line 85 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	self = (Curve*) base;
#line 85 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	g_return_if_fail (cr != NULL);
#line 86 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp0_ = scale;
#line 86 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp1_ = scale;
#line 86 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	point_scale (&self->priv->p0, _tmp0_, _tmp1_, &_tmp2_);
#line 86 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	c0 = _tmp2_;
#line 87 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp3_ = scale;
#line 87 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp4_ = scale;
#line 87 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	point_scale (&self->priv->p1, _tmp3_, _tmp4_, &_tmp5_);
#line 87 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	c1 = _tmp5_;
#line 88 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp6_ = scale;
#line 88 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp7_ = scale;
#line 88 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	point_scale (&self->priv->p2, _tmp6_, _tmp7_, &_tmp8_);
#line 88 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	c2 = _tmp8_;
#line 89 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp9_ = scale;
#line 89 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp10_ = scale;
#line 89 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	point_scale (&self->priv->p3, _tmp9_, _tmp10_, &_tmp11_);
#line 89 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	c3 = _tmp11_;
#line 90 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp12_ = cr;
#line 90 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp13_ = c0;
#line 90 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp14_ = _tmp13_.x;
#line 90 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp15_ = c0;
#line 90 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp16_ = _tmp15_.y;
#line 90 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	cairo_move_to (_tmp12_, _tmp14_, _tmp16_);
#line 91 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp17_ = cr;
#line 91 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp18_ = c1;
#line 91 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp19_ = _tmp18_.x;
#line 91 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp20_ = c1;
#line 91 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp21_ = _tmp20_.y;
#line 91 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp22_ = c2;
#line 91 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp23_ = _tmp22_.x;
#line 91 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp24_ = c2;
#line 91 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp25_ = _tmp24_.y;
#line 91 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp26_ = c3;
#line 91 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp27_ = _tmp26_.x;
#line 91 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp28_ = c3;
#line 91 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp29_ = _tmp28_.y;
#line 91 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	cairo_curve_to (_tmp17_, _tmp19_, _tmp21_, _tmp23_, _tmp25_, _tmp27_, _tmp29_);
#line 92 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp30_ = cr;
#line 92 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	cairo_stroke (_tmp30_);
#line 935 "curve.c"
}


static void curve_real_draw_controls (Seed* base, cairo_t* cr, gdouble scale) {
	Curve * self;
	cairo_t* _tmp0_ = NULL;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	Point _tmp3_ = {0};
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
	Point _tmp6_ = {0};
	cairo_t* _tmp7_ = NULL;
	gdouble _tmp8_ = 0.0;
	gdouble _tmp9_ = 0.0;
	Point _tmp10_ = {0};
	gdouble _tmp11_ = 0.0;
	gdouble _tmp12_ = 0.0;
	Point _tmp13_ = {0};
	cairo_t* _tmp14_ = NULL;
	gdouble _tmp15_ = 0.0;
	gdouble _tmp16_ = 0.0;
	Point _tmp17_ = {0};
	cairo_t* _tmp18_ = NULL;
	gdouble _tmp19_ = 0.0;
	gdouble _tmp20_ = 0.0;
	Point _tmp21_ = {0};
	cairo_t* _tmp22_ = NULL;
	gdouble _tmp23_ = 0.0;
	gdouble _tmp24_ = 0.0;
	Point _tmp25_ = {0};
	cairo_t* _tmp26_ = NULL;
	gdouble _tmp27_ = 0.0;
	gdouble _tmp28_ = 0.0;
	Point _tmp29_ = {0};
#line 95 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	self = (Curve*) base;
#line 95 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	g_return_if_fail (cr != NULL);
#line 96 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp0_ = cr;
#line 96 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp1_ = scale;
#line 96 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp2_ = scale;
#line 96 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	point_scale (&self->priv->p0, _tmp1_, _tmp2_, &_tmp3_);
#line 96 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp4_ = scale;
#line 96 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp5_ = scale;
#line 96 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	point_scale (&self->priv->p1, _tmp4_, _tmp5_, &_tmp6_);
#line 96 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	seed_draw_line_control ((Seed*) self, _tmp0_, &_tmp3_, &_tmp6_);
#line 97 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp7_ = cr;
#line 97 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp8_ = scale;
#line 97 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp9_ = scale;
#line 97 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	point_scale (&self->priv->p2, _tmp8_, _tmp9_, &_tmp10_);
#line 97 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp11_ = scale;
#line 97 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp12_ = scale;
#line 97 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	point_scale (&self->priv->p3, _tmp11_, _tmp12_, &_tmp13_);
#line 97 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	seed_draw_line_control ((Seed*) self, _tmp7_, &_tmp10_, &_tmp13_);
#line 98 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp14_ = cr;
#line 98 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp15_ = scale;
#line 98 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp16_ = scale;
#line 98 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	point_scale (&self->priv->p0, _tmp15_, _tmp16_, &_tmp17_);
#line 98 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	seed_draw_square_control ((Seed*) self, _tmp14_, &_tmp17_);
#line 99 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp18_ = cr;
#line 99 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp19_ = scale;
#line 99 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp20_ = scale;
#line 99 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	point_scale (&self->priv->p1, _tmp19_, _tmp20_, &_tmp21_);
#line 99 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	seed_draw_square_control ((Seed*) self, _tmp18_, &_tmp21_);
#line 100 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp22_ = cr;
#line 100 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp23_ = scale;
#line 100 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp24_ = scale;
#line 100 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	point_scale (&self->priv->p2, _tmp23_, _tmp24_, &_tmp25_);
#line 100 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	seed_draw_square_control ((Seed*) self, _tmp22_, &_tmp25_);
#line 101 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp26_ = cr;
#line 101 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp27_ = scale;
#line 101 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp28_ = scale;
#line 101 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	point_scale (&self->priv->p3, _tmp27_, _tmp28_, &_tmp29_);
#line 101 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	seed_draw_square_control ((Seed*) self, _tmp26_, &_tmp29_);
#line 1047 "curve.c"
}


static gint curve_real_pressed_control (Seed* base, Point* p, gdouble scale) {
	Curve * self;
	gint result = 0;
	gint _tmp0_ = 0;
	Point _tmp1_ = {0};
	Point _tmp2_ = {0};
	gdouble _tmp3_ = 0.0;
	gboolean _tmp4_ = FALSE;
	gint _tmp23_ = 0;
#line 104 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	self = (Curve*) base;
#line 104 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	g_return_val_if_fail (p != NULL, 0);
#line 105 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp1_ = *p;
#line 105 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp2_ = self->priv->p2;
#line 105 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp3_ = scale;
#line 105 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp4_ = seed_within_touch_range ((Seed*) self, &_tmp1_, &_tmp2_, _tmp3_);
#line 105 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	if (_tmp4_) {
#line 105 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
		_tmp0_ = 2;
#line 1076 "curve.c"
	} else {
		gint _tmp5_ = 0;
		Point _tmp6_ = {0};
		Point _tmp7_ = {0};
		gdouble _tmp8_ = 0.0;
		gboolean _tmp9_ = FALSE;
		gint _tmp22_ = 0;
#line 106 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
		_tmp6_ = *p;
#line 106 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
		_tmp7_ = self->priv->p1;
#line 106 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
		_tmp8_ = scale;
#line 106 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
		_tmp9_ = seed_within_touch_range ((Seed*) self, &_tmp6_, &_tmp7_, _tmp8_);
#line 106 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
		if (_tmp9_) {
#line 106 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
			_tmp5_ = 1;
#line 1096 "curve.c"
		} else {
			gint _tmp10_ = 0;
			Point _tmp11_ = {0};
			Point _tmp12_ = {0};
			gdouble _tmp13_ = 0.0;
			gboolean _tmp14_ = FALSE;
			gint _tmp21_ = 0;
#line 107 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
			_tmp11_ = *p;
#line 107 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
			_tmp12_ = self->priv->p3;
#line 107 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
			_tmp13_ = scale;
#line 107 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
			_tmp14_ = seed_within_touch_range ((Seed*) self, &_tmp11_, &_tmp12_, _tmp13_);
#line 107 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
			if (_tmp14_) {
#line 107 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
				_tmp10_ = 3;
#line 1116 "curve.c"
			} else {
				gint _tmp15_ = 0;
				Point _tmp16_ = {0};
				Point _tmp17_ = {0};
				gdouble _tmp18_ = 0.0;
				gboolean _tmp19_ = FALSE;
				gint _tmp20_ = 0;
#line 108 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
				_tmp16_ = *p;
#line 108 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
				_tmp17_ = self->priv->p0;
#line 108 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
				_tmp18_ = scale;
#line 108 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
				_tmp19_ = seed_within_touch_range ((Seed*) self, &_tmp16_, &_tmp17_, _tmp18_);
#line 108 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
				if (_tmp19_) {
#line 108 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
					_tmp15_ = 0;
#line 1136 "curve.c"
				} else {
#line 108 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
					_tmp15_ = -1;
#line 1140 "curve.c"
				}
#line 108 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
				_tmp20_ = _tmp15_;
#line 108 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
				_tmp10_ = _tmp20_;
#line 1146 "curve.c"
			}
#line 107 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
			_tmp21_ = _tmp10_;
#line 107 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
			_tmp5_ = _tmp21_;
#line 1152 "curve.c"
		}
#line 106 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
		_tmp22_ = _tmp5_;
#line 106 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
		_tmp0_ = _tmp22_;
#line 1158 "curve.c"
	}
#line 105 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp23_ = _tmp0_;
#line 105 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	result = _tmp23_;
#line 105 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	return result;
#line 1166 "curve.c"
}


static void curve_real_save_drag_context (Seed* base) {
	Curve * self;
	Point _tmp0_ = {0};
	Point _tmp1_ = {0};
	Point _tmp2_ = {0};
	Point _tmp3_ = {0};
#line 116 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	self = (Curve*) base;
#line 117 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp0_ = self->priv->p0;
#line 117 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	self->priv->p0_save = _tmp0_;
#line 118 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp1_ = self->priv->p1;
#line 118 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	self->priv->p1_save = _tmp1_;
#line 119 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp2_ = self->priv->p2;
#line 119 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	self->priv->p2_save = _tmp2_;
#line 120 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp3_ = self->priv->p3;
#line 120 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	self->priv->p3_save = _tmp3_;
#line 1194 "curve.c"
}


static void curve_real_drag_control (Seed* base, Point* p, gdouble scale, gboolean snap_on, gdouble grid_size, gdouble snap_angle) {
	Curve * self;
	Point p_snapped = {0};
	Point _tmp0_ = {0};
	gboolean _tmp1_ = FALSE;
	gint _tmp4_ = 0;
#line 123 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	self = (Curve*) base;
#line 123 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	g_return_if_fail (p != NULL);
#line 124 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp0_ = *p;
#line 124 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	p_snapped = _tmp0_;
#line 125 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp1_ = snap_on;
#line 125 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	if (_tmp1_) {
#line 1216 "curve.c"
		gdouble _tmp2_ = 0.0;
		gdouble _tmp3_ = 0.0;
#line 125 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
		_tmp2_ = scale;
#line 125 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
		_tmp3_ = grid_size;
#line 125 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
		seed_snap ((Seed*) self, &p_snapped, _tmp2_, _tmp3_);
#line 1225 "curve.c"
	}
#line 128 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp4_ = ((Seed*) self)->selected_control;
#line 128 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	if (_tmp4_ == 0) {
#line 1231 "curve.c"
		Point _tmp5_ = {0};
		gboolean _tmp6_ = FALSE;
		gboolean _tmp7_ = FALSE;
		gboolean _tmp12_ = FALSE;
		Point _tmp15_ = {0};
		Point _tmp16_ = {0};
		gdouble _tmp17_ = 0.0;
		Point _tmp18_ = {0};
		gdouble _tmp19_ = 0.0;
		Point _tmp20_ = {0};
		gdouble _tmp21_ = 0.0;
		Point _tmp22_ = {0};
		gdouble _tmp23_ = 0.0;
		Point _tmp24_ = {0};
#line 129 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
		_tmp7_ = snap_on;
#line 129 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
		if (_tmp7_) {
#line 1250 "curve.c"
			Point _tmp8_ = {0};
			Point _tmp9_ = {0};
			gdouble _tmp10_ = 0.0;
			gboolean _tmp11_ = FALSE;
#line 129 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
			_tmp8_ = *p;
#line 129 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
			_tmp9_ = self->priv->p3;
#line 129 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
			_tmp10_ = scale;
#line 129 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
			_tmp11_ = seed_within_snap_range ((Seed*) self, &_tmp8_, &_tmp9_, _tmp10_);
#line 129 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
			_tmp6_ = _tmp11_;
#line 1265 "curve.c"
		} else {
#line 129 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
			_tmp6_ = FALSE;
#line 1269 "curve.c"
		}
#line 129 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
		_tmp12_ = _tmp6_;
#line 129 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
		if (_tmp12_) {
#line 1275 "curve.c"
			Point _tmp13_ = {0};
#line 129 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
			_tmp13_ = self->priv->p3;
#line 129 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
			_tmp5_ = _tmp13_;
#line 1281 "curve.c"
		} else {
			Point _tmp14_ = {0};
#line 129 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
			_tmp14_ = p_snapped;
#line 129 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
			_tmp5_ = _tmp14_;
#line 1288 "curve.c"
		}
#line 129 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
		_tmp15_ = _tmp5_;
#line 129 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
		self->priv->p0 = _tmp15_;
#line 131 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
		_tmp16_ = self->priv->p0;
#line 131 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
		_tmp17_ = _tmp16_.x;
#line 131 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
		_tmp18_ = self->priv->p0_save;
#line 131 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
		_tmp19_ = _tmp18_.x;
#line 131 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
		_tmp20_ = self->priv->p0;
#line 131 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
		_tmp21_ = _tmp20_.y;
#line 131 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
		_tmp22_ = self->priv->p0_save;
#line 131 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
		_tmp23_ = _tmp22_.y;
#line 131 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
		point_move_xy (&self->priv->p1_save, _tmp17_ - _tmp19_, _tmp21_ - _tmp23_, &_tmp24_);
#line 131 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
		self->priv->p1 = _tmp24_;
#line 1314 "curve.c"
	} else {
		gint _tmp25_ = 0;
#line 133 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
		_tmp25_ = ((Seed*) self)->selected_control;
#line 133 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
		if (_tmp25_ == 1) {
#line 1321 "curve.c"
			Point _tmp26_ = {0};
#line 134 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
			_tmp26_ = p_snapped;
#line 134 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
			self->priv->p1 = _tmp26_;
#line 1327 "curve.c"
		} else {
			gint _tmp27_ = 0;
#line 136 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
			_tmp27_ = ((Seed*) self)->selected_control;
#line 136 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
			if (_tmp27_ == 2) {
#line 1334 "curve.c"
				Point _tmp28_ = {0};
#line 137 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
				_tmp28_ = p_snapped;
#line 137 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
				self->priv->p2 = _tmp28_;
#line 1340 "curve.c"
			} else {
				gint _tmp29_ = 0;
#line 139 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
				_tmp29_ = ((Seed*) self)->selected_control;
#line 139 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
				if (_tmp29_ == 3) {
#line 1347 "curve.c"
					Point _tmp30_ = {0};
					gboolean _tmp31_ = FALSE;
					gboolean _tmp32_ = FALSE;
					gboolean _tmp37_ = FALSE;
					Point _tmp40_ = {0};
					Point _tmp41_ = {0};
					gdouble _tmp42_ = 0.0;
					Point _tmp43_ = {0};
					gdouble _tmp44_ = 0.0;
					Point _tmp45_ = {0};
					gdouble _tmp46_ = 0.0;
					Point _tmp47_ = {0};
					gdouble _tmp48_ = 0.0;
					Point _tmp49_ = {0};
#line 140 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
					_tmp32_ = snap_on;
#line 140 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
					if (_tmp32_) {
#line 1366 "curve.c"
						Point _tmp33_ = {0};
						Point _tmp34_ = {0};
						gdouble _tmp35_ = 0.0;
						gboolean _tmp36_ = FALSE;
#line 140 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
						_tmp33_ = *p;
#line 140 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
						_tmp34_ = self->priv->p0;
#line 140 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
						_tmp35_ = scale;
#line 140 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
						_tmp36_ = seed_within_snap_range ((Seed*) self, &_tmp33_, &_tmp34_, _tmp35_);
#line 140 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
						_tmp31_ = _tmp36_;
#line 1381 "curve.c"
					} else {
#line 140 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
						_tmp31_ = FALSE;
#line 1385 "curve.c"
					}
#line 140 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
					_tmp37_ = _tmp31_;
#line 140 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
					if (_tmp37_) {
#line 1391 "curve.c"
						Point _tmp38_ = {0};
#line 140 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
						_tmp38_ = self->priv->p0;
#line 140 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
						_tmp30_ = _tmp38_;
#line 1397 "curve.c"
					} else {
						Point _tmp39_ = {0};
#line 140 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
						_tmp39_ = p_snapped;
#line 140 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
						_tmp30_ = _tmp39_;
#line 1404 "curve.c"
					}
#line 140 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
					_tmp40_ = _tmp30_;
#line 140 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
					self->priv->p3 = _tmp40_;
#line 142 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
					_tmp41_ = self->priv->p3;
#line 142 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
					_tmp42_ = _tmp41_.x;
#line 142 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
					_tmp43_ = self->priv->p3_save;
#line 142 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
					_tmp44_ = _tmp43_.x;
#line 142 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
					_tmp45_ = self->priv->p3;
#line 142 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
					_tmp46_ = _tmp45_.y;
#line 142 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
					_tmp47_ = self->priv->p3_save;
#line 142 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
					_tmp48_ = _tmp47_.y;
#line 142 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
					point_move_xy (&self->priv->p2_save, _tmp42_ - _tmp44_, _tmp46_ - _tmp48_, &_tmp49_);
#line 142 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
					self->priv->p2 = _tmp49_;
#line 1430 "curve.c"
				} else {
#line 144 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
					g_assert_not_reached ();
#line 1434 "curve.c"
				}
			}
		}
	}
}


static void curve_real_move_shape (Seed* base, gdouble delta_x, gdouble delta_y) {
	Curve * self;
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	Point _tmp2_ = {0};
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	Point _tmp5_ = {0};
	gdouble _tmp6_ = 0.0;
	gdouble _tmp7_ = 0.0;
	Point _tmp8_ = {0};
	gdouble _tmp9_ = 0.0;
	gdouble _tmp10_ = 0.0;
	Point _tmp11_ = {0};
#line 147 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	self = (Curve*) base;
#line 148 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp0_ = delta_x;
#line 148 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp1_ = delta_y;
#line 148 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	point_move_xy (&self->priv->p0_save, _tmp0_, _tmp1_, &_tmp2_);
#line 148 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	self->priv->p0 = _tmp2_;
#line 149 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp3_ = delta_x;
#line 149 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp4_ = delta_y;
#line 149 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	point_move_xy (&self->priv->p1_save, _tmp3_, _tmp4_, &_tmp5_);
#line 149 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	self->priv->p1 = _tmp5_;
#line 150 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp6_ = delta_x;
#line 150 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp7_ = delta_y;
#line 150 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	point_move_xy (&self->priv->p2_save, _tmp6_, _tmp7_, &_tmp8_);
#line 150 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	self->priv->p2 = _tmp8_;
#line 151 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp9_ = delta_x;
#line 151 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp10_ = delta_y;
#line 151 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	point_move_xy (&self->priv->p3_save, _tmp9_, _tmp10_, &_tmp11_);
#line 151 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	self->priv->p3 = _tmp11_;
#line 1490 "curve.c"
}


static Point* curve_real_points_to_snap (Seed* base, int* result_length1) {
	Curve * self;
	Point* result = NULL;
	Point _tmp0_ = {0};
	Point _tmp1_ = {0};
	Point _tmp2_ = {0};
	Point _tmp3_ = {0};
	Point* _tmp4_ = NULL;
	Point* _tmp5_ = NULL;
	gint _tmp5__length1 = 0;
#line 154 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	self = (Curve*) base;
#line 155 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp0_ = self->priv->p0;
#line 155 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp1_ = self->priv->p1;
#line 155 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp2_ = self->priv->p2;
#line 155 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp3_ = self->priv->p3;
#line 155 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp4_ = g_new0 (Point, 4);
#line 155 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp4_[0] = _tmp0_;
#line 155 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp4_[1] = _tmp1_;
#line 155 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp4_[2] = _tmp2_;
#line 155 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp4_[3] = _tmp3_;
#line 155 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp5_ = _tmp4_;
#line 155 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp5__length1 = 4;
#line 155 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	if (result_length1) {
#line 155 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
		*result_length1 = _tmp5__length1;
#line 1532 "curve.c"
	}
#line 155 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	result = _tmp5_;
#line 155 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	return result;
#line 1538 "curve.c"
}


static void curve_real_draw_icon (Seed* base, cairo_t* cr, gdouble width, gdouble height) {
	Curve * self;
	gdouble* args = NULL;
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	gdouble* _tmp5_ = NULL;
	gint args_length1 = 0;
	gint _args_size_ = 0;
	cairo_t* _tmp6_ = NULL;
#line 158 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	self = (Curve*) base;
#line 158 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	g_return_if_fail (cr != NULL);
#line 159 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp0_ = width;
#line 159 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp1_ = height;
#line 159 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp2_ = width;
#line 159 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp3_ = width;
#line 159 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp4_ = height;
#line 159 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp5_ = g_new0 (gdouble, 8);
#line 159 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp5_[0] = (gdouble) 0;
#line 159 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp5_[1] = (gdouble) 0;
#line 159 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp5_[2] = _tmp0_ / 4;
#line 159 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp5_[3] = _tmp1_;
#line 159 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp5_[4] = 0.75 * _tmp2_;
#line 159 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp5_[5] = (gdouble) 0;
#line 159 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp5_[6] = _tmp3_;
#line 159 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp5_[7] = _tmp4_;
#line 159 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	args = _tmp5_;
#line 159 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	args_length1 = 8;
#line 159 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_args_size_ = args_length1;
#line 160 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	seed_init_full ((Seed*) self, args, args_length1);
#line 161 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	_tmp6_ = cr;
#line 161 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	seed_draw_direct ((Seed*) self, _tmp6_, (gdouble) 1);
#line 158 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	args = (g_free (args), NULL);
#line 1600 "curve.c"
}


Curve* curve_construct (GType object_type) {
	Curve * self = NULL;
#line 19 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	self = (Curve*) seed_construct (object_type);
#line 19 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	return self;
#line 1610 "curve.c"
}


Curve* curve_new (void) {
#line 19 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	return curve_construct (TYPE_CURVE);
#line 1617 "curve.c"
}


static void curve_class_init (CurveClass * klass) {
#line 19 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	curve_parent_class = g_type_class_peek_parent (klass);
#line 19 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	g_type_class_add_private (klass, sizeof (CurvePrivate));
#line 19 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	SEED_CLASS (klass)->init_default_sub = curve_real_init_default_sub;
#line 19 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	SEED_CLASS (klass)->init_full_sub = curve_real_init_full_sub;
#line 19 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	SEED_CLASS (klass)->serialize_sub = curve_real_serialize_sub;
#line 19 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	SEED_CLASS (klass)->point_raw = curve_real_point_raw;
#line 19 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	SEED_CLASS (klass)->distant_point = curve_real_distant_point;
#line 19 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	SEED_CLASS (klass)->draw_direct = curve_real_draw_direct;
#line 19 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	SEED_CLASS (klass)->draw_controls = curve_real_draw_controls;
#line 19 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	SEED_CLASS (klass)->pressed_control = curve_real_pressed_control;
#line 19 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	SEED_CLASS (klass)->save_drag_context = curve_real_save_drag_context;
#line 19 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	SEED_CLASS (klass)->drag_control = curve_real_drag_control;
#line 19 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	SEED_CLASS (klass)->move_shape = curve_real_move_shape;
#line 19 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	SEED_CLASS (klass)->points_to_snap = curve_real_points_to_snap;
#line 19 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	SEED_CLASS (klass)->draw_icon = curve_real_draw_icon;
#line 19 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	G_OBJECT_CLASS (klass)->finalize = curve_finalize;
#line 1654 "curve.c"
}


static void curve_instance_init (Curve * self) {
#line 19 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	self->priv = CURVE_GET_PRIVATE (self);
#line 1661 "curve.c"
}


static void curve_finalize (GObject* obj) {
	Curve * self;
#line 19 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_CURVE, Curve);
#line 19 "/home/jaidi/project/mutiara/mutiara-code/src/curve.vala"
	G_OBJECT_CLASS (curve_parent_class)->finalize (obj);
#line 1671 "curve.c"
}


GType curve_get_type (void) {
	static volatile gsize curve_type_id__volatile = 0;
	if (g_once_init_enter (&curve_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (CurveClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) curve_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Curve), 0, (GInstanceInitFunc) curve_instance_init, NULL };
		GType curve_type_id;
		curve_type_id = g_type_register_static (TYPE_SEED, "Curve", &g_define_type_info, 0);
		g_once_init_leave (&curve_type_id__volatile, curve_type_id);
	}
	return curve_type_id__volatile;
}



