/* line.c generated by valac 0.22.0, the Vala compiler
 * generated from line.vala, do not modify */

/*  Mutiara motif designer.
Copyright (C) 2011  Nor Jaidi Tuah

This file is part of Mutiara.

Mutiara is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <glib.h>
#include <glib-object.h>
#include <float.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <cairo.h>


#define TYPE_SEED (seed_get_type ())
#define SEED(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SEED, Seed))
#define SEED_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SEED, SeedClass))
#define IS_SEED(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SEED))
#define IS_SEED_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SEED))
#define SEED_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SEED, SeedClass))

typedef struct _Seed Seed;
typedef struct _SeedClass SeedClass;
typedef struct _SeedPrivate SeedPrivate;

#define TYPE_POINT (point_get_type ())
typedef struct _Point Point;

#define TYPE_ROLE (role_get_type ())

#define TYPE_FLIP (flip_get_type ())

#define TYPE_TWEAK (tweak_get_type ())
typedef struct _Tweak Tweak;

#define TYPE_RGBA (rgba_get_type ())
typedef struct _RGBA RGBA;

#define TYPE_RENDER_STYLE (render_style_get_type ())

#define TYPE_PROJECTION (projection_get_type ())
#define PROJECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PROJECTION, Projection))
#define PROJECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PROJECTION, ProjectionClass))
#define IS_PROJECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PROJECTION))
#define IS_PROJECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PROJECTION))
#define PROJECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PROJECTION, ProjectionClass))

typedef struct _Projection Projection;
typedef struct _ProjectionClass ProjectionClass;

#define TYPE_LINE (line_get_type ())
#define LINE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LINE, Line))
#define LINE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_LINE, LineClass))
#define IS_LINE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LINE))
#define IS_LINE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_LINE))
#define LINE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_LINE, LineClass))

typedef struct _Line Line;
typedef struct _LineClass LineClass;
typedef struct _LinePrivate LinePrivate;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _Point {
	gdouble x;
	gdouble y;
};

typedef enum  {
	ROLE_DUAL = 0,
	ROLE_MOTIF = 1,
	ROLE_BASE = 2
} Role;

typedef enum  {
	FLIP_NONE = 0,
	FLIP_Y = 1,
	FLIP_X = 2,
	FLIP_XY = 3
} Flip;

struct _Tweak {
	gdouble scale_x;
	gdouble scale_y;
	gdouble rotate;
	gdouble move_x;
	gdouble move_y;
};

struct _RGBA {
	gdouble r;
	gdouble g;
	gdouble b;
	gdouble a;
};

typedef enum  {
	RENDER_STYLE_THIN = 0,
	RENDER_STYLE_THICK = 1,
	RENDER_STYLE_HOLLOW = 2,
	RENDER_STYLE_FILLED = 3,
	RENDER_STYLE_CLOSED = 4,
	RENDER_STYLE_NONE = 5
} RenderStyle;

struct _Seed {
	GObject parent_instance;
	SeedPrivate * priv;
	gboolean debug;
	gboolean is_affine;
	Role role;
	gdouble base_offset;
	Flip flip_even;
	Flip flip_odd;
	Tweak tweak;
	gdouble width0;
	gdouble width1;
	gint num_segment;
	gint level_of_detail;
	RGBA color;
	gdouble color_mix;
	RenderStyle render_style;
	Projection** projection;
	gint projection_length1;
	gint selected_control;
	Point pressed_point;
};

struct _SeedClass {
	GObjectClass parent_class;
	void (*init_default_sub) (Seed* self, Point* p);
	void (*init_full_sub) (Seed* self, gdouble* args, int args_length1);
	gchar* (*serialize_sub) (Seed* self);
	void (*point_raw) (Seed* self, gdouble t, Point* result);
	void (*init_distance_to_parametric) (Seed* self);
	void (*distant_point) (Seed* self, gdouble x_distance, gdouble y_distance, Point* result);
	void (*draw_direct) (Seed* self, cairo_t* cr, gdouble scale);
	void (*draw_controls) (Seed* self, cairo_t* cr, gdouble scale);
	gint (*pressed_control) (Seed* self, Point* p, gdouble scale);
	void (*save_drag_context) (Seed* self);
	void (*move_shape) (Seed* self, gdouble delta_x, gdouble delta_y);
	void (*drag_control) (Seed* self, Point* p, gdouble scale, gboolean snap_on, gdouble grid_size, gdouble snap_angle);
	Point* (*points_to_snap) (Seed* self, int* result_length1);
	void (*draw_icon) (Seed* self, cairo_t* cr, gdouble width, gdouble height);
};

struct _Line {
	Seed parent_instance;
	LinePrivate * priv;
	Point p0;
	Point p1;
	gdouble sin_perpendicular_angle;
	gdouble cos_perpendicular_angle;
};

struct _LineClass {
	SeedClass parent_class;
};

struct _LinePrivate {
	Point p0_save;
	Point p1_save;
};


static gpointer line_parent_class = NULL;

GType seed_get_type (void) G_GNUC_CONST;
GType point_get_type (void) G_GNUC_CONST;
Point* point_dup (const Point* self);
void point_free (Point* self);
GType role_get_type (void) G_GNUC_CONST;
GType flip_get_type (void) G_GNUC_CONST;
GType tweak_get_type (void) G_GNUC_CONST;
Tweak* tweak_dup (const Tweak* self);
void tweak_free (Tweak* self);
GType rgba_get_type (void) G_GNUC_CONST;
RGBA* rgba_dup (const RGBA* self);
void rgba_free (RGBA* self);
GType render_style_get_type (void) G_GNUC_CONST;
gpointer projection_ref (gpointer instance);
void projection_unref (gpointer instance);
GParamSpec* param_spec_projection (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_projection (GValue* value, gpointer v_object);
void value_take_projection (GValue* value, gpointer v_object);
gpointer value_get_projection (const GValue* value);
GType projection_get_type (void) G_GNUC_CONST;
GType line_get_type (void) G_GNUC_CONST;
#define LINE_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_LINE, LinePrivate))
enum  {
	LINE_DUMMY_PROPERTY
};
static void line_real_init_default_sub (Seed* base, Point* p);
static void line_memo_perpendicular_angle (Line* self);
static void line_real_init_full_sub (Seed* base, gdouble* args, int args_length1);
static gchar* line_real_serialize_sub (Seed* base);
gchar* util_format (gdouble n, gint decimal_places);
static void line_real_point_raw (Seed* base, gdouble t, Point* result);
static void line_real_init_distance_to_parametric (Seed* base);
static void line_real_distant_point (Seed* base, gdouble x_distance, gdouble y_distance, Point* result);
static void line_real_draw_direct (Seed* base, cairo_t* cr, gdouble scale);
void point_scale (Point *self, gdouble sx, gdouble sy, Point* result);
static void line_real_draw_controls (Seed* base, cairo_t* cr, gdouble scale);
void seed_draw_square_control (Seed* self, cairo_t* cr, Point* p);
static gint line_real_pressed_control (Seed* base, Point* p, gdouble scale);
gboolean seed_within_touch_range (Seed* self, Point* p0, Point* p1, gdouble scale);
static void line_real_save_drag_context (Seed* base);
static void line_real_drag_control (Seed* base, Point* p, gdouble scale, gboolean snap_on, gdouble grid_size, gdouble snap_angle);
gboolean seed_snap (Seed* self, Point* p, gdouble scale, gdouble grid_size);
static void line_real_move_shape (Seed* base, gdouble delta_x, gdouble delta_y);
void point_move_xy (Point *self, gdouble x, gdouble y, Point* result);
static Point* line_real_points_to_snap (Seed* base, int* result_length1);
static void line_real_draw_icon (Seed* base, cairo_t* cr, gdouble width, gdouble height);
void seed_init_full (Seed* self, gdouble* args, int args_length1);
void seed_draw_direct (Seed* self, cairo_t* cr, gdouble scale);
Line* line_new (void);
Line* line_construct (GType object_type);
Seed* seed_construct (GType object_type);
static void line_finalize (GObject* obj);


static void line_real_init_default_sub (Seed* base, Point* p) {
	Line * self;
	Point _tmp0_ = {0};
	Point _tmp1_ = {0};
#line 30 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	self = (Line*) base;
#line 30 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	g_return_if_fail (p != NULL);
#line 31 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	_tmp0_ = *p;
#line 31 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	self->p0 = _tmp0_;
#line 32 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	_tmp1_ = *p;
#line 32 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	self->p1 = _tmp1_;
#line 33 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	line_memo_perpendicular_angle (self);
#line 258 "line.c"
}


static void line_real_init_full_sub (Seed* base, gdouble* args, int args_length1) {
	Line * self;
	gdouble* _tmp0_ = NULL;
	gint _tmp0__length1 = 0;
	gdouble* _tmp1_ = NULL;
	gint _tmp1__length1 = 0;
	gdouble _tmp2_ = 0.0;
	gdouble* _tmp3_ = NULL;
	gint _tmp3__length1 = 0;
	gdouble _tmp4_ = 0.0;
	Point _tmp5_ = {0};
	Point _tmp6_ = {0};
	gdouble* _tmp7_ = NULL;
	gint _tmp7__length1 = 0;
	gdouble _tmp8_ = 0.0;
	gdouble* _tmp9_ = NULL;
	gint _tmp9__length1 = 0;
	gdouble _tmp10_ = 0.0;
	Point _tmp11_ = {0};
	Point _tmp12_ = {0};
#line 36 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	self = (Line*) base;
#line 37 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	_tmp0_ = args;
#line 37 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	_tmp0__length1 = args_length1;
#line 37 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	_vala_assert (_tmp0__length1 >= 4, "args.length >= 4");
#line 38 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	_tmp1_ = args;
#line 38 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	_tmp1__length1 = args_length1;
#line 38 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	_tmp2_ = _tmp1_[0];
#line 38 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	_tmp3_ = args;
#line 38 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	_tmp3__length1 = args_length1;
#line 38 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	_tmp4_ = _tmp3_[1];
#line 38 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	memset (&_tmp5_, 0, sizeof (Point));
#line 38 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	_tmp5_.x = _tmp2_;
#line 38 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	_tmp5_.y = _tmp4_;
#line 38 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	self->p0 = _tmp5_;
#line 38 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	_tmp6_ = self->p0;
#line 39 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	_tmp7_ = args;
#line 39 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	_tmp7__length1 = args_length1;
#line 39 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	_tmp8_ = _tmp7_[2];
#line 39 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	_tmp9_ = args;
#line 39 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	_tmp9__length1 = args_length1;
#line 39 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	_tmp10_ = _tmp9_[3];
#line 39 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	memset (&_tmp11_, 0, sizeof (Point));
#line 39 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	_tmp11_.x = _tmp8_;
#line 39 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	_tmp11_.y = _tmp10_;
#line 39 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	self->p1 = _tmp11_;
#line 39 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	_tmp12_ = self->p1;
#line 40 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	line_memo_perpendicular_angle (self);
#line 336 "line.c"
}


static gchar* line_real_serialize_sub (Seed* base) {
	Line * self;
	gchar* result = NULL;
	Point _tmp0_ = {0};
	gdouble _tmp1_ = 0.0;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	Point _tmp4_ = {0};
	gdouble _tmp5_ = 0.0;
	gchar* _tmp6_ = NULL;
	gchar* _tmp7_ = NULL;
	Point _tmp8_ = {0};
	gdouble _tmp9_ = 0.0;
	gchar* _tmp10_ = NULL;
	gchar* _tmp11_ = NULL;
	Point _tmp12_ = {0};
	gdouble _tmp13_ = 0.0;
	gchar* _tmp14_ = NULL;
	gchar* _tmp15_ = NULL;
	gchar* _tmp16_ = NULL;
	gchar* _tmp17_ = NULL;
#line 43 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	self = (Line*) base;
#line 44 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	_tmp0_ = self->p0;
#line 44 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	_tmp1_ = _tmp0_.x;
#line 44 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	_tmp2_ = util_format (_tmp1_, 4);
#line 44 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	_tmp3_ = _tmp2_;
#line 44 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	_tmp4_ = self->p0;
#line 44 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	_tmp5_ = _tmp4_.y;
#line 44 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	_tmp6_ = util_format (_tmp5_, 4);
#line 44 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	_tmp7_ = _tmp6_;
#line 44 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	_tmp8_ = self->p1;
#line 44 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	_tmp9_ = _tmp8_.x;
#line 44 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	_tmp10_ = util_format (_tmp9_, 4);
#line 44 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	_tmp11_ = _tmp10_;
#line 44 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	_tmp12_ = self->p1;
#line 44 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	_tmp13_ = _tmp12_.y;
#line 44 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	_tmp14_ = util_format (_tmp13_, 4);
#line 44 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	_tmp15_ = _tmp14_;
#line 44 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	_tmp16_ = g_strdup_printf ("Line (%s, %s) (%s, %s)", _tmp3_, _tmp7_, _tmp11_, _tmp15_);
#line 44 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	_tmp17_ = _tmp16_;
#line 44 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	_g_free0 (_tmp15_);
#line 44 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	_g_free0 (_tmp11_);
#line 44 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	_g_free0 (_tmp7_);
#line 44 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	_g_free0 (_tmp3_);
#line 44 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	result = _tmp17_;
#line 44 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	return result;
#line 411 "line.c"
}


static void line_real_point_raw (Seed* base, gdouble t, Point* result) {
	Line * self;
	gdouble s = 0.0;
	gdouble _tmp0_ = 0.0;
	Point _tmp1_ = {0};
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	Point _tmp4_ = {0};
	gdouble _tmp5_ = 0.0;
	Point _tmp6_ = {0};
	gdouble _tmp7_ = 0.0;
	gdouble _tmp8_ = 0.0;
	Point _tmp9_ = {0};
	gdouble _tmp10_ = 0.0;
	Point _tmp11_ = {0};
#line 49 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	self = (Line*) base;
#line 51 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	_tmp0_ = t;
#line 51 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	s = 1.0 - _tmp0_;
#line 52 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	_tmp1_ = self->p0;
#line 52 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	_tmp2_ = _tmp1_.x;
#line 52 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	_tmp3_ = t;
#line 52 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	_tmp4_ = self->p1;
#line 52 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	_tmp5_ = _tmp4_.x;
#line 52 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	_tmp6_ = self->p0;
#line 52 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	_tmp7_ = _tmp6_.y;
#line 52 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	_tmp8_ = t;
#line 52 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	_tmp9_ = self->p1;
#line 52 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	_tmp10_ = _tmp9_.y;
#line 52 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	memset (&_tmp11_, 0, sizeof (Point));
#line 52 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	_tmp11_.x = (s * _tmp2_) + (_tmp3_ * _tmp5_);
#line 52 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	_tmp11_.y = (s * _tmp7_) + (_tmp8_ * _tmp10_);
#line 52 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	*result = _tmp11_;
#line 52 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	return;
#line 466 "line.c"
}


static void line_real_init_distance_to_parametric (Seed* base) {
	Line * self;
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
#line 55 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	self = (Line*) base;
#line 56 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	line_memo_perpendicular_angle (self);
#line 57 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	_tmp0_ = ((Seed*) self)->width0;
#line 57 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	_tmp1_ = ((Seed*) self)->width1;
#line 57 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	_tmp2_ = fabs (_tmp0_ - _tmp1_);
#line 57 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	((Seed*) self)->is_affine = _tmp2_ < 0.0000001;
#line 487 "line.c"
}


static void line_real_distant_point (Seed* base, gdouble x_distance, gdouble y_distance, Point* result) {
	Line * self;
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	gdouble t = 0.0;
	gdouble _tmp5_ = 0.0;
	gdouble s = 0.0;
	Point _tmp6_ = {0};
	gdouble _tmp7_ = 0.0;
	Point _tmp8_ = {0};
	gdouble _tmp9_ = 0.0;
	gdouble _tmp10_ = 0.0;
	gdouble _tmp11_ = 0.0;
	Point _tmp12_ = {0};
	gdouble _tmp13_ = 0.0;
	Point _tmp14_ = {0};
	gdouble _tmp15_ = 0.0;
	gdouble _tmp16_ = 0.0;
	gdouble _tmp17_ = 0.0;
	Point _tmp18_ = {0};
#line 60 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	self = (Line*) base;
#line 62 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	_tmp0_ = y_distance;
#line 62 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	_tmp1_ = x_distance;
#line 62 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	_tmp2_ = ((Seed*) self)->width0;
#line 62 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	_tmp3_ = x_distance;
#line 62 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	_tmp4_ = ((Seed*) self)->width1;
#line 62 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	y_distance = _tmp0_ * (((1 - _tmp1_) * _tmp2_) + (_tmp3_ * _tmp4_));
#line 66 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	_tmp5_ = x_distance;
#line 66 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	t = _tmp5_;
#line 67 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	s = 1.0 - t;
#line 68 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	_tmp6_ = self->p0;
#line 68 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	_tmp7_ = _tmp6_.x;
#line 68 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	_tmp8_ = self->p1;
#line 68 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	_tmp9_ = _tmp8_.x;
#line 68 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	_tmp10_ = y_distance;
#line 68 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	_tmp11_ = self->cos_perpendicular_angle;
#line 68 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	_tmp12_ = self->p0;
#line 68 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	_tmp13_ = _tmp12_.y;
#line 68 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	_tmp14_ = self->p1;
#line 68 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	_tmp15_ = _tmp14_.y;
#line 68 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	_tmp16_ = y_distance;
#line 68 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	_tmp17_ = self->sin_perpendicular_angle;
#line 68 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	memset (&_tmp18_, 0, sizeof (Point));
#line 68 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	_tmp18_.x = ((s * _tmp7_) + (t * _tmp9_)) + (_tmp10_ * _tmp11_);
#line 68 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	_tmp18_.y = ((s * _tmp13_) + (t * _tmp15_)) + (_tmp16_ * _tmp17_);
#line 68 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	*result = _tmp18_;
#line 68 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	return;
#line 568 "line.c"
}


static void line_memo_perpendicular_angle (Line* self) {
	Point _tmp0_ = {0};
	gdouble _tmp1_ = 0.0;
	Point _tmp2_ = {0};
	gdouble _tmp3_ = 0.0;
	Point _tmp4_ = {0};
	gdouble _tmp5_ = 0.0;
	Point _tmp6_ = {0};
	gdouble _tmp7_ = 0.0;
	gdouble _tmp8_ = 0.0;
	gdouble _tmp9_ = 0.0;
	gdouble _tmp10_ = 0.0;
#line 73 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	g_return_if_fail (self != NULL);
#line 74 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	_tmp0_ = self->p0;
#line 74 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	_tmp1_ = _tmp0_.x;
#line 74 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	_tmp2_ = self->p1;
#line 74 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	_tmp3_ = _tmp2_.x;
#line 74 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	_tmp4_ = self->p1;
#line 74 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	_tmp5_ = _tmp4_.y;
#line 74 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	_tmp6_ = self->p0;
#line 74 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	_tmp7_ = _tmp6_.y;
#line 74 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	_tmp8_ = atan2 (_tmp1_ - _tmp3_, _tmp5_ - _tmp7_);
#line 74 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	sincos (_tmp8_, &_tmp9_, &_tmp10_);
#line 74 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	self->sin_perpendicular_angle = _tmp9_;
#line 74 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	self->cos_perpendicular_angle = _tmp10_;
#line 610 "line.c"
}


static void line_real_draw_direct (Seed* base, cairo_t* cr, gdouble scale) {
	Line * self;
	Point c0 = {0};
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	Point _tmp2_ = {0};
	Point c1 = {0};
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	Point _tmp5_ = {0};
	cairo_t* _tmp6_ = NULL;
	Point _tmp7_ = {0};
	gdouble _tmp8_ = 0.0;
	Point _tmp9_ = {0};
	gdouble _tmp10_ = 0.0;
	cairo_t* _tmp11_ = NULL;
	Point _tmp12_ = {0};
	gdouble _tmp13_ = 0.0;
	Point _tmp14_ = {0};
	gdouble _tmp15_ = 0.0;
	cairo_t* _tmp16_ = NULL;
#line 79 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	self = (Line*) base;
#line 79 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	g_return_if_fail (cr != NULL);
#line 80 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	_tmp0_ = scale;
#line 80 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	_tmp1_ = scale;
#line 80 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	point_scale (&self->p0, _tmp0_, _tmp1_, &_tmp2_);
#line 80 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	c0 = _tmp2_;
#line 81 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	_tmp3_ = scale;
#line 81 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	_tmp4_ = scale;
#line 81 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	point_scale (&self->p1, _tmp3_, _tmp4_, &_tmp5_);
#line 81 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	c1 = _tmp5_;
#line 82 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	_tmp6_ = cr;
#line 82 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	_tmp7_ = c0;
#line 82 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	_tmp8_ = _tmp7_.x;
#line 82 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	_tmp9_ = c0;
#line 82 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	_tmp10_ = _tmp9_.y;
#line 82 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	cairo_move_to (_tmp6_, _tmp8_, _tmp10_);
#line 83 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	_tmp11_ = cr;
#line 83 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	_tmp12_ = c1;
#line 83 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	_tmp13_ = _tmp12_.x;
#line 83 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	_tmp14_ = c1;
#line 83 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	_tmp15_ = _tmp14_.y;
#line 83 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	cairo_line_to (_tmp11_, _tmp13_, _tmp15_);
#line 84 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	_tmp16_ = cr;
#line 84 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	cairo_stroke (_tmp16_);
#line 683 "line.c"
}


static void line_real_draw_controls (Seed* base, cairo_t* cr, gdouble scale) {
	Line * self;
	cairo_t* _tmp0_ = NULL;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	Point _tmp3_ = {0};
	cairo_t* _tmp4_ = NULL;
	gdouble _tmp5_ = 0.0;
	gdouble _tmp6_ = 0.0;
	Point _tmp7_ = {0};
#line 87 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	self = (Line*) base;
#line 87 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	g_return_if_fail (cr != NULL);
#line 88 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	_tmp0_ = cr;
#line 88 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	_tmp1_ = scale;
#line 88 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	_tmp2_ = scale;
#line 88 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	point_scale (&self->p0, _tmp1_, _tmp2_, &_tmp3_);
#line 88 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	seed_draw_square_control ((Seed*) self, _tmp0_, &_tmp3_);
#line 89 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	_tmp4_ = cr;
#line 89 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	_tmp5_ = scale;
#line 89 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	_tmp6_ = scale;
#line 89 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	point_scale (&self->p1, _tmp5_, _tmp6_, &_tmp7_);
#line 89 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	seed_draw_square_control ((Seed*) self, _tmp4_, &_tmp7_);
#line 721 "line.c"
}


static gint line_real_pressed_control (Seed* base, Point* p, gdouble scale) {
	Line * self;
	gint result = 0;
	gint _tmp0_ = 0;
	Point _tmp1_ = {0};
	Point _tmp2_ = {0};
	gdouble _tmp3_ = 0.0;
	gboolean _tmp4_ = FALSE;
	gint _tmp11_ = 0;
#line 100 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	self = (Line*) base;
#line 100 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	g_return_val_if_fail (p != NULL, 0);
#line 101 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	_tmp1_ = *p;
#line 101 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	_tmp2_ = self->p1;
#line 101 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	_tmp3_ = scale;
#line 101 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	_tmp4_ = seed_within_touch_range ((Seed*) self, &_tmp1_, &_tmp2_, _tmp3_);
#line 101 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	if (_tmp4_) {
#line 101 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
		_tmp0_ = 1;
#line 750 "line.c"
	} else {
		gint _tmp5_ = 0;
		Point _tmp6_ = {0};
		Point _tmp7_ = {0};
		gdouble _tmp8_ = 0.0;
		gboolean _tmp9_ = FALSE;
		gint _tmp10_ = 0;
#line 102 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
		_tmp6_ = *p;
#line 102 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
		_tmp7_ = self->p0;
#line 102 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
		_tmp8_ = scale;
#line 102 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
		_tmp9_ = seed_within_touch_range ((Seed*) self, &_tmp6_, &_tmp7_, _tmp8_);
#line 102 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
		if (_tmp9_) {
#line 102 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
			_tmp5_ = 0;
#line 770 "line.c"
		} else {
#line 102 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
			_tmp5_ = -1;
#line 774 "line.c"
		}
#line 102 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
		_tmp10_ = _tmp5_;
#line 102 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
		_tmp0_ = _tmp10_;
#line 780 "line.c"
	}
#line 101 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	_tmp11_ = _tmp0_;
#line 101 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	result = _tmp11_;
#line 101 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	return result;
#line 788 "line.c"
}


static void line_real_save_drag_context (Seed* base) {
	Line * self;
	Point _tmp0_ = {0};
	Point _tmp1_ = {0};
#line 105 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	self = (Line*) base;
#line 106 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	_tmp0_ = self->p0;
#line 106 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	self->priv->p0_save = _tmp0_;
#line 107 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	_tmp1_ = self->p1;
#line 107 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	self->priv->p1_save = _tmp1_;
#line 806 "line.c"
}


static void line_real_drag_control (Seed* base, Point* p, gdouble scale, gboolean snap_on, gdouble grid_size, gdouble snap_angle) {
	Line * self;
	gboolean _tmp0_ = FALSE;
	gint _tmp3_ = 0;
#line 110 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	self = (Line*) base;
#line 110 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	g_return_if_fail (p != NULL);
#line 111 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	_tmp0_ = snap_on;
#line 111 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	if (_tmp0_) {
#line 822 "line.c"
		gdouble _tmp1_ = 0.0;
		gdouble _tmp2_ = 0.0;
#line 111 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
		_tmp1_ = scale;
#line 111 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
		_tmp2_ = grid_size;
#line 111 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
		seed_snap ((Seed*) self, p, _tmp1_, _tmp2_);
#line 831 "line.c"
	}
#line 112 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	_tmp3_ = ((Seed*) self)->selected_control;
#line 112 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	if (_tmp3_ == 0) {
#line 837 "line.c"
		Point _tmp4_ = {0};
#line 112 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
		_tmp4_ = *p;
#line 112 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
		self->p0 = _tmp4_;
#line 843 "line.c"
	} else {
		gint _tmp5_ = 0;
#line 113 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
		_tmp5_ = ((Seed*) self)->selected_control;
#line 113 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
		if (_tmp5_ == 1) {
#line 850 "line.c"
			Point _tmp6_ = {0};
#line 113 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
			_tmp6_ = *p;
#line 113 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
			self->p1 = _tmp6_;
#line 856 "line.c"
		} else {
#line 114 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
			g_assert_not_reached ();
#line 860 "line.c"
		}
	}
}


static void line_real_move_shape (Seed* base, gdouble delta_x, gdouble delta_y) {
	Line * self;
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	Point _tmp2_ = {0};
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	Point _tmp5_ = {0};
#line 117 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	self = (Line*) base;
#line 118 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	_tmp0_ = delta_x;
#line 118 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	_tmp1_ = delta_y;
#line 118 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	point_move_xy (&self->priv->p0_save, _tmp0_, _tmp1_, &_tmp2_);
#line 118 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	self->p0 = _tmp2_;
#line 119 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	_tmp3_ = delta_x;
#line 119 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	_tmp4_ = delta_y;
#line 119 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	point_move_xy (&self->priv->p1_save, _tmp3_, _tmp4_, &_tmp5_);
#line 119 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	self->p1 = _tmp5_;
#line 892 "line.c"
}


static Point* line_real_points_to_snap (Seed* base, int* result_length1) {
	Line * self;
	Point* result = NULL;
	Point _tmp0_ = {0};
	Point _tmp1_ = {0};
	Point* _tmp2_ = NULL;
	Point* _tmp3_ = NULL;
	gint _tmp3__length1 = 0;
#line 122 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	self = (Line*) base;
#line 123 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	_tmp0_ = self->p0;
#line 123 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	_tmp1_ = self->p1;
#line 123 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	_tmp2_ = g_new0 (Point, 2);
#line 123 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	_tmp2_[0] = _tmp0_;
#line 123 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	_tmp2_[1] = _tmp1_;
#line 123 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	_tmp3_ = _tmp2_;
#line 123 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	_tmp3__length1 = 2;
#line 123 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	if (result_length1) {
#line 123 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
		*result_length1 = _tmp3__length1;
#line 924 "line.c"
	}
#line 123 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	result = _tmp3_;
#line 123 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	return result;
#line 930 "line.c"
}


static void line_real_draw_icon (Seed* base, cairo_t* cr, gdouble width, gdouble height) {
	Line * self;
	gdouble* args = NULL;
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble* _tmp2_ = NULL;
	gint args_length1 = 0;
	gint _args_size_ = 0;
	cairo_t* _tmp3_ = NULL;
#line 126 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	self = (Line*) base;
#line 126 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	g_return_if_fail (cr != NULL);
#line 127 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	_tmp0_ = width;
#line 127 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	_tmp1_ = height;
#line 127 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	_tmp2_ = g_new0 (gdouble, 4);
#line 127 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	_tmp2_[0] = (gdouble) 0;
#line 127 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	_tmp2_[1] = (gdouble) 0;
#line 127 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	_tmp2_[2] = _tmp0_;
#line 127 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	_tmp2_[3] = _tmp1_;
#line 127 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	args = _tmp2_;
#line 127 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	args_length1 = 4;
#line 127 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	_args_size_ = args_length1;
#line 128 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	seed_init_full ((Seed*) self, args, args_length1);
#line 129 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	_tmp3_ = cr;
#line 129 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	seed_draw_direct ((Seed*) self, _tmp3_, (gdouble) 1);
#line 126 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	args = (g_free (args), NULL);
#line 975 "line.c"
}


Line* line_construct (GType object_type) {
	Line * self = NULL;
#line 19 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	self = (Line*) seed_construct (object_type);
#line 19 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	return self;
#line 985 "line.c"
}


Line* line_new (void) {
#line 19 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	return line_construct (TYPE_LINE);
#line 992 "line.c"
}


static void line_class_init (LineClass * klass) {
#line 19 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	line_parent_class = g_type_class_peek_parent (klass);
#line 19 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	g_type_class_add_private (klass, sizeof (LinePrivate));
#line 19 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	SEED_CLASS (klass)->init_default_sub = line_real_init_default_sub;
#line 19 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	SEED_CLASS (klass)->init_full_sub = line_real_init_full_sub;
#line 19 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	SEED_CLASS (klass)->serialize_sub = line_real_serialize_sub;
#line 19 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	SEED_CLASS (klass)->point_raw = line_real_point_raw;
#line 19 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	SEED_CLASS (klass)->init_distance_to_parametric = line_real_init_distance_to_parametric;
#line 19 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	SEED_CLASS (klass)->distant_point = line_real_distant_point;
#line 19 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	SEED_CLASS (klass)->draw_direct = line_real_draw_direct;
#line 19 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	SEED_CLASS (klass)->draw_controls = line_real_draw_controls;
#line 19 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	SEED_CLASS (klass)->pressed_control = line_real_pressed_control;
#line 19 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	SEED_CLASS (klass)->save_drag_context = line_real_save_drag_context;
#line 19 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	SEED_CLASS (klass)->drag_control = line_real_drag_control;
#line 19 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	SEED_CLASS (klass)->move_shape = line_real_move_shape;
#line 19 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	SEED_CLASS (klass)->points_to_snap = line_real_points_to_snap;
#line 19 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	SEED_CLASS (klass)->draw_icon = line_real_draw_icon;
#line 19 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	G_OBJECT_CLASS (klass)->finalize = line_finalize;
#line 1031 "line.c"
}


static void line_instance_init (Line * self) {
#line 19 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	self->priv = LINE_GET_PRIVATE (self);
#line 1038 "line.c"
}


static void line_finalize (GObject* obj) {
	Line * self;
#line 19 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_LINE, Line);
#line 19 "/home/jaidi/project/mutiara/mutiara-code/src/line.vala"
	G_OBJECT_CLASS (line_parent_class)->finalize (obj);
#line 1048 "line.c"
}


GType line_get_type (void) {
	static volatile gsize line_type_id__volatile = 0;
	if (g_once_init_enter (&line_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (LineClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) line_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Line), 0, (GInstanceInitFunc) line_instance_init, NULL };
		GType line_type_id;
		line_type_id = g_type_register_static (TYPE_SEED, "Line", &g_define_type_info, 0);
		g_once_init_leave (&line_type_id__volatile, line_type_id);
	}
	return line_type_id__volatile;
}



