/* pod.c generated by valac 0.22.0, the Vala compiler
 * generated from pod.vala, do not modify */

/*  Mutiara motif designer.
Copyright (C) 2011  Nor Jaidi Tuah

This file is part of Mutiara.

Mutiara is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>
#include <gee.h>
#include <locale.h>
#include <cairo.h>


#define TYPE_POD (pod_get_type ())
#define POD(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_POD, Pod))
#define POD_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_POD, PodClass))
#define IS_POD(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_POD))
#define IS_POD_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_POD))
#define POD_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_POD, PodClass))

typedef struct _Pod Pod;
typedef struct _PodClass PodClass;
typedef struct _PodPrivate PodPrivate;

#define TYPE_POINT (point_get_type ())
typedef struct _Point Point;

#define TYPE_SEED (seed_get_type ())
#define SEED(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SEED, Seed))
#define SEED_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SEED, SeedClass))
#define IS_SEED(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SEED))
#define IS_SEED_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SEED))
#define SEED_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SEED, SeedClass))

typedef struct _Seed Seed;
typedef struct _SeedClass SeedClass;

#define TYPE_FLIP (flip_get_type ())

#define TYPE_TWEAK (tweak_get_type ())
typedef struct _Tweak Tweak;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

#define TYPE_LINE (line_get_type ())
#define LINE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LINE, Line))
#define LINE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_LINE, LineClass))
#define IS_LINE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LINE))
#define IS_LINE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_LINE))
#define LINE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_LINE, LineClass))

typedef struct _Line Line;
typedef struct _LineClass LineClass;
typedef struct _SeedPrivate SeedPrivate;

#define TYPE_ROLE (role_get_type ())

#define TYPE_RGBA (rgba_get_type ())
typedef struct _RGBA RGBA;

#define TYPE_RENDER_STYLE (render_style_get_type ())

#define TYPE_PROJECTION (projection_get_type ())
#define PROJECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PROJECTION, Projection))
#define PROJECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PROJECTION, ProjectionClass))
#define IS_PROJECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PROJECTION))
#define IS_PROJECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PROJECTION))
#define PROJECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PROJECTION, ProjectionClass))

typedef struct _Projection Projection;
typedef struct _ProjectionClass ProjectionClass;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _Point {
	gdouble x;
	gdouble y;
};

typedef enum  {
	FLIP_NONE = 0,
	FLIP_Y = 1,
	FLIP_X = 2,
	FLIP_XY = 3
} Flip;

struct _Tweak {
	gdouble scale_x;
	gdouble scale_y;
	gdouble rotate;
	gdouble move_x;
	gdouble move_y;
};

struct _Pod {
	GObject parent_instance;
	PodPrivate * priv;
	gboolean test;
	Flip flip_even;
	Flip flip_odd;
	Tweak tweak;
	gint level_of_detail;
};

struct _PodClass {
	GObjectClass parent_class;
	gchar* (*serialize_aux) (Pod* self);
	void (*compile) (Pod* self, const gchar* s);
	Seed* (*add_seed_at_point) (Pod* self, GType type, Point* p);
	void (*remove) (Pod* self, Seed* seed);
	void (*add) (Pod* self, Seed* seed);
	void (*clear) (Pod* self);
	void (*swap) (Pod* self, gint i, gint j);
};

struct _PodPrivate {
	GeeArrayList* seeds;
};

typedef enum  {
	ROLE_DUAL = 0,
	ROLE_MOTIF = 1,
	ROLE_BASE = 2
} Role;

struct _RGBA {
	gdouble r;
	gdouble g;
	gdouble b;
	gdouble a;
};

typedef enum  {
	RENDER_STYLE_THIN = 0,
	RENDER_STYLE_THICK = 1,
	RENDER_STYLE_HOLLOW = 2,
	RENDER_STYLE_FILLED = 3,
	RENDER_STYLE_CLOSED = 4,
	RENDER_STYLE_NONE = 5
} RenderStyle;

struct _Seed {
	GObject parent_instance;
	SeedPrivate * priv;
	gboolean debug;
	gboolean is_affine;
	Role role;
	gdouble base_offset;
	Flip flip_even;
	Flip flip_odd;
	Tweak tweak;
	gdouble width0;
	gdouble width1;
	gint num_segment;
	gint level_of_detail;
	RGBA color;
	gdouble color_mix;
	RenderStyle render_style;
	Projection** projection;
	gint projection_length1;
	gint selected_control;
	Point pressed_point;
};

struct _SeedClass {
	GObjectClass parent_class;
	void (*init_default_sub) (Seed* self, Point* p);
	void (*init_full_sub) (Seed* self, gdouble* args, int args_length1);
	gchar* (*serialize_sub) (Seed* self);
	void (*point_raw) (Seed* self, gdouble t, Point* result);
	void (*init_distance_to_parametric) (Seed* self);
	void (*distant_point) (Seed* self, gdouble x_distance, gdouble y_distance, Point* result);
	void (*draw_direct) (Seed* self, cairo_t* cr, gdouble scale);
	void (*draw_controls) (Seed* self, cairo_t* cr, gdouble scale);
	gint (*pressed_control) (Seed* self, Point* p, gdouble scale);
	void (*save_drag_context) (Seed* self);
	void (*move_shape) (Seed* self, gdouble delta_x, gdouble delta_y);
	void (*drag_control) (Seed* self, Point* p, gdouble scale, gboolean snap_on, gdouble grid_size, gdouble snap_angle);
	Point* (*points_to_snap) (Seed* self, int* result_length1);
	void (*draw_icon) (Seed* self, cairo_t* cr, gdouble width, gdouble height);
};


static gpointer pod_parent_class = NULL;

GType pod_get_type (void) G_GNUC_CONST;
GType point_get_type (void) G_GNUC_CONST;
Point* point_dup (const Point* self);
void point_free (Point* self);
GType seed_get_type (void) G_GNUC_CONST;
GType flip_get_type (void) G_GNUC_CONST;
GType tweak_get_type (void) G_GNUC_CONST;
Tweak* tweak_dup (const Tweak* self);
void tweak_free (Tweak* self);
#define POD_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_POD, PodPrivate))
enum  {
	POD_DUMMY_PROPERTY,
	POD_SIZE
};
Pod* pod_new (void);
Pod* pod_construct (GType object_type);
static void pod_set_defaults (Pod* self);
void tweak_init (Tweak *self);
gchar* pod_serialize (Pod* self);
gchar* pod_serialize_aux (Pod* self);
static gchar* pod_real_serialize_aux (Pod* self);
gboolean tweak_equals (Tweak *self, Tweak* t);
gchar* tweak_serialize (Tweak *self);
gchar* seed_serialize (Seed* self, gboolean for_border);
void pod_copy (Pod* self, Pod* pod);
void pod_compile (Pod* self, const gchar* s);
gboolean pod_same_as (Pod* self, Pod* pod);
gint pod_search (GeeArrayList* pods, Pod* pod);
static void pod_real_compile (Pod* self, const gchar* s);
Line* line_new (void);
Line* line_construct (GType object_type);
GType line_get_type (void) G_GNUC_CONST;
static void _vala_array_add4 (gdouble** array, int* length, int* size, gdouble value);
static void _vala_array_add5 (gdouble** array, int* length, int* size, gdouble value);
void seed_init_full (Seed* self, gdouble* args, int args_length1);
GType role_get_type (void) G_GNUC_CONST;
GType rgba_get_type (void) G_GNUC_CONST;
RGBA* rgba_dup (const RGBA* self);
void rgba_free (RGBA* self);
GType render_style_get_type (void) G_GNUC_CONST;
gpointer projection_ref (gpointer instance);
void projection_unref (gpointer instance);
GParamSpec* param_spec_projection (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_projection (GValue* value, gpointer v_object);
void value_take_projection (GValue* value, gpointer v_object);
gpointer value_get_projection (const GValue* value);
GType projection_get_type (void) G_GNUC_CONST;
void rgba_init (RGBA *self, gdouble r, gdouble g, gdouble b, gdouble a);
Seed* pod_add_seed_at_point (Pod* self, GType type, Point* p);
static Seed* pod_real_add_seed_at_point (Pod* self, GType type, Point* p);
void seed_init_default (Seed* self, Point* p);
GeeIterator* pod_iterator (Pod* self);
Seed* pod_get (Pod* self, gint n);
gint pod_index_of (Pod* self, Seed* seed);
void pod_remove (Pod* self, Seed* seed);
static void pod_real_remove (Pod* self, Seed* seed);
void pod_add (Pod* self, Seed* seed);
static void pod_real_add (Pod* self, Seed* seed);
void pod_clear (Pod* self);
static void pod_real_clear (Pod* self);
void pod_swap (Pod* self, gint i, gint j);
static void pod_real_swap (Pod* self, gint i, gint j);
gint pod_get_size (Pod* self);
static void pod_finalize (GObject* obj);
static void _vala_pod_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);


Pod* pod_construct (GType object_type) {
	Pod * self = NULL;
#line 43 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	self = (Pod*) g_object_new (object_type, NULL);
#line 44 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	pod_set_defaults (self);
#line 43 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	return self;
#line 284 "pod.c"
}


Pod* pod_new (void) {
#line 43 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	return pod_construct (TYPE_POD);
#line 291 "pod.c"
}


/**
 * Don't change these default. It is assumed in serialized version.
 */
static void pod_set_defaults (Pod* self) {
#line 50 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	g_return_if_fail (self != NULL);
#line 51 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	self->flip_even = FLIP_NONE;
#line 52 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	self->flip_odd = FLIP_Y;
#line 53 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	tweak_init (&self->tweak);
#line 54 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	self->level_of_detail = 100;
#line 309 "pod.c"
}


/**
 * Convert to text that can be compiled ().
 */
gchar* pod_serialize (Pod* self) {
	gchar* result = NULL;
	gchar* locale = NULL;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	gchar* text = NULL;
	gchar* _tmp2_ = NULL;
#line 60 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 61 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	_tmp0_ = setlocale (LC_NUMERIC, NULL);
#line 61 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 61 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	locale = _tmp1_;
#line 62 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	setlocale (LC_NUMERIC, "C");
#line 63 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	_tmp2_ = pod_serialize_aux (self);
#line 63 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	text = _tmp2_;
#line 64 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	setlocale (LC_NUMERIC, locale);
#line 65 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	result = text;
#line 65 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	_g_free0 (locale);
#line 65 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	return result;
#line 345 "pod.c"
}


static gpointer _g_object_ref0 (gpointer self) {
#line 73 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	return self ? g_object_ref (self) : NULL;
#line 352 "pod.c"
}


static gchar* pod_real_serialize_aux (Pod* self) {
	gchar* result = NULL;
	gchar* s = NULL;
	gchar* _tmp0_ = NULL;
	gint _tmp1_ = 0;
	gboolean _tmp7_ = FALSE;
	Flip _tmp8_ = 0;
	gboolean _tmp10_ = FALSE;
	Tweak _tmp17_ = {0};
	gboolean _tmp18_ = FALSE;
#line 69 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	_tmp0_ = g_strdup ("");
#line 69 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	s = _tmp0_;
#line 70 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	_tmp1_ = self->level_of_detail;
#line 70 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	if (_tmp1_ != 100) {
#line 374 "pod.c"
		const gchar* _tmp2_ = NULL;
		gint _tmp3_ = 0;
		gchar* _tmp4_ = NULL;
		gchar* _tmp5_ = NULL;
		gchar* _tmp6_ = NULL;
#line 70 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
		_tmp2_ = s;
#line 70 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
		_tmp3_ = self->level_of_detail;
#line 70 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
		_tmp4_ = g_strdup_printf ("level-of-detail %d\n", _tmp3_);
#line 70 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
		_tmp5_ = _tmp4_;
#line 70 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
		_tmp6_ = g_strconcat (_tmp2_, _tmp5_, NULL);
#line 70 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
		_g_free0 (s);
#line 70 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
		s = _tmp6_;
#line 70 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
		_g_free0 (_tmp5_);
#line 396 "pod.c"
	}
#line 71 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	_tmp8_ = self->flip_even;
#line 71 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	if (_tmp8_ != FLIP_NONE) {
#line 71 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
		_tmp7_ = TRUE;
#line 404 "pod.c"
	} else {
		Flip _tmp9_ = 0;
#line 71 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
		_tmp9_ = self->flip_odd;
#line 71 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
		_tmp7_ = _tmp9_ != FLIP_Y;
#line 411 "pod.c"
	}
#line 71 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	_tmp10_ = _tmp7_;
#line 71 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	if (_tmp10_) {
#line 417 "pod.c"
		const gchar* _tmp11_ = NULL;
		Flip _tmp12_ = 0;
		Flip _tmp13_ = 0;
		gchar* _tmp14_ = NULL;
		gchar* _tmp15_ = NULL;
		gchar* _tmp16_ = NULL;
#line 71 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
		_tmp11_ = s;
#line 71 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
		_tmp12_ = self->flip_even;
#line 71 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
		_tmp13_ = self->flip_odd;
#line 71 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
		_tmp14_ = g_strdup_printf ("flip %d %d\n", (gint) _tmp12_, (gint) _tmp13_);
#line 71 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
		_tmp15_ = _tmp14_;
#line 71 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
		_tmp16_ = g_strconcat (_tmp11_, _tmp15_, NULL);
#line 71 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
		_g_free0 (s);
#line 71 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
		s = _tmp16_;
#line 71 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
		_g_free0 (_tmp15_);
#line 442 "pod.c"
	}
#line 72 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	tweak_init (&_tmp17_);
#line 72 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	_tmp18_ = tweak_equals (&self->tweak, &_tmp17_);
#line 72 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	if (!_tmp18_) {
#line 450 "pod.c"
		const gchar* _tmp19_ = NULL;
		gchar* _tmp20_ = NULL;
		gchar* _tmp21_ = NULL;
		gchar* _tmp22_ = NULL;
		gchar* _tmp23_ = NULL;
		gchar* _tmp24_ = NULL;
#line 72 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
		_tmp19_ = s;
#line 72 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
		_tmp20_ = tweak_serialize (&self->tweak);
#line 72 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
		_tmp21_ = _tmp20_;
#line 72 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
		_tmp22_ = g_strdup_printf ("tweakwhole %s\n", _tmp21_);
#line 72 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
		_tmp23_ = _tmp22_;
#line 72 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
		_tmp24_ = g_strconcat (_tmp19_, _tmp23_, NULL);
#line 72 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
		_g_free0 (s);
#line 72 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
		s = _tmp24_;
#line 72 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
		_g_free0 (_tmp23_);
#line 72 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
		_g_free0 (_tmp21_);
#line 477 "pod.c"
	}
	{
		GeeArrayList* _seed_list = NULL;
		GeeArrayList* _tmp25_ = NULL;
		GeeArrayList* _tmp26_ = NULL;
		gint _seed_size = 0;
		GeeArrayList* _tmp27_ = NULL;
		gint _tmp28_ = 0;
		gint _tmp29_ = 0;
		gint _seed_index = 0;
#line 73 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
		_tmp25_ = self->priv->seeds;
#line 73 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
		_tmp26_ = _g_object_ref0 (_tmp25_);
#line 73 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
		_seed_list = _tmp26_;
#line 73 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
		_tmp27_ = _seed_list;
#line 73 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
		_tmp28_ = gee_abstract_collection_get_size ((GeeCollection*) _tmp27_);
#line 73 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
		_tmp29_ = _tmp28_;
#line 73 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
		_seed_size = _tmp29_;
#line 73 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
		_seed_index = -1;
#line 73 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
		while (TRUE) {
#line 506 "pod.c"
			gint _tmp30_ = 0;
			gint _tmp31_ = 0;
			gint _tmp32_ = 0;
			Seed* seed = NULL;
			GeeArrayList* _tmp33_ = NULL;
			gint _tmp34_ = 0;
			gpointer _tmp35_ = NULL;
			const gchar* _tmp36_ = NULL;
			Seed* _tmp37_ = NULL;
			gchar* _tmp38_ = NULL;
			gchar* _tmp39_ = NULL;
			gchar* _tmp40_ = NULL;
#line 73 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
			_tmp30_ = _seed_index;
#line 73 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
			_seed_index = _tmp30_ + 1;
#line 73 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
			_tmp31_ = _seed_index;
#line 73 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
			_tmp32_ = _seed_size;
#line 73 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
			if (!(_tmp31_ < _tmp32_)) {
#line 73 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
				break;
#line 531 "pod.c"
			}
#line 73 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
			_tmp33_ = _seed_list;
#line 73 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
			_tmp34_ = _seed_index;
#line 73 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
			_tmp35_ = gee_abstract_list_get ((GeeAbstractList*) _tmp33_, _tmp34_);
#line 73 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
			seed = (Seed*) _tmp35_;
#line 73 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
			_tmp36_ = s;
#line 73 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
			_tmp37_ = seed;
#line 73 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
			_tmp38_ = seed_serialize (_tmp37_, FALSE);
#line 73 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
			_tmp39_ = _tmp38_;
#line 73 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
			_tmp40_ = g_strconcat (_tmp36_, _tmp39_, NULL);
#line 73 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
			_g_free0 (s);
#line 73 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
			s = _tmp40_;
#line 73 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
			_g_free0 (_tmp39_);
#line 73 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
			_g_object_unref0 (seed);
#line 559 "pod.c"
		}
#line 73 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
		_g_object_unref0 (_seed_list);
#line 563 "pod.c"
	}
#line 74 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	result = s;
#line 74 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	return result;
#line 569 "pod.c"
}


gchar* pod_serialize_aux (Pod* self) {
#line 68 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 68 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	return POD_GET_CLASS (self)->serialize_aux (self);
#line 578 "pod.c"
}


/**
 * Quick and dirty way of copying
 */
void pod_copy (Pod* self, Pod* pod) {
	Pod* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
#line 80 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	g_return_if_fail (self != NULL);
#line 80 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	g_return_if_fail (pod != NULL);
#line 81 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	_tmp0_ = pod;
#line 81 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	_tmp1_ = pod_serialize (_tmp0_);
#line 81 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	_tmp2_ = _tmp1_;
#line 81 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	pod_compile (self, _tmp2_);
#line 81 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	_g_free0 (_tmp2_);
#line 603 "pod.c"
}


/**
 * Check if this pod is approximately equal to another
 */
gboolean pod_same_as (Pod* self, Pod* pod) {
	gboolean result = FALSE;
	gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	Pod* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	gboolean _tmp5_ = FALSE;
#line 87 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 87 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	g_return_val_if_fail (pod != NULL, FALSE);
#line 88 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	_tmp0_ = pod_serialize (self);
#line 88 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	_tmp1_ = _tmp0_;
#line 88 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	_tmp2_ = pod;
#line 88 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	_tmp3_ = pod_serialize (_tmp2_);
#line 88 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	_tmp4_ = _tmp3_;
#line 88 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	_tmp5_ = g_strcmp0 (_tmp1_, _tmp4_) == 0;
#line 88 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	_g_free0 (_tmp4_);
#line 88 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	_g_free0 (_tmp1_);
#line 88 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	result = _tmp5_;
#line 88 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	return result;
#line 642 "pod.c"
}


gint pod_search (GeeArrayList* pods, Pod* pod) {
	gint result = 0;
#line 91 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	g_return_val_if_fail (pods != NULL, 0);
#line 91 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	g_return_val_if_fail (pod != NULL, 0);
#line 652 "pod.c"
	{
		gint i = 0;
#line 92 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
		i = 0;
#line 657 "pod.c"
		{
			gboolean _tmp0_ = FALSE;
#line 92 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
			_tmp0_ = TRUE;
#line 92 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
			while (TRUE) {
#line 664 "pod.c"
				gboolean _tmp1_ = FALSE;
				gint _tmp3_ = 0;
				GeeArrayList* _tmp4_ = NULL;
				gint _tmp5_ = 0;
				gint _tmp6_ = 0;
				GeeArrayList* _tmp7_ = NULL;
				gint _tmp8_ = 0;
				gpointer _tmp9_ = NULL;
				Pod* _tmp10_ = NULL;
				Pod* _tmp11_ = NULL;
				gboolean _tmp12_ = FALSE;
				gboolean _tmp13_ = FALSE;
#line 92 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
				_tmp1_ = _tmp0_;
#line 92 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
				if (!_tmp1_) {
#line 681 "pod.c"
					gint _tmp2_ = 0;
#line 92 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
					_tmp2_ = i;
#line 92 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
					i = _tmp2_ + 1;
#line 687 "pod.c"
				}
#line 92 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
				_tmp0_ = FALSE;
#line 92 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
				_tmp3_ = i;
#line 92 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
				_tmp4_ = pods;
#line 92 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
				_tmp5_ = gee_abstract_collection_get_size ((GeeCollection*) _tmp4_);
#line 92 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
				_tmp6_ = _tmp5_;
#line 92 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
				if (!(_tmp3_ < _tmp6_)) {
#line 92 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
					break;
#line 703 "pod.c"
				}
#line 93 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
				_tmp7_ = pods;
#line 93 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
				_tmp8_ = i;
#line 93 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
				_tmp9_ = gee_abstract_list_get ((GeeAbstractList*) _tmp7_, _tmp8_);
#line 93 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
				_tmp10_ = (Pod*) _tmp9_;
#line 93 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
				_tmp11_ = pod;
#line 93 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
				_tmp12_ = pod_same_as (_tmp10_, _tmp11_);
#line 93 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
				_tmp13_ = _tmp12_;
#line 93 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
				_g_object_unref0 (_tmp10_);
#line 93 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
				if (_tmp13_) {
#line 93 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
					result = i;
#line 93 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
					return result;
#line 727 "pod.c"
				}
			}
		}
	}
#line 95 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	result = -1;
#line 95 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	return result;
#line 736 "pod.c"
}


/**
 * A very forgiving compiler
 */
static gchar* string_strip (const gchar* self) {
	gchar* result = NULL;
	gchar* _result_ = NULL;
	gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
#line 1084 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1085 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1085 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1086 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1086 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	g_strstrip (_tmp1_);
#line 1087 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	result = _result_;
#line 1087 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	return result;
#line 762 "pod.c"
}


static gdouble double_parse (const gchar* str) {
	gdouble result = 0.0;
	const gchar* _tmp0_ = NULL;
	gdouble _tmp1_ = 0.0;
#line 787 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	g_return_val_if_fail (str != NULL, 0.0);
#line 788 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	_tmp0_ = str;
#line 788 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	_tmp1_ = g_ascii_strtod (_tmp0_, NULL);
#line 788 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	result = _tmp1_;
#line 788 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	return result;
#line 780 "pod.c"
}


static void _vala_array_add4 (gdouble** array, int* length, int* size, gdouble value) {
#line 115 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	if ((*length) == (*size)) {
#line 115 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 115 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
		*array = g_renew (gdouble, *array, *size);
#line 791 "pod.c"
	}
#line 115 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	(*array)[(*length)++] = value;
#line 795 "pod.c"
}


static void _vala_array_add5 (gdouble** array, int* length, int* size, gdouble value) {
#line 118 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	if ((*length) == (*size)) {
#line 118 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 118 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
		*array = g_renew (gdouble, *array, *size);
#line 806 "pod.c"
	}
#line 118 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	(*array)[(*length)++] = value;
#line 810 "pod.c"
}


static void pod_real_compile (Pod* self, const gchar* s) {
	GeeArrayList* _tmp0_ = NULL;
	Seed* null_seed = NULL;
	Line* _tmp1_ = NULL;
	Seed* seed = NULL;
	Seed* _tmp2_ = NULL;
	Seed* _tmp3_ = NULL;
	const gchar* _tmp4_ = NULL;
	gchar** _tmp5_ = NULL;
	gchar** _tmp6_ = NULL;
#line 101 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	g_return_if_fail (s != NULL);
#line 102 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	pod_set_defaults (self);
#line 103 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	_tmp0_ = self->priv->seeds;
#line 103 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp0_);
#line 105 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	_tmp1_ = line_new ();
#line 105 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	null_seed = (Seed*) _tmp1_;
#line 106 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	_tmp2_ = null_seed;
#line 106 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 106 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	seed = _tmp3_;
#line 107 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	_tmp4_ = s;
#line 107 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	_tmp6_ = _tmp5_ = g_strsplit (_tmp4_, "\n", 0);
#line 846 "pod.c"
	{
		gchar** line_collection = NULL;
		gint line_collection_length1 = 0;
		gint _line_collection_size_ = 0;
		gint line_it = 0;
#line 107 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
		line_collection = _tmp6_;
#line 107 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
		line_collection_length1 = _vala_array_length (_tmp5_);
#line 107 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
		for (line_it = 0; line_it < _vala_array_length (_tmp5_); line_it = line_it + 1) {
#line 858 "pod.c"
			gchar* _tmp7_ = NULL;
			gchar* line = NULL;
#line 107 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
			_tmp7_ = g_strdup (line_collection[line_it]);
#line 107 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
			line = _tmp7_;
#line 865 "pod.c"
			{
				gchar** cmdarg = NULL;
				const gchar* _tmp8_ = NULL;
				gchar* _tmp9_ = NULL;
				gchar* _tmp10_ = NULL;
				gchar** _tmp11_ = NULL;
				gchar** _tmp12_ = NULL;
				gchar** _tmp13_ = NULL;
				gint _tmp13__length1 = 0;
				gint cmdarg_length1 = 0;
				gint _cmdarg_size_ = 0;
				gchar** _tmp14_ = NULL;
				gint _tmp14__length1 = 0;
				gdouble* arg = NULL;
				gdouble* _tmp15_ = NULL;
				gint arg_length1 = 0;
				gint _arg_size_ = 0;
				gchar** _tmp16_ = NULL;
				gint _tmp16__length1 = 0;
				gchar** _tmp33_ = NULL;
				gint _tmp33__length1 = 0;
				const gchar* _tmp34_ = NULL;
				const gchar* _tmp35_ = NULL;
				GQuark _tmp37_ = 0U;
#line 120 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
				static GQuark _tmp36_label0 = 0;
#line 120 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
				static GQuark _tmp36_label1 = 0;
#line 120 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
				static GQuark _tmp36_label2 = 0;
#line 120 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
				static GQuark _tmp36_label3 = 0;
#line 120 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
				static GQuark _tmp36_label4 = 0;
#line 120 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
				static GQuark _tmp36_label5 = 0;
#line 120 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
				static GQuark _tmp36_label6 = 0;
#line 120 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
				static GQuark _tmp36_label7 = 0;
#line 120 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
				static GQuark _tmp36_label8 = 0;
#line 120 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
				static GQuark _tmp36_label9 = 0;
#line 120 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
				static GQuark _tmp36_label10 = 0;
#line 120 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
				static GQuark _tmp36_label11 = 0;
#line 120 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
				static GQuark _tmp36_label12 = 0;
#line 120 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
				static GQuark _tmp36_label13 = 0;
#line 120 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
				static GQuark _tmp36_label14 = 0;
#line 109 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
				_tmp8_ = line;
#line 109 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
				_tmp9_ = string_strip (_tmp8_);
#line 109 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
				_tmp10_ = _tmp9_;
#line 109 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
				_tmp12_ = _tmp11_ = g_strsplit (_tmp10_, " ", 2);
#line 109 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
				_tmp13_ = _tmp12_;
#line 109 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
				_tmp13__length1 = _vala_array_length (_tmp11_);
#line 109 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
				_g_free0 (_tmp10_);
#line 109 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
				cmdarg = _tmp13_;
#line 109 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
				cmdarg_length1 = _tmp13__length1;
#line 109 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
				_cmdarg_size_ = cmdarg_length1;
#line 110 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
				_tmp14_ = cmdarg;
#line 110 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
				_tmp14__length1 = cmdarg_length1;
#line 110 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
				if (_tmp14__length1 == 0) {
#line 110 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
					cmdarg = (_vala_array_free (cmdarg, cmdarg_length1, (GDestroyNotify) g_free), NULL);
#line 110 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
					_g_free0 (line);
#line 110 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
					continue;
#line 952 "pod.c"
				}
#line 111 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
				_tmp15_ = g_new0 (gdouble, 0);
#line 111 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
				arg = _tmp15_;
#line 111 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
				arg_length1 = 0;
#line 111 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
				_arg_size_ = arg_length1;
#line 112 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
				_tmp16_ = cmdarg;
#line 112 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
				_tmp16__length1 = cmdarg_length1;
#line 112 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
				if (_tmp16__length1 == 2) {
#line 968 "pod.c"
					gchar** _tmp17_ = NULL;
					gint _tmp17__length1 = 0;
					const gchar* _tmp18_ = NULL;
					gchar** _tmp19_ = NULL;
					gchar** _tmp20_ = NULL;
#line 113 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
					_tmp17_ = cmdarg;
#line 113 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
					_tmp17__length1 = cmdarg_length1;
#line 113 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
					_tmp18_ = _tmp17_[1];
#line 113 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
					_tmp20_ = _tmp19_ = g_regex_split_simple ("[\\(|\\)|\\,|\\s]++", _tmp18_, 0, 0);
#line 982 "pod.c"
					{
						gchar** token_collection = NULL;
						gint token_collection_length1 = 0;
						gint _token_collection_size_ = 0;
						gint token_it = 0;
#line 113 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
						token_collection = _tmp20_;
#line 113 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
						token_collection_length1 = _vala_array_length (_tmp19_);
#line 113 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
						for (token_it = 0; token_it < _vala_array_length (_tmp19_); token_it = token_it + 1) {
#line 994 "pod.c"
							gchar* _tmp21_ = NULL;
							gchar* token = NULL;
#line 113 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							_tmp21_ = g_strdup (token_collection[token_it]);
#line 113 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							token = _tmp21_;
#line 1001 "pod.c"
							{
								const gchar* _tmp22_ = NULL;
								gint _tmp23_ = 0;
								gint _tmp24_ = 0;
								gdouble* _tmp25_ = NULL;
								gint _tmp25__length1 = 0;
								const gchar* _tmp26_ = NULL;
								gdouble _tmp27_ = 0.0;
#line 114 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
								_tmp22_ = token;
#line 114 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
								_tmp23_ = strlen (_tmp22_);
#line 114 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
								_tmp24_ = _tmp23_;
#line 114 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
								if (_tmp24_ == 0) {
#line 114 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
									_g_free0 (token);
#line 114 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
									continue;
#line 1022 "pod.c"
								}
#line 115 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
								_tmp25_ = arg;
#line 115 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
								_tmp25__length1 = arg_length1;
#line 115 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
								_tmp26_ = token;
#line 115 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
								_tmp27_ = double_parse (_tmp26_);
#line 115 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
								_vala_array_add4 (&arg, &arg_length1, &_arg_size_, _tmp27_);
#line 113 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
								_g_free0 (token);
#line 1036 "pod.c"
							}
						}
#line 113 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
						token_collection = (_vala_array_free (token_collection, token_collection_length1, (GDestroyNotify) g_free), NULL);
#line 1041 "pod.c"
					}
					{
						gint i = 0;
#line 118 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
						i = 0;
#line 1047 "pod.c"
						{
							gboolean _tmp28_ = FALSE;
#line 118 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							_tmp28_ = TRUE;
#line 118 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							while (TRUE) {
#line 1054 "pod.c"
								gboolean _tmp29_ = FALSE;
								gint _tmp31_ = 0;
								gdouble* _tmp32_ = NULL;
								gint _tmp32__length1 = 0;
#line 118 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
								_tmp29_ = _tmp28_;
#line 118 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
								if (!_tmp29_) {
#line 1063 "pod.c"
									gint _tmp30_ = 0;
#line 118 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
									_tmp30_ = i;
#line 118 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
									i = _tmp30_ + 1;
#line 1069 "pod.c"
								}
#line 118 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
								_tmp28_ = FALSE;
#line 118 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
								_tmp31_ = i;
#line 118 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
								if (!(_tmp31_ < 10)) {
#line 118 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
									break;
#line 1079 "pod.c"
								}
#line 118 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
								_tmp32_ = arg;
#line 118 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
								_tmp32__length1 = arg_length1;
#line 118 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
								_vala_array_add5 (&arg, &arg_length1, &_arg_size_, 0.0);
#line 1087 "pod.c"
							}
						}
					}
				}
#line 120 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
				_tmp33_ = cmdarg;
#line 120 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
				_tmp33__length1 = cmdarg_length1;
#line 120 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
				_tmp34_ = _tmp33_[0];
#line 120 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
				_tmp35_ = _tmp34_;
#line 120 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
				_tmp37_ = (NULL == _tmp35_) ? 0 : g_quark_from_string (_tmp35_);
#line 120 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
				if (((_tmp37_ == ((0 != _tmp36_label0) ? _tmp36_label0 : (_tmp36_label0 = g_quark_from_static_string ("Line")))) || (_tmp37_ == ((0 != _tmp36_label1) ? _tmp36_label1 : (_tmp36_label1 = g_quark_from_static_string ("Curve"))))) || (_tmp37_ == ((0 != _tmp36_label2) ? _tmp36_label2 : (_tmp36_label2 = g_quark_from_static_string ("Arc"))))) {
#line 120 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
					switch (0) {
#line 1106 "pod.c"
						default:
						{
							gchar** _tmp38_ = NULL;
							gint _tmp38__length1 = 0;
							const gchar* _tmp39_ = NULL;
							GType _tmp40_ = 0UL;
							GObject* _tmp41_ = NULL;
							GObject* _tmp42_ = NULL;
							Seed* _tmp43_ = NULL;
							gdouble* _tmp44_ = NULL;
							gint _tmp44__length1 = 0;
							GeeArrayList* _tmp45_ = NULL;
							Seed* _tmp46_ = NULL;
#line 124 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							_tmp38_ = cmdarg;
#line 124 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							_tmp38__length1 = cmdarg_length1;
#line 124 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							_tmp39_ = _tmp38_[0];
#line 124 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							_tmp40_ = g_type_from_name (_tmp39_);
#line 124 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							_tmp41_ = g_object_new (_tmp40_, NULL);
#line 124 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							_tmp42_ = G_IS_INITIALLY_UNOWNED (_tmp41_) ? g_object_ref_sink (_tmp41_) : _tmp41_;
#line 124 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							_g_object_unref0 (seed);
#line 124 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							seed = G_TYPE_CHECK_INSTANCE_CAST (_tmp42_, TYPE_SEED, Seed);
#line 125 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							_tmp43_ = seed;
#line 125 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							_tmp44_ = arg;
#line 125 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							_tmp44__length1 = arg_length1;
#line 125 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							seed_init_full (_tmp43_, _tmp44_, _tmp44__length1);
#line 126 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							_tmp45_ = self->priv->seeds;
#line 126 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							_tmp46_ = seed;
#line 126 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							gee_abstract_collection_add ((GeeAbstractCollection*) _tmp45_, _tmp46_);
#line 127 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							break;
#line 1152 "pod.c"
						}
					}
				} else if (_tmp37_ == ((0 != _tmp36_label3) ? _tmp36_label3 : (_tmp36_label3 = g_quark_from_static_string ("test")))) {
#line 124 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
					switch (0) {
#line 1158 "pod.c"
						default:
						{
#line 129 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							self->test = TRUE;
#line 130 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							break;
#line 1165 "pod.c"
						}
					}
				} else if (_tmp37_ == ((0 != _tmp36_label4) ? _tmp36_label4 : (_tmp36_label4 = g_quark_from_static_string ("segmentation")))) {
#line 124 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
					switch (0) {
#line 1171 "pod.c"
						default:
						{
							Seed* _tmp47_ = NULL;
							gdouble* _tmp48_ = NULL;
							gint _tmp48__length1 = 0;
							gdouble _tmp49_ = 0.0;
							Seed* _tmp50_ = NULL;
							gdouble* _tmp51_ = NULL;
							gint _tmp51__length1 = 0;
							gdouble _tmp52_ = 0.0;
#line 132 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							_tmp47_ = seed;
#line 132 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							_tmp48_ = arg;
#line 132 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							_tmp48__length1 = arg_length1;
#line 132 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							_tmp49_ = _tmp48_[0];
#line 132 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							_tmp47_->base_offset = _tmp49_;
#line 133 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							_tmp50_ = seed;
#line 133 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							_tmp51_ = arg;
#line 133 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							_tmp51__length1 = arg_length1;
#line 133 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							_tmp52_ = _tmp51_[1];
#line 133 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							_tmp50_->num_segment = (gint) _tmp52_;
#line 134 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							break;
#line 1204 "pod.c"
						}
					}
				} else if (_tmp37_ == ((0 != _tmp36_label5) ? _tmp36_label5 : (_tmp36_label5 = g_quark_from_static_string ("width")))) {
#line 124 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
					switch (0) {
#line 1210 "pod.c"
						default:
						{
							Seed* _tmp53_ = NULL;
							gdouble* _tmp54_ = NULL;
							gint _tmp54__length1 = 0;
							gdouble _tmp55_ = 0.0;
							Seed* _tmp56_ = NULL;
							gdouble* _tmp57_ = NULL;
							gint _tmp57__length1 = 0;
							gdouble _tmp58_ = 0.0;
#line 136 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							_tmp53_ = seed;
#line 136 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							_tmp54_ = arg;
#line 136 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							_tmp54__length1 = arg_length1;
#line 136 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							_tmp55_ = _tmp54_[0];
#line 136 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							_tmp53_->width0 = _tmp55_;
#line 137 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							_tmp56_ = seed;
#line 137 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							_tmp57_ = arg;
#line 137 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							_tmp57__length1 = arg_length1;
#line 137 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							_tmp58_ = _tmp57_[1];
#line 137 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							_tmp56_->width1 = _tmp58_;
#line 138 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							break;
#line 1243 "pod.c"
						}
					}
				} else if (_tmp37_ == ((0 != _tmp36_label6) ? _tmp36_label6 : (_tmp36_label6 = g_quark_from_static_string ("replication")))) {
#line 124 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
					switch (0) {
#line 1249 "pod.c"
						default:
						{
							Seed* _tmp59_ = NULL;
							gdouble* _tmp60_ = NULL;
							gint _tmp60__length1 = 0;
							gdouble _tmp61_ = 0.0;
							Seed* _tmp62_ = NULL;
							gdouble* _tmp63_ = NULL;
							gint _tmp63__length1 = 0;
							gdouble _tmp64_ = 0.0;
							Seed* _tmp65_ = NULL;
							gdouble* _tmp66_ = NULL;
							gint _tmp66__length1 = 0;
							gdouble _tmp67_ = 0.0;
							Seed* _tmp68_ = NULL;
							gdouble* _tmp69_ = NULL;
							gint _tmp69__length1 = 0;
							gdouble _tmp70_ = 0.0;
#line 140 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							_tmp59_ = seed;
#line 140 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							_tmp60_ = arg;
#line 140 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							_tmp60__length1 = arg_length1;
#line 140 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							_tmp61_ = _tmp60_[0];
#line 140 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							_tmp59_->role = (Role) _tmp61_;
#line 141 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							_tmp62_ = seed;
#line 141 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							_tmp63_ = arg;
#line 141 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							_tmp63__length1 = arg_length1;
#line 141 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							_tmp64_ = _tmp63_[1];
#line 141 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							_tmp62_->level_of_detail = (gint) _tmp64_;
#line 142 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							_tmp65_ = seed;
#line 142 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							_tmp66_ = arg;
#line 142 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							_tmp66__length1 = arg_length1;
#line 142 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							_tmp67_ = _tmp66_[2];
#line 142 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							_tmp65_->flip_even = (Flip) _tmp67_;
#line 143 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							_tmp68_ = seed;
#line 143 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							_tmp69_ = arg;
#line 143 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							_tmp69__length1 = arg_length1;
#line 143 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							_tmp70_ = _tmp69_[3];
#line 143 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							_tmp68_->flip_odd = (Flip) _tmp70_;
#line 144 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							break;
#line 1310 "pod.c"
						}
					}
				} else if (_tmp37_ == ((0 != _tmp36_label7) ? _tmp36_label7 : (_tmp36_label7 = g_quark_from_static_string ("level-of-detail")))) {
#line 124 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
					switch (0) {
#line 1316 "pod.c"
						default:
						{
							gdouble* _tmp71_ = NULL;
							gint _tmp71__length1 = 0;
							gdouble _tmp72_ = 0.0;
#line 146 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							_tmp71_ = arg;
#line 146 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							_tmp71__length1 = arg_length1;
#line 146 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							_tmp72_ = _tmp71_[0];
#line 146 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							self->level_of_detail = (gint) _tmp72_;
#line 147 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							break;
#line 1332 "pod.c"
						}
					}
				} else if (_tmp37_ == ((0 != _tmp36_label8) ? _tmp36_label8 : (_tmp36_label8 = g_quark_from_static_string ("flip")))) {
#line 124 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
					switch (0) {
#line 1338 "pod.c"
						default:
						{
							gdouble* _tmp73_ = NULL;
							gint _tmp73__length1 = 0;
							gdouble _tmp74_ = 0.0;
							gdouble* _tmp75_ = NULL;
							gint _tmp75__length1 = 0;
							gdouble _tmp76_ = 0.0;
#line 149 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							_tmp73_ = arg;
#line 149 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							_tmp73__length1 = arg_length1;
#line 149 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							_tmp74_ = _tmp73_[0];
#line 149 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							self->flip_even = (Flip) _tmp74_;
#line 150 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							_tmp75_ = arg;
#line 150 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							_tmp75__length1 = arg_length1;
#line 150 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							_tmp76_ = _tmp75_[1];
#line 150 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							self->flip_odd = (Flip) _tmp76_;
#line 151 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							break;
#line 1365 "pod.c"
						}
					}
				} else if (_tmp37_ == ((0 != _tmp36_label9) ? _tmp36_label9 : (_tmp36_label9 = g_quark_from_static_string ("tweak")))) {
#line 124 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
					switch (0) {
#line 1371 "pod.c"
						default:
						{
							Seed* _tmp77_ = NULL;
							gdouble* _tmp78_ = NULL;
							gint _tmp78__length1 = 0;
							gdouble _tmp79_ = 0.0;
							Seed* _tmp80_ = NULL;
							gdouble* _tmp81_ = NULL;
							gint _tmp81__length1 = 0;
							gdouble _tmp82_ = 0.0;
							Seed* _tmp83_ = NULL;
							gdouble* _tmp84_ = NULL;
							gint _tmp84__length1 = 0;
							gdouble _tmp85_ = 0.0;
							Seed* _tmp86_ = NULL;
							gdouble* _tmp87_ = NULL;
							gint _tmp87__length1 = 0;
							gdouble _tmp88_ = 0.0;
							Seed* _tmp89_ = NULL;
							gdouble* _tmp90_ = NULL;
							gint _tmp90__length1 = 0;
							gdouble _tmp91_ = 0.0;
#line 153 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							_tmp77_ = seed;
#line 153 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							_tmp78_ = arg;
#line 153 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							_tmp78__length1 = arg_length1;
#line 153 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							_tmp79_ = _tmp78_[0];
#line 153 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							_tmp77_->tweak.scale_x = _tmp79_;
#line 154 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							_tmp80_ = seed;
#line 154 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							_tmp81_ = arg;
#line 154 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							_tmp81__length1 = arg_length1;
#line 154 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							_tmp82_ = _tmp81_[1];
#line 154 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							_tmp80_->tweak.scale_y = _tmp82_;
#line 155 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							_tmp83_ = seed;
#line 155 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							_tmp84_ = arg;
#line 155 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							_tmp84__length1 = arg_length1;
#line 155 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							_tmp85_ = _tmp84_[2];
#line 155 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							_tmp83_->tweak.rotate = _tmp85_;
#line 156 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							_tmp86_ = seed;
#line 156 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							_tmp87_ = arg;
#line 156 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							_tmp87__length1 = arg_length1;
#line 156 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							_tmp88_ = _tmp87_[3];
#line 156 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							_tmp86_->tweak.move_x = _tmp88_;
#line 157 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							_tmp89_ = seed;
#line 157 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							_tmp90_ = arg;
#line 157 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							_tmp90__length1 = arg_length1;
#line 157 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							_tmp91_ = _tmp90_[4];
#line 157 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							_tmp89_->tweak.move_y = _tmp91_;
#line 158 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							break;
#line 1446 "pod.c"
						}
					}
				} else if (_tmp37_ == ((0 != _tmp36_label10) ? _tmp36_label10 : (_tmp36_label10 = g_quark_from_static_string ("tweakwhole")))) {
#line 124 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
					switch (0) {
#line 1452 "pod.c"
						default:
						{
							gdouble* _tmp92_ = NULL;
							gint _tmp92__length1 = 0;
							gdouble _tmp93_ = 0.0;
							gdouble* _tmp94_ = NULL;
							gint _tmp94__length1 = 0;
							gdouble _tmp95_ = 0.0;
							gdouble* _tmp96_ = NULL;
							gint _tmp96__length1 = 0;
							gdouble _tmp97_ = 0.0;
							gdouble* _tmp98_ = NULL;
							gint _tmp98__length1 = 0;
							gdouble _tmp99_ = 0.0;
							gdouble* _tmp100_ = NULL;
							gint _tmp100__length1 = 0;
							gdouble _tmp101_ = 0.0;
#line 160 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							_tmp92_ = arg;
#line 160 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							_tmp92__length1 = arg_length1;
#line 160 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							_tmp93_ = _tmp92_[0];
#line 160 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							self->tweak.scale_x = _tmp93_;
#line 161 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							_tmp94_ = arg;
#line 161 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							_tmp94__length1 = arg_length1;
#line 161 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							_tmp95_ = _tmp94_[1];
#line 161 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							self->tweak.scale_y = _tmp95_;
#line 162 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							_tmp96_ = arg;
#line 162 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							_tmp96__length1 = arg_length1;
#line 162 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							_tmp97_ = _tmp96_[2];
#line 162 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							self->tweak.rotate = _tmp97_;
#line 163 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							_tmp98_ = arg;
#line 163 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							_tmp98__length1 = arg_length1;
#line 163 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							_tmp99_ = _tmp98_[3];
#line 163 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							self->tweak.move_x = _tmp99_;
#line 164 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							_tmp100_ = arg;
#line 164 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							_tmp100__length1 = arg_length1;
#line 164 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							_tmp101_ = _tmp100_[4];
#line 164 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							self->tweak.move_y = _tmp101_;
#line 165 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							break;
#line 1512 "pod.c"
						}
					}
				} else if (_tmp37_ == ((0 != _tmp36_label11) ? _tmp36_label11 : (_tmp36_label11 = g_quark_from_static_string ("color")))) {
#line 124 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
					switch (0) {
#line 1518 "pod.c"
						default:
						{
							Seed* _tmp102_ = NULL;
							gdouble* _tmp103_ = NULL;
							gint _tmp103__length1 = 0;
							gdouble _tmp104_ = 0.0;
							gdouble* _tmp105_ = NULL;
							gint _tmp105__length1 = 0;
							gdouble _tmp106_ = 0.0;
							gdouble* _tmp107_ = NULL;
							gint _tmp107__length1 = 0;
							gdouble _tmp108_ = 0.0;
							gdouble* _tmp109_ = NULL;
							gint _tmp109__length1 = 0;
							gdouble _tmp110_ = 0.0;
							Seed* _tmp111_ = NULL;
							gdouble* _tmp112_ = NULL;
							gint _tmp112__length1 = 0;
							gdouble _tmp113_ = 0.0;
#line 167 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							_tmp102_ = seed;
#line 167 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							_tmp103_ = arg;
#line 167 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							_tmp103__length1 = arg_length1;
#line 167 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							_tmp104_ = _tmp103_[0];
#line 167 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							_tmp105_ = arg;
#line 167 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							_tmp105__length1 = arg_length1;
#line 167 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							_tmp106_ = _tmp105_[1];
#line 167 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							_tmp107_ = arg;
#line 167 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							_tmp107__length1 = arg_length1;
#line 167 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							_tmp108_ = _tmp107_[2];
#line 167 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							_tmp109_ = arg;
#line 167 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							_tmp109__length1 = arg_length1;
#line 167 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							_tmp110_ = _tmp109_[3];
#line 167 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							rgba_init (&_tmp102_->color, _tmp104_, _tmp106_, _tmp108_, _tmp110_);
#line 168 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							_tmp111_ = seed;
#line 168 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							_tmp112_ = arg;
#line 168 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							_tmp112__length1 = arg_length1;
#line 168 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							_tmp113_ = _tmp112_[4];
#line 168 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							_tmp111_->color_mix = _tmp113_;
#line 169 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							break;
#line 1578 "pod.c"
						}
					}
				} else if (_tmp37_ == ((0 != _tmp36_label12) ? _tmp36_label12 : (_tmp36_label12 = g_quark_from_static_string ("style")))) {
#line 124 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
					switch (0) {
#line 1584 "pod.c"
						default:
						{
							Seed* _tmp114_ = NULL;
							gdouble* _tmp115_ = NULL;
							gint _tmp115__length1 = 0;
							gdouble _tmp116_ = 0.0;
#line 171 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							_tmp114_ = seed;
#line 171 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							_tmp115_ = arg;
#line 171 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							_tmp115__length1 = arg_length1;
#line 171 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							_tmp116_ = _tmp115_[0];
#line 171 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							_tmp114_->render_style = (RenderStyle) _tmp116_;
#line 172 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							break;
#line 1603 "pod.c"
						}
					}
				} else if (_tmp37_ == ((0 != _tmp36_label13) ? _tmp36_label13 : (_tmp36_label13 = g_quark_from_static_string ("debug")))) {
#line 124 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
					switch (0) {
#line 1609 "pod.c"
						default:
						{
							Seed* _tmp117_ = NULL;
#line 174 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							_tmp117_ = seed;
#line 174 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							_tmp117_->debug = TRUE;
#line 175 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							break;
#line 1619 "pod.c"
						}
					}
				} else if (_tmp37_ == ((0 != _tmp36_label14) ? _tmp36_label14 : (_tmp36_label14 = g_quark_from_static_string ("#")))) {
#line 124 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
					switch (0) {
#line 1625 "pod.c"
						default:
						{
#line 177 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							break;
#line 1630 "pod.c"
						}
					}
				} else {
#line 124 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
					switch (0) {
#line 1636 "pod.c"
						default:
						{
							gchar** _tmp118_ = NULL;
							gint _tmp118__length1 = 0;
							const gchar* _tmp119_ = NULL;
#line 179 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							_tmp118_ = cmdarg;
#line 179 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							_tmp118__length1 = cmdarg_length1;
#line 179 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							_tmp119_ = _tmp118_[0];
#line 179 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							g_warning ("pod.vala:179: Unknown option: %s", _tmp119_);
#line 180 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
							break;
#line 1652 "pod.c"
						}
					}
				}
#line 120 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
				arg = (g_free (arg), NULL);
#line 120 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
				cmdarg = (_vala_array_free (cmdarg, cmdarg_length1, (GDestroyNotify) g_free), NULL);
#line 120 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
				_g_free0 (line);
#line 1662 "pod.c"
			}
		}
#line 120 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
		line_collection = (_vala_array_free (line_collection, line_collection_length1, (GDestroyNotify) g_free), NULL);
#line 1667 "pod.c"
	}
#line 183 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	g_signal_emit_by_name (self, "signal-changed");
#line 107 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	_g_object_unref0 (seed);
#line 107 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	_g_object_unref0 (null_seed);
#line 1675 "pod.c"
}


void pod_compile (Pod* self, const gchar* s) {
#line 107 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	g_return_if_fail (self != NULL);
#line 107 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	POD_GET_CLASS (self)->compile (self, s);
#line 1684 "pod.c"
}


static Seed* pod_real_add_seed_at_point (Pod* self, GType type, Point* p) {
	Seed* result = NULL;
	Seed* seed = NULL;
	GType _tmp0_ = 0UL;
	GObject* _tmp1_ = NULL;
	GObject* _tmp2_ = NULL;
	Seed* _tmp3_ = NULL;
	Point _tmp4_ = {0};
	GeeArrayList* _tmp5_ = NULL;
#line 186 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	g_return_val_if_fail (p != NULL, NULL);
#line 187 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	_tmp0_ = type;
#line 187 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	_tmp1_ = g_object_new (_tmp0_, NULL);
#line 187 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	_tmp2_ = G_IS_INITIALLY_UNOWNED (_tmp1_) ? g_object_ref_sink (_tmp1_) : _tmp1_;
#line 187 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	_tmp3_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp2_, TYPE_SEED) ? ((Seed*) _tmp2_) : NULL;
#line 187 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	if (_tmp3_ == NULL) {
#line 187 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
		_g_object_unref0 (_tmp2_);
#line 1711 "pod.c"
	}
#line 187 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	seed = _tmp3_;
#line 188 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	_vala_assert (seed != NULL, "seed != null");
#line 189 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	_tmp4_ = *p;
#line 189 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	seed_init_default (seed, &_tmp4_);
#line 190 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	_tmp5_ = self->priv->seeds;
#line 190 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp5_, seed);
#line 191 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	result = seed;
#line 191 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	return result;
#line 1729 "pod.c"
}


Seed* pod_add_seed_at_point (Pod* self, GType type, Point* p) {
#line 187 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 187 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	return POD_GET_CLASS (self)->add_seed_at_point (self, type, p);
#line 1738 "pod.c"
}


GeeIterator* pod_iterator (Pod* self) {
	GeeIterator* result = NULL;
	GeeArrayList* _tmp0_ = NULL;
	GeeIterator* _tmp1_ = NULL;
#line 194 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 195 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	_tmp0_ = self->priv->seeds;
#line 195 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	_tmp1_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _tmp0_);
#line 195 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	result = _tmp1_;
#line 195 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	return result;
#line 1756 "pod.c"
}


Seed* pod_get (Pod* self, gint n) {
	Seed* result = NULL;
	GeeArrayList* _tmp0_ = NULL;
	gint _tmp1_ = 0;
	gpointer _tmp2_ = NULL;
#line 205 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 206 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	_tmp0_ = self->priv->seeds;
#line 206 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	_tmp1_ = n;
#line 206 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	_tmp2_ = gee_abstract_list_get ((GeeAbstractList*) _tmp0_, _tmp1_);
#line 206 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	result = (Seed*) _tmp2_;
#line 206 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	return result;
#line 1777 "pod.c"
}


gint pod_index_of (Pod* self, Seed* seed) {
	gint result = 0;
	GeeArrayList* _tmp0_ = NULL;
	Seed* _tmp1_ = NULL;
	gint _tmp2_ = 0;
#line 209 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 210 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	_tmp0_ = self->priv->seeds;
#line 210 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	_tmp1_ = seed;
#line 210 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	_tmp2_ = gee_abstract_list_index_of ((GeeAbstractList*) _tmp0_, _tmp1_);
#line 210 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	result = _tmp2_;
#line 210 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	return result;
#line 1798 "pod.c"
}


static void pod_real_remove (Pod* self, Seed* seed) {
	GeeArrayList* _tmp0_ = NULL;
	Seed* _tmp1_ = NULL;
#line 213 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	g_return_if_fail (seed != NULL);
#line 214 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	_tmp0_ = self->priv->seeds;
#line 214 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	_tmp1_ = seed;
#line 214 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp0_, _tmp1_);
#line 1813 "pod.c"
}


void pod_remove (Pod* self, Seed* seed) {
#line 213 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	g_return_if_fail (self != NULL);
#line 213 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	POD_GET_CLASS (self)->remove (self, seed);
#line 1822 "pod.c"
}


static void pod_real_add (Pod* self, Seed* seed) {
	GeeArrayList* _tmp0_ = NULL;
	Seed* _tmp1_ = NULL;
#line 217 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	g_return_if_fail (seed != NULL);
#line 218 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	_tmp0_ = self->priv->seeds;
#line 218 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	_tmp1_ = seed;
#line 218 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp0_, _tmp1_);
#line 1837 "pod.c"
}


void pod_add (Pod* self, Seed* seed) {
#line 217 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	g_return_if_fail (self != NULL);
#line 217 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	POD_GET_CLASS (self)->add (self, seed);
#line 1846 "pod.c"
}


static void pod_real_clear (Pod* self) {
	GeeArrayList* _tmp0_ = NULL;
#line 222 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	_tmp0_ = self->priv->seeds;
#line 222 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp0_);
#line 1856 "pod.c"
}


void pod_clear (Pod* self) {
#line 221 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	g_return_if_fail (self != NULL);
#line 221 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	POD_GET_CLASS (self)->clear (self);
#line 1865 "pod.c"
}


/**
 * Swap seed positions
 */
static void pod_real_swap (Pod* self, gint i, gint j) {
	Seed* t = NULL;
	GeeArrayList* _tmp0_ = NULL;
	gint _tmp1_ = 0;
	gpointer _tmp2_ = NULL;
	GeeArrayList* _tmp3_ = NULL;
	gint _tmp4_ = 0;
	GeeArrayList* _tmp5_ = NULL;
	gint _tmp6_ = 0;
	gpointer _tmp7_ = NULL;
	Seed* _tmp8_ = NULL;
	GeeArrayList* _tmp9_ = NULL;
	gint _tmp10_ = 0;
#line 229 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	_tmp0_ = self->priv->seeds;
#line 229 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	_tmp1_ = i;
#line 229 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	_tmp2_ = gee_abstract_list_get ((GeeAbstractList*) _tmp0_, _tmp1_);
#line 229 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	t = (Seed*) _tmp2_;
#line 230 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	_tmp3_ = self->priv->seeds;
#line 230 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	_tmp4_ = i;
#line 230 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	_tmp5_ = self->priv->seeds;
#line 230 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	_tmp6_ = j;
#line 230 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	_tmp7_ = gee_abstract_list_get ((GeeAbstractList*) _tmp5_, _tmp6_);
#line 230 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	_tmp8_ = (Seed*) _tmp7_;
#line 230 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	gee_abstract_list_set ((GeeAbstractList*) _tmp3_, _tmp4_, _tmp8_);
#line 230 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	_g_object_unref0 (_tmp8_);
#line 231 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	_tmp9_ = self->priv->seeds;
#line 231 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	_tmp10_ = j;
#line 231 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	gee_abstract_list_set ((GeeAbstractList*) _tmp9_, _tmp10_, t);
#line 228 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	_g_object_unref0 (t);
#line 1917 "pod.c"
}


void pod_swap (Pod* self, gint i, gint j) {
#line 228 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	g_return_if_fail (self != NULL);
#line 228 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	POD_GET_CLASS (self)->swap (self, i, j);
#line 1926 "pod.c"
}


gint pod_get_size (Pod* self) {
	gint result;
	GeeArrayList* _tmp0_ = NULL;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
#line 202 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 202 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	_tmp0_ = self->priv->seeds;
#line 202 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	_tmp1_ = gee_abstract_collection_get_size ((GeeCollection*) _tmp0_);
#line 202 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	_tmp2_ = _tmp1_;
#line 202 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	result = _tmp2_;
#line 202 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	return result;
#line 1947 "pod.c"
}


static void pod_class_init (PodClass * klass) {
#line 21 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	pod_parent_class = g_type_class_peek_parent (klass);
#line 21 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	g_type_class_add_private (klass, sizeof (PodPrivate));
#line 21 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	POD_CLASS (klass)->serialize_aux = pod_real_serialize_aux;
#line 21 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	POD_CLASS (klass)->compile = pod_real_compile;
#line 21 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	POD_CLASS (klass)->add_seed_at_point = pod_real_add_seed_at_point;
#line 21 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	POD_CLASS (klass)->remove = pod_real_remove;
#line 21 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	POD_CLASS (klass)->add = pod_real_add;
#line 21 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	POD_CLASS (klass)->clear = pod_real_clear;
#line 21 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	POD_CLASS (klass)->swap = pod_real_swap;
#line 21 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_pod_get_property;
#line 21 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	G_OBJECT_CLASS (klass)->finalize = pod_finalize;
#line 1974 "pod.c"
	/**
	 * Access to seeds
	 */
#line 21 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), POD_SIZE, g_param_spec_int ("size", "size", "size", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 21 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	g_signal_new ("signal_changed", TYPE_POD, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 1982 "pod.c"
}


static void pod_instance_init (Pod * self) {
	GeeArrayList* _tmp0_ = NULL;
#line 21 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	self->priv = POD_GET_PRIVATE (self);
#line 28 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	self->test = FALSE;
#line 36 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	_tmp0_ = gee_array_list_new (TYPE_SEED, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
#line 36 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	self->priv->seeds = _tmp0_;
#line 1996 "pod.c"
}


static void pod_finalize (GObject* obj) {
	Pod * self;
#line 21 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_POD, Pod);
#line 36 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	_g_object_unref0 (self->priv->seeds);
#line 186 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	G_OBJECT_CLASS (pod_parent_class)->finalize (obj);
#line 2008 "pod.c"
}


GType pod_get_type (void) {
	static volatile gsize pod_type_id__volatile = 0;
	if (g_once_init_enter (&pod_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PodClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) pod_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Pod), 0, (GInstanceInitFunc) pod_instance_init, NULL };
		GType pod_type_id;
		pod_type_id = g_type_register_static (G_TYPE_OBJECT, "Pod", &g_define_type_info, 0);
		g_once_init_leave (&pod_type_id__volatile, pod_type_id);
	}
	return pod_type_id__volatile;
}


static void _vala_pod_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	Pod * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_POD, Pod);
#line 21 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	switch (property_id) {
#line 21 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
		case POD_SIZE:
#line 21 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
		g_value_set_int (value, pod_get_size (self));
#line 21 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
		break;
#line 2035 "pod.c"
		default:
#line 21 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 21 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
		break;
#line 2041 "pod.c"
	}
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
#line 101 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	if ((array != NULL) && (destroy_func != NULL)) {
#line 2049 "pod.c"
		int i;
#line 101 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
		for (i = 0; i < array_length; i = i + 1) {
#line 101 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
			if (((gpointer*) array)[i] != NULL) {
#line 101 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
				destroy_func (((gpointer*) array)[i]);
#line 2057 "pod.c"
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
#line 101 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	_vala_array_destroy (array, array_length, destroy_func);
#line 101 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	g_free (array);
#line 2069 "pod.c"
}


static gint _vala_array_length (gpointer array) {
	int length;
	length = 0;
#line 101 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	if (array) {
#line 101 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
		while (((gpointer*) array)[length]) {
#line 101 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
			length++;
#line 2082 "pod.c"
		}
	}
#line 101 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	return length;
#line 2087 "pod.c"
}



