/* point.c generated by valac 0.22.0, the Vala compiler
 * generated from point.vala, do not modify */

/*  Mutiara motif designer.
Copyright (C) 2011  Nor Jaidi Tuah

This file is part of Mutiara.

Mutiara is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <glib.h>
#include <glib-object.h>
#include <float.h>
#include <math.h>
#include <string.h>
#include <stdlib.h>
#include <cairo.h>
#include <gobject/gvaluecollector.h>


#define TYPE_POINT (point_get_type ())
typedef struct _Point Point;

#define TYPE_ROLE (role_get_type ())

#define TYPE_RENDER_STYLE (render_style_get_type ())

#define TYPE_PROJECTION (projection_get_type ())
#define PROJECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PROJECTION, Projection))
#define PROJECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PROJECTION, ProjectionClass))
#define IS_PROJECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PROJECTION))
#define IS_PROJECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PROJECTION))
#define PROJECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PROJECTION, ProjectionClass))

typedef struct _Projection Projection;
typedef struct _ProjectionClass ProjectionClass;
typedef struct _ProjectionPrivate ProjectionPrivate;

#define TYPE_SEED (seed_get_type ())
#define SEED(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SEED, Seed))
#define SEED_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SEED, SeedClass))
#define IS_SEED(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SEED))
#define IS_SEED_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SEED))
#define SEED_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SEED, SeedClass))

typedef struct _Seed Seed;
typedef struct _SeedClass SeedClass;

#define TYPE_FLIP (flip_get_type ())
typedef struct _SeedPrivate SeedPrivate;

#define TYPE_TWEAK (tweak_get_type ())
typedef struct _Tweak Tweak;

#define TYPE_RGBA (rgba_get_type ())
typedef struct _RGBA RGBA;

#define TYPE_LINE (line_get_type ())
#define LINE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LINE, Line))
#define LINE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_LINE, LineClass))
#define IS_LINE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LINE))
#define IS_LINE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_LINE))
#define LINE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_LINE, LineClass))

typedef struct _Line Line;
typedef struct _LineClass LineClass;
typedef struct _LinePrivate LinePrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _ParamSpecProjection ParamSpecProjection;

struct _Point {
	gdouble x;
	gdouble y;
};

typedef enum  {
	ROLE_DUAL = 0,
	ROLE_MOTIF = 1,
	ROLE_BASE = 2
} Role;

typedef enum  {
	RENDER_STYLE_THIN = 0,
	RENDER_STYLE_THICK = 1,
	RENDER_STYLE_HOLLOW = 2,
	RENDER_STYLE_FILLED = 3,
	RENDER_STYLE_CLOSED = 4,
	RENDER_STYLE_NONE = 5
} RenderStyle;

struct _Projection {
	GTypeInstance parent_instance;
	volatile int ref_count;
	ProjectionPrivate * priv;
};

struct _ProjectionClass {
	GTypeClass parent_class;
	void (*finalize) (Projection *self);
};

struct _ProjectionPrivate {
	Seed* seed;
	Projection* parent;
	gdouble m[6];
};

typedef enum  {
	FLIP_NONE = 0,
	FLIP_Y = 1,
	FLIP_X = 2,
	FLIP_XY = 3
} Flip;

struct _Tweak {
	gdouble scale_x;
	gdouble scale_y;
	gdouble rotate;
	gdouble move_x;
	gdouble move_y;
};

struct _RGBA {
	gdouble r;
	gdouble g;
	gdouble b;
	gdouble a;
};

struct _Seed {
	GObject parent_instance;
	SeedPrivate * priv;
	gboolean debug;
	gboolean is_affine;
	Role role;
	gdouble base_offset;
	Flip flip_even;
	Flip flip_odd;
	Tweak tweak;
	gdouble width0;
	gdouble width1;
	gint num_segment;
	gint level_of_detail;
	RGBA color;
	gdouble color_mix;
	RenderStyle render_style;
	Projection** projection;
	gint projection_length1;
	gint selected_control;
	Point pressed_point;
};

struct _SeedClass {
	GObjectClass parent_class;
	void (*init_default_sub) (Seed* self, Point* p);
	void (*init_full_sub) (Seed* self, gdouble* args, int args_length1);
	gchar* (*serialize_sub) (Seed* self);
	void (*point_raw) (Seed* self, gdouble t, Point* result);
	void (*init_distance_to_parametric) (Seed* self);
	void (*distant_point) (Seed* self, gdouble x_distance, gdouble y_distance, Point* result);
	void (*draw_direct) (Seed* self, cairo_t* cr, gdouble scale);
	void (*draw_controls) (Seed* self, cairo_t* cr, gdouble scale);
	gint (*pressed_control) (Seed* self, Point* p, gdouble scale);
	void (*save_drag_context) (Seed* self);
	void (*move_shape) (Seed* self, gdouble delta_x, gdouble delta_y);
	void (*drag_control) (Seed* self, Point* p, gdouble scale, gboolean snap_on, gdouble grid_size, gdouble snap_angle);
	Point* (*points_to_snap) (Seed* self, int* result_length1);
	void (*draw_icon) (Seed* self, cairo_t* cr, gdouble width, gdouble height);
};

struct _Line {
	Seed parent_instance;
	LinePrivate * priv;
	Point p0;
	Point p1;
	gdouble sin_perpendicular_angle;
	gdouble cos_perpendicular_angle;
};

struct _LineClass {
	SeedClass parent_class;
};

struct _ParamSpecProjection {
	GParamSpec parent_instance;
};


static gpointer projection_parent_class = NULL;

GType point_get_type (void) G_GNUC_CONST;
Point* point_dup (const Point* self);
void point_free (Point* self);
gdouble point_hypot (Point* p0, Point* p1);
void point_rotate (Point *self, gdouble angle, Point* result);
void point_scale (Point *self, gdouble sx, gdouble sy, Point* result);
void point_move (Point *self, Point* new_origin, Point* result);
void point_move_xy (Point *self, gdouble x, gdouble y, Point* result);
GType role_get_type (void) G_GNUC_CONST;
GType render_style_get_type (void) G_GNUC_CONST;
gpointer projection_ref (gpointer instance);
void projection_unref (gpointer instance);
GParamSpec* param_spec_projection (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_projection (GValue* value, gpointer v_object);
void value_take_projection (GValue* value, gpointer v_object);
gpointer value_get_projection (const GValue* value);
GType projection_get_type (void) G_GNUC_CONST;
GType seed_get_type (void) G_GNUC_CONST;
#define PROJECTION_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_PROJECTION, ProjectionPrivate))
enum  {
	PROJECTION_DUMMY_PROPERTY
};
GType flip_get_type (void) G_GNUC_CONST;
Projection* projection_new_by_segment (Seed* seed, gdouble t0, gdouble t1, Flip flip);
Projection* projection_construct_by_segment (GType object_type, Seed* seed, gdouble t0, gdouble t1, Flip flip);
static void projection_add (Projection* self, gdouble p, gdouble q, gdouble r, gdouble s, gdouble t, gdouble u);
GType tweak_get_type (void) G_GNUC_CONST;
Tweak* tweak_dup (const Tweak* self);
void tweak_free (Tweak* self);
GType rgba_get_type (void) G_GNUC_CONST;
RGBA* rgba_dup (const RGBA* self);
void rgba_free (RGBA* self);
gboolean flip_x (Flip self);
gboolean flip_y (Flip self);
GType line_get_type (void) G_GNUC_CONST;
void projection_copy_projection (Projection* self, Projection* source);
void projection_compose (Projection* self, Projection* parent, Projection* source);
void projection_compose_unit_matrix (Projection* self);
void projection_map (Projection* pr, Point* p, Point* result);
void seed_distant_point (Seed* self, gdouble x_distance, gdouble y_distance, Point* result);
Projection* projection_new (void);
Projection* projection_construct (GType object_type);
static void projection_finalize (Projection* obj);
void rgba_init (RGBA *self, gdouble r, gdouble g, gdouble b, gdouble a);


gdouble point_hypot (Point* p0, Point* p1) {
	gdouble result = 0.0;
	Point _tmp0_ = {0};
	gdouble _tmp1_ = 0.0;
	Point _tmp2_ = {0};
	gdouble _tmp3_ = 0.0;
	Point _tmp4_ = {0};
	gdouble _tmp5_ = 0.0;
	Point _tmp6_ = {0};
	gdouble _tmp7_ = 0.0;
	gdouble _tmp8_ = 0.0;
#line 23 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	g_return_val_if_fail (p0 != NULL, 0.0);
#line 23 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	g_return_val_if_fail (p1 != NULL, 0.0);
#line 24 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	_tmp0_ = *p1;
#line 24 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	_tmp1_ = _tmp0_.y;
#line 24 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	_tmp2_ = *p0;
#line 24 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	_tmp3_ = _tmp2_.y;
#line 24 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	_tmp4_ = *p1;
#line 24 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	_tmp5_ = _tmp4_.x;
#line 24 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	_tmp6_ = *p0;
#line 24 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	_tmp7_ = _tmp6_.x;
#line 24 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	_tmp8_ = hypot (_tmp1_ - _tmp3_, _tmp5_ - _tmp7_);
#line 24 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	result = _tmp8_;
#line 24 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	return result;
#line 287 "point.c"
}


void point_rotate (Point *self, gdouble angle, Point* result) {
	gdouble sin = 0.0;
	gdouble cos = 0.0;
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
	gdouble _tmp6_ = 0.0;
	Point _tmp7_ = {0};
#line 30 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	_tmp0_ = angle;
#line 30 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	sincos (_tmp0_, &_tmp1_, &_tmp2_);
#line 30 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	sin = _tmp1_;
#line 30 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	cos = _tmp2_;
#line 31 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	_tmp3_ = (*self).x;
#line 31 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	_tmp4_ = (*self).y;
#line 31 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	_tmp5_ = (*self).x;
#line 31 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	_tmp6_ = (*self).y;
#line 31 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	memset (&_tmp7_, 0, sizeof (Point));
#line 31 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	_tmp7_.x = (_tmp3_ * cos) - (_tmp4_ * sin);
#line 31 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	_tmp7_.y = (_tmp5_ * sin) + (_tmp6_ * cos);
#line 31 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	*result = _tmp7_;
#line 31 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	return;
#line 328 "point.c"
}


void point_scale (Point *self, gdouble sx, gdouble sy, Point* result) {
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	Point _tmp4_ = {0};
#line 37 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	_tmp0_ = (*self).x;
#line 37 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	_tmp1_ = sx;
#line 37 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	_tmp2_ = (*self).y;
#line 37 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	_tmp3_ = sy;
#line 37 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	memset (&_tmp4_, 0, sizeof (Point));
#line 37 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	_tmp4_.x = _tmp0_ * _tmp1_;
#line 37 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	_tmp4_.y = _tmp2_ * _tmp3_;
#line 37 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	*result = _tmp4_;
#line 37 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	return;
#line 356 "point.c"
}


void point_move (Point *self, Point* new_origin, Point* result) {
	gdouble _tmp0_ = 0.0;
	Point _tmp1_ = {0};
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	Point _tmp4_ = {0};
	gdouble _tmp5_ = 0.0;
	Point _tmp6_ = {0};
#line 40 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	g_return_if_fail (new_origin != NULL);
#line 41 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	_tmp0_ = (*self).x;
#line 41 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	_tmp1_ = *new_origin;
#line 41 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	_tmp2_ = _tmp1_.x;
#line 41 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	_tmp3_ = (*self).y;
#line 41 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	_tmp4_ = *new_origin;
#line 41 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	_tmp5_ = _tmp4_.y;
#line 41 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	memset (&_tmp6_, 0, sizeof (Point));
#line 41 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	_tmp6_.x = _tmp0_ + _tmp2_;
#line 41 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	_tmp6_.y = _tmp3_ + _tmp5_;
#line 41 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	*result = _tmp6_;
#line 41 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	return;
#line 392 "point.c"
}


void point_move_xy (Point *self, gdouble x, gdouble y, Point* result) {
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	Point _tmp4_ = {0};
#line 45 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	_tmp0_ = (*self).x;
#line 45 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	_tmp1_ = x;
#line 45 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	_tmp2_ = (*self).y;
#line 45 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	_tmp3_ = y;
#line 45 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	memset (&_tmp4_, 0, sizeof (Point));
#line 45 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	_tmp4_.x = _tmp0_ + _tmp1_;
#line 45 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	_tmp4_.y = _tmp2_ + _tmp3_;
#line 45 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	*result = _tmp4_;
#line 45 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	return;
#line 420 "point.c"
}


Point* point_dup (const Point* self) {
	Point* dup;
#line 19 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	dup = g_new0 (Point, 1);
#line 19 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	memcpy (dup, self, sizeof (Point));
#line 19 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	return dup;
#line 432 "point.c"
}


void point_free (Point* self) {
#line 19 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	g_free (self);
#line 439 "point.c"
}


GType point_get_type (void) {
	static volatile gsize point_type_id__volatile = 0;
	if (g_once_init_enter (&point_type_id__volatile)) {
		GType point_type_id;
		point_type_id = g_boxed_type_register_static ("Point", (GBoxedCopyFunc) point_dup, (GBoxedFreeFunc) point_free);
		g_once_init_leave (&point_type_id__volatile, point_type_id);
	}
	return point_type_id__volatile;
}


GType role_get_type (void) {
	static volatile gsize role_type_id__volatile = 0;
	if (g_once_init_enter (&role_type_id__volatile)) {
		static const GEnumValue values[] = {{ROLE_DUAL, "ROLE_DUAL", "dual"}, {ROLE_MOTIF, "ROLE_MOTIF", "motif"}, {ROLE_BASE, "ROLE_BASE", "base"}, {0, NULL, NULL}};
		GType role_type_id;
		role_type_id = g_enum_register_static ("Role", values);
		g_once_init_leave (&role_type_id__volatile, role_type_id);
	}
	return role_type_id__volatile;
}


GType render_style_get_type (void) {
	static volatile gsize render_style_type_id__volatile = 0;
	if (g_once_init_enter (&render_style_type_id__volatile)) {
		static const GEnumValue values[] = {{RENDER_STYLE_THIN, "RENDER_STYLE_THIN", "thin"}, {RENDER_STYLE_THICK, "RENDER_STYLE_THICK", "thick"}, {RENDER_STYLE_HOLLOW, "RENDER_STYLE_HOLLOW", "hollow"}, {RENDER_STYLE_FILLED, "RENDER_STYLE_FILLED", "filled"}, {RENDER_STYLE_CLOSED, "RENDER_STYLE_CLOSED", "closed"}, {RENDER_STYLE_NONE, "RENDER_STYLE_NONE", "none"}, {0, NULL, NULL}};
		GType render_style_type_id;
		render_style_type_id = g_enum_register_static ("RenderStyle", values);
		g_once_init_leave (&render_style_type_id__volatile, render_style_type_id);
	}
	return render_style_type_id__volatile;
}


/**
 * The projection represented by segment t0-t1 of seed.
 *
 * Project using the following reference points:
 *   (0,base_offset) -> point on projection.seed at t0
 *   (1,base_offset) -> point on projection.seed at t1
 * For other points:
 *   (x,base_offset) -> point on projection.seed at t = t0 + x/(t1-t0)
 *   (x,y)   -> point at a distance of base_offset-y from (x,base_offset)
 */
static gpointer _g_object_ref0 (gpointer self) {
#line 129 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	return self ? g_object_ref (self) : NULL;
#line 491 "point.c"
}


Projection* projection_construct_by_segment (GType object_type, Seed* seed, gdouble t0, gdouble t1, Flip flip) {
	Projection* self = NULL;
	Seed* _tmp0_ = NULL;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	Seed* _tmp5_ = NULL;
	Tweak _tmp6_ = {0};
	gdouble _tmp7_ = 0.0;
	Seed* _tmp8_ = NULL;
	Tweak _tmp9_ = {0};
	gdouble _tmp10_ = 0.0;
	gdouble angle = 0.0;
	Seed* _tmp11_ = NULL;
	Tweak _tmp12_ = {0};
	gdouble _tmp13_ = 0.0;
	gdouble sin = 0.0;
	gdouble cos = 0.0;
	gdouble _tmp14_ = 0.0;
	gdouble _tmp15_ = 0.0;
	gdouble _tmp16_ = 0.0;
	gdouble _tmp17_ = 0.0;
	gdouble _tmp18_ = 0.0;
	gdouble _tmp19_ = 0.0;
	gdouble _tmp20_ = 0.0;
	Seed* _tmp21_ = NULL;
	Tweak _tmp22_ = {0};
	gdouble _tmp23_ = 0.0;
	gdouble _tmp24_ = 0.0;
	Seed* _tmp25_ = NULL;
	Tweak _tmp26_ = {0};
	gdouble _tmp27_ = 0.0;
	gdouble _tmp28_ = 0.0;
	Flip _tmp29_ = 0;
	gboolean _tmp30_ = FALSE;
	Flip _tmp32_ = 0;
	gboolean _tmp33_ = FALSE;
	gdouble _tmp35_ = 0.0;
	gdouble _tmp36_ = 0.0;
	gdouble _tmp37_ = 0.0;
	gdouble _tmp38_ = 0.0;
	Seed* _tmp39_ = NULL;
	gdouble _tmp40_ = 0.0;
	gdouble _tmp41_ = 0.0;
	Seed* _tmp42_ = NULL;
	gboolean _tmp43_ = FALSE;
#line 93 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	g_return_val_if_fail (seed != NULL, NULL);
#line 93 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	self = (Projection*) g_type_create_instance (object_type);
#line 94 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	_tmp0_ = seed;
#line 94 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	self->priv->seed = _tmp0_;
#line 96 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	self->priv->m[0] = (gdouble) 1;
#line 96 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	_tmp1_ = self->priv->m[0];
#line 96 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	self->priv->m[3] = (gdouble) 1;
#line 96 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	_tmp2_ = self->priv->m[3];
#line 99 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	self->priv->m[4] = -0.5;
#line 99 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	_tmp3_ = self->priv->m[4];
#line 99 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	self->priv->m[5] = -0.5;
#line 99 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	_tmp4_ = self->priv->m[5];
#line 101 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	_tmp5_ = seed;
#line 101 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	_tmp6_ = _tmp5_->tweak;
#line 101 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	_tmp7_ = _tmp6_.scale_x;
#line 101 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	_tmp8_ = seed;
#line 101 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	_tmp9_ = _tmp8_->tweak;
#line 101 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	_tmp10_ = _tmp9_.scale_y;
#line 101 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	projection_add (self, _tmp7_, (gdouble) 0, (gdouble) 0, _tmp10_, (gdouble) 0, (gdouble) 0);
#line 103 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	_tmp11_ = seed;
#line 103 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	_tmp12_ = _tmp11_->tweak;
#line 103 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	_tmp13_ = _tmp12_.rotate;
#line 103 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	angle = (_tmp13_ * G_PI) / 180;
#line 105 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	_tmp14_ = angle;
#line 105 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	sincos (_tmp14_, &_tmp15_, &_tmp16_);
#line 105 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	sin = _tmp15_;
#line 105 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	cos = _tmp16_;
#line 106 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	_tmp17_ = cos;
#line 106 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	_tmp18_ = sin;
#line 106 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	_tmp19_ = sin;
#line 106 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	_tmp20_ = cos;
#line 106 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	projection_add (self, _tmp17_, _tmp18_, -_tmp19_, _tmp20_, (gdouble) 0, (gdouble) 0);
#line 109 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	_tmp21_ = seed;
#line 109 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	_tmp22_ = _tmp21_->tweak;
#line 109 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	_tmp23_ = _tmp22_.move_x;
#line 109 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	self->priv->m[4] += _tmp23_ + 0.5;
#line 109 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	_tmp24_ = self->priv->m[4];
#line 110 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	_tmp25_ = seed;
#line 110 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	_tmp26_ = _tmp25_->tweak;
#line 110 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	_tmp27_ = _tmp26_.move_y;
#line 110 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	self->priv->m[5] += _tmp27_ + 0.5;
#line 110 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	_tmp28_ = self->priv->m[5];
#line 112 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	_tmp29_ = flip;
#line 112 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	_tmp30_ = flip_x (_tmp29_);
#line 112 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	if (_tmp30_) {
#line 632 "point.c"
		gdouble _tmp31_ = 0.0;
#line 113 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		projection_add (self, (gdouble) (-1), (gdouble) 0, (gdouble) 0, (gdouble) 1, (gdouble) 0, (gdouble) 0);
#line 114 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		self->priv->m[4] += (gdouble) 1;
#line 114 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		_tmp31_ = self->priv->m[4];
#line 640 "point.c"
	}
#line 116 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	_tmp32_ = flip;
#line 116 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	_tmp33_ = flip_y (_tmp32_);
#line 116 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	if (_tmp33_) {
#line 648 "point.c"
		gdouble _tmp34_ = 0.0;
#line 117 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		projection_add (self, (gdouble) 1, (gdouble) 0, (gdouble) 0, (gdouble) (-1), (gdouble) 0, (gdouble) 0);
#line 118 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		self->priv->m[5] += (gdouble) 1;
#line 118 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		_tmp34_ = self->priv->m[5];
#line 656 "point.c"
	}
#line 123 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	_tmp35_ = t1;
#line 123 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	_tmp36_ = t0;
#line 123 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	projection_add (self, _tmp35_ - _tmp36_, (gdouble) 0, (gdouble) 0, (gdouble) (-1), (gdouble) 0, (gdouble) 0);
#line 124 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	_tmp37_ = t0;
#line 124 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	self->priv->m[4] += _tmp37_;
#line 124 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	_tmp38_ = self->priv->m[4];
#line 125 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	_tmp39_ = seed;
#line 125 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	_tmp40_ = _tmp39_->base_offset;
#line 125 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	self->priv->m[5] += _tmp40_;
#line 125 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	_tmp41_ = self->priv->m[5];
#line 128 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	_tmp42_ = seed;
#line 128 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	_tmp43_ = _tmp42_->is_affine;
#line 128 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	if (_tmp43_) {
#line 684 "point.c"
		Line* line = NULL;
		Seed* _tmp44_ = NULL;
		Line* _tmp45_ = NULL;
		gdouble dx = 0.0;
		Line* _tmp46_ = NULL;
		Point _tmp47_ = {0};
		gdouble _tmp48_ = 0.0;
		Line* _tmp49_ = NULL;
		Point _tmp50_ = {0};
		gdouble _tmp51_ = 0.0;
		gdouble dy = 0.0;
		Line* _tmp52_ = NULL;
		Point _tmp53_ = {0};
		gdouble _tmp54_ = 0.0;
		Line* _tmp55_ = NULL;
		Point _tmp56_ = {0};
		gdouble _tmp57_ = 0.0;
		gdouble w_cos = 0.0;
		Line* _tmp58_ = NULL;
		gdouble _tmp59_ = 0.0;
		Line* _tmp60_ = NULL;
		gdouble _tmp61_ = 0.0;
		gdouble w_sin = 0.0;
		Line* _tmp62_ = NULL;
		gdouble _tmp63_ = 0.0;
		Line* _tmp64_ = NULL;
		gdouble _tmp65_ = 0.0;
		gdouble m0 = 0.0;
		gdouble _tmp66_ = 0.0;
		gdouble _tmp67_ = 0.0;
		gdouble _tmp68_ = 0.0;
		gdouble _tmp69_ = 0.0;
		gdouble m2 = 0.0;
		gdouble _tmp70_ = 0.0;
		gdouble _tmp71_ = 0.0;
		gdouble _tmp72_ = 0.0;
		gdouble _tmp73_ = 0.0;
		gdouble m4 = 0.0;
		gdouble _tmp74_ = 0.0;
		gdouble _tmp75_ = 0.0;
		gdouble _tmp76_ = 0.0;
		gdouble _tmp77_ = 0.0;
		Line* _tmp78_ = NULL;
		Point _tmp79_ = {0};
		gdouble _tmp80_ = 0.0;
		gdouble m1 = 0.0;
		gdouble _tmp81_ = 0.0;
		gdouble _tmp82_ = 0.0;
		gdouble _tmp83_ = 0.0;
		gdouble _tmp84_ = 0.0;
		gdouble m3 = 0.0;
		gdouble _tmp85_ = 0.0;
		gdouble _tmp86_ = 0.0;
		gdouble _tmp87_ = 0.0;
		gdouble _tmp88_ = 0.0;
		gdouble m5 = 0.0;
		gdouble _tmp89_ = 0.0;
		gdouble _tmp90_ = 0.0;
		gdouble _tmp91_ = 0.0;
		gdouble _tmp92_ = 0.0;
		Line* _tmp93_ = NULL;
		Point _tmp94_ = {0};
		gdouble _tmp95_ = 0.0;
		gdouble _tmp96_ = 0.0;
		gdouble _tmp97_ = 0.0;
		gdouble _tmp98_ = 0.0;
		gdouble _tmp99_ = 0.0;
		gdouble _tmp100_ = 0.0;
		gdouble _tmp101_ = 0.0;
		gdouble _tmp102_ = 0.0;
		gdouble _tmp103_ = 0.0;
		gdouble _tmp104_ = 0.0;
		gdouble _tmp105_ = 0.0;
		gdouble _tmp106_ = 0.0;
		gdouble _tmp107_ = 0.0;
#line 129 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		_tmp44_ = seed;
#line 129 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		_tmp45_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp44_, TYPE_LINE) ? ((Line*) _tmp44_) : NULL);
#line 129 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		line = _tmp45_;
#line 130 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		_tmp46_ = line;
#line 130 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		_tmp47_ = _tmp46_->p1;
#line 130 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		_tmp48_ = _tmp47_.x;
#line 130 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		_tmp49_ = line;
#line 130 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		_tmp50_ = _tmp49_->p0;
#line 130 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		_tmp51_ = _tmp50_.x;
#line 130 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		dx = _tmp48_ - _tmp51_;
#line 131 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		_tmp52_ = line;
#line 131 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		_tmp53_ = _tmp52_->p1;
#line 131 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		_tmp54_ = _tmp53_.y;
#line 131 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		_tmp55_ = line;
#line 131 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		_tmp56_ = _tmp55_->p0;
#line 131 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		_tmp57_ = _tmp56_.y;
#line 131 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		dy = _tmp54_ - _tmp57_;
#line 132 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		_tmp58_ = line;
#line 132 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		_tmp59_ = ((Seed*) _tmp58_)->width0;
#line 132 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		_tmp60_ = line;
#line 132 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		_tmp61_ = _tmp60_->cos_perpendicular_angle;
#line 132 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		w_cos = _tmp59_ * _tmp61_;
#line 133 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		_tmp62_ = line;
#line 133 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		_tmp63_ = ((Seed*) _tmp62_)->width0;
#line 133 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		_tmp64_ = line;
#line 133 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		_tmp65_ = _tmp64_->sin_perpendicular_angle;
#line 133 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		w_sin = _tmp63_ * _tmp65_;
#line 134 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		_tmp66_ = dx;
#line 134 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		_tmp67_ = self->priv->m[0];
#line 134 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		_tmp68_ = w_cos;
#line 134 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		_tmp69_ = self->priv->m[1];
#line 134 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		m0 = (_tmp66_ * _tmp67_) + (_tmp68_ * _tmp69_);
#line 135 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		_tmp70_ = dx;
#line 135 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		_tmp71_ = self->priv->m[2];
#line 135 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		_tmp72_ = w_cos;
#line 135 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		_tmp73_ = self->priv->m[3];
#line 135 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		m2 = (_tmp70_ * _tmp71_) + (_tmp72_ * _tmp73_);
#line 136 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		_tmp74_ = dx;
#line 136 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		_tmp75_ = self->priv->m[4];
#line 136 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		_tmp76_ = w_cos;
#line 136 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		_tmp77_ = self->priv->m[5];
#line 136 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		_tmp78_ = line;
#line 136 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		_tmp79_ = _tmp78_->p0;
#line 136 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		_tmp80_ = _tmp79_.x;
#line 136 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		m4 = ((_tmp74_ * _tmp75_) + (_tmp76_ * _tmp77_)) + _tmp80_;
#line 137 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		_tmp81_ = dy;
#line 137 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		_tmp82_ = self->priv->m[0];
#line 137 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		_tmp83_ = w_sin;
#line 137 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		_tmp84_ = self->priv->m[1];
#line 137 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		m1 = (_tmp81_ * _tmp82_) + (_tmp83_ * _tmp84_);
#line 138 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		_tmp85_ = dy;
#line 138 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		_tmp86_ = self->priv->m[2];
#line 138 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		_tmp87_ = w_sin;
#line 138 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		_tmp88_ = self->priv->m[3];
#line 138 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		m3 = (_tmp85_ * _tmp86_) + (_tmp87_ * _tmp88_);
#line 139 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		_tmp89_ = dy;
#line 139 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		_tmp90_ = self->priv->m[4];
#line 139 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		_tmp91_ = w_sin;
#line 139 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		_tmp92_ = self->priv->m[5];
#line 139 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		_tmp93_ = line;
#line 139 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		_tmp94_ = _tmp93_->p0;
#line 139 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		_tmp95_ = _tmp94_.y;
#line 139 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		m5 = ((_tmp89_ * _tmp90_) + (_tmp91_ * _tmp92_)) + _tmp95_;
#line 140 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		_tmp96_ = m0;
#line 140 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		self->priv->m[0] = _tmp96_;
#line 140 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		_tmp97_ = self->priv->m[0];
#line 140 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		_tmp98_ = m1;
#line 140 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		self->priv->m[1] = _tmp98_;
#line 140 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		_tmp99_ = self->priv->m[1];
#line 140 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		_tmp100_ = m2;
#line 140 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		self->priv->m[2] = _tmp100_;
#line 140 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		_tmp101_ = self->priv->m[2];
#line 140 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		_tmp102_ = m3;
#line 140 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		self->priv->m[3] = _tmp102_;
#line 140 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		_tmp103_ = self->priv->m[3];
#line 140 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		_tmp104_ = m4;
#line 140 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		self->priv->m[4] = _tmp104_;
#line 140 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		_tmp105_ = self->priv->m[4];
#line 140 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		_tmp106_ = m5;
#line 140 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		self->priv->m[5] = _tmp106_;
#line 140 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		_tmp107_ = self->priv->m[5];
#line 141 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		self->priv->seed = NULL;
#line 128 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		_g_object_unref0 (line);
#line 926 "point.c"
	}
#line 93 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	return self;
#line 930 "point.c"
}


Projection* projection_new_by_segment (Seed* seed, gdouble t0, gdouble t1, Flip flip) {
#line 93 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	return projection_construct_by_segment (TYPE_PROJECTION, seed, t0, t1, flip);
#line 937 "point.c"
}


/**
 * Copy
 */
void projection_copy_projection (Projection* self, Projection* source) {
	Projection* _tmp0_ = NULL;
	Seed* _tmp1_ = NULL;
	Projection* _tmp2_ = NULL;
	Projection* _tmp3_ = NULL;
	Projection* _tmp4_ = NULL;
#line 148 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	g_return_if_fail (self != NULL);
#line 149 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	_tmp0_ = source;
#line 149 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	_tmp1_ = _tmp0_->priv->seed;
#line 149 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	self->priv->seed = _tmp1_;
#line 150 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	_tmp2_ = source;
#line 150 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	memcpy (self->priv->m, _tmp2_->priv->m, 6 * sizeof (gdouble));
#line 151 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	_tmp3_ = source;
#line 151 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	_tmp4_ = _tmp3_->priv->parent;
#line 151 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	self->priv->parent = _tmp4_;
#line 968 "point.c"
}


/**
 * Copy source and link it to a parent.
 */
void projection_compose (Projection* self, Projection* parent, Projection* source) {
	Projection* _tmp0_ = NULL;
	Seed* _tmp1_ = NULL;
	Projection* _tmp2_ = NULL;
	gboolean _tmp3_ = FALSE;
	Seed* _tmp4_ = NULL;
	gboolean _tmp6_ = FALSE;
#line 157 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	g_return_if_fail (self != NULL);
#line 158 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	_tmp0_ = source;
#line 158 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	_tmp1_ = _tmp0_->priv->seed;
#line 158 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	self->priv->seed = _tmp1_;
#line 159 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	_tmp2_ = source;
#line 159 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	memcpy (self->priv->m, _tmp2_->priv->m, 6 * sizeof (gdouble));
#line 160 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	_tmp4_ = self->priv->seed;
#line 160 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	if (_tmp4_ == NULL) {
#line 998 "point.c"
		Projection* _tmp5_ = NULL;
#line 160 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		_tmp5_ = parent;
#line 160 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		_tmp3_ = _tmp5_ != NULL;
#line 1004 "point.c"
	} else {
#line 160 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		_tmp3_ = FALSE;
#line 1008 "point.c"
	}
#line 160 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	_tmp6_ = _tmp3_;
#line 160 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	if (_tmp6_) {
#line 1014 "point.c"
		Projection* _tmp7_ = NULL;
		gdouble _tmp8_ = 0.0;
		Projection* _tmp9_ = NULL;
		gdouble _tmp10_ = 0.0;
		Projection* _tmp11_ = NULL;
		gdouble _tmp12_ = 0.0;
		Projection* _tmp13_ = NULL;
		gdouble _tmp14_ = 0.0;
		Projection* _tmp15_ = NULL;
		gdouble _tmp16_ = 0.0;
		Projection* _tmp17_ = NULL;
		gdouble _tmp18_ = 0.0;
		Projection* _tmp19_ = NULL;
		Seed* _tmp20_ = NULL;
		Projection* _tmp21_ = NULL;
		Projection* _tmp22_ = NULL;
#line 162 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		_tmp7_ = parent;
#line 162 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		_tmp8_ = _tmp7_->priv->m[0];
#line 162 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		_tmp9_ = parent;
#line 162 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		_tmp10_ = _tmp9_->priv->m[1];
#line 162 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		_tmp11_ = parent;
#line 162 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		_tmp12_ = _tmp11_->priv->m[2];
#line 162 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		_tmp13_ = parent;
#line 162 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		_tmp14_ = _tmp13_->priv->m[3];
#line 162 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		_tmp15_ = parent;
#line 162 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		_tmp16_ = _tmp15_->priv->m[4];
#line 162 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		_tmp17_ = parent;
#line 162 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		_tmp18_ = _tmp17_->priv->m[5];
#line 162 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		projection_add (self, _tmp8_, _tmp10_, _tmp12_, _tmp14_, _tmp16_, _tmp18_);
#line 163 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		_tmp19_ = parent;
#line 163 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		_tmp20_ = _tmp19_->priv->seed;
#line 163 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		self->priv->seed = _tmp20_;
#line 164 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		_tmp21_ = parent;
#line 164 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		_tmp22_ = _tmp21_->priv->parent;
#line 164 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		self->priv->parent = _tmp22_;
#line 1069 "point.c"
	} else {
		Projection* _tmp23_ = NULL;
#line 167 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		_tmp23_ = parent;
#line 167 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		self->priv->parent = _tmp23_;
#line 1076 "point.c"
	}
}


/**
 * [1 0 0]
 * [0 1 0]
 * [0 0 1]
 */
void projection_compose_unit_matrix (Projection* self) {
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
#line 176 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	g_return_if_fail (self != NULL);
#line 177 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	self->priv->m[0] = (gdouble) 1;
#line 177 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	_tmp0_ = self->priv->m[0];
#line 177 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	self->priv->m[1] = (gdouble) 0;
#line 177 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	_tmp1_ = self->priv->m[1];
#line 177 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	self->priv->m[2] = (gdouble) 0;
#line 177 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	_tmp2_ = self->priv->m[2];
#line 177 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	self->priv->m[3] = (gdouble) 1;
#line 177 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	_tmp3_ = self->priv->m[3];
#line 177 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	self->priv->m[4] = (gdouble) 0;
#line 177 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	_tmp4_ = self->priv->m[4];
#line 177 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	self->priv->m[5] = (gdouble) 0;
#line 177 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	_tmp5_ = self->priv->m[5];
#line 178 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	self->priv->parent = NULL;
#line 179 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	self->priv->seed = NULL;
#line 1123 "point.c"
}


/**
 * Return p * abcedf * seed
 */
void projection_map (Projection* pr, Point* p, Point* result) {
	Point _tmp32_ = {0};
#line 185 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	g_return_if_fail (p != NULL);
#line 186 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	while (TRUE) {
#line 1136 "point.c"
		Projection* _tmp0_ = NULL;
		gdouble x = 0.0;
		Projection* _tmp1_ = NULL;
		gdouble _tmp2_ = 0.0;
		Point _tmp3_ = {0};
		gdouble _tmp4_ = 0.0;
		Projection* _tmp5_ = NULL;
		gdouble _tmp6_ = 0.0;
		Point _tmp7_ = {0};
		gdouble _tmp8_ = 0.0;
		Projection* _tmp9_ = NULL;
		gdouble _tmp10_ = 0.0;
		gdouble y = 0.0;
		Projection* _tmp11_ = NULL;
		gdouble _tmp12_ = 0.0;
		Point _tmp13_ = {0};
		gdouble _tmp14_ = 0.0;
		Projection* _tmp15_ = NULL;
		gdouble _tmp16_ = 0.0;
		Point _tmp17_ = {0};
		gdouble _tmp18_ = 0.0;
		Projection* _tmp19_ = NULL;
		gdouble _tmp20_ = 0.0;
		Projection* _tmp21_ = NULL;
		Seed* _tmp22_ = NULL;
		Projection* _tmp30_ = NULL;
		Projection* _tmp31_ = NULL;
#line 186 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		_tmp0_ = pr;
#line 186 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		if (!(_tmp0_ != NULL)) {
#line 186 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
			break;
#line 1170 "point.c"
		}
#line 188 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		_tmp1_ = pr;
#line 188 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		_tmp2_ = _tmp1_->priv->m[0];
#line 188 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		_tmp3_ = *p;
#line 188 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		_tmp4_ = _tmp3_.x;
#line 188 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		_tmp5_ = pr;
#line 188 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		_tmp6_ = _tmp5_->priv->m[2];
#line 188 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		_tmp7_ = *p;
#line 188 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		_tmp8_ = _tmp7_.y;
#line 188 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		_tmp9_ = pr;
#line 188 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		_tmp10_ = _tmp9_->priv->m[4];
#line 188 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		x = ((_tmp2_ * _tmp4_) + (_tmp6_ * _tmp8_)) + _tmp10_;
#line 189 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		_tmp11_ = pr;
#line 189 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		_tmp12_ = _tmp11_->priv->m[1];
#line 189 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		_tmp13_ = *p;
#line 189 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		_tmp14_ = _tmp13_.x;
#line 189 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		_tmp15_ = pr;
#line 189 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		_tmp16_ = _tmp15_->priv->m[3];
#line 189 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		_tmp17_ = *p;
#line 189 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		_tmp18_ = _tmp17_.y;
#line 189 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		_tmp19_ = pr;
#line 189 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		_tmp20_ = _tmp19_->priv->m[5];
#line 189 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		y = ((_tmp12_ * _tmp14_) + (_tmp16_ * _tmp18_)) + _tmp20_;
#line 190 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		_tmp21_ = pr;
#line 190 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		_tmp22_ = _tmp21_->priv->seed;
#line 190 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		if (_tmp22_ == NULL) {
#line 1222 "point.c"
			gdouble _tmp23_ = 0.0;
			gdouble _tmp24_ = 0.0;
#line 191 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
			_tmp23_ = x;
#line 191 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
			(*p).x = _tmp23_;
#line 192 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
			_tmp24_ = y;
#line 192 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
			(*p).y = _tmp24_;
#line 1233 "point.c"
		} else {
			Projection* _tmp25_ = NULL;
			Seed* _tmp26_ = NULL;
			gdouble _tmp27_ = 0.0;
			gdouble _tmp28_ = 0.0;
			Point _tmp29_ = {0};
#line 195 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
			_tmp25_ = pr;
#line 195 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
			_tmp26_ = _tmp25_->priv->seed;
#line 195 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
			_tmp27_ = x;
#line 195 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
			_tmp28_ = y;
#line 195 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
			seed_distant_point (_tmp26_, _tmp27_, _tmp28_, &_tmp29_);
#line 195 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
			*p = _tmp29_;
#line 1252 "point.c"
		}
#line 197 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		_tmp30_ = pr;
#line 197 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		_tmp31_ = _tmp30_->priv->parent;
#line 197 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		pr = _tmp31_;
#line 1260 "point.c"
	}
#line 199 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	_tmp32_ = *p;
#line 199 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	*result = _tmp32_;
#line 199 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	return;
#line 1268 "point.c"
}


/**
 * abcdef = abcdef * pqrstu
 */
static void projection_add (Projection* self, gdouble p, gdouble q, gdouble r, gdouble s, gdouble t, gdouble u) {
	gdouble z[6] = {0};
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
	gdouble _tmp6_ = 0.0;
	gdouble _tmp7_ = 0.0;
	gdouble _tmp8_ = 0.0;
	gdouble _tmp9_ = 0.0;
	gdouble _tmp10_ = 0.0;
	gdouble _tmp11_ = 0.0;
	gdouble _tmp12_ = 0.0;
	gdouble _tmp13_ = 0.0;
	gdouble _tmp14_ = 0.0;
	gdouble _tmp15_ = 0.0;
	gdouble _tmp16_ = 0.0;
	gdouble _tmp17_ = 0.0;
	gdouble _tmp18_ = 0.0;
	gdouble _tmp19_ = 0.0;
	gdouble _tmp20_ = 0.0;
	gdouble _tmp21_ = 0.0;
	gdouble _tmp22_ = 0.0;
	gdouble _tmp23_ = 0.0;
	gdouble _tmp24_ = 0.0;
	gdouble _tmp25_ = 0.0;
	gdouble _tmp26_ = 0.0;
	gdouble _tmp27_ = 0.0;
	gdouble _tmp28_ = 0.0;
	gdouble _tmp29_ = 0.0;
	gdouble _tmp30_ = 0.0;
	gdouble _tmp31_ = 0.0;
#line 205 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	g_return_if_fail (self != NULL);
#line 207 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	_tmp0_ = self->priv->m[0];
#line 207 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	_tmp1_ = p;
#line 207 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	_tmp2_ = self->priv->m[1];
#line 207 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	_tmp3_ = r;
#line 207 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	z[0] = (_tmp0_ * _tmp1_) + (_tmp2_ * _tmp3_);
#line 207 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	_tmp4_ = z[0];
#line 208 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	_tmp5_ = self->priv->m[0];
#line 208 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	_tmp6_ = q;
#line 208 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	_tmp7_ = self->priv->m[1];
#line 208 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	_tmp8_ = s;
#line 208 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	z[1] = (_tmp5_ * _tmp6_) + (_tmp7_ * _tmp8_);
#line 208 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	_tmp9_ = z[1];
#line 209 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	_tmp10_ = self->priv->m[2];
#line 209 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	_tmp11_ = p;
#line 209 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	_tmp12_ = self->priv->m[3];
#line 209 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	_tmp13_ = r;
#line 209 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	z[2] = (_tmp10_ * _tmp11_) + (_tmp12_ * _tmp13_);
#line 209 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	_tmp14_ = z[2];
#line 210 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	_tmp15_ = self->priv->m[2];
#line 210 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	_tmp16_ = q;
#line 210 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	_tmp17_ = self->priv->m[3];
#line 210 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	_tmp18_ = s;
#line 210 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	z[3] = (_tmp15_ * _tmp16_) + (_tmp17_ * _tmp18_);
#line 210 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	_tmp19_ = z[3];
#line 211 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	_tmp20_ = self->priv->m[4];
#line 211 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	_tmp21_ = p;
#line 211 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	_tmp22_ = self->priv->m[5];
#line 211 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	_tmp23_ = r;
#line 211 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	_tmp24_ = t;
#line 211 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	z[4] = ((_tmp20_ * _tmp21_) + (_tmp22_ * _tmp23_)) + _tmp24_;
#line 211 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	_tmp25_ = z[4];
#line 212 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	_tmp26_ = self->priv->m[4];
#line 212 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	_tmp27_ = q;
#line 212 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	_tmp28_ = self->priv->m[5];
#line 212 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	_tmp29_ = s;
#line 212 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	_tmp30_ = u;
#line 212 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	z[5] = ((_tmp26_ * _tmp27_) + (_tmp28_ * _tmp29_)) + _tmp30_;
#line 212 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	_tmp31_ = z[5];
#line 213 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	memcpy (self->priv->m, z, 6 * sizeof (gdouble));
#line 1389 "point.c"
}


Projection* projection_construct (GType object_type) {
	Projection* self = NULL;
#line 73 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	self = (Projection*) g_type_create_instance (object_type);
#line 73 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	return self;
#line 1399 "point.c"
}


Projection* projection_new (void) {
#line 73 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	return projection_construct (TYPE_PROJECTION);
#line 1406 "point.c"
}


static void value_projection_init (GValue* value) {
#line 73 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	value->data[0].v_pointer = NULL;
#line 1413 "point.c"
}


static void value_projection_free_value (GValue* value) {
#line 73 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	if (value->data[0].v_pointer) {
#line 73 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		projection_unref (value->data[0].v_pointer);
#line 1422 "point.c"
	}
}


static void value_projection_copy_value (const GValue* src_value, GValue* dest_value) {
#line 73 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	if (src_value->data[0].v_pointer) {
#line 73 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		dest_value->data[0].v_pointer = projection_ref (src_value->data[0].v_pointer);
#line 1432 "point.c"
	} else {
#line 73 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		dest_value->data[0].v_pointer = NULL;
#line 1436 "point.c"
	}
}


static gpointer value_projection_peek_pointer (const GValue* value) {
#line 73 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	return value->data[0].v_pointer;
#line 1444 "point.c"
}


static gchar* value_projection_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
#line 73 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	if (collect_values[0].v_pointer) {
#line 1451 "point.c"
		Projection* object;
		object = collect_values[0].v_pointer;
#line 73 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		if (object->parent_instance.g_class == NULL) {
#line 73 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1458 "point.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 73 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1462 "point.c"
		}
#line 73 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		value->data[0].v_pointer = projection_ref (object);
#line 1466 "point.c"
	} else {
#line 73 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		value->data[0].v_pointer = NULL;
#line 1470 "point.c"
	}
#line 73 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	return NULL;
#line 1474 "point.c"
}


static gchar* value_projection_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	Projection** object_p;
	object_p = collect_values[0].v_pointer;
#line 73 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	if (!object_p) {
#line 73 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 1485 "point.c"
	}
#line 73 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	if (!value->data[0].v_pointer) {
#line 73 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		*object_p = NULL;
#line 1491 "point.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 73 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		*object_p = value->data[0].v_pointer;
#line 1495 "point.c"
	} else {
#line 73 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		*object_p = projection_ref (value->data[0].v_pointer);
#line 1499 "point.c"
	}
#line 73 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	return NULL;
#line 1503 "point.c"
}


GParamSpec* param_spec_projection (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	ParamSpecProjection* spec;
#line 73 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_PROJECTION), NULL);
#line 73 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 73 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 73 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	return G_PARAM_SPEC (spec);
#line 1517 "point.c"
}


gpointer value_get_projection (const GValue* value) {
#line 73 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PROJECTION), NULL);
#line 73 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	return value->data[0].v_pointer;
#line 1526 "point.c"
}


void value_set_projection (GValue* value, gpointer v_object) {
	Projection* old;
#line 73 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PROJECTION));
#line 73 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	old = value->data[0].v_pointer;
#line 73 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	if (v_object) {
#line 73 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_PROJECTION));
#line 73 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 73 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		value->data[0].v_pointer = v_object;
#line 73 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		projection_ref (value->data[0].v_pointer);
#line 1546 "point.c"
	} else {
#line 73 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		value->data[0].v_pointer = NULL;
#line 1550 "point.c"
	}
#line 73 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	if (old) {
#line 73 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		projection_unref (old);
#line 1556 "point.c"
	}
}


void value_take_projection (GValue* value, gpointer v_object) {
	Projection* old;
#line 73 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PROJECTION));
#line 73 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	old = value->data[0].v_pointer;
#line 73 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	if (v_object) {
#line 73 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_PROJECTION));
#line 73 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 73 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		value->data[0].v_pointer = v_object;
#line 1575 "point.c"
	} else {
#line 73 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		value->data[0].v_pointer = NULL;
#line 1579 "point.c"
	}
#line 73 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	if (old) {
#line 73 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		projection_unref (old);
#line 1585 "point.c"
	}
}


static void projection_class_init (ProjectionClass * klass) {
#line 73 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	projection_parent_class = g_type_class_peek_parent (klass);
#line 73 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	PROJECTION_CLASS (klass)->finalize = projection_finalize;
#line 73 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	g_type_class_add_private (klass, sizeof (ProjectionPrivate));
#line 1597 "point.c"
}


static void projection_instance_init (Projection * self) {
#line 73 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	self->priv = PROJECTION_GET_PRIVATE (self);
#line 73 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	self->ref_count = 1;
#line 1606 "point.c"
}


static void projection_finalize (Projection* obj) {
	Projection * self;
#line 73 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PROJECTION, Projection);
#line 1614 "point.c"
}


GType projection_get_type (void) {
	static volatile gsize projection_type_id__volatile = 0;
	if (g_once_init_enter (&projection_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_projection_init, value_projection_free_value, value_projection_copy_value, value_projection_peek_pointer, "p", value_projection_collect_value, "p", value_projection_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (ProjectionClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) projection_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Projection), 0, (GInstanceInitFunc) projection_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType projection_type_id;
		projection_type_id = g_type_register_fundamental (g_type_fundamental_next (), "Projection", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&projection_type_id__volatile, projection_type_id);
	}
	return projection_type_id__volatile;
}


gpointer projection_ref (gpointer instance) {
	Projection* self;
	self = instance;
#line 73 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	g_atomic_int_inc (&self->ref_count);
#line 73 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	return instance;
#line 1639 "point.c"
}


void projection_unref (gpointer instance) {
	Projection* self;
	self = instance;
#line 73 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 73 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		PROJECTION_GET_CLASS (self)->finalize (self);
#line 73 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 1652 "point.c"
	}
}


void rgba_init (RGBA *self, gdouble r, gdouble g, gdouble b, gdouble a) {
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
#line 223 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	memset (self, 0, sizeof (RGBA));
#line 224 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	_tmp0_ = r;
#line 224 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	(*self).r = _tmp0_;
#line 225 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	_tmp1_ = g;
#line 225 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	(*self).g = _tmp1_;
#line 226 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	_tmp2_ = b;
#line 226 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	(*self).b = _tmp2_;
#line 227 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	_tmp3_ = a;
#line 227 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	(*self).a = _tmp3_;
#line 1680 "point.c"
}


RGBA* rgba_dup (const RGBA* self) {
	RGBA* dup;
#line 217 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	dup = g_new0 (RGBA, 1);
#line 217 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	memcpy (dup, self, sizeof (RGBA));
#line 217 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	return dup;
#line 1692 "point.c"
}


void rgba_free (RGBA* self) {
#line 217 "/home/jaidi/project/mutiara/mutiara-code/src/point.vala"
	g_free (self);
#line 1699 "point.c"
}


GType rgba_get_type (void) {
	static volatile gsize rgba_type_id__volatile = 0;
	if (g_once_init_enter (&rgba_type_id__volatile)) {
		GType rgba_type_id;
		rgba_type_id = g_boxed_type_register_static ("RGBA", (GBoxedCopyFunc) rgba_dup, (GBoxedFreeFunc) rgba_free);
		g_once_init_leave (&rgba_type_id__volatile, rgba_type_id);
	}
	return rgba_type_id__volatile;
}



