/*  Mutiara motif designer.
	Copyright (C) 2011  Nor Jaidi Tuah

	This file is part of Mutiara.

	Mutiara is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

/**
 * Like GLib.Cancellable, but more lightweight and has a timer.
 */
public class Probe {
	public bool cancelled = false;
	Timer timer = new Timer ();
	double interval;

	public Probe () {
		interval = 1.0;
	}

	public void cancel () {
		cancelled = true;
	}

	public bool time_to_peek () {
		if (timer.elapsed () > interval) {
			timer.reset ();
			interval = double.min (interval * 2, 5);
			return true;
		}
		return false;
	}
}
// vim: tabstop=4: textwidth=100: autoindent:
