/*  Mutiara motif designer.
	Copyright (C) 2011  Nor Jaidi Tuah

	This file is part of Mutiara.

	Mutiara is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
public class SnapDialog : Object {
	/**
	 * Widgets to set by the run method
	 */
	Gtk.Dialog dialog = null;
	Gtk.SpinButton grid_size_entry;
	Gtk.SpinButton snap_angle_entry;

	public void run (Gtk.Window parent_window, PodDrawing pod_drawing) {
		if (dialog == null) make_dialog (parent_window);
		if (pod_drawing.edited_pod is Border) {
			grid_size_entry.set_range (5, 500);
			grid_size_entry.set_increments (10, 10);
		}
		else {
			grid_size_entry.set_range (0.01, 0.5);
			grid_size_entry.set_increments (0.05, 0.05);
		}
		grid_size_entry.value = pod_drawing.grid_size;
		snap_angle_entry.value = pod_drawing.snap_angle;
		var result = dialog.run ();
		dialog.hide ();
		if (result == Gtk.ResponseType.OK) {
			pod_drawing.grid_size = grid_size_entry.value;
			pod_drawing.snap_angle = snap_angle_entry.value;
		}
	}

	void make_dialog (Gtk.Window parent_window) {
		dialog = Util.make_dialog (parent_window, _("Snap Setting"), _("_Set Snap"), (grid) => {
			Util.attach (grid, 0, _("Grid size:"), grid_size_entry = Util.make_spin_button (0.01, 0.5, 0.05));
			Util.attach (grid, 1, _("Snap angle:"), snap_angle_entry = Util.make_spin_button (5, 90, 5));
			grid.attach (Util.label_centered (_("To snap, press Shift\nwhile dragging.")), 0, 2, 2, 1);
		});
	}
}
// vim: tabstop=4: textwidth=100: autoindent:
