/* util.c generated by valac 0.22.0, the Vala compiler
 * generated from util.vala, do not modify */

/*  Mutiara motif designer.
Copyright (C) 2011  Nor Jaidi Tuah

This file is part of Mutiara.

Mutiara is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <glib.h>
#include <glib-object.h>
#include <float.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>
#include <glib/gi18n-lib.h>
#include <gdk/gdk.h>

#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define TYPE_MUTIARA_APPLICATION (mutiara_application_get_type ())
#define MUTIARA_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MUTIARA_APPLICATION, MutiaraApplication))
#define MUTIARA_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MUTIARA_APPLICATION, MutiaraApplicationClass))
#define IS_MUTIARA_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MUTIARA_APPLICATION))
#define IS_MUTIARA_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MUTIARA_APPLICATION))
#define MUTIARA_APPLICATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MUTIARA_APPLICATION, MutiaraApplicationClass))

typedef struct _MutiaraApplication MutiaraApplication;
typedef struct _MutiaraApplicationClass MutiaraApplicationClass;

typedef void (*UtilContentsDelegate) (GtkGrid* grid, void* user_data);

extern MutiaraApplication* mutiara_application_instance;

gboolean util_debug_on (void);
gchar* util_format (gdouble n, gint decimal_places);
GtkLabel* util_label (const gchar* label_text);
GtkLabel* util_title (const gchar* label_text);
GtkLabel* util_label_centered (const gchar* label_text);
void util_attach (GtkGrid* grid, gint y, const gchar* label_text, GtkWidget* widget);
GtkDialog* util_make_dialog (GtkWindow* parent, const gchar* title, const gchar* ok_text, UtilContentsDelegate put_contents, void* put_contents_target);
void util_resolve_accelerator_clashes (GtkWidget* widget);
static gboolean __lambda7_ (GdkEventFocus* e);
GType mutiara_application_get_type (void) G_GNUC_CONST;
static gboolean ___lambda7__gtk_widget_focus_in_event (GtkWidget* _sender, GdkEventFocus* event, gpointer self);
static gboolean __lambda47_ (GdkEventFocus* e);
static gboolean ___lambda47__gtk_widget_focus_out_event (GtkWidget* _sender, GdkEventFocus* event, gpointer self);
GtkSpinButton* util_make_spin_button (gdouble min, gdouble max, gdouble step);

static GRegex* _tmp_regex_0 = NULL;

gboolean util_debug_on (void) {
	gboolean result = FALSE;
	const gchar* _tmp0_ = NULL;
#line 26 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
	_tmp0_ = g_getenv ("MUTIARA_DEBUG");
#line 26 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
	result = _tmp0_ != NULL;
#line 26 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
	return result;
#line 78 "util.c"
}


/**
 * Remove trailing zeros and decimal point.
 * e.g., 2.000 => 2
 *       5.240 => 5.24
 */
static inline GRegex* _thread_safe_regex_init (GRegex** re, const gchar * pattern, GRegexMatchFlags match_options) {
#line 38 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
	if (g_once_init_enter ((volatile gsize*) re)) {
#line 38 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
		GRegex* val = g_regex_new (pattern, match_options, 0, NULL);
#line 38 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
		g_once_init_leave ((volatile gsize*) re, (gsize) val);
#line 94 "util.c"
	}
#line 38 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
	return *re;
#line 98 "util.c"
}


gchar* util_format (gdouble n, gint decimal_places) {
	gchar* result = NULL;
	gchar* format_string = NULL;
	gint _tmp0_ = 0;
	gchar* _tmp1_ = NULL;
	gchar* number = NULL;
	const gchar* _tmp2_ = NULL;
	gdouble _tmp3_ = 0.0;
	gchar* _tmp4_ = NULL;
	GError * _inner_error_ = NULL;
#line 35 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
	_tmp0_ = decimal_places;
#line 35 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
	_tmp1_ = g_strdup_printf ("%%.%df", _tmp0_);
#line 35 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
	format_string = _tmp1_;
#line 36 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
	_tmp2_ = format_string;
#line 36 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
	_tmp3_ = n;
#line 36 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
	_tmp4_ = g_strdup_printf (_tmp2_, _tmp3_);
#line 36 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
	number = _tmp4_;
#line 126 "util.c"
	{
		gchar* _tmp5_ = NULL;
		const gchar* _tmp6_ = NULL;
		gchar* _tmp7_ = NULL;
		const gchar* _tmp8_ = NULL;
#line 38 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
		_tmp6_ = number;
#line 38 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
		_tmp7_ = g_regex_replace (_thread_safe_regex_init (&_tmp_regex_0, "\\.?0+$", 0), _tmp6_, (gssize) (-1), 0, "", 0, &_inner_error_);
#line 38 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
		_tmp5_ = _tmp7_;
#line 38 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
		if (_inner_error_ != NULL) {
#line 38 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
			if (_inner_error_->domain == G_REGEX_ERROR) {
#line 142 "util.c"
				goto __catch30_g_regex_error;
			}
#line 38 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
			_g_free0 (number);
#line 38 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
			_g_free0 (format_string);
#line 38 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 38 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
			g_clear_error (&_inner_error_);
#line 38 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
			return NULL;
#line 155 "util.c"
		}
#line 38 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
		_g_free0 (number);
#line 38 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
		number = _tmp5_;
#line 39 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
		_tmp8_ = number;
#line 39 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
		if (g_strcmp0 (_tmp8_, "-0") == 0) {
#line 165 "util.c"
			gchar* _tmp9_ = NULL;
#line 39 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
			_tmp9_ = g_strdup ("0");
#line 39 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
			result = _tmp9_;
#line 39 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
			_g_free0 (number);
#line 39 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
			_g_free0 (format_string);
#line 39 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
			return result;
#line 177 "util.c"
		} else {
#line 40 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
			result = number;
#line 40 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
			_g_free0 (format_string);
#line 40 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
			return result;
#line 185 "util.c"
		}
	}
	goto __finally30;
	__catch30_g_regex_error:
	{
		GError* e = NULL;
		GError* _tmp10_ = NULL;
		const gchar* _tmp11_ = NULL;
#line 37 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
		e = _inner_error_;
#line 37 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
		_inner_error_ = NULL;
#line 43 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
		_tmp10_ = e;
#line 43 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
		_tmp11_ = _tmp10_->message;
#line 43 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
		g_print ("%s\n", _tmp11_);
#line 44 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
		result = number;
#line 44 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
		_g_error_free0 (e);
#line 44 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
		_g_free0 (format_string);
#line 44 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
		return result;
#line 212 "util.c"
	}
	__finally30:
#line 37 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
	_g_free0 (number);
#line 37 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
	_g_free0 (format_string);
#line 37 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 37 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
	g_clear_error (&_inner_error_);
#line 37 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
	return NULL;
#line 225 "util.c"
}


/**
 * Create left-justified, left-positioned label
 */
GtkLabel* util_label (const gchar* label_text) {
	GtkLabel* result = NULL;
	GtkLabel* label = NULL;
	const gchar* _tmp0_ = NULL;
	GtkLabel* _tmp1_ = NULL;
#line 51 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
	g_return_val_if_fail (label_text != NULL, NULL);
#line 52 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
	_tmp0_ = label_text;
#line 52 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
	_tmp1_ = (GtkLabel*) gtk_label_new (_tmp0_);
#line 52 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
	g_object_ref_sink (_tmp1_);
#line 52 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
	label = _tmp1_;
#line 53 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
	gtk_widget_set_halign ((GtkWidget*) label, GTK_ALIGN_START);
#line 54 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
	gtk_label_set_justify (label, GTK_JUSTIFY_LEFT);
#line 55 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
	result = label;
#line 55 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
	return result;
#line 255 "util.c"
}


/**
 * Create title label
 */
GtkLabel* util_title (const gchar* label_text) {
	GtkLabel* result = NULL;
	GtkLabel* label = NULL;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	GtkLabel* _tmp5_ = NULL;
	GtkLabel* _tmp6_ = NULL;
#line 61 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
	g_return_val_if_fail (label_text != NULL, NULL);
#line 62 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
	_tmp0_ = label_text;
#line 62 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
	_tmp1_ = g_strconcat ("<b>", _tmp0_, NULL);
#line 62 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
	_tmp2_ = _tmp1_;
#line 62 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
	_tmp3_ = g_strconcat (_tmp2_, "</b>", NULL);
#line 62 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
	_tmp4_ = _tmp3_;
#line 62 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
	_tmp5_ = util_label_centered (_tmp4_);
#line 62 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
	_tmp6_ = _tmp5_;
#line 62 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
	_g_free0 (_tmp4_);
#line 62 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
	_g_free0 (_tmp2_);
#line 62 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
	label = _tmp6_;
#line 63 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
	gtk_label_set_use_markup (label, TRUE);
#line 64 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
	result = label;
#line 64 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
	return result;
#line 300 "util.c"
}


/**
 * Create centered label
 */
GtkLabel* util_label_centered (const gchar* label_text) {
	GtkLabel* result = NULL;
	GtkLabel* label = NULL;
	const gchar* _tmp0_ = NULL;
	GtkLabel* _tmp1_ = NULL;
#line 70 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
	g_return_val_if_fail (label_text != NULL, NULL);
#line 71 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
	_tmp0_ = label_text;
#line 71 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
	_tmp1_ = (GtkLabel*) gtk_label_new (_tmp0_);
#line 71 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
	g_object_ref_sink (_tmp1_);
#line 71 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
	label = _tmp1_;
#line 72 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
	gtk_widget_set_halign ((GtkWidget*) label, GTK_ALIGN_CENTER);
#line 73 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
	gtk_label_set_justify (label, GTK_JUSTIFY_CENTER);
#line 74 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
	gtk_widget_set_margin_top ((GtkWidget*) label, 10);
#line 75 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
	gtk_widget_set_margin_bottom ((GtkWidget*) label, 10);
#line 76 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
	result = label;
#line 76 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
	return result;
#line 334 "util.c"
}


/**
 * Attach a widget to a table complete with a left-justified label
 */
void util_attach (GtkGrid* grid, gint y, const gchar* label_text, GtkWidget* widget) {
	const gchar* _tmp0_ = NULL;
	GtkGrid* _tmp6_ = NULL;
	GtkWidget* _tmp7_ = NULL;
	gint _tmp8_ = 0;
#line 82 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
	g_return_if_fail (grid != NULL);
#line 83 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
	_tmp0_ = label_text;
#line 83 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
	if (_tmp0_ != NULL) {
#line 352 "util.c"
		GtkGrid* _tmp1_ = NULL;
		const gchar* _tmp2_ = NULL;
		GtkLabel* _tmp3_ = NULL;
		GtkLabel* _tmp4_ = NULL;
		gint _tmp5_ = 0;
#line 83 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
		_tmp1_ = grid;
#line 83 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
		_tmp2_ = label_text;
#line 83 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
		_tmp3_ = util_label (_tmp2_);
#line 83 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
		_tmp4_ = _tmp3_;
#line 83 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
		_tmp5_ = y;
#line 83 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
		gtk_grid_attach (_tmp1_, (GtkWidget*) _tmp4_, 0, _tmp5_, 1, 1);
#line 83 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
		_g_object_unref0 (_tmp4_);
#line 372 "util.c"
	}
#line 84 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
	_tmp6_ = grid;
#line 84 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
	_tmp7_ = widget;
#line 84 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
	_tmp8_ = y;
#line 84 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
	gtk_grid_attach (_tmp6_, _tmp7_, 1, _tmp8_, 1, 1);
#line 382 "util.c"
}


static gpointer _g_object_ref0 (gpointer self) {
#line 96 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
	return self ? g_object_ref (self) : NULL;
#line 389 "util.c"
}


GtkDialog* util_make_dialog (GtkWindow* parent, const gchar* title, const gchar* ok_text, UtilContentsDelegate put_contents, void* put_contents_target) {
	GtkDialog* result = NULL;
	GtkDialog* dialog = NULL;
	const gchar* _tmp0_ = NULL;
	GtkWindow* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	const gchar* _tmp3_ = NULL;
	GtkDialog* _tmp4_ = NULL;
	GtkBox* box = NULL;
	GtkBox* _tmp5_ = NULL;
	GtkBox* _tmp6_ = NULL;
	GtkGrid* grid = NULL;
	GtkGrid* _tmp7_ = NULL;
	UtilContentsDelegate _tmp8_ = NULL;
	void* _tmp8__target = NULL;
#line 92 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
	g_return_val_if_fail (parent != NULL, NULL);
#line 92 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
	g_return_val_if_fail (title != NULL, NULL);
#line 92 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
	g_return_val_if_fail (ok_text != NULL, NULL);
#line 93 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
	_tmp0_ = title;
#line 93 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
	_tmp1_ = parent;
#line 93 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
	_tmp2_ = _ ("Cancel");
#line 93 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
	_tmp3_ = ok_text;
#line 93 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
	_tmp4_ = (GtkDialog*) gtk_dialog_new_with_buttons (_tmp0_, _tmp1_, GTK_DIALOG_MODAL, _tmp2_, GTK_RESPONSE_CANCEL, _tmp3_, GTK_RESPONSE_OK, NULL);
#line 93 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
	g_object_ref_sink (_tmp4_);
#line 93 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
	dialog = _tmp4_;
#line 95 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
	gtk_window_set_resizable ((GtkWindow*) dialog, FALSE);
#line 96 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
	_tmp5_ = (GtkBox*) gtk_dialog_get_content_area (dialog);
#line 96 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
	_tmp6_ = _g_object_ref0 (_tmp5_);
#line 96 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
	box = _tmp6_;
#line 97 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
	_tmp7_ = (GtkGrid*) gtk_grid_new ();
#line 97 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
	g_object_ref_sink (_tmp7_);
#line 97 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
	grid = _tmp7_;
#line 98 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
	gtk_container_add ((GtkContainer*) box, (GtkWidget*) grid);
#line 100 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
	gtk_grid_set_row_spacing (grid, 5);
#line 101 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
	gtk_grid_set_column_spacing (grid, 10);
#line 102 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
	gtk_widget_set_margin_left ((GtkWidget*) grid, 5);
#line 103 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
	gtk_widget_set_margin_right ((GtkWidget*) grid, 5);
#line 104 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
	gtk_widget_set_margin_bottom ((GtkWidget*) grid, 20);
#line 105 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
	_tmp8_ = put_contents;
#line 105 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
	_tmp8__target = put_contents_target;
#line 105 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
	_tmp8_ (grid, _tmp8__target);
#line 106 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
	gtk_widget_show_all ((GtkWidget*) dialog);
#line 107 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
	result = dialog;
#line 107 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
	_g_object_unref0 (grid);
#line 107 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
	_g_object_unref0 (box);
#line 107 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
	return result;
#line 470 "util.c"
}


/**
 * Call this method with text editing components
 */
static gboolean __lambda7_ (GdkEventFocus* e) {
	gboolean result = FALSE;
	MutiaraApplication* _tmp0_ = NULL;
#line 114 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
	g_return_val_if_fail (e != NULL, FALSE);
#line 115 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
	_tmp0_ = mutiara_application_instance;
#line 115 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
	gtk_application_remove_accelerator ((GtkApplication*) _tmp0_, "win.Delete", NULL);
#line 116 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
	result = FALSE;
#line 116 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
	return result;
#line 490 "util.c"
}


static gboolean ___lambda7__gtk_widget_focus_in_event (GtkWidget* _sender, GdkEventFocus* event, gpointer self) {
	gboolean result;
	result = __lambda7_ (event);
#line 114 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
	return result;
#line 499 "util.c"
}


static gboolean __lambda47_ (GdkEventFocus* e) {
	gboolean result = FALSE;
	MutiaraApplication* _tmp0_ = NULL;
#line 118 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
	g_return_val_if_fail (e != NULL, FALSE);
#line 119 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
	_tmp0_ = mutiara_application_instance;
#line 119 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
	gtk_application_add_accelerator ((GtkApplication*) _tmp0_, "Delete", "win.Delete", NULL);
#line 120 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
	result = FALSE;
#line 120 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
	return result;
#line 516 "util.c"
}


static gboolean ___lambda47__gtk_widget_focus_out_event (GtkWidget* _sender, GdkEventFocus* event, gpointer self) {
	gboolean result;
	result = __lambda47_ (event);
#line 118 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
	return result;
#line 525 "util.c"
}


void util_resolve_accelerator_clashes (GtkWidget* widget) {
	GtkWidget* _tmp0_ = NULL;
	GtkWidget* _tmp1_ = NULL;
#line 113 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
	g_return_if_fail (widget != NULL);
#line 114 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
	_tmp0_ = widget;
#line 114 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
	g_signal_connect (_tmp0_, "focus-in-event", (GCallback) ___lambda7__gtk_widget_focus_in_event, NULL);
#line 118 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
	_tmp1_ = widget;
#line 118 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
	g_signal_connect (_tmp1_, "focus-out-event", (GCallback) ___lambda47__gtk_widget_focus_out_event, NULL);
#line 542 "util.c"
}


/**
 * Create a spin button which disable some accelerators upon focus.
 */
GtkSpinButton* util_make_spin_button (gdouble min, gdouble max, gdouble step) {
	GtkSpinButton* result = NULL;
	GtkSpinButton* button = NULL;
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	GtkSpinButton* _tmp3_ = NULL;
#line 128 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
	_tmp0_ = min;
#line 128 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
	_tmp1_ = max;
#line 128 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
	_tmp2_ = step;
#line 128 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
	_tmp3_ = (GtkSpinButton*) gtk_spin_button_new_with_range (_tmp0_, _tmp1_, _tmp2_);
#line 128 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
	g_object_ref_sink (_tmp3_);
#line 128 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
	button = _tmp3_;
#line 129 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
	util_resolve_accelerator_clashes ((GtkWidget*) button);
#line 130 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
	result = button;
#line 130 "/home/jaidi/project/mutiara/mutiara-code/src/util.vala"
	return result;
#line 574 "util.c"
}



