/* seed.c generated by valac 0.22.0, the Vala compiler
 * generated from seed.vala, do not modify */

/*  Mutiara motif designer.
Copyright (C) 2011  Nor Jaidi Tuah

This file is part of Mutiara.

Mutiara is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/**
 * User configurable attributes
 * ^^^^^^^^^^^^^^^^^^^^^^^^^^^^
 */
/**
 * Computed values used to speed up rendering
 * ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
 *
 * These values initialized by a call to start_render.
 */

#include <glib.h>
#include <glib-object.h>
#include <float.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <cairo.h>


#define TYPE_SEED (seed_get_type ())
#define SEED(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SEED, Seed))
#define SEED_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SEED, SeedClass))
#define IS_SEED(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SEED))
#define IS_SEED_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SEED))
#define SEED_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SEED, SeedClass))

typedef struct _Seed Seed;
typedef struct _SeedClass SeedClass;
typedef struct _SeedPrivate SeedPrivate;

#define TYPE_POINT (point_get_type ())
typedef struct _Point Point;

#define TYPE_ROLE (role_get_type ())

#define TYPE_FLIP (flip_get_type ())

#define TYPE_TWEAK (tweak_get_type ())
typedef struct _Tweak Tweak;

#define TYPE_RGBA (rgba_get_type ())
typedef struct _RGBA RGBA;

#define TYPE_RENDER_STYLE (render_style_get_type ())

#define TYPE_PROJECTION (projection_get_type ())
#define PROJECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PROJECTION, Projection))
#define PROJECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PROJECTION, ProjectionClass))
#define IS_PROJECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PROJECTION))
#define IS_PROJECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PROJECTION))
#define PROJECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PROJECTION, ProjectionClass))

typedef struct _Projection Projection;
typedef struct _ProjectionClass ProjectionClass;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _projection_unref0(var) ((var == NULL) ? NULL : (var = (projection_unref (var), NULL)))

#define TYPE_PROBE (probe_get_type ())
#define PROBE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PROBE, Probe))
#define PROBE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PROBE, ProbeClass))
#define IS_PROBE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PROBE))
#define IS_PROBE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PROBE))
#define PROBE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PROBE, ProbeClass))

typedef struct _Probe Probe;
typedef struct _ProbeClass ProbeClass;
typedef struct _ProbePrivate ProbePrivate;

#define TYPE_DEFERRED_CAIRO (deferred_cairo_get_type ())
#define DEFERRED_CAIRO(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DEFERRED_CAIRO, DeferredCairo))
#define DEFERRED_CAIRO_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DEFERRED_CAIRO, DeferredCairoClass))
#define IS_DEFERRED_CAIRO(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DEFERRED_CAIRO))
#define IS_DEFERRED_CAIRO_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DEFERRED_CAIRO))
#define DEFERRED_CAIRO_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DEFERRED_CAIRO, DeferredCairoClass))

typedef struct _DeferredCairo DeferredCairo;
typedef struct _DeferredCairoClass DeferredCairoClass;

#define TYPE_LINE (line_get_type ())
#define LINE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LINE, Line))
#define LINE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_LINE, LineClass))
#define IS_LINE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LINE))
#define IS_LINE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_LINE))
#define LINE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_LINE, LineClass))

typedef struct _Line Line;
typedef struct _LineClass LineClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _deferred_cairo_unref0(var) ((var == NULL) ? NULL : (var = (deferred_cairo_unref (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _Point {
	gdouble x;
	gdouble y;
};

typedef enum  {
	ROLE_DUAL = 0,
	ROLE_MOTIF = 1,
	ROLE_BASE = 2
} Role;

typedef enum  {
	FLIP_NONE = 0,
	FLIP_Y = 1,
	FLIP_X = 2,
	FLIP_XY = 3
} Flip;

struct _Tweak {
	gdouble scale_x;
	gdouble scale_y;
	gdouble rotate;
	gdouble move_x;
	gdouble move_y;
};

struct _RGBA {
	gdouble r;
	gdouble g;
	gdouble b;
	gdouble a;
};

typedef enum  {
	RENDER_STYLE_THIN = 0,
	RENDER_STYLE_THICK = 1,
	RENDER_STYLE_HOLLOW = 2,
	RENDER_STYLE_FILLED = 3,
	RENDER_STYLE_CLOSED = 4,
	RENDER_STYLE_NONE = 5
} RenderStyle;

struct _Seed {
	GObject parent_instance;
	SeedPrivate * priv;
	gboolean debug;
	gboolean is_affine;
	Role role;
	gdouble base_offset;
	Flip flip_even;
	Flip flip_odd;
	Tweak tweak;
	gdouble width0;
	gdouble width1;
	gint num_segment;
	gint level_of_detail;
	RGBA color;
	gdouble color_mix;
	RenderStyle render_style;
	Projection** projection;
	gint projection_length1;
	gint selected_control;
	Point pressed_point;
};

struct _SeedClass {
	GObjectClass parent_class;
	void (*init_default_sub) (Seed* self, Point* p);
	void (*init_full_sub) (Seed* self, gdouble* args, int args_length1);
	gchar* (*serialize_sub) (Seed* self);
	void (*point_raw) (Seed* self, gdouble t, Point* result);
	void (*init_distance_to_parametric) (Seed* self);
	void (*distant_point) (Seed* self, gdouble x_distance, gdouble y_distance, Point* result);
	void (*draw_direct) (Seed* self, cairo_t* cr, gdouble scale);
	void (*draw_controls) (Seed* self, cairo_t* cr, gdouble scale);
	gint (*pressed_control) (Seed* self, Point* p, gdouble scale);
	void (*save_drag_context) (Seed* self);
	void (*move_shape) (Seed* self, gdouble delta_x, gdouble delta_y);
	void (*drag_control) (Seed* self, Point* p, gdouble scale, gboolean snap_on, gdouble grid_size, gdouble snap_angle);
	Point* (*points_to_snap) (Seed* self, int* result_length1);
	void (*draw_icon) (Seed* self, cairo_t* cr, gdouble width, gdouble height);
};

struct _SeedPrivate {
	gdouble* distance_to_param;
	gint distance_to_param_length1;
	gint _distance_to_param_size_;
	gint div;
	gboolean* self_intersect;
	gint self_intersect_length1;
	gint _self_intersect_size_;
	gboolean twisted;
	gdouble control_radius;
	gdouble control_magnetic_range;
	gdouble grid_magnetic_range;
};

struct _Probe {
	GTypeInstance parent_instance;
	volatile int ref_count;
	ProbePrivate * priv;
	gboolean cancelled;
};

struct _ProbeClass {
	GTypeClass parent_class;
	void (*finalize) (Probe *self);
};


static gpointer seed_parent_class = NULL;
static gdouble seed_epsilon;
static gdouble seed_epsilon = 0.0;

GType seed_get_type (void) G_GNUC_CONST;
GType point_get_type (void) G_GNUC_CONST;
Point* point_dup (const Point* self);
void point_free (Point* self);
GType role_get_type (void) G_GNUC_CONST;
GType flip_get_type (void) G_GNUC_CONST;
GType tweak_get_type (void) G_GNUC_CONST;
Tweak* tweak_dup (const Tweak* self);
void tweak_free (Tweak* self);
GType rgba_get_type (void) G_GNUC_CONST;
RGBA* rgba_dup (const RGBA* self);
void rgba_free (RGBA* self);
GType render_style_get_type (void) G_GNUC_CONST;
gpointer projection_ref (gpointer instance);
void projection_unref (gpointer instance);
GParamSpec* param_spec_projection (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_projection (GValue* value, gpointer v_object);
void value_take_projection (GValue* value, gpointer v_object);
gpointer value_get_projection (const GValue* value);
GType projection_get_type (void) G_GNUC_CONST;
#define SEED_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_SEED, SeedPrivate))
enum  {
	SEED_DUMMY_PROPERTY
};
void tweak_init (Tweak *self);
void rgba_init (RGBA *self, gdouble r, gdouble g, gdouble b, gdouble a);
void seed_init_default (Seed* self, Point* p);
void seed_init_default_sub (Seed* self, Point* p);
void seed_init_full (Seed* self, gdouble* args, int args_length1);
void seed_init_full_sub (Seed* self, gdouble* args, int args_length1);
static void seed_real_init_default_sub (Seed* self, Point* p);
static void seed_real_init_full_sub (Seed* self, gdouble* args, int args_length1);
gchar* seed_serialize (Seed* self, gboolean for_border);
gchar* seed_serialize_sub (Seed* self);
gchar* util_format (gdouble n, gint decimal_places);
static gchar* seed_serialize_tweak (Seed* self);
gboolean tweak_equals (Tweak *self, Tweak* t);
gchar* tweak_serialize (Tweak *self);
static gchar* seed_real_serialize_sub (Seed* self);
void seed_copy_parameters (Seed* self, Seed* source);
void seed_point (Seed* self, gdouble distance, Point* result);
void seed_point_raw (Seed* self, gdouble t, Point* result);
gdouble seed_parameter (Seed* self, gdouble distance);
static void seed_real_point_raw (Seed* self, gdouble t, Point* result);
void seed_start_render (Seed* self);
void seed_init_distance_to_parametric (Seed* self);
static void seed_init_self_intersect (Seed* self);
static void seed_init_projection (Seed* self);
void seed_stop_render (Seed* self);
static void seed_real_init_distance_to_parametric (Seed* self);
gdouble point_hypot (Point* p0, Point* p1);
gboolean seed_check_twisted (Seed* self, gint n);
static gboolean seed_check_self_intersect (Seed* self, gint n);
void seed_distant_point (Seed* self, gdouble x_distance, gdouble y_distance, Point* result);
static gboolean seed_check_intersect (Point* p1, Point* p2, Point* q1, Point* q2);
static gdouble seed_area_sign (Point* p1, Point* p2, Point* p3);
Projection* projection_new_by_segment (Seed* seed, gdouble t0, gdouble t1, Flip flip);
Projection* projection_construct_by_segment (GType object_type, Seed* seed, gdouble t0, gdouble t1, Flip flip);
static void seed_real_distant_point (Seed* self, gdouble x_distance, gdouble y_distance, Point* result);
gpointer probe_ref (gpointer instance);
void probe_unref (gpointer instance);
GParamSpec* param_spec_probe (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_probe (GValue* value, gpointer v_object);
void value_take_probe (GValue* value, gpointer v_object);
gpointer value_get_probe (const GValue* value);
GType probe_get_type (void) G_GNUC_CONST;
gboolean seed_too_thin (Seed* self, Projection* pr, Probe* probe, gdouble thickness, gboolean segment_twisted, gdouble* width);
static void seed_compute_area_perimeter (Seed* self, Projection* pr, Probe* probe, gdouble limit, gdouble x0, gdouble y0, gdouble x1, gdouble y1, gdouble* area, gdouble* perimeter);
void projection_map (Projection* pr, Point* p, Point* result);
static void seed_compute_sub_area_perimeter (Seed* self, Projection* pr, Probe* probe, gdouble limit, gdouble x0, gdouble y0, Point* p0, gdouble x1, gdouble y1, Point* p1, gdouble distance, gdouble* area, gdouble* perimeter, gint depth);
gpointer deferred_cairo_ref (gpointer instance);
void deferred_cairo_unref (gpointer instance);
GParamSpec* param_spec_deferred_cairo (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_deferred_cairo (GValue* value, gpointer v_object);
void value_take_deferred_cairo (GValue* value, gpointer v_object);
gpointer value_get_deferred_cairo (const GValue* value);
GType deferred_cairo_get_type (void) G_GNUC_CONST;
void seed_draw (Seed* self, DeferredCairo* dc, Projection* pr, Probe* probe, gdouble limit);
void deferred_cairo_move_to (DeferredCairo* self, Point* p);
static void seed_draw_segment (Seed* self, DeferredCairo* dc, Projection* pr, Probe* probe, gdouble x0, gdouble y0, gdouble x1, gdouble y1, gdouble limit);
void deferred_cairo_stroke (DeferredCairo* self);
GType line_get_type (void) G_GNUC_CONST;
Line* line_new (void);
Line* line_construct (GType object_type);
void deferred_cairo_fill (DeferredCairo* self);
void seed_draw_segmentation (Seed* self, cairo_t* cr, Projection* pr);
DeferredCairo* deferred_cairo_new (void);
DeferredCairo* deferred_cairo_construct (GType object_type);
void deferred_cairo_render (DeferredCairo* self, cairo_t* cr);
static void seed_draw_sub_segment (Seed* self, DeferredCairo* dc, Projection* pr, Probe* probe, gdouble x0, gdouble y0, Point* p0, gdouble x1, gdouble y1, Point* p1, gdouble distance, gdouble limit, gint depth);
void deferred_cairo_line_to (DeferredCairo* self, Point* p);
void seed_draw_direct (Seed* self, cairo_t* cr, gdouble scale);
static void seed_real_draw_direct (Seed* self, cairo_t* cr, gdouble scale);
void seed_draw_controls (Seed* self, cairo_t* cr, gdouble scale);
static void seed_real_draw_controls (Seed* self, cairo_t* cr, gdouble scale);
void seed_draw_square_control (Seed* self, cairo_t* cr, Point* p);
void seed_draw_line_control (Seed* self, cairo_t* cr, Point* p0, Point* p1);
void seed_draw_circle_control (Seed* self, cairo_t* cr, Point* p);
gboolean seed_within_snap_range (Seed* self, Point* p0, Point* p1, gdouble scale);
gboolean seed_within_touch_range (Seed* self, Point* p0, Point* p1, gdouble scale);
gboolean seed_touching (Seed* self, Point* p, gdouble scale);
gboolean seed_start_drag (Seed* self, Point* p, gdouble scale, gboolean selected, gboolean snap_on, gdouble grid_size);
void seed_save_drag_context (Seed* self);
gboolean seed_snap (Seed* self, Point* p, gdouble scale, gdouble grid_size);
gint seed_pressed_control (Seed* self, Point* p, gdouble scale);
static gint seed_real_pressed_control (Seed* self, Point* p, gdouble scale);
static void seed_real_save_drag_context (Seed* self);
void seed_drag (Seed* self, Point* p, gdouble scale, gboolean snap_on, gdouble grid_size, gdouble snap_angle);
void seed_move_shape (Seed* self, gdouble delta_x, gdouble delta_y);
void seed_distance_to_grid (Seed* self, gdouble scale, gdouble grid_size, gdouble* distance_x, gdouble* distance_y);
void seed_drag_control (Seed* self, Point* p, gdouble scale, gboolean snap_on, gdouble grid_size, gdouble snap_angle);
static void seed_real_move_shape (Seed* self, gdouble delta_x, gdouble delta_y);
static void seed_real_drag_control (Seed* self, Point* p, gdouble scale, gboolean snap_on, gdouble grid_size, gdouble snap_angle);
gboolean seed_snap_x (Seed* self, Point* p, gdouble scale, gdouble grid_size);
gboolean seed_snap_y (Seed* self, Point* p, gdouble scale, gdouble grid_size);
Point* seed_points_to_snap (Seed* self, int* result_length1);
static Point* seed_real_points_to_snap (Seed* self, int* result_length1);
void seed_draw_icon (Seed* self, cairo_t* cr, gdouble width, gdouble height);
static void seed_real_draw_icon (Seed* self, cairo_t* cr, gdouble width, gdouble height);
Seed* seed_construct (GType object_type);
static void seed_finalize (GObject* obj);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);


/**
 * After creating a seed, call one of these to initialize.
 */
void seed_init_default (Seed* self, Point* p) {
	Point _tmp0_ = {0};
#line 108 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	g_return_if_fail (self != NULL);
#line 108 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	g_return_if_fail (p != NULL);
#line 109 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp0_ = *p;
#line 109 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	seed_init_default_sub (self, &_tmp0_);
#line 367 "seed.c"
}


void seed_init_full (Seed* self, gdouble* args, int args_length1) {
	gdouble* _tmp0_ = NULL;
	gint _tmp0__length1 = 0;
#line 112 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	g_return_if_fail (self != NULL);
#line 113 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp0_ = args;
#line 113 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp0__length1 = args_length1;
#line 113 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	seed_init_full_sub (self, _tmp0_, _tmp0__length1);
#line 382 "seed.c"
}


static void seed_real_init_default_sub (Seed* self, Point* p) {
#line 116 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	g_critical ("Type `%s' does not implement abstract method `seed_init_default_sub'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 116 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	return;
#line 391 "seed.c"
}


void seed_init_default_sub (Seed* self, Point* p) {
#line 116 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	g_return_if_fail (self != NULL);
#line 116 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	SEED_GET_CLASS (self)->init_default_sub (self, p);
#line 400 "seed.c"
}


static void seed_real_init_full_sub (Seed* self, gdouble* args, int args_length1) {
#line 117 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	g_critical ("Type `%s' does not implement abstract method `seed_init_full_sub'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 117 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	return;
#line 409 "seed.c"
}


void seed_init_full_sub (Seed* self, gdouble* args, int args_length1) {
#line 117 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	g_return_if_fail (self != NULL);
#line 117 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	SEED_GET_CLASS (self)->init_full_sub (self, args, args_length1);
#line 418 "seed.c"
}


/**
 * See Pod.serialize
 */
gchar* seed_serialize (Seed* self, gboolean for_border) {
	gchar* result = NULL;
	gboolean _tmp0_ = FALSE;
#line 122 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 123 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp0_ = for_border;
#line 123 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	if (_tmp0_) {
#line 434 "seed.c"
		gchar* _tmp1_ = NULL;
		gchar* _tmp2_ = NULL;
		gdouble _tmp3_ = 0.0;
		gint _tmp4_ = 0;
		gdouble _tmp5_ = 0.0;
		gchar* _tmp6_ = NULL;
		gchar* _tmp7_ = NULL;
		gdouble _tmp8_ = 0.0;
		gchar* _tmp9_ = NULL;
		gchar* _tmp10_ = NULL;
		Role _tmp11_ = 0;
		gint _tmp12_ = 0;
		Flip _tmp13_ = 0;
		Flip _tmp14_ = 0;
		gchar* _tmp15_ = NULL;
		gchar* _tmp16_ = NULL;
		gchar* _tmp17_ = NULL;
		gchar* _tmp18_ = NULL;
#line 124 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp1_ = seed_serialize_sub (self);
#line 124 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp2_ = _tmp1_;
#line 124 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp3_ = self->base_offset;
#line 124 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp4_ = self->num_segment;
#line 124 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp5_ = self->width0;
#line 124 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp6_ = util_format (_tmp5_, 4);
#line 124 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp7_ = _tmp6_;
#line 124 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp8_ = self->width1;
#line 124 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp9_ = util_format (_tmp8_, 4);
#line 124 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp10_ = _tmp9_;
#line 124 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp11_ = self->role;
#line 124 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp12_ = self->level_of_detail;
#line 124 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp13_ = self->flip_even;
#line 124 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp14_ = self->flip_odd;
#line 124 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp15_ = seed_serialize_tweak (self);
#line 124 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp16_ = _tmp15_;
#line 124 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp17_ = g_strdup_printf ("%s\n" \
"    segmentation %.1g, %d\n" \
"    width %s, %s\n" \
"    replication %d, %d, %d, %d%s\n", _tmp2_, _tmp3_, _tmp4_, _tmp7_, _tmp10_, (gint) _tmp11_, _tmp12_, (gint) _tmp13_, (gint) _tmp14_, _tmp16_);
#line 124 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp18_ = _tmp17_;
#line 124 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_g_free0 (_tmp16_);
#line 124 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_g_free0 (_tmp10_);
#line 124 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_g_free0 (_tmp7_);
#line 124 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_g_free0 (_tmp2_);
#line 124 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		result = _tmp18_;
#line 124 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		return result;
#line 501 "seed.c"
	} else {
		const gchar* _tmp19_ = NULL;
		gboolean _tmp20_ = FALSE;
		gchar* _tmp21_ = NULL;
		gchar* _tmp22_ = NULL;
		const gchar* _tmp23_ = NULL;
		gdouble _tmp24_ = 0.0;
		gint _tmp25_ = 0;
		gdouble _tmp26_ = 0.0;
		gchar* _tmp27_ = NULL;
		gchar* _tmp28_ = NULL;
		gdouble _tmp29_ = 0.0;
		gchar* _tmp30_ = NULL;
		gchar* _tmp31_ = NULL;
		Role _tmp32_ = 0;
		gint _tmp33_ = 0;
		Flip _tmp34_ = 0;
		Flip _tmp35_ = 0;
		gchar* _tmp36_ = NULL;
		gchar* _tmp37_ = NULL;
		RGBA _tmp38_ = {0};
		gdouble _tmp39_ = 0.0;
		RGBA _tmp40_ = {0};
		gdouble _tmp41_ = 0.0;
		RGBA _tmp42_ = {0};
		gdouble _tmp43_ = 0.0;
		RGBA _tmp44_ = {0};
		gdouble _tmp45_ = 0.0;
		gdouble _tmp46_ = 0.0;
		RenderStyle _tmp47_ = 0;
		gchar* _tmp48_ = NULL;
		gchar* _tmp49_ = NULL;
#line 143 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp20_ = self->debug;
#line 143 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		if (_tmp20_) {
#line 143 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
			_tmp19_ = "\ndebug";
#line 540 "seed.c"
		} else {
#line 143 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
			_tmp19_ = "";
#line 544 "seed.c"
		}
#line 135 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp21_ = seed_serialize_sub (self);
#line 135 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp22_ = _tmp21_;
#line 135 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp23_ = _tmp19_;
#line 135 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp24_ = self->base_offset;
#line 135 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp25_ = self->num_segment;
#line 135 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp26_ = self->width0;
#line 135 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp27_ = util_format (_tmp26_, 4);
#line 135 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp28_ = _tmp27_;
#line 135 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp29_ = self->width1;
#line 135 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp30_ = util_format (_tmp29_, 4);
#line 135 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp31_ = _tmp30_;
#line 135 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp32_ = self->role;
#line 135 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp33_ = self->level_of_detail;
#line 135 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp34_ = self->flip_even;
#line 135 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp35_ = self->flip_odd;
#line 135 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp36_ = seed_serialize_tweak (self);
#line 135 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp37_ = _tmp36_;
#line 135 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp38_ = self->color;
#line 135 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp39_ = _tmp38_.r;
#line 135 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp40_ = self->color;
#line 135 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp41_ = _tmp40_.g;
#line 135 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp42_ = self->color;
#line 135 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp43_ = _tmp42_.b;
#line 135 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp44_ = self->color;
#line 135 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp45_ = _tmp44_.a;
#line 135 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp46_ = self->color_mix;
#line 135 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp47_ = self->render_style;
#line 135 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp48_ = g_strdup_printf ("%s%s\n" \
"    segmentation %.1g, %d\n" \
"    width %s, %s\n" \
"    replication %d, %d, %d, %d%s\n" \
"    color (%.2g, %.2g, %.2g, %.2g) %.2g\n" \
"    style %d\n", _tmp22_, _tmp23_, _tmp24_, _tmp25_, _tmp28_, _tmp31_, (gint) _tmp32_, _tmp33_, (gint) _tmp34_, (gint) _tmp35_, _tmp37_, _tmp39_, _tmp41_, _tmp43_, _tmp45_, _tmp46_, (gint) _tmp47_);
#line 135 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp49_ = _tmp48_;
#line 135 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_g_free0 (_tmp37_);
#line 135 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_g_free0 (_tmp31_);
#line 135 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_g_free0 (_tmp28_);
#line 135 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_g_free0 (_tmp22_);
#line 135 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		result = _tmp49_;
#line 135 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		return result;
#line 616 "seed.c"
	}
}


static gchar* seed_serialize_tweak (Seed* self) {
	gchar* result = NULL;
	Tweak _tmp0_ = {0};
	gboolean _tmp1_ = FALSE;
#line 151 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 152 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	tweak_init (&_tmp0_);
#line 152 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp1_ = tweak_equals (&self->tweak, &_tmp0_);
#line 152 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	if (_tmp1_) {
#line 633 "seed.c"
		gchar* _tmp2_ = NULL;
#line 152 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp2_ = g_strdup ("");
#line 152 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		result = _tmp2_;
#line 152 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		return result;
#line 641 "seed.c"
	} else {
		gchar* _tmp3_ = NULL;
		gchar* _tmp4_ = NULL;
		gchar* _tmp5_ = NULL;
		gchar* _tmp6_ = NULL;
#line 153 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp3_ = tweak_serialize (&self->tweak);
#line 153 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp4_ = _tmp3_;
#line 153 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp5_ = g_strdup_printf ("\n    tweak %s", _tmp4_);
#line 153 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp6_ = _tmp5_;
#line 153 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_g_free0 (_tmp4_);
#line 153 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		result = _tmp6_;
#line 153 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		return result;
#line 661 "seed.c"
	}
}


static gchar* seed_real_serialize_sub (Seed* self) {
#line 156 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	g_critical ("Type `%s' does not implement abstract method `seed_serialize_sub'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 156 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	return NULL;
#line 671 "seed.c"
}


gchar* seed_serialize_sub (Seed* self) {
#line 156 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 156 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	return SEED_GET_CLASS (self)->serialize_sub (self);
#line 680 "seed.c"
}


void seed_copy_parameters (Seed* self, Seed* source) {
	Seed* _tmp0_ = NULL;
	gdouble _tmp1_ = 0.0;
	Seed* _tmp2_ = NULL;
	gint _tmp3_ = 0;
	Seed* _tmp4_ = NULL;
	gdouble _tmp5_ = 0.0;
	Seed* _tmp6_ = NULL;
	gdouble _tmp7_ = 0.0;
	Seed* _tmp8_ = NULL;
	Role _tmp9_ = 0;
	Seed* _tmp10_ = NULL;
	gint _tmp11_ = 0;
	Seed* _tmp12_ = NULL;
	Flip _tmp13_ = 0;
	Seed* _tmp14_ = NULL;
	Flip _tmp15_ = 0;
	Seed* _tmp16_ = NULL;
	Tweak _tmp17_ = {0};
	Seed* _tmp18_ = NULL;
	RGBA _tmp19_ = {0};
	Seed* _tmp20_ = NULL;
	gdouble _tmp21_ = 0.0;
	Seed* _tmp22_ = NULL;
	RenderStyle _tmp23_ = 0;
#line 158 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	g_return_if_fail (self != NULL);
#line 158 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	g_return_if_fail (source != NULL);
#line 159 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp0_ = source;
#line 159 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp1_ = _tmp0_->base_offset;
#line 159 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	self->base_offset = _tmp1_;
#line 160 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp2_ = source;
#line 160 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp3_ = _tmp2_->num_segment;
#line 160 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	self->num_segment = _tmp3_;
#line 161 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp4_ = source;
#line 161 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp5_ = _tmp4_->width0;
#line 161 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	self->width0 = _tmp5_;
#line 162 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp6_ = source;
#line 162 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp7_ = _tmp6_->width1;
#line 162 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	self->width1 = _tmp7_;
#line 163 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp8_ = source;
#line 163 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp9_ = _tmp8_->role;
#line 163 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	self->role = _tmp9_;
#line 164 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp10_ = source;
#line 164 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp11_ = _tmp10_->level_of_detail;
#line 164 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	self->level_of_detail = _tmp11_;
#line 165 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp12_ = source;
#line 165 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp13_ = _tmp12_->flip_even;
#line 165 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	self->flip_even = _tmp13_;
#line 166 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp14_ = source;
#line 166 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp15_ = _tmp14_->flip_odd;
#line 166 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	self->flip_odd = _tmp15_;
#line 167 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp16_ = source;
#line 167 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp17_ = _tmp16_->tweak;
#line 167 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	self->tweak = _tmp17_;
#line 168 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp18_ = source;
#line 168 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp19_ = _tmp18_->color;
#line 168 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	self->color = _tmp19_;
#line 169 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp20_ = source;
#line 169 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp21_ = _tmp20_->color_mix;
#line 169 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	self->color_mix = _tmp21_;
#line 170 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp22_ = source;
#line 170 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp23_ = _tmp22_->render_style;
#line 170 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	self->render_style = _tmp23_;
#line 785 "seed.c"
}


/**
 * Compute (x(t), y(t)), where t is the distance (or time)
 * of a "constant speed" curve.
 */
void seed_point (Seed* self, gdouble distance, Point* result) {
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	Point _tmp2_ = {0};
#line 177 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	g_return_if_fail (self != NULL);
#line 178 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp0_ = distance;
#line 178 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp1_ = seed_parameter (self, _tmp0_);
#line 178 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	seed_point_raw (self, _tmp1_, &_tmp2_);
#line 178 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	*result = _tmp2_;
#line 178 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	return;
#line 809 "seed.c"
}


static void seed_real_point_raw (Seed* self, gdouble t, Point* result) {
#line 181 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	g_critical ("Type `%s' does not implement abstract method `seed_point_raw'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 181 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	return;
#line 818 "seed.c"
}


void seed_point_raw (Seed* self, gdouble t, Point* result) {
#line 181 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	g_return_if_fail (self != NULL);
#line 181 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	SEED_GET_CLASS (self)->point_raw (self, t, result);
#line 827 "seed.c"
}


/**
 * Given a distance on a "constant speed" curve, convert it
 * to a more convenient parameter for the computation of points on
 * the curve.
 */
gdouble seed_parameter (Seed* self, gdouble distance) {
	gdouble result = 0.0;
	gdouble* _tmp0_ = NULL;
	gint _tmp0__length1 = 0;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp9_ = 0.0;
	gdouble n_exact = 0.0;
	gdouble _tmp18_ = 0.0;
	gint _tmp19_ = 0;
	gint n = 0;
	gdouble _tmp20_ = 0.0;
	gdouble t0 = 0.0;
	gdouble* _tmp21_ = NULL;
	gint _tmp21__length1 = 0;
	gint _tmp22_ = 0;
	gdouble _tmp23_ = 0.0;
	gdouble t1 = 0.0;
	gdouble* _tmp24_ = NULL;
	gint _tmp24__length1 = 0;
	gint _tmp25_ = 0;
	gdouble _tmp26_ = 0.0;
	gdouble gap = 0.0;
	gdouble _tmp27_ = 0.0;
	gdouble _tmp28_ = 0.0;
	gdouble t = 0.0;
	gdouble _tmp29_ = 0.0;
	gdouble _tmp30_ = 0.0;
	gint _tmp31_ = 0;
	gdouble _tmp32_ = 0.0;
	gdouble _tmp33_ = 0.0;
#line 188 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 189 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp0_ = self->priv->distance_to_param;
#line 189 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp0__length1 = self->priv->distance_to_param_length1;
#line 189 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	if (_tmp0_ == NULL) {
#line 874 "seed.c"
		gdouble _tmp1_ = 0.0;
#line 189 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp1_ = distance;
#line 189 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		result = _tmp1_;
#line 189 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		return result;
#line 882 "seed.c"
	}
#line 190 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp2_ = distance;
#line 190 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	if (_tmp2_ < ((gdouble) 0)) {
#line 888 "seed.c"
		gdouble _tmp3_ = 0.0;
		gdouble* _tmp4_ = NULL;
		gint _tmp4__length1 = 0;
		gdouble _tmp5_ = 0.0;
		gdouble* _tmp6_ = NULL;
		gint _tmp6__length1 = 0;
		gdouble _tmp7_ = 0.0;
		gint _tmp8_ = 0;
#line 191 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp3_ = distance;
#line 191 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp4_ = self->priv->distance_to_param;
#line 191 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp4__length1 = self->priv->distance_to_param_length1;
#line 191 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp5_ = _tmp4_[1];
#line 191 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp6_ = self->priv->distance_to_param;
#line 191 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp6__length1 = self->priv->distance_to_param_length1;
#line 191 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp7_ = _tmp6_[0];
#line 191 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp8_ = self->priv->div;
#line 191 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		result = (_tmp3_ * (_tmp5_ - _tmp7_)) * _tmp8_;
#line 191 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		return result;
#line 917 "seed.c"
	}
#line 193 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp9_ = distance;
#line 193 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	if (_tmp9_ >= ((gdouble) 1)) {
#line 923 "seed.c"
		gdouble _tmp10_ = 0.0;
		gdouble* _tmp11_ = NULL;
		gint _tmp11__length1 = 0;
		gint _tmp12_ = 0;
		gdouble _tmp13_ = 0.0;
		gdouble* _tmp14_ = NULL;
		gint _tmp14__length1 = 0;
		gint _tmp15_ = 0;
		gdouble _tmp16_ = 0.0;
		gint _tmp17_ = 0;
#line 194 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp10_ = distance;
#line 194 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp11_ = self->priv->distance_to_param;
#line 194 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp11__length1 = self->priv->distance_to_param_length1;
#line 194 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp12_ = self->priv->div;
#line 194 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp13_ = _tmp11_[_tmp12_];
#line 194 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp14_ = self->priv->distance_to_param;
#line 194 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp14__length1 = self->priv->distance_to_param_length1;
#line 194 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp15_ = self->priv->div;
#line 194 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp16_ = _tmp14_[_tmp15_ - 1];
#line 194 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp17_ = self->priv->div;
#line 194 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		result = 1 + (((_tmp10_ - 1) * (_tmp13_ - _tmp16_)) * _tmp17_);
#line 194 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		return result;
#line 958 "seed.c"
	}
#line 197 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp18_ = distance;
#line 197 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp19_ = self->priv->div;
#line 197 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	n_exact = _tmp18_ * _tmp19_;
#line 198 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp20_ = n_exact;
#line 198 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	n = (gint) _tmp20_;
#line 199 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp21_ = self->priv->distance_to_param;
#line 199 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp21__length1 = self->priv->distance_to_param_length1;
#line 199 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp22_ = n;
#line 199 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp23_ = _tmp21_[_tmp22_];
#line 199 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	t0 = _tmp23_;
#line 200 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp24_ = self->priv->distance_to_param;
#line 200 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp24__length1 = self->priv->distance_to_param_length1;
#line 200 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp25_ = n;
#line 200 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp26_ = _tmp24_[_tmp25_ + 1];
#line 200 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	t1 = _tmp26_;
#line 201 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp27_ = t1;
#line 201 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp28_ = t0;
#line 201 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	gap = _tmp27_ - _tmp28_;
#line 202 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp29_ = t0;
#line 202 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp30_ = n_exact;
#line 202 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp31_ = n;
#line 202 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp32_ = gap;
#line 202 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	t = _tmp29_ + ((_tmp30_ - _tmp31_) * _tmp32_);
#line 203 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp33_ = t;
#line 203 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	if (_tmp33_ < ((gdouble) 0)) {
#line 1010 "seed.c"
		gdouble _tmp34_ = 0.0;
#line 204 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp34_ = t;
#line 204 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		g_warning ("seed.vala:204: unexpected value: t=%f", _tmp34_);
#line 1016 "seed.c"
	}
#line 206 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	result = t;
#line 206 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	return result;
#line 1022 "seed.c"
}


/**
 * To avoid unnecessary memory allocation, distance_to_param is populated
 * only before rendering, and released after rendering.
 */
void seed_start_render (Seed* self) {
#line 213 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	g_return_if_fail (self != NULL);
#line 215 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	self->priv->distance_to_param = (g_free (self->priv->distance_to_param), NULL);
#line 215 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	self->priv->distance_to_param = NULL;
#line 215 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	self->priv->distance_to_param_length1 = 0;
#line 215 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	self->priv->_distance_to_param_size_ = self->priv->distance_to_param_length1;
#line 216 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	seed_init_distance_to_parametric (self);
#line 217 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	seed_init_self_intersect (self);
#line 218 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	seed_init_projection (self);
#line 1047 "seed.c"
}


void seed_stop_render (Seed* self) {
#line 221 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	g_return_if_fail (self != NULL);
#line 222 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	self->priv->distance_to_param = (g_free (self->priv->distance_to_param), NULL);
#line 222 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	self->priv->distance_to_param = NULL;
#line 222 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	self->priv->distance_to_param_length1 = 0;
#line 222 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	self->priv->_distance_to_param_size_ = self->priv->distance_to_param_length1;
#line 223 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	self->priv->self_intersect = (g_free (self->priv->self_intersect), NULL);
#line 223 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	self->priv->self_intersect = NULL;
#line 223 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	self->priv->self_intersect_length1 = 0;
#line 223 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	self->priv->_self_intersect_size_ = self->priv->self_intersect_length1;
#line 224 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	self->projection = (_vala_array_free (self->projection, self->projection_length1, (GDestroyNotify) projection_unref), NULL);
#line 224 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	self->projection = NULL;
#line 224 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	self->projection_length1 = 0;
#line 1076 "seed.c"
}


/**
 * Populate distance_to_param table.
 */
static void seed_real_init_distance_to_parametric (Seed* self) {
	gdouble length = 0.0;
	Point p0 = {0};
	Point _tmp0_ = {0};
	gint div_calc = 0;
	gboolean normalized = FALSE;
	gdouble _tmp22_ = 0.0;
	gdouble _tmp23_ = 0.0;
	gboolean _tmp24_ = FALSE;
	gdouble _tmp27_ = 0.0;
	gint _tmp28_ = 0;
	gint _tmp29_ = 0;
	gdouble* _tmp30_ = NULL;
	gdouble* _tmp31_ = NULL;
	gint _tmp31__length1 = 0;
	gdouble _tmp32_ = 0.0;
	gdouble* _tmp33_ = NULL;
	gint _tmp33__length1 = 0;
	gint _tmp34_ = 0;
	gdouble _tmp35_ = 0.0;
	gint i0 = 0;
	gdouble len_1 = 0.0;
	gdouble dist_0 = 0.0;
	gdouble dist_1 = 0.0;
#line 232 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	length = 0.0;
#line 233 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	seed_point_raw (self, (gdouble) 0, &_tmp0_);
#line 233 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	p0 = _tmp0_;
#line 234 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	div_calc = 5000;
#line 235 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	normalized = TRUE;
#line 1117 "seed.c"
	{
		gint i = 0;
#line 236 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		i = 1;
#line 1122 "seed.c"
		{
			gboolean _tmp1_ = FALSE;
#line 236 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
			_tmp1_ = TRUE;
#line 236 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
			while (TRUE) {
#line 1129 "seed.c"
				gboolean _tmp2_ = FALSE;
				gint _tmp4_ = 0;
				gint _tmp5_ = 0;
				Point p1 = {0};
				gint _tmp6_ = 0;
				gint _tmp7_ = 0;
				Point _tmp8_ = {0};
				gboolean _tmp9_ = FALSE;
				Point _tmp10_ = {0};
				gdouble _tmp11_ = 0.0;
				gdouble _tmp12_ = 0.0;
				gboolean _tmp16_ = FALSE;
				gdouble _tmp17_ = 0.0;
				Point _tmp18_ = {0};
				Point _tmp19_ = {0};
				gdouble _tmp20_ = 0.0;
				Point _tmp21_ = {0};
#line 236 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp2_ = _tmp1_;
#line 236 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				if (!_tmp2_) {
#line 1151 "seed.c"
					gint _tmp3_ = 0;
#line 236 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
					_tmp3_ = i;
#line 236 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
					i = _tmp3_ + 1;
#line 1157 "seed.c"
				}
#line 236 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp1_ = FALSE;
#line 236 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp4_ = i;
#line 236 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp5_ = div_calc;
#line 236 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				if (!(_tmp4_ <= _tmp5_)) {
#line 236 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
					break;
#line 1169 "seed.c"
				}
#line 237 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp6_ = i;
#line 237 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp7_ = div_calc;
#line 237 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				seed_point_raw (self, ((gdouble) _tmp6_) / _tmp7_, &_tmp8_);
#line 237 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				p1 = _tmp8_;
#line 238 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp10_ = p1;
#line 238 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp11_ = _tmp10_.x;
#line 238 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp12_ = fabs (_tmp11_);
#line 238 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				if (_tmp12_ > 3.0) {
#line 1187 "seed.c"
					Point _tmp13_ = {0};
					gdouble _tmp14_ = 0.0;
					gdouble _tmp15_ = 0.0;
#line 238 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
					_tmp13_ = p1;
#line 238 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
					_tmp14_ = _tmp13_.y;
#line 238 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
					_tmp15_ = fabs (_tmp14_);
#line 238 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
					_tmp9_ = _tmp15_ > 3.0;
#line 1199 "seed.c"
				} else {
#line 238 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
					_tmp9_ = FALSE;
#line 1203 "seed.c"
				}
#line 238 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp16_ = _tmp9_;
#line 238 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				if (_tmp16_) {
#line 238 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
					normalized = FALSE;
#line 1211 "seed.c"
				}
#line 239 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp17_ = length;
#line 239 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp18_ = p0;
#line 239 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp19_ = p1;
#line 239 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp20_ = point_hypot (&_tmp18_, &_tmp19_);
#line 239 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				length = _tmp17_ + _tmp20_;
#line 240 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp21_ = p1;
#line 240 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				p0 = _tmp21_;
#line 1227 "seed.c"
			}
		}
	}
#line 242 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp22_ = length;
#line 242 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	if (_tmp22_ == ((gdouble) 0)) {
#line 243 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		self->priv->distance_to_param = (g_free (self->priv->distance_to_param), NULL);
#line 243 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		self->priv->distance_to_param = NULL;
#line 243 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		self->priv->distance_to_param_length1 = 0;
#line 243 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		self->priv->_distance_to_param_size_ = self->priv->distance_to_param_length1;
#line 244 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		return;
#line 1245 "seed.c"
	}
#line 250 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp24_ = normalized;
#line 250 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	if (_tmp24_) {
#line 1251 "seed.c"
		gdouble _tmp25_ = 0.0;
#line 250 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp25_ = length;
#line 250 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp23_ = _tmp25_ * 1000;
#line 1257 "seed.c"
	} else {
		gdouble _tmp26_ = 0.0;
#line 250 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp26_ = length;
#line 250 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp23_ = _tmp26_;
#line 1264 "seed.c"
	}
#line 250 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp27_ = _tmp23_;
#line 250 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp28_ = MAX (100, ((gint) _tmp27_) / 5);
#line 250 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	self->priv->div = _tmp28_;
#line 251 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp29_ = self->priv->div;
#line 251 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp30_ = g_new0 (gdouble, _tmp29_ + 1);
#line 251 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	self->priv->distance_to_param = (g_free (self->priv->distance_to_param), NULL);
#line 251 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	self->priv->distance_to_param = _tmp30_;
#line 251 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	self->priv->distance_to_param_length1 = _tmp29_ + 1;
#line 251 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	self->priv->_distance_to_param_size_ = self->priv->distance_to_param_length1;
#line 252 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp31_ = self->priv->distance_to_param;
#line 252 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp31__length1 = self->priv->distance_to_param_length1;
#line 252 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp31_[0] = 0.0;
#line 252 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp32_ = _tmp31_[0];
#line 253 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp33_ = self->priv->distance_to_param;
#line 253 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp33__length1 = self->priv->distance_to_param_length1;
#line 253 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp34_ = self->priv->div;
#line 253 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp33_[_tmp34_] = 1.0;
#line 253 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp35_ = _tmp33_[_tmp34_];
#line 256 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	i0 = -1;
#line 257 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	len_1 = 0.0;
#line 258 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	dist_0 = 0.0;
#line 259 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	dist_1 = 0.0;
#line 1310 "seed.c"
	{
		gint d = 0;
#line 260 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		d = 1;
#line 1315 "seed.c"
		{
			gboolean _tmp36_ = FALSE;
#line 260 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
			_tmp36_ = TRUE;
#line 260 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
			while (TRUE) {
#line 1322 "seed.c"
				gboolean _tmp37_ = FALSE;
				gint _tmp39_ = 0;
				gint _tmp40_ = 0;
				gdouble distance = 0.0;
				gint _tmp41_ = 0;
				gint _tmp42_ = 0;
				gboolean _tmp61_ = FALSE;
				gdouble _tmp62_ = 0.0;
				gdouble _tmp63_ = 0.0;
				gboolean _tmp66_ = FALSE;
				gdouble _tmp67_ = 0.0;
				gdouble _tmp68_ = 0.0;
				gdouble _tmp69_ = 0.0;
				gdouble _tmp70_ = 0.0;
				gdouble _tmp71_ = 0.0;
				gdouble t = 0.0;
				gdouble _tmp80_ = 0.0;
				gdouble _tmp81_ = 0.0;
				gdouble _tmp82_ = 0.0;
				gdouble* _tmp84_ = NULL;
				gint _tmp84__length1 = 0;
				gint _tmp85_ = 0;
				gdouble _tmp86_ = 0.0;
				gdouble _tmp87_ = 0.0;
#line 260 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp37_ = _tmp36_;
#line 260 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				if (!_tmp37_) {
#line 1351 "seed.c"
					gint _tmp38_ = 0;
#line 260 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
					_tmp38_ = d;
#line 260 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
					d = _tmp38_ + 1;
#line 1357 "seed.c"
				}
#line 260 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp36_ = FALSE;
#line 260 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp39_ = d;
#line 260 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp40_ = self->priv->div;
#line 260 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				if (!(_tmp39_ < _tmp40_)) {
#line 260 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
					break;
#line 1369 "seed.c"
				}
#line 261 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp41_ = d;
#line 261 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp42_ = self->priv->div;
#line 261 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				distance = ((gdouble) _tmp41_) / _tmp42_;
#line 263 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				while (TRUE) {
#line 1379 "seed.c"
					gdouble _tmp43_ = 0.0;
					gdouble _tmp44_ = 0.0;
					gint _tmp45_ = 0;
					gint _tmp46_ = 0;
					gint _tmp47_ = 0;
					gint _tmp48_ = 0;
					gint _tmp49_ = 0;
					Point _tmp50_ = {0};
					Point p1 = {0};
					gint _tmp51_ = 0;
					gint _tmp52_ = 0;
					Point _tmp53_ = {0};
					gdouble _tmp54_ = 0.0;
					Point _tmp55_ = {0};
					Point _tmp56_ = {0};
					gdouble _tmp57_ = 0.0;
					gdouble _tmp58_ = 0.0;
					gdouble _tmp59_ = 0.0;
					gdouble _tmp60_ = 0.0;
#line 263 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
					_tmp43_ = dist_1;
#line 263 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
					_tmp44_ = distance;
#line 263 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
					if (!(_tmp43_ < _tmp44_)) {
#line 263 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
						break;
#line 1407 "seed.c"
					}
#line 264 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
					_tmp45_ = i0;
#line 264 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
					i0 = _tmp45_ + 1;
#line 265 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
					_tmp46_ = i0;
#line 265 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
					_tmp47_ = div_calc;
#line 265 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
					_vala_assert ((_tmp46_ + 1) <= _tmp47_, "i0 + 1 <= div_calc");
#line 266 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
					_tmp48_ = i0;
#line 266 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
					_tmp49_ = div_calc;
#line 266 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
					seed_point_raw (self, ((gdouble) _tmp48_) / _tmp49_, &_tmp50_);
#line 266 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
					p0 = _tmp50_;
#line 267 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
					_tmp51_ = i0;
#line 267 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
					_tmp52_ = div_calc;
#line 267 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
					seed_point_raw (self, ((gdouble) (_tmp51_ + 1)) / _tmp52_, &_tmp53_);
#line 267 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
					p1 = _tmp53_;
#line 268 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
					_tmp54_ = len_1;
#line 268 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
					_tmp55_ = p0;
#line 268 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
					_tmp56_ = p1;
#line 268 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
					_tmp57_ = point_hypot (&_tmp55_, &_tmp56_);
#line 268 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
					len_1 = _tmp54_ + _tmp57_;
#line 269 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
					_tmp58_ = dist_1;
#line 269 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
					dist_0 = _tmp58_;
#line 270 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
					_tmp59_ = len_1;
#line 270 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
					_tmp60_ = length;
#line 270 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
					dist_1 = _tmp59_ / _tmp60_;
#line 1455 "seed.c"
				}
#line 272 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp62_ = dist_0;
#line 272 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp63_ = distance;
#line 272 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				if (_tmp62_ <= _tmp63_) {
#line 1463 "seed.c"
					gdouble _tmp64_ = 0.0;
					gdouble _tmp65_ = 0.0;
#line 272 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
					_tmp64_ = distance;
#line 272 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
					_tmp65_ = dist_1;
#line 272 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
					_tmp61_ = _tmp64_ <= _tmp65_;
#line 1472 "seed.c"
				} else {
#line 272 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
					_tmp61_ = FALSE;
#line 1476 "seed.c"
				}
#line 272 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp66_ = _tmp61_;
#line 272 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				if (!_tmp66_) {
#line 1482 "seed.c"
				}
#line 275 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp68_ = dist_1;
#line 275 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp69_ = dist_0;
#line 275 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp70_ = fabs (_tmp68_ - _tmp69_);
#line 275 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp71_ = seed_epsilon;
#line 275 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				if (_tmp70_ < _tmp71_) {
#line 1494 "seed.c"
					gint _tmp72_ = 0;
					gint _tmp73_ = 0;
#line 276 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
					_tmp72_ = i0;
#line 276 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
					_tmp73_ = div_calc;
#line 276 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
					_tmp67_ = ((gdouble) _tmp72_) / _tmp73_;
#line 1503 "seed.c"
				} else {
					gint _tmp74_ = 0;
					gdouble _tmp75_ = 0.0;
					gdouble _tmp76_ = 0.0;
					gdouble _tmp77_ = 0.0;
					gdouble _tmp78_ = 0.0;
					gint _tmp79_ = 0;
#line 277 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
					_tmp74_ = i0;
#line 277 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
					_tmp75_ = distance;
#line 277 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
					_tmp76_ = dist_0;
#line 277 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
					_tmp77_ = dist_1;
#line 277 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
					_tmp78_ = dist_0;
#line 277 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
					_tmp79_ = div_calc;
#line 277 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
					_tmp67_ = (_tmp74_ + ((_tmp75_ - _tmp76_) / (_tmp77_ - _tmp78_))) / _tmp79_;
#line 1525 "seed.c"
				}
#line 275 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp80_ = _tmp67_;
#line 275 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				t = _tmp80_;
#line 278 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp81_ = t;
#line 278 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				if (_tmp81_ > ((gdouble) 1)) {
#line 278 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
					t = (gdouble) 1;
#line 1537 "seed.c"
				}
#line 279 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp82_ = t;
#line 279 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				if (_tmp82_ < ((gdouble) 0)) {
#line 1543 "seed.c"
					gdouble _tmp83_ = 0.0;
#line 280 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
					_tmp83_ = t;
#line 280 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
					g_warning ("seed.vala:280: unexpected value: t=%f (set to 0)", _tmp83_);
#line 281 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
					t = (gdouble) 0;
#line 1551 "seed.c"
				}
#line 283 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp84_ = self->priv->distance_to_param;
#line 283 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp84__length1 = self->priv->distance_to_param_length1;
#line 283 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp85_ = d;
#line 283 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp86_ = t;
#line 283 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp84_[_tmp85_] = _tmp86_;
#line 283 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp87_ = _tmp84_[_tmp85_];
#line 1565 "seed.c"
			}
		}
	}
}


void seed_init_distance_to_parametric (Seed* self) {
#line 230 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	g_return_if_fail (self != NULL);
#line 230 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	SEED_GET_CLASS (self)->init_distance_to_parametric (self);
#line 1577 "seed.c"
}


/**
 * Check if segment n is self-intersecting
 */
gboolean seed_check_twisted (Seed* self, gint n) {
	gboolean result = FALSE;
	gboolean* _tmp0_ = NULL;
	gint _tmp0__length1 = 0;
	gint _tmp1_ = 0;
	gboolean _tmp2_ = FALSE;
#line 290 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 291 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp0_ = self->priv->self_intersect;
#line 291 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp0__length1 = self->priv->self_intersect_length1;
#line 291 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp1_ = n;
#line 291 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp2_ = _tmp0_[_tmp1_];
#line 291 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	result = _tmp2_;
#line 291 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	return result;
#line 1604 "seed.c"
}


/**
 * Initialize self_intersect table.
 */
static void seed_init_self_intersect (Seed* self) {
	gint _tmp0_ = 0;
	gboolean* _tmp1_ = NULL;
#line 297 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	g_return_if_fail (self != NULL);
#line 298 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp0_ = self->num_segment;
#line 298 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp1_ = g_new0 (gboolean, _tmp0_);
#line 298 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	self->priv->self_intersect = (g_free (self->priv->self_intersect), NULL);
#line 298 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	self->priv->self_intersect = _tmp1_;
#line 298 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	self->priv->self_intersect_length1 = _tmp0_;
#line 298 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	self->priv->_self_intersect_size_ = self->priv->self_intersect_length1;
#line 1628 "seed.c"
	{
		gint i = 0;
#line 299 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		i = 0;
#line 1633 "seed.c"
		{
			gboolean _tmp2_ = FALSE;
#line 299 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
			_tmp2_ = TRUE;
#line 299 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
			while (TRUE) {
#line 1640 "seed.c"
				gboolean _tmp3_ = FALSE;
				gint _tmp5_ = 0;
				gint _tmp6_ = 0;
				gboolean* _tmp7_ = NULL;
				gint _tmp7__length1 = 0;
				gint _tmp8_ = 0;
				gint _tmp9_ = 0;
				gboolean _tmp10_ = FALSE;
				gboolean _tmp11_ = FALSE;
				gboolean _tmp12_ = FALSE;
				gboolean _tmp13_ = FALSE;
				gboolean _tmp17_ = FALSE;
#line 299 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp3_ = _tmp2_;
#line 299 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				if (!_tmp3_) {
#line 1657 "seed.c"
					gint _tmp4_ = 0;
#line 299 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
					_tmp4_ = i;
#line 299 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
					i = _tmp4_ + 1;
#line 1663 "seed.c"
				}
#line 299 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp2_ = FALSE;
#line 299 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp5_ = i;
#line 299 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp6_ = self->num_segment;
#line 299 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				if (!(_tmp5_ < _tmp6_)) {
#line 299 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
					break;
#line 1675 "seed.c"
				}
#line 300 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp7_ = self->priv->self_intersect;
#line 300 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp7__length1 = self->priv->self_intersect_length1;
#line 300 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp8_ = i;
#line 300 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp9_ = i;
#line 300 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp10_ = seed_check_self_intersect (self, _tmp9_);
#line 300 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp7_[_tmp8_] = _tmp10_;
#line 300 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp11_ = _tmp7_[_tmp8_];
#line 301 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp13_ = self->priv->twisted;
#line 301 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				if (_tmp13_) {
#line 301 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
					_tmp12_ = TRUE;
#line 1697 "seed.c"
				} else {
					gboolean* _tmp14_ = NULL;
					gint _tmp14__length1 = 0;
					gint _tmp15_ = 0;
					gboolean _tmp16_ = FALSE;
#line 301 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
					_tmp14_ = self->priv->self_intersect;
#line 301 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
					_tmp14__length1 = self->priv->self_intersect_length1;
#line 301 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
					_tmp15_ = i;
#line 301 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
					_tmp16_ = _tmp14_[_tmp15_];
#line 301 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
					_tmp12_ = _tmp16_;
#line 1713 "seed.c"
				}
#line 301 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp17_ = _tmp12_;
#line 301 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				self->priv->twisted = _tmp17_;
#line 1719 "seed.c"
			}
		}
	}
}


/**
 * Check if the normals striding segment n intersect each other
 * or the curve joining their corresponding ends.
 */
static gboolean seed_check_self_intersect (Seed* self, gint n) {
	gboolean result = FALSE;
	gdouble t0 = 0.0;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	gdouble t1 = 0.0;
	gint _tmp2_ = 0;
	gint _tmp3_ = 0;
	Point p0 = {0};
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
	Point _tmp6_ = {0};
	Point p1 = {0};
	gdouble _tmp7_ = 0.0;
	gdouble _tmp8_ = 0.0;
	Point _tmp9_ = {0};
	Point q0 = {0};
	gdouble _tmp10_ = 0.0;
	gdouble _tmp11_ = 0.0;
	Point _tmp12_ = {0};
	Point q1 = {0};
	gdouble _tmp13_ = 0.0;
	gdouble _tmp14_ = 0.0;
	Point _tmp15_ = {0};
	Point _tmp16_ = {0};
	Point _tmp17_ = {0};
	Point _tmp18_ = {0};
	Point _tmp19_ = {0};
	gboolean _tmp20_ = FALSE;
	gint num_points = 0;
	gint _tmp21_ = 0;
	gint _tmp22_ = 0;
	gint _tmp23_ = 0;
#line 309 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 310 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp0_ = n;
#line 310 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp1_ = self->num_segment;
#line 310 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	t0 = ((gdouble) _tmp0_) / _tmp1_;
#line 311 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp2_ = n;
#line 311 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp3_ = self->num_segment;
#line 311 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	t1 = ((gdouble) (_tmp2_ + 1)) / _tmp3_;
#line 313 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp4_ = t0;
#line 313 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp5_ = self->base_offset;
#line 313 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	seed_distant_point (self, _tmp4_, _tmp5_, &_tmp6_);
#line 313 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	p0 = _tmp6_;
#line 314 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp7_ = t0;
#line 314 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp8_ = self->base_offset;
#line 314 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	seed_distant_point (self, _tmp7_, _tmp8_ - 1, &_tmp9_);
#line 314 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	p1 = _tmp9_;
#line 316 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp10_ = t1;
#line 316 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp11_ = self->base_offset;
#line 316 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	seed_distant_point (self, _tmp10_, _tmp11_, &_tmp12_);
#line 316 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	q0 = _tmp12_;
#line 317 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp13_ = t1;
#line 317 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp14_ = self->base_offset;
#line 317 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	seed_distant_point (self, _tmp13_, _tmp14_ - 1, &_tmp15_);
#line 317 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	q1 = _tmp15_;
#line 319 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp16_ = p0;
#line 319 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp17_ = p1;
#line 319 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp18_ = q0;
#line 319 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp19_ = q1;
#line 319 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp20_ = seed_check_intersect (&_tmp16_, &_tmp17_, &_tmp18_, &_tmp19_);
#line 319 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	if (_tmp20_) {
#line 319 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		result = TRUE;
#line 319 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		return result;
#line 1825 "seed.c"
	}
#line 327 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp21_ = self->priv->div;
#line 327 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp22_ = self->num_segment;
#line 327 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp23_ = MAX (50, _tmp21_ / _tmp22_);
#line 327 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	num_points = _tmp23_;
#line 1835 "seed.c"
	{
		gint k = 0;
#line 328 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		k = 0;
#line 1840 "seed.c"
		{
			gboolean _tmp24_ = FALSE;
#line 328 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
			_tmp24_ = TRUE;
#line 328 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
			while (TRUE) {
#line 1847 "seed.c"
				gboolean _tmp25_ = FALSE;
				gint _tmp27_ = 0;
				gint _tmp28_ = 0;
#line 328 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp25_ = _tmp24_;
#line 328 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				if (!_tmp25_) {
#line 1855 "seed.c"
					gint _tmp26_ = 0;
#line 328 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
					_tmp26_ = k;
#line 328 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
					k = _tmp26_ + 1;
#line 1861 "seed.c"
				}
#line 328 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp24_ = FALSE;
#line 328 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp27_ = k;
#line 328 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				if (!(_tmp27_ < 2)) {
#line 328 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
					break;
#line 1871 "seed.c"
				}
#line 329 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp28_ = num_points;
#line 329 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				num_points = _tmp28_ + 1;
#line 1877 "seed.c"
				{
					gint i = 0;
#line 330 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
					i = 0;
#line 1882 "seed.c"
					{
						gboolean _tmp29_ = FALSE;
#line 330 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
						_tmp29_ = TRUE;
#line 330 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
						while (TRUE) {
#line 1889 "seed.c"
							gboolean _tmp30_ = FALSE;
							gint _tmp32_ = 0;
							gint _tmp33_ = 0;
							gdouble tA = 0.0;
							gdouble _tmp34_ = 0.0;
							gint _tmp35_ = 0;
							gint _tmp36_ = 0;
							gint _tmp37_ = 0;
							gdouble tB = 0.0;
							gdouble _tmp38_ = 0.0;
							gint _tmp39_ = 0;
							gint _tmp40_ = 0;
							gint _tmp41_ = 0;
							Point pA = {0};
							gdouble _tmp42_ = 0.0;
							gdouble _tmp43_ = 0.0;
							Point _tmp44_ = {0};
							Point pB = {0};
							gdouble _tmp45_ = 0.0;
							gdouble _tmp46_ = 0.0;
							Point _tmp47_ = {0};
							Point qA = {0};
							gdouble _tmp48_ = 0.0;
							gdouble _tmp49_ = 0.0;
							Point _tmp50_ = {0};
							Point qB = {0};
							gdouble _tmp51_ = 0.0;
							gdouble _tmp52_ = 0.0;
							Point _tmp53_ = {0};
							gboolean _tmp54_ = FALSE;
							gboolean _tmp55_ = FALSE;
							gboolean _tmp56_ = FALSE;
							Point _tmp57_ = {0};
							Point _tmp58_ = {0};
							Point _tmp59_ = {0};
							Point _tmp60_ = {0};
							gboolean _tmp61_ = FALSE;
							gboolean _tmp67_ = FALSE;
							gboolean _tmp73_ = FALSE;
							gboolean _tmp79_ = FALSE;
#line 330 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
							_tmp30_ = _tmp29_;
#line 330 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
							if (!_tmp30_) {
#line 1934 "seed.c"
								gint _tmp31_ = 0;
#line 330 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
								_tmp31_ = i;
#line 330 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
								i = _tmp31_ + 1;
#line 1940 "seed.c"
							}
#line 330 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
							_tmp29_ = FALSE;
#line 330 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
							_tmp32_ = i;
#line 330 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
							_tmp33_ = num_points;
#line 330 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
							if (!(_tmp32_ < _tmp33_)) {
#line 330 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
								break;
#line 1952 "seed.c"
							}
#line 331 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
							_tmp34_ = t0;
#line 331 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
							_tmp35_ = i;
#line 331 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
							_tmp36_ = num_points;
#line 331 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
							_tmp37_ = self->num_segment;
#line 331 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
							tA = _tmp34_ + ((((gdouble) _tmp35_) / _tmp36_) / _tmp37_);
#line 332 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
							_tmp38_ = t0;
#line 332 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
							_tmp39_ = i;
#line 332 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
							_tmp40_ = num_points;
#line 332 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
							_tmp41_ = self->num_segment;
#line 332 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
							tB = _tmp38_ + ((((gdouble) (_tmp39_ + 1)) / _tmp40_) / _tmp41_);
#line 334 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
							_tmp42_ = tA;
#line 334 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
							_tmp43_ = self->base_offset;
#line 334 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
							seed_distant_point (self, _tmp42_, _tmp43_, &_tmp44_);
#line 334 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
							pA = _tmp44_;
#line 335 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
							_tmp45_ = tB;
#line 335 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
							_tmp46_ = self->base_offset;
#line 335 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
							seed_distant_point (self, _tmp45_, _tmp46_, &_tmp47_);
#line 335 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
							pB = _tmp47_;
#line 336 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
							_tmp48_ = tA;
#line 336 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
							_tmp49_ = self->base_offset;
#line 336 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
							seed_distant_point (self, _tmp48_, _tmp49_ - 1, &_tmp50_);
#line 336 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
							qA = _tmp50_;
#line 337 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
							_tmp51_ = tB;
#line 337 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
							_tmp52_ = self->base_offset;
#line 337 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
							seed_distant_point (self, _tmp51_, _tmp52_ - 1, &_tmp53_);
#line 337 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
							qB = _tmp53_;
#line 338 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
							_tmp57_ = p0;
#line 338 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
							_tmp58_ = p1;
#line 338 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
							_tmp59_ = pA;
#line 338 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
							_tmp60_ = pB;
#line 338 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
							_tmp61_ = seed_check_intersect (&_tmp57_, &_tmp58_, &_tmp59_, &_tmp60_);
#line 338 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
							if (_tmp61_) {
#line 338 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
								_tmp56_ = TRUE;
#line 2020 "seed.c"
							} else {
								Point _tmp62_ = {0};
								Point _tmp63_ = {0};
								Point _tmp64_ = {0};
								Point _tmp65_ = {0};
								gboolean _tmp66_ = FALSE;
#line 339 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
								_tmp62_ = p0;
#line 339 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
								_tmp63_ = p1;
#line 339 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
								_tmp64_ = qA;
#line 339 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
								_tmp65_ = qB;
#line 339 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
								_tmp66_ = seed_check_intersect (&_tmp62_, &_tmp63_, &_tmp64_, &_tmp65_);
#line 339 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
								_tmp56_ = _tmp66_;
#line 2039 "seed.c"
							}
#line 338 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
							_tmp67_ = _tmp56_;
#line 338 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
							if (_tmp67_) {
#line 338 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
								_tmp55_ = TRUE;
#line 2047 "seed.c"
							} else {
								Point _tmp68_ = {0};
								Point _tmp69_ = {0};
								Point _tmp70_ = {0};
								Point _tmp71_ = {0};
								gboolean _tmp72_ = FALSE;
#line 340 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
								_tmp68_ = q0;
#line 340 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
								_tmp69_ = q1;
#line 340 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
								_tmp70_ = pA;
#line 340 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
								_tmp71_ = pB;
#line 340 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
								_tmp72_ = seed_check_intersect (&_tmp68_, &_tmp69_, &_tmp70_, &_tmp71_);
#line 340 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
								_tmp55_ = _tmp72_;
#line 2066 "seed.c"
							}
#line 338 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
							_tmp73_ = _tmp55_;
#line 338 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
							if (_tmp73_) {
#line 338 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
								_tmp54_ = TRUE;
#line 2074 "seed.c"
							} else {
								Point _tmp74_ = {0};
								Point _tmp75_ = {0};
								Point _tmp76_ = {0};
								Point _tmp77_ = {0};
								gboolean _tmp78_ = FALSE;
#line 341 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
								_tmp74_ = q0;
#line 341 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
								_tmp75_ = q1;
#line 341 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
								_tmp76_ = qA;
#line 341 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
								_tmp77_ = qB;
#line 341 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
								_tmp78_ = seed_check_intersect (&_tmp74_, &_tmp75_, &_tmp76_, &_tmp77_);
#line 341 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
								_tmp54_ = _tmp78_;
#line 2093 "seed.c"
							}
#line 338 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
							_tmp79_ = _tmp54_;
#line 338 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
							if (_tmp79_) {
#line 343 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
								result = TRUE;
#line 343 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
								return result;
#line 2103 "seed.c"
							}
						}
					}
				}
			}
		}
	}
#line 347 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	result = FALSE;
#line 347 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	return result;
#line 2115 "seed.c"
}


/**
 * Is p1, p2, p3 clockwise (-ve area), anti-clockwise (+ve area), or colinear (zero) ?
 * We want the sign rather than the actual area.
 */
static gdouble seed_area_sign (Point* p1, Point* p2, Point* p3) {
	gdouble result = 0.0;
	gdouble area = 0.0;
	Point _tmp0_ = {0};
	gdouble _tmp1_ = 0.0;
	Point _tmp2_ = {0};
	gdouble _tmp3_ = 0.0;
	Point _tmp4_ = {0};
	gdouble _tmp5_ = 0.0;
	Point _tmp6_ = {0};
	gdouble _tmp7_ = 0.0;
	Point _tmp8_ = {0};
	gdouble _tmp9_ = 0.0;
	Point _tmp10_ = {0};
	gdouble _tmp11_ = 0.0;
	Point _tmp12_ = {0};
	gdouble _tmp13_ = 0.0;
	Point _tmp14_ = {0};
	gdouble _tmp15_ = 0.0;
	gdouble _tmp16_ = 0.0;
	gdouble _tmp17_ = 0.0;
	gdouble _tmp18_ = 0.0;
#line 354 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	g_return_val_if_fail (p1 != NULL, 0.0);
#line 354 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	g_return_val_if_fail (p2 != NULL, 0.0);
#line 354 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	g_return_val_if_fail (p3 != NULL, 0.0);
#line 355 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp0_ = *p2;
#line 355 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp1_ = _tmp0_.x;
#line 355 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp2_ = *p1;
#line 355 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp3_ = _tmp2_.x;
#line 355 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp4_ = *p3;
#line 355 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp5_ = _tmp4_.y;
#line 355 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp6_ = *p1;
#line 355 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp7_ = _tmp6_.y;
#line 355 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp8_ = *p3;
#line 355 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp9_ = _tmp8_.x;
#line 355 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp10_ = *p1;
#line 355 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp11_ = _tmp10_.x;
#line 355 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp12_ = *p2;
#line 355 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp13_ = _tmp12_.y;
#line 355 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp14_ = *p1;
#line 355 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp15_ = _tmp14_.y;
#line 355 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	area = ((_tmp1_ - _tmp3_) * (_tmp5_ - _tmp7_)) - ((_tmp9_ - _tmp11_) * (_tmp13_ - _tmp15_));
#line 356 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp16_ = area;
#line 356 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp17_ = fabs (_tmp16_);
#line 356 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp18_ = seed_epsilon;
#line 356 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	if (_tmp17_ <= _tmp18_) {
#line 356 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		result = (gdouble) 0;
#line 356 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		return result;
#line 2197 "seed.c"
	}
#line 357 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	result = area;
#line 357 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	return result;
#line 2203 "seed.c"
}


/**
 * Are the two lines p1-p2 and q1-q2 intersecting?
 */
static gboolean seed_check_intersect (Point* p1, Point* p2, Point* q1, Point* q2) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	Point _tmp1_ = {0};
	Point _tmp2_ = {0};
	Point _tmp3_ = {0};
	gdouble _tmp4_ = 0.0;
	Point _tmp5_ = {0};
	Point _tmp6_ = {0};
	Point _tmp7_ = {0};
	gdouble _tmp8_ = 0.0;
	gboolean _tmp17_ = FALSE;
#line 363 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	g_return_val_if_fail (p1 != NULL, FALSE);
#line 363 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	g_return_val_if_fail (p2 != NULL, FALSE);
#line 363 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	g_return_val_if_fail (q1 != NULL, FALSE);
#line 363 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	g_return_val_if_fail (q2 != NULL, FALSE);
#line 366 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp1_ = *p1;
#line 366 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp2_ = *p2;
#line 366 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp3_ = *q1;
#line 366 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp4_ = seed_area_sign (&_tmp1_, &_tmp2_, &_tmp3_);
#line 366 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp5_ = *p1;
#line 366 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp6_ = *p2;
#line 366 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp7_ = *q2;
#line 366 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp8_ = seed_area_sign (&_tmp5_, &_tmp6_, &_tmp7_);
#line 366 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	if ((_tmp4_ * _tmp8_) < ((gdouble) 0)) {
#line 2248 "seed.c"
		Point _tmp9_ = {0};
		Point _tmp10_ = {0};
		Point _tmp11_ = {0};
		gdouble _tmp12_ = 0.0;
		Point _tmp13_ = {0};
		Point _tmp14_ = {0};
		Point _tmp15_ = {0};
		gdouble _tmp16_ = 0.0;
#line 368 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp9_ = *q1;
#line 368 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp10_ = *q2;
#line 368 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp11_ = *p1;
#line 368 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp12_ = seed_area_sign (&_tmp9_, &_tmp10_, &_tmp11_);
#line 368 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp13_ = *q1;
#line 368 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp14_ = *q2;
#line 368 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp15_ = *p2;
#line 368 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp16_ = seed_area_sign (&_tmp13_, &_tmp14_, &_tmp15_);
#line 368 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp0_ = (_tmp12_ * _tmp16_) < ((gdouble) 0);
#line 2275 "seed.c"
	} else {
#line 366 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp0_ = FALSE;
#line 2279 "seed.c"
	}
#line 364 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp17_ = _tmp0_;
#line 364 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	result = _tmp17_;
#line 364 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	return result;
#line 2287 "seed.c"
}


/**
 * Precompute projections represented by each segment
 */
static void seed_init_projection (Seed* self) {
	gint _tmp0_ = 0;
	Projection** _tmp1_ = NULL;
#line 374 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	g_return_if_fail (self != NULL);
#line 375 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp0_ = self->num_segment;
#line 375 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp1_ = g_new0 (Projection*, _tmp0_ + 1);
#line 375 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	self->projection = (_vala_array_free (self->projection, self->projection_length1, (GDestroyNotify) projection_unref), NULL);
#line 375 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	self->projection = _tmp1_;
#line 375 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	self->projection_length1 = _tmp0_;
#line 2309 "seed.c"
	{
		gint i = 0;
		gint _tmp2_ = 0;
#line 376 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp2_ = self->num_segment;
#line 376 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		i = _tmp2_ - 1;
#line 2317 "seed.c"
		{
			gboolean _tmp3_ = FALSE;
#line 376 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
			_tmp3_ = TRUE;
#line 376 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
			while (TRUE) {
#line 2324 "seed.c"
				gboolean _tmp4_ = FALSE;
				gint _tmp6_ = 0;
				gboolean odd = FALSE;
				gint _tmp7_ = 0;
				gdouble t0 = 0.0;
				gint _tmp8_ = 0;
				gint _tmp9_ = 0;
				gdouble t1 = 0.0;
				gint _tmp10_ = 0;
				gint _tmp11_ = 0;
				Flip _tmp12_ = 0;
				gboolean _tmp13_ = FALSE;
				Projection** _tmp16_ = NULL;
				gint _tmp16__length1 = 0;
				gint _tmp17_ = 0;
				gdouble _tmp18_ = 0.0;
				gdouble _tmp19_ = 0.0;
				Flip _tmp20_ = 0;
				Projection* _tmp21_ = NULL;
				Projection* _tmp22_ = NULL;
#line 376 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp4_ = _tmp3_;
#line 376 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				if (!_tmp4_) {
#line 2349 "seed.c"
					gint _tmp5_ = 0;
#line 376 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
					_tmp5_ = i;
#line 376 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
					i = _tmp5_ - 1;
#line 2355 "seed.c"
				}
#line 376 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp3_ = FALSE;
#line 376 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp6_ = i;
#line 376 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				if (!(_tmp6_ >= 0)) {
#line 376 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
					break;
#line 2365 "seed.c"
				}
#line 377 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp7_ = i;
#line 377 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				odd = (_tmp7_ % 2) == 1;
#line 378 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp8_ = i;
#line 378 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp9_ = self->num_segment;
#line 378 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				t0 = ((gdouble) _tmp8_) / _tmp9_;
#line 379 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp10_ = i;
#line 379 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp11_ = self->num_segment;
#line 379 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				t1 = ((gdouble) (_tmp10_ + 1)) / _tmp11_;
#line 380 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp13_ = odd;
#line 380 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				if (_tmp13_) {
#line 2387 "seed.c"
					Flip _tmp14_ = 0;
#line 380 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
					_tmp14_ = self->flip_odd;
#line 380 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
					_tmp12_ = _tmp14_;
#line 2393 "seed.c"
				} else {
					Flip _tmp15_ = 0;
#line 380 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
					_tmp15_ = self->flip_even;
#line 380 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
					_tmp12_ = _tmp15_;
#line 2400 "seed.c"
				}
#line 380 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp16_ = self->projection;
#line 380 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp16__length1 = self->projection_length1;
#line 380 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp17_ = i;
#line 380 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp18_ = t0;
#line 380 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp19_ = t1;
#line 380 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp20_ = _tmp12_;
#line 380 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp21_ = projection_new_by_segment (self, _tmp18_, _tmp19_, _tmp20_);
#line 380 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_projection_unref0 (_tmp16_[_tmp17_]);
#line 380 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp16_[_tmp17_] = _tmp21_;
#line 380 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp22_ = _tmp16_[_tmp17_];
#line 2422 "seed.c"
			}
		}
	}
}


/**
 * Compute the point x_distance along the seed and y_distance along the perpendicular
 * at point (x_distance).
 * y_distance is scaled according to width0 and width1.
 */
static void seed_real_distant_point (Seed* self, gdouble x_distance, gdouble y_distance, Point* result) {
#line 389 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	g_critical ("Type `%s' does not implement abstract method `seed_distant_point'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 389 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	return;
#line 2439 "seed.c"
}


void seed_distant_point (Seed* self, gdouble x_distance, gdouble y_distance, Point* result) {
#line 389 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	g_return_if_fail (self != NULL);
#line 389 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	SEED_GET_CLASS (self)->distant_point (self, x_distance, y_distance, result);
#line 2448 "seed.c"
}


/**
 * Is the projected shape thinner than the given thickness?
 * The thickness of the projected shape is calculated as area / perimeter.
 * As a side effect, calculate "width" for rendering.
 */
gboolean seed_too_thin (Seed* self, Projection* pr, Probe* probe, gdouble thickness, gboolean segment_twisted, gdouble* width) {
	gboolean result = FALSE;
	gdouble limit = 0.0;
	gdouble _tmp0_ = 0.0;
	gdouble area_ax = 0.0;
	gdouble area_bx = 0.0;
	gdouble area_cx = 0.0;
	gdouble area_dx = 0.0;
	gdouble area_ab = 0.0;
	gdouble area_bc = 0.0;
	gdouble area_cd = 0.0;
	gdouble area_da = 0.0;
	gdouble perimeter = 0.0;
	gdouble dummy = 0.0;
	Projection* _tmp1_ = NULL;
	Probe* _tmp2_ = NULL;
	gdouble _tmp3_ = 0.0;
	Projection* _tmp4_ = NULL;
	Probe* _tmp5_ = NULL;
	gdouble _tmp6_ = 0.0;
	Projection* _tmp7_ = NULL;
	Probe* _tmp8_ = NULL;
	gdouble _tmp9_ = 0.0;
	Projection* _tmp10_ = NULL;
	Probe* _tmp11_ = NULL;
	gdouble _tmp12_ = 0.0;
	gdouble area = 0.0;
	gdouble _tmp13_ = 0.0;
	gdouble _tmp14_ = 0.0;
	gdouble _tmp15_ = 0.0;
	gdouble _tmp16_ = 0.0;
	gdouble _tmp17_ = 0.0;
	gdouble _tmp18_ = 0.0;
	gdouble _tmp19_ = 0.0;
	gdouble _tmp20_ = 0.0;
	gdouble _tmp21_ = 0.0;
	gdouble _tmp22_ = 0.0;
	gboolean _tmp23_ = FALSE;
	gboolean _tmp24_ = FALSE;
	gboolean _tmp26_ = FALSE;
	Projection* _tmp27_ = NULL;
	Probe* _tmp28_ = NULL;
	gdouble _tmp29_ = 0.0;
	Projection* _tmp30_ = NULL;
	Probe* _tmp31_ = NULL;
	gdouble _tmp32_ = 0.0;
	Projection* _tmp33_ = NULL;
	Probe* _tmp34_ = NULL;
	gdouble _tmp35_ = 0.0;
	Projection* _tmp36_ = NULL;
	Probe* _tmp37_ = NULL;
	gdouble _tmp38_ = 0.0;
	gdouble _tmp39_ = 0.0;
	gdouble _tmp40_ = 0.0;
	gdouble _tmp41_ = 0.0;
	gdouble _tmp42_ = 0.0;
	gdouble _tmp43_ = 0.0;
	gdouble _tmp44_ = 0.0;
	gdouble _tmp45_ = 0.0;
	gdouble _tmp46_ = 0.0;
	gdouble _tmp47_ = 0.0;
	gdouble _tmp48_ = 0.0;
	gdouble _tmp49_ = 0.0;
	gdouble _tmp50_ = 0.0;
	gdouble _tmp51_ = 0.0;
	gdouble _tmp52_ = 0.0;
	gdouble _tmp53_ = 0.0;
	gdouble _tmp54_ = 0.0;
	gdouble _tmp55_ = 0.0;
	gdouble _tmp56_ = 0.0;
	gdouble _tmp57_ = 0.0;
	gdouble _tmp58_ = 0.0;
#line 396 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 397 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp0_ = thickness;
#line 397 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	limit = 0.5 * _tmp0_;
#line 407 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	area_ax = 0.0;
#line 408 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	area_bx = 0.0;
#line 409 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	area_cx = 0.0;
#line 410 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	area_dx = 0.0;
#line 411 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	area_ab = 0.0;
#line 412 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	area_bc = 0.0;
#line 413 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	area_cd = 0.0;
#line 414 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	area_da = 0.0;
#line 415 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	perimeter = 0.0;
#line 416 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	dummy = 0.0;
#line 418 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp1_ = pr;
#line 418 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp2_ = probe;
#line 418 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp3_ = limit;
#line 418 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	seed_compute_area_perimeter (self, _tmp1_, _tmp2_, _tmp3_, (gdouble) 0, (gdouble) 0, (gdouble) 1, (gdouble) 0, &area_ab, &perimeter);
#line 419 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp4_ = pr;
#line 419 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp5_ = probe;
#line 419 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp6_ = limit;
#line 419 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	seed_compute_area_perimeter (self, _tmp4_, _tmp5_, _tmp6_, (gdouble) 1, (gdouble) 0, (gdouble) 1, (gdouble) 1, &area_bc, &perimeter);
#line 420 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp7_ = pr;
#line 420 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp8_ = probe;
#line 420 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp9_ = limit;
#line 420 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	seed_compute_area_perimeter (self, _tmp7_, _tmp8_, _tmp9_, (gdouble) 1, (gdouble) 1, (gdouble) 0, (gdouble) 1, &area_cd, &perimeter);
#line 421 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp10_ = pr;
#line 421 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp11_ = probe;
#line 421 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp12_ = limit;
#line 421 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	seed_compute_area_perimeter (self, _tmp10_, _tmp11_, _tmp12_, (gdouble) 0, (gdouble) 1, (gdouble) 0, (gdouble) 0, &area_da, &perimeter);
#line 422 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp13_ = area_ab;
#line 422 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp14_ = area_bc;
#line 422 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp15_ = area_cd;
#line 422 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp16_ = area_da;
#line 422 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp17_ = fabs (((_tmp13_ + _tmp14_) + _tmp15_) + _tmp16_);
#line 422 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	area = _tmp17_;
#line 423 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp18_ = area;
#line 423 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp19_ = perimeter;
#line 423 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	*width = (3.5 * _tmp18_) / _tmp19_;
#line 426 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp20_ = perimeter;
#line 426 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	if (_tmp20_ <= ((gdouble) 6)) {
#line 426 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		result = TRUE;
#line 426 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		return result;
#line 2613 "seed.c"
	}
#line 429 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp21_ = *width;
#line 429 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp22_ = thickness;
#line 429 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	if (_tmp21_ > _tmp22_) {
#line 429 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		result = FALSE;
#line 429 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		return result;
#line 2625 "seed.c"
	}
#line 430 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp24_ = self->priv->twisted;
#line 430 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	if (!_tmp24_) {
#line 2631 "seed.c"
		gboolean _tmp25_ = FALSE;
#line 430 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp25_ = segment_twisted;
#line 430 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp23_ = !_tmp25_;
#line 2637 "seed.c"
	} else {
#line 430 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp23_ = FALSE;
#line 2641 "seed.c"
	}
#line 430 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp26_ = _tmp23_;
#line 430 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	if (_tmp26_) {
#line 430 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		result = TRUE;
#line 430 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		return result;
#line 2651 "seed.c"
	}
#line 433 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp27_ = pr;
#line 433 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp28_ = probe;
#line 433 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp29_ = limit;
#line 433 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	seed_compute_area_perimeter (self, _tmp27_, _tmp28_, _tmp29_, (gdouble) 0, (gdouble) 0, 0.5, 0.5, &area_ax, &dummy);
#line 434 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp30_ = pr;
#line 434 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp31_ = probe;
#line 434 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp32_ = limit;
#line 434 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	seed_compute_area_perimeter (self, _tmp30_, _tmp31_, _tmp32_, (gdouble) 1, (gdouble) 0, 0.5, 0.5, &area_bx, &dummy);
#line 435 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp33_ = pr;
#line 435 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp34_ = probe;
#line 435 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp35_ = limit;
#line 435 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	seed_compute_area_perimeter (self, _tmp33_, _tmp34_, _tmp35_, (gdouble) 1, (gdouble) 1, 0.5, 0.5, &area_cx, &dummy);
#line 436 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp36_ = pr;
#line 436 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp37_ = probe;
#line 436 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp38_ = limit;
#line 436 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	seed_compute_area_perimeter (self, _tmp36_, _tmp37_, _tmp38_, (gdouble) 0, (gdouble) 1, 0.5, 0.5, &area_dx, &dummy);
#line 438 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp39_ = area_ab;
#line 438 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp40_ = area_bx;
#line 438 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp41_ = area_ax;
#line 438 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp42_ = fabs ((_tmp39_ + _tmp40_) - _tmp41_);
#line 438 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp43_ = area_bc;
#line 438 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp44_ = area_cx;
#line 438 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp45_ = area_bx;
#line 438 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp46_ = fabs ((_tmp43_ + _tmp44_) - _tmp45_);
#line 438 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp47_ = area_cd;
#line 438 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp48_ = area_dx;
#line 438 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp49_ = area_cx;
#line 438 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp50_ = fabs ((_tmp47_ + _tmp48_) - _tmp49_);
#line 438 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp51_ = area_da;
#line 438 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp52_ = area_ax;
#line 438 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp53_ = area_dx;
#line 438 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp54_ = fabs ((_tmp51_ + _tmp52_) - _tmp53_);
#line 438 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	area = ((_tmp42_ + _tmp46_) + _tmp50_) + _tmp54_;
#line 442 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp55_ = area;
#line 442 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp56_ = perimeter;
#line 442 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	*width = (3.5 * _tmp55_) / _tmp56_;
#line 443 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp57_ = *width;
#line 443 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp58_ = thickness;
#line 443 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	result = _tmp57_ <= _tmp58_;
#line 443 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	return result;
#line 2733 "seed.c"
}


static void seed_compute_area_perimeter (Seed* self, Projection* pr, Probe* probe, gdouble limit, gdouble x0, gdouble y0, gdouble x1, gdouble y1, gdouble* area, gdouble* perimeter) {
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	Point p0 = {0};
	Projection* _tmp4_ = NULL;
	gdouble _tmp5_ = 0.0;
	gdouble _tmp6_ = 0.0;
	Point _tmp7_ = {0};
	Point _tmp8_ = {0};
	Point p1 = {0};
	Projection* _tmp9_ = NULL;
	gdouble _tmp10_ = 0.0;
	gdouble _tmp11_ = 0.0;
	Point _tmp12_ = {0};
	Point _tmp13_ = {0};
	Projection* _tmp14_ = NULL;
	Probe* _tmp15_ = NULL;
	gdouble _tmp16_ = 0.0;
	gdouble _tmp17_ = 0.0;
	gdouble _tmp18_ = 0.0;
	Point _tmp19_ = {0};
	gdouble _tmp20_ = 0.0;
	gdouble _tmp21_ = 0.0;
	Point _tmp22_ = {0};
	Point _tmp23_ = {0};
	Point _tmp24_ = {0};
	gdouble _tmp25_ = 0.0;
#line 446 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	g_return_if_fail (self != NULL);
#line 450 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp0_ = self->base_offset;
#line 450 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp1_ = y0;
#line 450 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	y0 = _tmp0_ - _tmp1_;
#line 451 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp2_ = self->base_offset;
#line 451 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp3_ = y1;
#line 451 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	y1 = _tmp2_ - _tmp3_;
#line 452 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp4_ = pr;
#line 452 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp5_ = x0;
#line 452 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp6_ = y0;
#line 452 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	seed_distant_point (self, _tmp5_, _tmp6_, &_tmp7_);
#line 452 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	projection_map (_tmp4_, &_tmp7_, &_tmp8_);
#line 452 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	p0 = _tmp8_;
#line 453 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp9_ = pr;
#line 453 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp10_ = x1;
#line 453 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp11_ = y1;
#line 453 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	seed_distant_point (self, _tmp10_, _tmp11_, &_tmp12_);
#line 453 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	projection_map (_tmp9_, &_tmp12_, &_tmp13_);
#line 453 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	p1 = _tmp13_;
#line 454 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp14_ = pr;
#line 454 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp15_ = probe;
#line 454 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp16_ = limit;
#line 454 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp17_ = x0;
#line 454 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp18_ = y0;
#line 454 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp19_ = p0;
#line 454 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp20_ = x1;
#line 454 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp21_ = y1;
#line 454 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp22_ = p1;
#line 454 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp23_ = p0;
#line 454 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp24_ = p1;
#line 454 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp25_ = point_hypot (&_tmp23_, &_tmp24_);
#line 454 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	seed_compute_sub_area_perimeter (self, _tmp14_, _tmp15_, _tmp16_, _tmp17_, _tmp18_, &_tmp19_, _tmp20_, _tmp21_, &_tmp22_, _tmp25_, area, perimeter, 1000);
#line 2830 "seed.c"
}


static void seed_compute_sub_area_perimeter (Seed* self, Projection* pr, Probe* probe, gdouble limit, gdouble x0, gdouble y0, Point* p0, gdouble x1, gdouble y1, Point* p1, gdouble distance, gdouble* area, gdouble* perimeter, gint depth) {
	gboolean _tmp0_ = FALSE;
	Probe* _tmp1_ = NULL;
	gboolean _tmp4_ = FALSE;
#line 461 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	g_return_if_fail (self != NULL);
#line 461 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	g_return_if_fail (p0 != NULL);
#line 461 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	g_return_if_fail (p1 != NULL);
#line 467 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp1_ = probe;
#line 467 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	if (_tmp1_ != NULL) {
#line 2848 "seed.c"
		Probe* _tmp2_ = NULL;
		gboolean _tmp3_ = FALSE;
#line 467 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp2_ = probe;
#line 467 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp3_ = _tmp2_->cancelled;
#line 467 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp0_ = _tmp3_;
#line 2857 "seed.c"
	} else {
#line 467 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp0_ = FALSE;
#line 2861 "seed.c"
	}
#line 467 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp4_ = _tmp0_;
#line 467 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	if (_tmp4_) {
#line 467 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		return;
#line 2869 "seed.c"
	}
#line 468 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	while (TRUE) {
#line 2873 "seed.c"
		gdouble xm = 0.0;
		gdouble _tmp5_ = 0.0;
		gdouble _tmp6_ = 0.0;
		gdouble ym = 0.0;
		gdouble _tmp7_ = 0.0;
		gdouble _tmp8_ = 0.0;
		Point pm = {0};
		Projection* _tmp9_ = NULL;
		gdouble _tmp10_ = 0.0;
		gdouble _tmp11_ = 0.0;
		Point _tmp12_ = {0};
		Point _tmp13_ = {0};
		gdouble distance_half = 0.0;
		Point _tmp14_ = {0};
		Point _tmp15_ = {0};
		gdouble _tmp16_ = 0.0;
		gboolean _tmp17_ = FALSE;
		gboolean _tmp18_ = FALSE;
		gboolean _tmp19_ = FALSE;
		gdouble _tmp20_ = 0.0;
		gdouble _tmp21_ = 0.0;
		gboolean _tmp24_ = FALSE;
		gboolean _tmp35_ = FALSE;
		gboolean _tmp37_ = FALSE;
		Projection* _tmp49_ = NULL;
		Probe* _tmp50_ = NULL;
		gdouble _tmp51_ = 0.0;
		gdouble _tmp52_ = 0.0;
		gdouble _tmp53_ = 0.0;
		Point _tmp54_ = {0};
		gdouble _tmp55_ = 0.0;
		gdouble _tmp56_ = 0.0;
		Point _tmp57_ = {0};
		gdouble _tmp58_ = 0.0;
		gint _tmp59_ = 0;
		gdouble _tmp60_ = 0.0;
		gdouble _tmp61_ = 0.0;
		Point _tmp62_ = {0};
		gint _tmp63_ = 0;
		Point _tmp64_ = {0};
		Point _tmp65_ = {0};
		gdouble _tmp66_ = 0.0;
#line 469 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp5_ = x0;
#line 469 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp6_ = x1;
#line 469 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		xm = (_tmp5_ + _tmp6_) / 2;
#line 470 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp7_ = y0;
#line 470 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp8_ = y1;
#line 470 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		ym = (_tmp7_ + _tmp8_) / 2;
#line 471 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp9_ = pr;
#line 471 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp10_ = xm;
#line 471 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp11_ = ym;
#line 471 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		seed_distant_point (self, _tmp10_, _tmp11_, &_tmp12_);
#line 471 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		projection_map (_tmp9_, &_tmp12_, &_tmp13_);
#line 471 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		pm = _tmp13_;
#line 472 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp14_ = *p0;
#line 472 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp15_ = pm;
#line 472 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp16_ = point_hypot (&_tmp14_, &_tmp15_);
#line 472 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		distance_half = _tmp16_;
#line 473 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp20_ = distance;
#line 473 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp21_ = limit;
#line 473 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		if (_tmp20_ <= _tmp21_) {
#line 2954 "seed.c"
			gdouble _tmp22_ = 0.0;
			gdouble _tmp23_ = 0.0;
#line 473 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
			_tmp22_ = distance_half;
#line 473 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
			_tmp23_ = distance;
#line 473 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
			_tmp19_ = _tmp22_ <= _tmp23_;
#line 2963 "seed.c"
		} else {
#line 473 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
			_tmp19_ = FALSE;
#line 2967 "seed.c"
		}
#line 473 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp24_ = _tmp19_;
#line 473 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		if (_tmp24_) {
#line 2973 "seed.c"
			Point _tmp25_ = {0};
			Projection* _tmp26_ = NULL;
			gdouble _tmp27_ = 0.0;
			gdouble _tmp28_ = 0.0;
			gdouble _tmp29_ = 0.0;
			gdouble _tmp30_ = 0.0;
			Point _tmp31_ = {0};
			Point _tmp32_ = {0};
			gdouble _tmp33_ = 0.0;
			gdouble _tmp34_ = 0.0;
#line 474 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
			_tmp25_ = *p0;
#line 474 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
			_tmp26_ = pr;
#line 474 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
			_tmp27_ = x0;
#line 474 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
			_tmp28_ = x1;
#line 474 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
			_tmp29_ = y0;
#line 474 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
			_tmp30_ = y1;
#line 474 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
			seed_distant_point (self, (0.85 * _tmp27_) + (0.15 * _tmp28_), (0.85 * _tmp29_) + (0.15 * _tmp30_), &_tmp31_);
#line 474 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
			projection_map (_tmp26_, &_tmp31_, &_tmp32_);
#line 474 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
			_tmp33_ = point_hypot (&_tmp25_, &_tmp32_);
#line 474 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
			_tmp34_ = distance;
#line 474 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
			_tmp18_ = _tmp33_ <= _tmp34_;
#line 3006 "seed.c"
		} else {
#line 473 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
			_tmp18_ = FALSE;
#line 3010 "seed.c"
		}
#line 473 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp35_ = _tmp18_;
#line 473 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		if (_tmp35_) {
#line 473 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
			_tmp17_ = TRUE;
#line 3018 "seed.c"
		} else {
			gint _tmp36_ = 0;
#line 476 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
			_tmp36_ = depth;
#line 476 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
			_tmp17_ = _tmp36_ == 0;
#line 3025 "seed.c"
		}
#line 473 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp37_ = _tmp17_;
#line 473 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		if (_tmp37_) {
#line 3031 "seed.c"
			gdouble _tmp38_ = 0.0;
			Point _tmp39_ = {0};
			gdouble _tmp40_ = 0.0;
			Point _tmp41_ = {0};
			gdouble _tmp42_ = 0.0;
			Point _tmp43_ = {0};
			gdouble _tmp44_ = 0.0;
			Point _tmp45_ = {0};
			gdouble _tmp46_ = 0.0;
			gdouble _tmp47_ = 0.0;
			gdouble _tmp48_ = 0.0;
#line 478 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
			_tmp38_ = *area;
#line 478 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
			_tmp39_ = *p0;
#line 478 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
			_tmp40_ = _tmp39_.x;
#line 478 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
			_tmp41_ = *p1;
#line 478 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
			_tmp42_ = _tmp41_.y;
#line 478 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
			_tmp43_ = *p0;
#line 478 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
			_tmp44_ = _tmp43_.y;
#line 478 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
			_tmp45_ = *p1;
#line 478 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
			_tmp46_ = _tmp45_.x;
#line 478 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
			*area = _tmp38_ + ((_tmp40_ * _tmp42_) - (_tmp44_ * _tmp46_));
#line 479 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
			_tmp47_ = *perimeter;
#line 479 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
			_tmp48_ = distance;
#line 479 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
			*perimeter = _tmp47_ + _tmp48_;
#line 480 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
			return;
#line 3071 "seed.c"
		}
#line 482 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp49_ = pr;
#line 482 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp50_ = probe;
#line 482 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp51_ = limit;
#line 482 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp52_ = x0;
#line 482 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp53_ = y0;
#line 482 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp54_ = *p0;
#line 482 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp55_ = xm;
#line 482 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp56_ = ym;
#line 482 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp57_ = pm;
#line 482 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp58_ = distance_half;
#line 482 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp59_ = depth;
#line 482 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		seed_compute_sub_area_perimeter (self, _tmp49_, _tmp50_, _tmp51_, _tmp52_, _tmp53_, &_tmp54_, _tmp55_, _tmp56_, &_tmp57_, _tmp58_, area, perimeter, _tmp59_ - 1);
#line 486 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp60_ = xm;
#line 486 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		x0 = _tmp60_;
#line 486 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp61_ = ym;
#line 486 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		y0 = _tmp61_;
#line 486 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp62_ = pm;
#line 486 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		*p0 = _tmp62_;
#line 486 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp63_ = depth;
#line 486 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		depth = _tmp63_ - 1;
#line 487 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp64_ = *p0;
#line 487 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp65_ = *p1;
#line 487 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp66_ = point_hypot (&_tmp64_, &_tmp65_);
#line 487 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		distance = _tmp66_;
#line 3121 "seed.c"
	}
}


/**
 * Draw by mapping every point onto the projection.
 */
void seed_draw (Seed* self, DeferredCairo* dc, Projection* pr, Probe* probe, gdouble limit) {
	gboolean draft = FALSE;
	gdouble _tmp0_ = 0.0;
	gboolean _tmp1_ = FALSE;
	RenderStyle _tmp2_ = 0;
	gboolean _tmp7_ = FALSE;
#line 494 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	g_return_if_fail (self != NULL);
#line 494 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	g_return_if_fail (dc != NULL);
#line 495 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp0_ = limit;
#line 495 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	draft = _tmp0_ > 2.0;
#line 496 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp2_ = self->render_style;
#line 496 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	if (_tmp2_ == RENDER_STYLE_THIN) {
#line 496 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp1_ = TRUE;
#line 3149 "seed.c"
	} else {
		gboolean _tmp3_ = FALSE;
		gboolean _tmp4_ = FALSE;
		gboolean _tmp6_ = FALSE;
#line 496 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp4_ = draft;
#line 496 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		if (_tmp4_) {
#line 3158 "seed.c"
			RenderStyle _tmp5_ = 0;
#line 496 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
			_tmp5_ = self->render_style;
#line 496 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
			_tmp3_ = _tmp5_ == RENDER_STYLE_NONE;
#line 3164 "seed.c"
		} else {
#line 496 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
			_tmp3_ = FALSE;
#line 3168 "seed.c"
		}
#line 496 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp6_ = _tmp3_;
#line 496 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp1_ = _tmp6_;
#line 3174 "seed.c"
	}
#line 496 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp7_ = _tmp1_;
#line 496 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	if (_tmp7_) {
#line 3180 "seed.c"
		Point p = {0};
		Projection* _tmp8_ = NULL;
		Point _tmp9_ = {0};
		Point _tmp10_ = {0};
		DeferredCairo* _tmp11_ = NULL;
		Point _tmp12_ = {0};
		DeferredCairo* _tmp13_ = NULL;
		Projection* _tmp14_ = NULL;
		Probe* _tmp15_ = NULL;
		gdouble _tmp16_ = 0.0;
		DeferredCairo* _tmp17_ = NULL;
#line 497 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp8_ = pr;
#line 497 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		seed_point_raw (self, 0.0, &_tmp9_);
#line 497 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		projection_map (_tmp8_, &_tmp9_, &_tmp10_);
#line 497 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		p = _tmp10_;
#line 498 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp11_ = dc;
#line 498 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp12_ = p;
#line 498 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		deferred_cairo_move_to (_tmp11_, &_tmp12_);
#line 499 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp13_ = dc;
#line 499 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp14_ = pr;
#line 499 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp15_ = probe;
#line 499 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp16_ = limit;
#line 499 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		seed_draw_segment (self, _tmp13_, _tmp14_, _tmp15_, (gdouble) 0, (gdouble) 0, (gdouble) 1, (gdouble) 0, _tmp16_);
#line 500 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp17_ = dc;
#line 500 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		deferred_cairo_stroke (_tmp17_);
#line 3220 "seed.c"
	} else {
		gboolean _tmp18_ = FALSE;
		RenderStyle _tmp19_ = 0;
		gboolean _tmp21_ = FALSE;
#line 502 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp19_ = self->render_style;
#line 502 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		if (_tmp19_ == RENDER_STYLE_FILLED) {
#line 502 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
			_tmp18_ = TRUE;
#line 3231 "seed.c"
		} else {
			RenderStyle _tmp20_ = 0;
#line 502 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
			_tmp20_ = self->render_style;
#line 502 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
			_tmp18_ = _tmp20_ == RENDER_STYLE_CLOSED;
#line 3238 "seed.c"
		}
#line 502 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp21_ = _tmp18_;
#line 502 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		if (_tmp21_) {
#line 3244 "seed.c"
			Point p = {0};
			Projection* _tmp22_ = NULL;
			Point _tmp23_ = {0};
			Point _tmp24_ = {0};
			DeferredCairo* _tmp25_ = NULL;
			Point _tmp26_ = {0};
			DeferredCairo* _tmp27_ = NULL;
			Projection* _tmp28_ = NULL;
			Probe* _tmp29_ = NULL;
			gdouble _tmp30_ = 0.0;
			Projection* _tmp31_ = NULL;
			gboolean _tmp51_ = FALSE;
			gboolean _tmp52_ = FALSE;
			gboolean _tmp54_ = FALSE;
#line 503 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
			_tmp22_ = pr;
#line 503 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
			seed_point_raw (self, 0.0, &_tmp23_);
#line 503 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
			projection_map (_tmp22_, &_tmp23_, &_tmp24_);
#line 503 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
			p = _tmp24_;
#line 504 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
			_tmp25_ = dc;
#line 504 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
			_tmp26_ = p;
#line 504 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
			deferred_cairo_move_to (_tmp25_, &_tmp26_);
#line 505 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
			_tmp27_ = dc;
#line 505 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
			_tmp28_ = pr;
#line 505 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
			_tmp29_ = probe;
#line 505 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
			_tmp30_ = limit;
#line 505 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
			seed_draw_segment (self, _tmp27_, _tmp28_, _tmp29_, (gdouble) 0, (gdouble) 0, (gdouble) 1, (gdouble) 0, _tmp30_);
#line 506 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
			_tmp31_ = pr;
#line 506 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
			if (_tmp31_ != NULL) {
#line 3287 "seed.c"
				Line* line = NULL;
				Line* _tmp32_ = NULL;
				Point p0 = {0};
				Point _tmp33_ = {0};
				Point p1 = {0};
				Point _tmp34_ = {0};
				Line* _tmp35_ = NULL;
				Point _tmp36_ = {0};
				gdouble _tmp37_ = 0.0;
				Point _tmp38_ = {0};
				gdouble _tmp39_ = 0.0;
				Point _tmp40_ = {0};
				gdouble _tmp41_ = 0.0;
				Point _tmp42_ = {0};
				gdouble _tmp43_ = 0.0;
				gdouble* _tmp44_ = NULL;
				gdouble* _tmp45_ = NULL;
				gint _tmp45__length1 = 0;
				Line* _tmp46_ = NULL;
				DeferredCairo* _tmp47_ = NULL;
				Projection* _tmp48_ = NULL;
				Probe* _tmp49_ = NULL;
				gdouble _tmp50_ = 0.0;
#line 508 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp32_ = line_new ();
#line 508 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				line = _tmp32_;
#line 509 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				seed_point_raw (self, (gdouble) 0, &_tmp33_);
#line 509 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				p0 = _tmp33_;
#line 510 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				seed_point_raw (self, (gdouble) 1, &_tmp34_);
#line 510 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				p1 = _tmp34_;
#line 511 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp35_ = line;
#line 511 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp36_ = p0;
#line 511 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp37_ = _tmp36_.x;
#line 511 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp38_ = p0;
#line 511 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp39_ = _tmp38_.y;
#line 511 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp40_ = p1;
#line 511 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp41_ = _tmp40_.x;
#line 511 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp42_ = p1;
#line 511 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp43_ = _tmp42_.y;
#line 511 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp44_ = g_new0 (gdouble, 4);
#line 511 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp44_[0] = _tmp37_;
#line 511 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp44_[1] = _tmp39_;
#line 511 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp44_[2] = _tmp41_;
#line 511 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp44_[3] = _tmp43_;
#line 511 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp45_ = _tmp44_;
#line 511 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp45__length1 = 4;
#line 511 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				seed_init_full ((Seed*) _tmp35_, _tmp45_, 4);
#line 511 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp45_ = (g_free (_tmp45_), NULL);
#line 512 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp46_ = line;
#line 512 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp47_ = dc;
#line 512 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp48_ = pr;
#line 512 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp49_ = probe;
#line 512 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp50_ = limit;
#line 512 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				seed_draw_segment ((Seed*) _tmp46_, _tmp47_, _tmp48_, _tmp49_, (gdouble) 1, (gdouble) 0, (gdouble) 0, (gdouble) 0, _tmp50_);
#line 506 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_g_object_unref0 (line);
#line 3373 "seed.c"
			}
#line 514 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
			_tmp52_ = draft;
#line 514 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
			if (!_tmp52_) {
#line 3379 "seed.c"
				RenderStyle _tmp53_ = 0;
#line 514 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp53_ = self->render_style;
#line 514 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp51_ = _tmp53_ == RENDER_STYLE_FILLED;
#line 3385 "seed.c"
			} else {
#line 514 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp51_ = FALSE;
#line 3389 "seed.c"
			}
#line 514 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
			_tmp54_ = _tmp51_;
#line 514 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
			if (_tmp54_) {
#line 3395 "seed.c"
				DeferredCairo* _tmp55_ = NULL;
#line 514 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp55_ = dc;
#line 514 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				deferred_cairo_fill (_tmp55_);
#line 3401 "seed.c"
			} else {
				DeferredCairo* _tmp56_ = NULL;
#line 515 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp56_ = dc;
#line 515 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				deferred_cairo_stroke (_tmp56_);
#line 3408 "seed.c"
			}
		} else {
			gboolean _tmp57_ = FALSE;
			RenderStyle _tmp58_ = 0;
			gboolean _tmp60_ = FALSE;
#line 517 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
			_tmp58_ = self->render_style;
#line 517 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
			if (_tmp58_ == RENDER_STYLE_THICK) {
#line 517 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp57_ = TRUE;
#line 3420 "seed.c"
			} else {
				RenderStyle _tmp59_ = 0;
#line 517 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp59_ = self->render_style;
#line 517 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp57_ = _tmp59_ == RENDER_STYLE_HOLLOW;
#line 3427 "seed.c"
			}
#line 517 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
			_tmp60_ = _tmp57_;
#line 517 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
			if (_tmp60_) {
#line 3433 "seed.c"
				Point p = {0};
				Projection* _tmp61_ = NULL;
				gdouble _tmp62_ = 0.0;
				Point _tmp63_ = {0};
				Point _tmp64_ = {0};
				DeferredCairo* _tmp65_ = NULL;
				Point _tmp66_ = {0};
				DeferredCairo* _tmp67_ = NULL;
				Projection* _tmp68_ = NULL;
				Probe* _tmp69_ = NULL;
				gdouble _tmp70_ = 0.0;
				gdouble _tmp71_ = 0.0;
				gdouble _tmp72_ = 0.0;
				DeferredCairo* _tmp73_ = NULL;
				Projection* _tmp74_ = NULL;
				Probe* _tmp75_ = NULL;
				gdouble _tmp76_ = 0.0;
				gdouble _tmp77_ = 0.0;
				gdouble _tmp78_ = 0.0;
				DeferredCairo* _tmp79_ = NULL;
				Projection* _tmp80_ = NULL;
				Probe* _tmp81_ = NULL;
				gdouble _tmp82_ = 0.0;
				gdouble _tmp83_ = 0.0;
				gdouble _tmp84_ = 0.0;
				DeferredCairo* _tmp85_ = NULL;
				Projection* _tmp86_ = NULL;
				Probe* _tmp87_ = NULL;
				gdouble _tmp88_ = 0.0;
				gdouble _tmp89_ = 0.0;
				gdouble _tmp90_ = 0.0;
				gboolean _tmp91_ = FALSE;
				gboolean _tmp92_ = FALSE;
				gboolean _tmp94_ = FALSE;
#line 518 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp61_ = pr;
#line 518 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp62_ = self->base_offset;
#line 518 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				seed_distant_point (self, 0.0, _tmp62_, &_tmp63_);
#line 518 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				projection_map (_tmp61_, &_tmp63_, &_tmp64_);
#line 518 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				p = _tmp64_;
#line 519 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp65_ = dc;
#line 519 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp66_ = p;
#line 519 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				deferred_cairo_move_to (_tmp65_, &_tmp66_);
#line 520 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp67_ = dc;
#line 520 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp68_ = pr;
#line 520 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp69_ = probe;
#line 520 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp70_ = self->base_offset;
#line 520 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp71_ = self->base_offset;
#line 520 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp72_ = limit;
#line 520 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				seed_draw_segment (self, _tmp67_, _tmp68_, _tmp69_, (gdouble) 0, _tmp70_, (gdouble) 1, _tmp71_, _tmp72_);
#line 521 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp73_ = dc;
#line 521 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp74_ = pr;
#line 521 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp75_ = probe;
#line 521 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp76_ = self->base_offset;
#line 521 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp77_ = self->base_offset;
#line 521 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp78_ = limit;
#line 521 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				seed_draw_segment (self, _tmp73_, _tmp74_, _tmp75_, (gdouble) 1, _tmp76_, (gdouble) 1, _tmp77_ - 1, _tmp78_);
#line 522 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp79_ = dc;
#line 522 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp80_ = pr;
#line 522 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp81_ = probe;
#line 522 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp82_ = self->base_offset;
#line 522 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp83_ = self->base_offset;
#line 522 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp84_ = limit;
#line 522 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				seed_draw_segment (self, _tmp79_, _tmp80_, _tmp81_, (gdouble) 1, _tmp82_ - 1, (gdouble) 0, _tmp83_ - 1, _tmp84_);
#line 523 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp85_ = dc;
#line 523 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp86_ = pr;
#line 523 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp87_ = probe;
#line 523 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp88_ = self->base_offset;
#line 523 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp89_ = self->base_offset;
#line 523 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp90_ = limit;
#line 523 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				seed_draw_segment (self, _tmp85_, _tmp86_, _tmp87_, (gdouble) 0, _tmp88_ - 1, (gdouble) 0, _tmp89_, _tmp90_);
#line 524 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp92_ = draft;
#line 524 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				if (!_tmp92_) {
#line 3544 "seed.c"
					RenderStyle _tmp93_ = 0;
#line 524 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
					_tmp93_ = self->render_style;
#line 524 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
					_tmp91_ = _tmp93_ == RENDER_STYLE_THICK;
#line 3550 "seed.c"
				} else {
#line 524 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
					_tmp91_ = FALSE;
#line 3554 "seed.c"
				}
#line 524 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp94_ = _tmp91_;
#line 524 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				if (_tmp94_) {
#line 3560 "seed.c"
					DeferredCairo* _tmp95_ = NULL;
#line 524 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
					_tmp95_ = dc;
#line 524 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
					deferred_cairo_fill (_tmp95_);
#line 3566 "seed.c"
				} else {
					DeferredCairo* _tmp96_ = NULL;
#line 525 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
					_tmp96_ = dc;
#line 525 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
					deferred_cairo_stroke (_tmp96_);
#line 3573 "seed.c"
				}
			}
		}
	}
}


/**
 * Draw the segmentation of the seed, showing the projection boxes.
 */
void seed_draw_segmentation (Seed* self, cairo_t* cr, Projection* pr) {
	DeferredCairo* dc = NULL;
	DeferredCairo* _tmp0_ = NULL;
	Point p = {0};
	Projection* _tmp1_ = NULL;
	gdouble _tmp2_ = 0.0;
	Point _tmp3_ = {0};
	Point _tmp4_ = {0};
	DeferredCairo* _tmp5_ = NULL;
	Point _tmp6_ = {0};
	DeferredCairo* _tmp7_ = NULL;
	Projection* _tmp8_ = NULL;
	gdouble _tmp9_ = 0.0;
	gdouble _tmp10_ = 0.0;
	DeferredCairo* _tmp11_ = NULL;
	DeferredCairo* _tmp12_ = NULL;
	cairo_t* _tmp13_ = NULL;
	Projection* _tmp14_ = NULL;
	gdouble _tmp15_ = 0.0;
	Point _tmp16_ = {0};
	Point _tmp17_ = {0};
	DeferredCairo* _tmp18_ = NULL;
	Point _tmp19_ = {0};
	DeferredCairo* _tmp20_ = NULL;
	Projection* _tmp21_ = NULL;
	gdouble _tmp22_ = 0.0;
	gdouble _tmp23_ = 0.0;
	DeferredCairo* _tmp24_ = NULL;
	DeferredCairo* _tmp25_ = NULL;
	cairo_t* _tmp26_ = NULL;
#line 532 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	g_return_if_fail (self != NULL);
#line 532 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	g_return_if_fail (cr != NULL);
#line 533 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	seed_start_render (self);
#line 534 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp0_ = deferred_cairo_new ();
#line 534 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	dc = _tmp0_;
#line 536 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp1_ = pr;
#line 536 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp2_ = self->base_offset;
#line 536 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	seed_distant_point (self, (gdouble) 0, _tmp2_, &_tmp3_);
#line 536 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	projection_map (_tmp1_, &_tmp3_, &_tmp4_);
#line 536 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	p = _tmp4_;
#line 537 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp5_ = dc;
#line 537 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp6_ = p;
#line 537 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	deferred_cairo_move_to (_tmp5_, &_tmp6_);
#line 538 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp7_ = dc;
#line 538 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp8_ = pr;
#line 538 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp9_ = self->base_offset;
#line 538 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp10_ = self->base_offset;
#line 538 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	seed_draw_segment (self, _tmp7_, _tmp8_, NULL, (gdouble) 0, _tmp9_, (gdouble) 1, _tmp10_, 0.5);
#line 539 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp11_ = dc;
#line 539 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	deferred_cairo_stroke (_tmp11_);
#line 540 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp12_ = dc;
#line 540 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp13_ = cr;
#line 540 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	deferred_cairo_render (_tmp12_, _tmp13_);
#line 542 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp14_ = pr;
#line 542 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp15_ = self->base_offset;
#line 542 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	seed_distant_point (self, (gdouble) 0, _tmp15_ - 1, &_tmp16_);
#line 542 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	projection_map (_tmp14_, &_tmp16_, &_tmp17_);
#line 542 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	p = _tmp17_;
#line 543 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp18_ = dc;
#line 543 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp19_ = p;
#line 543 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	deferred_cairo_move_to (_tmp18_, &_tmp19_);
#line 544 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp20_ = dc;
#line 544 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp21_ = pr;
#line 544 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp22_ = self->base_offset;
#line 544 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp23_ = self->base_offset;
#line 544 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	seed_draw_segment (self, _tmp20_, _tmp21_, NULL, (gdouble) 0, _tmp22_ - 1, (gdouble) 1, _tmp23_ - 1, 0.5);
#line 545 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp24_ = dc;
#line 545 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	deferred_cairo_stroke (_tmp24_);
#line 546 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp25_ = dc;
#line 546 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp26_ = cr;
#line 546 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	deferred_cairo_render (_tmp25_, _tmp26_);
#line 3696 "seed.c"
	{
		gint i = 0;
#line 548 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		i = 0;
#line 3701 "seed.c"
		{
			gboolean _tmp27_ = FALSE;
#line 548 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
			_tmp27_ = TRUE;
#line 548 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
			while (TRUE) {
#line 3708 "seed.c"
				gboolean _tmp28_ = FALSE;
				gint _tmp30_ = 0;
				gint _tmp31_ = 0;
				gdouble x = 0.0;
				gint _tmp32_ = 0;
				gint _tmp33_ = 0;
				Projection* _tmp34_ = NULL;
				gdouble _tmp35_ = 0.0;
				gdouble _tmp36_ = 0.0;
				Point _tmp37_ = {0};
				Point _tmp38_ = {0};
				DeferredCairo* _tmp39_ = NULL;
				Point _tmp40_ = {0};
				DeferredCairo* _tmp41_ = NULL;
				Projection* _tmp42_ = NULL;
				gdouble _tmp43_ = 0.0;
				gdouble _tmp44_ = 0.0;
				gdouble _tmp45_ = 0.0;
				gdouble _tmp46_ = 0.0;
				DeferredCairo* _tmp47_ = NULL;
				DeferredCairo* _tmp48_ = NULL;
				cairo_t* _tmp49_ = NULL;
#line 548 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp28_ = _tmp27_;
#line 548 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				if (!_tmp28_) {
#line 3735 "seed.c"
					gint _tmp29_ = 0;
#line 548 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
					_tmp29_ = i;
#line 548 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
					i = _tmp29_ + 1;
#line 3741 "seed.c"
				}
#line 548 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp27_ = FALSE;
#line 548 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp30_ = i;
#line 548 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp31_ = self->num_segment;
#line 548 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				if (!(_tmp30_ <= _tmp31_)) {
#line 548 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
					break;
#line 3753 "seed.c"
				}
#line 549 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp32_ = i;
#line 549 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp33_ = self->num_segment;
#line 549 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				x = ((gdouble) _tmp32_) / _tmp33_;
#line 550 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp34_ = pr;
#line 550 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp35_ = x;
#line 550 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp36_ = self->base_offset;
#line 550 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				seed_distant_point (self, _tmp35_, _tmp36_, &_tmp37_);
#line 550 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				projection_map (_tmp34_, &_tmp37_, &_tmp38_);
#line 550 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				p = _tmp38_;
#line 551 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp39_ = dc;
#line 551 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp40_ = p;
#line 551 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				deferred_cairo_move_to (_tmp39_, &_tmp40_);
#line 552 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp41_ = dc;
#line 552 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp42_ = pr;
#line 552 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp43_ = x;
#line 552 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp44_ = self->base_offset;
#line 552 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp45_ = x;
#line 552 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp46_ = self->base_offset;
#line 552 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				seed_draw_segment (self, _tmp41_, _tmp42_, NULL, _tmp43_, _tmp44_, _tmp45_, _tmp46_ - 1, 0.5);
#line 553 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp47_ = dc;
#line 553 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				deferred_cairo_stroke (_tmp47_);
#line 554 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp48_ = dc;
#line 554 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp49_ = cr;
#line 554 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				deferred_cairo_render (_tmp48_, _tmp49_);
#line 3803 "seed.c"
			}
		}
	}
#line 556 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	seed_stop_render (self);
#line 532 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_deferred_cairo_unref0 (dc);
#line 3811 "seed.c"
}


/**
 * Draw a projected line segment.
 */
static void seed_draw_segment (Seed* self, DeferredCairo* dc, Projection* pr, Probe* probe, gdouble x0, gdouble y0, gdouble x1, gdouble y1, gdouble limit) {
	Point p0 = {0};
	Projection* _tmp0_ = NULL;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	Point _tmp3_ = {0};
	Point _tmp4_ = {0};
	Point p1 = {0};
	Projection* _tmp5_ = NULL;
	gdouble _tmp6_ = 0.0;
	gdouble _tmp7_ = 0.0;
	Point _tmp8_ = {0};
	Point _tmp9_ = {0};
	DeferredCairo* _tmp10_ = NULL;
	Projection* _tmp11_ = NULL;
	Probe* _tmp12_ = NULL;
	gdouble _tmp13_ = 0.0;
	gdouble _tmp14_ = 0.0;
	Point _tmp15_ = {0};
	gdouble _tmp16_ = 0.0;
	gdouble _tmp17_ = 0.0;
	Point _tmp18_ = {0};
	Point _tmp19_ = {0};
	Point _tmp20_ = {0};
	gdouble _tmp21_ = 0.0;
	gdouble _tmp22_ = 0.0;
#line 562 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	g_return_if_fail (self != NULL);
#line 562 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	g_return_if_fail (dc != NULL);
#line 564 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp0_ = pr;
#line 564 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp1_ = x0;
#line 564 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp2_ = y0;
#line 564 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	seed_distant_point (self, _tmp1_, _tmp2_, &_tmp3_);
#line 564 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	projection_map (_tmp0_, &_tmp3_, &_tmp4_);
#line 564 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	p0 = _tmp4_;
#line 565 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp5_ = pr;
#line 565 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp6_ = x1;
#line 565 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp7_ = y1;
#line 565 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	seed_distant_point (self, _tmp6_, _tmp7_, &_tmp8_);
#line 565 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	projection_map (_tmp5_, &_tmp8_, &_tmp9_);
#line 565 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	p1 = _tmp9_;
#line 566 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp10_ = dc;
#line 566 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp11_ = pr;
#line 566 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp12_ = probe;
#line 566 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp13_ = x0;
#line 566 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp14_ = y0;
#line 566 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp15_ = p0;
#line 566 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp16_ = x1;
#line 566 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp17_ = y1;
#line 566 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp18_ = p1;
#line 566 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp19_ = p0;
#line 566 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp20_ = p1;
#line 566 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp21_ = point_hypot (&_tmp19_, &_tmp20_);
#line 566 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp22_ = limit;
#line 566 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	seed_draw_sub_segment (self, _tmp10_, _tmp11_, _tmp12_, _tmp13_, _tmp14_, &_tmp15_, _tmp16_, _tmp17_, &_tmp18_, _tmp21_, _tmp22_, 1000);
#line 3900 "seed.c"
}


/**
 * Draw by recursively splitting into two smaller subsegments.
 * p0 and p1 are pre-computed projections of (x0, y0) and (x1, y1) respectively.
 */
static void seed_draw_sub_segment (Seed* self, DeferredCairo* dc, Projection* pr, Probe* probe, gdouble x0, gdouble y0, Point* p0, gdouble x1, gdouble y1, Point* p1, gdouble distance, gdouble limit, gint depth) {
	gboolean _tmp0_ = FALSE;
	Probe* _tmp1_ = NULL;
	gboolean _tmp4_ = FALSE;
#line 577 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	g_return_if_fail (self != NULL);
#line 577 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	g_return_if_fail (dc != NULL);
#line 577 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	g_return_if_fail (p0 != NULL);
#line 577 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	g_return_if_fail (p1 != NULL);
#line 580 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp1_ = probe;
#line 580 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	if (_tmp1_ != NULL) {
#line 3924 "seed.c"
		Probe* _tmp2_ = NULL;
		gboolean _tmp3_ = FALSE;
#line 580 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp2_ = probe;
#line 580 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp3_ = _tmp2_->cancelled;
#line 580 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp0_ = _tmp3_;
#line 3933 "seed.c"
	} else {
#line 580 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp0_ = FALSE;
#line 3937 "seed.c"
	}
#line 580 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp4_ = _tmp0_;
#line 580 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	if (_tmp4_) {
#line 580 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		return;
#line 3945 "seed.c"
	}
#line 581 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	while (TRUE) {
#line 3949 "seed.c"
		gint _tmp5_ = 0;
		gdouble xm = 0.0;
		gdouble _tmp6_ = 0.0;
		gdouble _tmp7_ = 0.0;
		gdouble ym = 0.0;
		gdouble _tmp8_ = 0.0;
		gdouble _tmp9_ = 0.0;
		Point pm = {0};
		Projection* _tmp10_ = NULL;
		gdouble _tmp11_ = 0.0;
		gdouble _tmp12_ = 0.0;
		Point _tmp13_ = {0};
		Point _tmp14_ = {0};
		gdouble distance_half = 0.0;
		Point _tmp15_ = {0};
		Point _tmp16_ = {0};
		gdouble _tmp17_ = 0.0;
		gboolean _tmp18_ = FALSE;
		gboolean _tmp19_ = FALSE;
		gdouble _tmp20_ = 0.0;
		gdouble _tmp21_ = 0.0;
		gboolean _tmp24_ = FALSE;
		gboolean _tmp35_ = FALSE;
		DeferredCairo* _tmp38_ = NULL;
		Projection* _tmp39_ = NULL;
		Probe* _tmp40_ = NULL;
		gdouble _tmp41_ = 0.0;
		gdouble _tmp42_ = 0.0;
		Point _tmp43_ = {0};
		gdouble _tmp44_ = 0.0;
		gdouble _tmp45_ = 0.0;
		Point _tmp46_ = {0};
		gdouble _tmp47_ = 0.0;
		gdouble _tmp48_ = 0.0;
		gint _tmp49_ = 0;
		gdouble _tmp50_ = 0.0;
		gdouble _tmp51_ = 0.0;
		Point _tmp52_ = {0};
		gint _tmp53_ = 0;
		Point _tmp54_ = {0};
		Point _tmp55_ = {0};
		gdouble _tmp56_ = 0.0;
#line 582 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp5_ = depth;
#line 582 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		if (_tmp5_ == 0) {
#line 582 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
			return;
#line 3998 "seed.c"
		}
#line 583 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp6_ = x0;
#line 583 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp7_ = x1;
#line 583 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		xm = (_tmp6_ + _tmp7_) / 2;
#line 584 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp8_ = y0;
#line 584 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp9_ = y1;
#line 584 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		ym = (_tmp8_ + _tmp9_) / 2;
#line 585 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp10_ = pr;
#line 585 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp11_ = xm;
#line 585 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp12_ = ym;
#line 585 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		seed_distant_point (self, _tmp11_, _tmp12_, &_tmp13_);
#line 585 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		projection_map (_tmp10_, &_tmp13_, &_tmp14_);
#line 585 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		pm = _tmp14_;
#line 586 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp15_ = *p0;
#line 586 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp16_ = pm;
#line 586 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp17_ = point_hypot (&_tmp15_, &_tmp16_);
#line 586 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		distance_half = _tmp17_;
#line 588 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp20_ = distance;
#line 588 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp21_ = limit;
#line 588 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		if (_tmp20_ <= _tmp21_) {
#line 4038 "seed.c"
			gdouble _tmp22_ = 0.0;
			gdouble _tmp23_ = 0.0;
#line 588 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
			_tmp22_ = distance_half;
#line 588 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
			_tmp23_ = distance;
#line 588 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
			_tmp19_ = _tmp22_ <= _tmp23_;
#line 4047 "seed.c"
		} else {
#line 588 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
			_tmp19_ = FALSE;
#line 4051 "seed.c"
		}
#line 588 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp24_ = _tmp19_;
#line 588 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		if (_tmp24_) {
#line 4057 "seed.c"
			Point _tmp25_ = {0};
			Projection* _tmp26_ = NULL;
			gdouble _tmp27_ = 0.0;
			gdouble _tmp28_ = 0.0;
			gdouble _tmp29_ = 0.0;
			gdouble _tmp30_ = 0.0;
			Point _tmp31_ = {0};
			Point _tmp32_ = {0};
			gdouble _tmp33_ = 0.0;
			gdouble _tmp34_ = 0.0;
#line 589 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
			_tmp25_ = *p0;
#line 589 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
			_tmp26_ = pr;
#line 589 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
			_tmp27_ = x0;
#line 589 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
			_tmp28_ = x1;
#line 589 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
			_tmp29_ = y0;
#line 589 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
			_tmp30_ = y1;
#line 589 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
			seed_distant_point (self, (0.85 * _tmp27_) + (0.15 * _tmp28_), (0.85 * _tmp29_) + (0.15 * _tmp30_), &_tmp31_);
#line 589 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
			projection_map (_tmp26_, &_tmp31_, &_tmp32_);
#line 589 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
			_tmp33_ = point_hypot (&_tmp25_, &_tmp32_);
#line 589 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
			_tmp34_ = distance;
#line 589 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
			_tmp18_ = _tmp33_ <= _tmp34_;
#line 4090 "seed.c"
		} else {
#line 588 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
			_tmp18_ = FALSE;
#line 4094 "seed.c"
		}
#line 588 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp35_ = _tmp18_;
#line 588 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		if (_tmp35_) {
#line 4100 "seed.c"
			DeferredCairo* _tmp36_ = NULL;
			Point _tmp37_ = {0};
#line 592 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
			_tmp36_ = dc;
#line 592 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
			_tmp37_ = *p1;
#line 592 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
			deferred_cairo_line_to (_tmp36_, &_tmp37_);
#line 593 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
			return;
#line 4111 "seed.c"
		}
#line 595 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp38_ = dc;
#line 595 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp39_ = pr;
#line 595 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp40_ = probe;
#line 595 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp41_ = x0;
#line 595 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp42_ = y0;
#line 595 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp43_ = *p0;
#line 595 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp44_ = xm;
#line 595 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp45_ = ym;
#line 595 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp46_ = pm;
#line 595 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp47_ = distance_half;
#line 595 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp48_ = limit;
#line 595 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp49_ = depth;
#line 595 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		seed_draw_sub_segment (self, _tmp38_, _tmp39_, _tmp40_, _tmp41_, _tmp42_, &_tmp43_, _tmp44_, _tmp45_, &_tmp46_, _tmp47_, _tmp48_, _tmp49_ - 1);
#line 597 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp50_ = xm;
#line 597 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		x0 = _tmp50_;
#line 597 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp51_ = ym;
#line 597 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		y0 = _tmp51_;
#line 597 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp52_ = pm;
#line 597 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		*p0 = _tmp52_;
#line 597 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp53_ = depth;
#line 597 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		depth = _tmp53_ - 1;
#line 598 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp54_ = *p0;
#line 598 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp55_ = *p1;
#line 598 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp56_ = point_hypot (&_tmp54_, &_tmp55_);
#line 598 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		distance = _tmp56_;
#line 4163 "seed.c"
	}
}


/**
 * Draw directly using cairo methods.
 */
static void seed_real_draw_direct (Seed* self, cairo_t* cr, gdouble scale) {
#line 614 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	g_critical ("Type `%s' does not implement abstract method `seed_draw_direct'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 614 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	return;
#line 4176 "seed.c"
}


void seed_draw_direct (Seed* self, cairo_t* cr, gdouble scale) {
#line 614 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	g_return_if_fail (self != NULL);
#line 614 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	SEED_GET_CLASS (self)->draw_direct (self, cr, scale);
#line 4185 "seed.c"
}


/**
 * Controls used for moving, scaling, rotation, etc.
 */
static void seed_real_draw_controls (Seed* self, cairo_t* cr, gdouble scale) {
#line 619 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	g_critical ("Type `%s' does not implement abstract method `seed_draw_controls'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 619 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	return;
#line 4197 "seed.c"
}


void seed_draw_controls (Seed* self, cairo_t* cr, gdouble scale) {
#line 619 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	g_return_if_fail (self != NULL);
#line 619 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	SEED_GET_CLASS (self)->draw_controls (self, cr, scale);
#line 4206 "seed.c"
}


void seed_draw_square_control (Seed* self, cairo_t* cr, Point* p) {
	cairo_t* _tmp0_ = NULL;
	Point _tmp1_ = {0};
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	Point _tmp4_ = {0};
	gdouble _tmp5_ = 0.0;
	gdouble _tmp6_ = 0.0;
	gdouble _tmp7_ = 0.0;
	gdouble _tmp8_ = 0.0;
	cairo_t* _tmp9_ = NULL;
#line 621 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	g_return_if_fail (self != NULL);
#line 621 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	g_return_if_fail (cr != NULL);
#line 621 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	g_return_if_fail (p != NULL);
#line 622 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp0_ = cr;
#line 622 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp1_ = *p;
#line 622 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp2_ = _tmp1_.x;
#line 622 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp3_ = self->priv->control_radius;
#line 622 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp4_ = *p;
#line 622 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp5_ = _tmp4_.y;
#line 622 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp6_ = self->priv->control_radius;
#line 622 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp7_ = self->priv->control_radius;
#line 622 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp8_ = self->priv->control_radius;
#line 622 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	cairo_rectangle (_tmp0_, _tmp2_ - _tmp3_, _tmp5_ - _tmp6_, _tmp7_ * 2, _tmp8_ * 2);
#line 623 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp9_ = cr;
#line 623 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	cairo_fill (_tmp9_);
#line 4251 "seed.c"
}


void seed_draw_line_control (Seed* self, cairo_t* cr, Point* p0, Point* p1) {
	cairo_t* _tmp0_ = NULL;
	Point _tmp1_ = {0};
	gdouble _tmp2_ = 0.0;
	Point _tmp3_ = {0};
	gdouble _tmp4_ = 0.0;
	cairo_t* _tmp5_ = NULL;
	Point _tmp6_ = {0};
	gdouble _tmp7_ = 0.0;
	Point _tmp8_ = {0};
	gdouble _tmp9_ = 0.0;
	cairo_t* _tmp10_ = NULL;
#line 626 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	g_return_if_fail (self != NULL);
#line 626 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	g_return_if_fail (cr != NULL);
#line 626 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	g_return_if_fail (p0 != NULL);
#line 626 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	g_return_if_fail (p1 != NULL);
#line 627 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp0_ = cr;
#line 627 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp1_ = *p0;
#line 627 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp2_ = _tmp1_.x;
#line 627 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp3_ = *p0;
#line 627 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp4_ = _tmp3_.y;
#line 627 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	cairo_move_to (_tmp0_, _tmp2_, _tmp4_);
#line 628 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp5_ = cr;
#line 628 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp6_ = *p1;
#line 628 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp7_ = _tmp6_.x;
#line 628 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp8_ = *p1;
#line 628 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp9_ = _tmp8_.y;
#line 628 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	cairo_line_to (_tmp5_, _tmp7_, _tmp9_);
#line 629 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp10_ = cr;
#line 629 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	cairo_stroke (_tmp10_);
#line 4303 "seed.c"
}


void seed_draw_circle_control (Seed* self, cairo_t* cr, Point* p) {
	cairo_t* _tmp0_ = NULL;
	Point _tmp1_ = {0};
	gdouble _tmp2_ = 0.0;
	Point _tmp3_ = {0};
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
	cairo_t* _tmp6_ = NULL;
#line 632 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	g_return_if_fail (self != NULL);
#line 632 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	g_return_if_fail (cr != NULL);
#line 632 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	g_return_if_fail (p != NULL);
#line 633 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp0_ = cr;
#line 633 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp1_ = *p;
#line 633 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp2_ = _tmp1_.x;
#line 633 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp3_ = *p;
#line 633 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp4_ = _tmp3_.y;
#line 633 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp5_ = self->priv->control_radius;
#line 633 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	cairo_arc (_tmp0_, _tmp2_, _tmp4_, _tmp5_, (gdouble) 0, 2 * G_PI);
#line 634 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp6_ = cr;
#line 634 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	cairo_fill (_tmp6_);
#line 4339 "seed.c"
}


/**
 * Is point 0 and point 1 within range?
 * One of the point is a control, the other is the cursor.
 */
gboolean seed_within_snap_range (Seed* self, Point* p0, Point* p1, gdouble scale) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	Point _tmp1_ = {0};
	gdouble _tmp2_ = 0.0;
	Point _tmp3_ = {0};
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
	gdouble _tmp6_ = 0.0;
	gdouble _tmp7_ = 0.0;
	gboolean _tmp15_ = FALSE;
#line 641 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 641 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	g_return_val_if_fail (p0 != NULL, FALSE);
#line 641 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	g_return_val_if_fail (p1 != NULL, FALSE);
#line 642 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp1_ = *p0;
#line 642 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp2_ = _tmp1_.x;
#line 642 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp3_ = *p1;
#line 642 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp4_ = _tmp3_.x;
#line 642 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp5_ = fabs (_tmp2_ - _tmp4_);
#line 642 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp6_ = scale;
#line 642 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp7_ = self->priv->control_magnetic_range;
#line 642 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	if ((_tmp5_ * _tmp6_) <= _tmp7_) {
#line 4380 "seed.c"
		Point _tmp8_ = {0};
		gdouble _tmp9_ = 0.0;
		Point _tmp10_ = {0};
		gdouble _tmp11_ = 0.0;
		gdouble _tmp12_ = 0.0;
		gdouble _tmp13_ = 0.0;
		gdouble _tmp14_ = 0.0;
#line 643 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp8_ = *p0;
#line 643 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp9_ = _tmp8_.y;
#line 643 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp10_ = *p1;
#line 643 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp11_ = _tmp10_.y;
#line 643 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp12_ = fabs (_tmp9_ - _tmp11_);
#line 643 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp13_ = scale;
#line 643 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp14_ = self->priv->control_magnetic_range;
#line 643 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp0_ = (_tmp12_ * _tmp13_) <= _tmp14_;
#line 4404 "seed.c"
	} else {
#line 642 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp0_ = FALSE;
#line 4408 "seed.c"
	}
#line 642 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp15_ = _tmp0_;
#line 642 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	result = _tmp15_;
#line 642 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	return result;
#line 4416 "seed.c"
}


gboolean seed_within_touch_range (Seed* self, Point* p0, Point* p1, gdouble scale) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	Point _tmp1_ = {0};
	gdouble _tmp2_ = 0.0;
	Point _tmp3_ = {0};
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
	gdouble _tmp6_ = 0.0;
	gdouble _tmp7_ = 0.0;
	gboolean _tmp15_ = FALSE;
#line 646 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 646 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	g_return_val_if_fail (p0 != NULL, FALSE);
#line 646 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	g_return_val_if_fail (p1 != NULL, FALSE);
#line 647 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp1_ = *p0;
#line 647 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp2_ = _tmp1_.x;
#line 647 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp3_ = *p1;
#line 647 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp4_ = _tmp3_.x;
#line 647 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp5_ = fabs (_tmp2_ - _tmp4_);
#line 647 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp6_ = scale;
#line 647 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp7_ = self->priv->control_radius;
#line 647 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	if ((_tmp5_ * _tmp6_) <= _tmp7_) {
#line 4453 "seed.c"
		Point _tmp8_ = {0};
		gdouble _tmp9_ = 0.0;
		Point _tmp10_ = {0};
		gdouble _tmp11_ = 0.0;
		gdouble _tmp12_ = 0.0;
		gdouble _tmp13_ = 0.0;
		gdouble _tmp14_ = 0.0;
#line 648 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp8_ = *p0;
#line 648 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp9_ = _tmp8_.y;
#line 648 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp10_ = *p1;
#line 648 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp11_ = _tmp10_.y;
#line 648 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp12_ = fabs (_tmp9_ - _tmp11_);
#line 648 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp13_ = scale;
#line 648 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp14_ = self->priv->control_radius;
#line 648 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp0_ = (_tmp12_ * _tmp13_) <= _tmp14_;
#line 4477 "seed.c"
	} else {
#line 647 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp0_ = FALSE;
#line 4481 "seed.c"
	}
#line 647 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp15_ = _tmp0_;
#line 647 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	result = _tmp15_;
#line 647 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	return result;
#line 4489 "seed.c"
}


/**
 * Is point p touching the seed
 */
gboolean seed_touching (Seed* self, Point* p, gdouble scale) {
	gboolean result = FALSE;
#line 654 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 654 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	g_return_val_if_fail (p != NULL, FALSE);
#line 4502 "seed.c"
	{
		gint i = 0;
#line 656 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		i = 0;
#line 4507 "seed.c"
		{
			gboolean _tmp0_ = FALSE;
#line 656 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
			_tmp0_ = TRUE;
#line 656 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
			while (TRUE) {
#line 4514 "seed.c"
				gboolean _tmp1_ = FALSE;
				gint _tmp3_ = 0;
				gdouble t0 = 0.0;
				gint _tmp4_ = 0;
				gdouble t1 = 0.0;
				gint _tmp5_ = 0;
#line 656 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp1_ = _tmp0_;
#line 656 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				if (!_tmp1_) {
#line 4525 "seed.c"
					gint _tmp2_ = 0;
#line 656 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
					_tmp2_ = i;
#line 656 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
					i = _tmp2_ + 1;
#line 4531 "seed.c"
				}
#line 656 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp0_ = FALSE;
#line 656 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp3_ = i;
#line 656 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				if (!(_tmp3_ < 4)) {
#line 656 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
					break;
#line 4541 "seed.c"
				}
#line 658 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp4_ = i;
#line 658 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				t0 = 0.25 * _tmp4_;
#line 659 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp5_ = i;
#line 659 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				t1 = 0.25 * (_tmp5_ + 1);
#line 660 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				while (TRUE) {
#line 4553 "seed.c"
					gdouble _tmp6_ = 0.0;
					gdouble _tmp7_ = 0.0;
					gdouble _tmp8_ = 0.0;
					gdouble d0 = 0.0;
					Point _tmp9_ = {0};
					gdouble _tmp10_ = 0.0;
					Point _tmp11_ = {0};
					gdouble _tmp12_ = 0.0;
					gdouble _tmp13_ = 0.0;
					gdouble d1 = 0.0;
					Point _tmp14_ = {0};
					gdouble _tmp15_ = 0.0;
					Point _tmp16_ = {0};
					gdouble _tmp17_ = 0.0;
					gdouble _tmp18_ = 0.0;
					gboolean _tmp19_ = FALSE;
					gdouble _tmp20_ = 0.0;
					gdouble _tmp21_ = 0.0;
					gboolean _tmp24_ = FALSE;
#line 660 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
					_tmp6_ = t1;
#line 660 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
					_tmp7_ = t0;
#line 660 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
					_tmp8_ = seed_epsilon;
#line 660 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
					if (!((_tmp6_ - _tmp7_) > _tmp8_)) {
#line 660 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
						break;
#line 4583 "seed.c"
					}
#line 661 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
					_tmp9_ = *p;
#line 661 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
					_tmp10_ = t0;
#line 661 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
					seed_point (self, _tmp10_, &_tmp11_);
#line 661 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
					_tmp12_ = point_hypot (&_tmp9_, &_tmp11_);
#line 661 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
					_tmp13_ = scale;
#line 661 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
					d0 = _tmp12_ * _tmp13_;
#line 662 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
					_tmp14_ = *p;
#line 662 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
					_tmp15_ = t1;
#line 662 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
					seed_point (self, _tmp15_, &_tmp16_);
#line 662 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
					_tmp17_ = point_hypot (&_tmp14_, &_tmp16_);
#line 662 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
					_tmp18_ = scale;
#line 662 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
					d1 = _tmp17_ * _tmp18_;
#line 663 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
					_tmp20_ = d0;
#line 663 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
					_tmp21_ = self->priv->control_radius;
#line 663 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
					if (_tmp20_ <= _tmp21_) {
#line 663 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
						_tmp19_ = TRUE;
#line 4617 "seed.c"
					} else {
						gdouble _tmp22_ = 0.0;
						gdouble _tmp23_ = 0.0;
#line 663 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
						_tmp22_ = d1;
#line 663 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
						_tmp23_ = self->priv->control_radius;
#line 663 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
						_tmp19_ = _tmp22_ <= _tmp23_;
#line 4627 "seed.c"
					}
#line 663 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
					_tmp24_ = _tmp19_;
#line 663 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
					if (_tmp24_) {
#line 664 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
						result = TRUE;
#line 664 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
						return result;
#line 4637 "seed.c"
					} else {
						gdouble _tmp25_ = 0.0;
						gdouble _tmp26_ = 0.0;
#line 666 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
						_tmp25_ = d0;
#line 666 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
						_tmp26_ = d1;
#line 666 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
						if (_tmp25_ < _tmp26_) {
#line 4647 "seed.c"
							gdouble _tmp27_ = 0.0;
							gdouble _tmp28_ = 0.0;
#line 667 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
							_tmp27_ = t0;
#line 667 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
							_tmp28_ = t1;
#line 667 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
							t1 = (_tmp27_ + _tmp28_) / 2;
#line 4656 "seed.c"
						} else {
							gdouble _tmp29_ = 0.0;
							gdouble _tmp30_ = 0.0;
#line 670 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
							_tmp29_ = t0;
#line 670 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
							_tmp30_ = t1;
#line 670 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
							t0 = (_tmp29_ + _tmp30_) / 2;
#line 4666 "seed.c"
						}
					}
				}
			}
		}
	}
#line 674 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	result = FALSE;
#line 674 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	return result;
#line 4677 "seed.c"
}


/**
 * See if any control is within the range of the cursor.
 * Output: 
 *  + selected_control
 *            -1 : not selected
 *           100 : drag the entire shape
 *        others : determined by pressed_control
 * + pressed_point : the point where the drag began
 */
gboolean seed_start_drag (Seed* self, Point* p, gdouble scale, gboolean selected, gboolean snap_on, gdouble grid_size) {
	gboolean result = FALSE;
	Point snapped_p = {0};
	Point _tmp0_ = {0};
	gboolean _tmp1_ = FALSE;
	gboolean _tmp6_ = FALSE;
	gboolean _tmp10_ = FALSE;
	gint _tmp11_ = 0;
	gboolean _tmp15_ = FALSE;
	gint _tmp17_ = 0;
#line 686 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 686 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	g_return_val_if_fail (p != NULL, FALSE);
#line 687 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	self->selected_control = -1;
#line 688 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	seed_save_drag_context (self);
#line 689 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp0_ = *p;
#line 689 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	snapped_p = _tmp0_;
#line 690 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp1_ = snap_on;
#line 690 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	if (_tmp1_) {
#line 4716 "seed.c"
		gdouble _tmp2_ = 0.0;
		gdouble _tmp3_ = 0.0;
		gboolean _tmp4_ = FALSE;
#line 691 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp2_ = scale;
#line 691 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp3_ = grid_size;
#line 691 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp4_ = seed_snap (self, &snapped_p, _tmp2_, _tmp3_);
#line 691 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		if (_tmp4_) {
#line 4728 "seed.c"
			Point _tmp5_ = {0};
#line 691 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
			_tmp5_ = snapped_p;
#line 691 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
			seed_init_default (self, &_tmp5_);
#line 4734 "seed.c"
		}
	}
#line 693 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp6_ = selected;
#line 693 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	if (_tmp6_) {
#line 4741 "seed.c"
		Point _tmp7_ = {0};
		gdouble _tmp8_ = 0.0;
		gint _tmp9_ = 0;
#line 694 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp7_ = snapped_p;
#line 694 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp8_ = scale;
#line 694 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp9_ = seed_pressed_control (self, &_tmp7_, _tmp8_);
#line 694 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		self->selected_control = _tmp9_;
#line 4753 "seed.c"
	}
#line 696 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp11_ = self->selected_control;
#line 696 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	if (_tmp11_ == (-1)) {
#line 4759 "seed.c"
		Point _tmp12_ = {0};
		gdouble _tmp13_ = 0.0;
		gboolean _tmp14_ = FALSE;
#line 696 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp12_ = *p;
#line 696 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp13_ = scale;
#line 696 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp14_ = seed_touching (self, &_tmp12_, _tmp13_);
#line 696 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp10_ = _tmp14_;
#line 4771 "seed.c"
	} else {
#line 696 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp10_ = FALSE;
#line 4775 "seed.c"
	}
#line 696 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp15_ = _tmp10_;
#line 696 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	if (_tmp15_) {
#line 4781 "seed.c"
		Point _tmp16_ = {0};
#line 697 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		self->selected_control = 100;
#line 698 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp16_ = *p;
#line 698 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		self->pressed_point = _tmp16_;
#line 4789 "seed.c"
	}
#line 700 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp17_ = self->selected_control;
#line 700 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	result = _tmp17_ != (-1);
#line 700 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	return result;
#line 4797 "seed.c"
}


/**
 * Which control is pressed and about to be dragged?
 */
static gint seed_real_pressed_control (Seed* self, Point* p, gdouble scale) {
#line 706 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	g_critical ("Type `%s' does not implement abstract method `seed_pressed_control'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 706 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	return 0;
#line 4809 "seed.c"
}


gint seed_pressed_control (Seed* self, Point* p, gdouble scale) {
#line 706 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 706 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	return SEED_GET_CLASS (self)->pressed_control (self, p, scale);
#line 4818 "seed.c"
}


static void seed_real_save_drag_context (Seed* self) {
#line 707 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	g_critical ("Type `%s' does not implement abstract method `seed_save_drag_context'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 707 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	return;
#line 4827 "seed.c"
}


void seed_save_drag_context (Seed* self) {
#line 707 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	g_return_if_fail (self != NULL);
#line 707 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	SEED_GET_CLASS (self)->save_drag_context (self);
#line 4836 "seed.c"
}


void seed_drag (Seed* self, Point* p, gdouble scale, gboolean snap_on, gdouble grid_size, gdouble snap_angle) {
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	gint _tmp30_ = 0;
#line 709 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	g_return_if_fail (self != NULL);
#line 709 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	g_return_if_fail (p != NULL);
#line 709 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp0_ = self->selected_control;
#line 709 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	g_return_if_fail (_tmp0_ != (-1));
#line 711 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp1_ = self->selected_control;
#line 711 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	if (_tmp1_ == 100) {
#line 4856 "seed.c"
		gdouble delta_x = 0.0;
		Point _tmp2_ = {0};
		gdouble _tmp3_ = 0.0;
		Point _tmp4_ = {0};
		gdouble _tmp5_ = 0.0;
		gdouble delta_y = 0.0;
		Point _tmp6_ = {0};
		gdouble _tmp7_ = 0.0;
		Point _tmp8_ = {0};
		gdouble _tmp9_ = 0.0;
		gdouble _tmp10_ = 0.0;
		gdouble _tmp11_ = 0.0;
		gboolean _tmp12_ = FALSE;
#line 712 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp2_ = *p;
#line 712 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp3_ = _tmp2_.x;
#line 712 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp4_ = self->pressed_point;
#line 712 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp5_ = _tmp4_.x;
#line 712 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		delta_x = _tmp3_ - _tmp5_;
#line 713 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp6_ = *p;
#line 713 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp7_ = _tmp6_.y;
#line 713 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp8_ = self->pressed_point;
#line 713 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp9_ = _tmp8_.y;
#line 713 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		delta_y = _tmp7_ - _tmp9_;
#line 714 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp10_ = delta_x;
#line 714 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp11_ = delta_y;
#line 714 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		seed_move_shape (self, _tmp10_, _tmp11_);
#line 715 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp12_ = snap_on;
#line 715 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		if (_tmp12_) {
#line 4900 "seed.c"
			gdouble dx = 0.0;
			gdouble dy = 0.0;
			gdouble _tmp13_ = 0.0;
			gdouble _tmp14_ = 0.0;
			gdouble _tmp15_ = 0.0;
			gdouble _tmp16_ = 0.0;
			gdouble _tmp17_ = 0.0;
			gdouble _tmp20_ = 0.0;
			gdouble _tmp23_ = 0.0;
			gdouble _tmp24_ = 0.0;
#line 716 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
			dx = (gdouble) 999999;
#line 717 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
			dy = (gdouble) 999999;
#line 718 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
			_tmp13_ = scale;
#line 718 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
			_tmp14_ = grid_size;
#line 718 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
			seed_distance_to_grid (self, _tmp13_, _tmp14_, &_tmp15_, &_tmp16_);
#line 718 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
			dx = _tmp15_;
#line 718 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
			dy = _tmp16_;
#line 719 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
			_tmp17_ = dx;
#line 719 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
			if (_tmp17_ != ((gdouble) 999999)) {
#line 4929 "seed.c"
				gdouble _tmp18_ = 0.0;
				gdouble _tmp19_ = 0.0;
#line 719 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp18_ = delta_x;
#line 719 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp19_ = dx;
#line 719 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				delta_x = _tmp18_ - _tmp19_;
#line 4938 "seed.c"
			}
#line 720 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
			_tmp20_ = dy;
#line 720 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
			if (_tmp20_ != ((gdouble) 999999)) {
#line 4944 "seed.c"
				gdouble _tmp21_ = 0.0;
				gdouble _tmp22_ = 0.0;
#line 720 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp21_ = delta_y;
#line 720 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp22_ = dy;
#line 720 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				delta_y = _tmp21_ - _tmp22_;
#line 4953 "seed.c"
			}
#line 721 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
			_tmp23_ = delta_x;
#line 721 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
			_tmp24_ = delta_y;
#line 721 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
			seed_move_shape (self, _tmp23_, _tmp24_);
#line 4961 "seed.c"
		}
	} else {
		Point _tmp25_ = {0};
		gdouble _tmp26_ = 0.0;
		gboolean _tmp27_ = FALSE;
		gdouble _tmp28_ = 0.0;
		gdouble _tmp29_ = 0.0;
#line 725 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp25_ = *p;
#line 725 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp26_ = scale;
#line 725 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp27_ = snap_on;
#line 725 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp28_ = grid_size;
#line 725 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp29_ = snap_angle;
#line 725 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		seed_drag_control (self, &_tmp25_, _tmp26_, _tmp27_, _tmp28_, _tmp29_);
#line 4981 "seed.c"
	}
#line 728 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp30_ = self->selected_control;
#line 728 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	if (_tmp30_ != 100) {
#line 728 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		seed_init_distance_to_parametric (self);
#line 4989 "seed.c"
	}
}


static void seed_real_move_shape (Seed* self, gdouble delta_x, gdouble delta_y) {
#line 731 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	g_critical ("Type `%s' does not implement abstract method `seed_move_shape'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 731 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	return;
#line 4999 "seed.c"
}


void seed_move_shape (Seed* self, gdouble delta_x, gdouble delta_y) {
#line 731 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	g_return_if_fail (self != NULL);
#line 731 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	SEED_GET_CLASS (self)->move_shape (self, delta_x, delta_y);
#line 5008 "seed.c"
}


static void seed_real_drag_control (Seed* self, Point* p, gdouble scale, gboolean snap_on, gdouble grid_size, gdouble snap_angle) {
#line 732 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	g_critical ("Type `%s' does not implement abstract method `seed_drag_control'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 732 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	return;
#line 5017 "seed.c"
}


void seed_drag_control (Seed* self, Point* p, gdouble scale, gboolean snap_on, gdouble grid_size, gdouble snap_angle) {
#line 732 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	g_return_if_fail (self != NULL);
#line 732 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	SEED_GET_CLASS (self)->drag_control (self, p, scale, snap_on, grid_size, snap_angle);
#line 5026 "seed.c"
}


/**
 * Snap to the nearest grid
 */
gboolean seed_snap (Seed* self, Point* p, gdouble scale, gdouble grid_size) {
	gboolean result = FALSE;
	gboolean bx = FALSE;
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	gboolean _tmp2_ = FALSE;
	gboolean by = FALSE;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	gboolean _tmp5_ = FALSE;
	gboolean _tmp6_ = FALSE;
	gboolean _tmp7_ = FALSE;
	gboolean _tmp9_ = FALSE;
#line 737 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 737 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	g_return_val_if_fail (p != NULL, FALSE);
#line 738 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp0_ = scale;
#line 738 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp1_ = grid_size;
#line 738 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp2_ = seed_snap_x (self, p, _tmp0_, _tmp1_);
#line 738 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	bx = _tmp2_;
#line 739 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp3_ = scale;
#line 739 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp4_ = grid_size;
#line 739 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp5_ = seed_snap_y (self, p, _tmp3_, _tmp4_);
#line 739 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	by = _tmp5_;
#line 740 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp7_ = bx;
#line 740 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	if (_tmp7_) {
#line 740 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp6_ = TRUE;
#line 5072 "seed.c"
	} else {
		gboolean _tmp8_ = FALSE;
#line 740 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp8_ = by;
#line 740 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp6_ = _tmp8_;
#line 5079 "seed.c"
	}
#line 740 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp9_ = _tmp6_;
#line 740 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	result = _tmp9_;
#line 740 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	return result;
#line 5087 "seed.c"
}


gboolean seed_snap_x (Seed* self, Point* p, gdouble scale, gdouble grid_size) {
	gboolean result = FALSE;
	gdouble grid_x = 0.0;
	Point _tmp0_ = {0};
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	Point _tmp5_ = {0};
	gdouble _tmp6_ = 0.0;
	gdouble _tmp7_ = 0.0;
	gdouble _tmp8_ = 0.0;
	gdouble _tmp9_ = 0.0;
	gdouble _tmp10_ = 0.0;
#line 743 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 743 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	g_return_val_if_fail (p != NULL, FALSE);
#line 744 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp0_ = *p;
#line 744 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp1_ = _tmp0_.x;
#line 744 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp2_ = grid_size;
#line 744 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp3_ = round (_tmp1_ / _tmp2_);
#line 744 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp4_ = grid_size;
#line 744 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	grid_x = _tmp3_ * _tmp4_;
#line 745 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp5_ = *p;
#line 745 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp6_ = _tmp5_.x;
#line 745 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp7_ = grid_x;
#line 745 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp8_ = fabs (_tmp6_ - _tmp7_);
#line 745 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp9_ = scale;
#line 745 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp10_ = self->priv->grid_magnetic_range;
#line 745 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	if ((_tmp8_ * _tmp9_) <= _tmp10_) {
#line 5135 "seed.c"
		gdouble _tmp11_ = 0.0;
#line 746 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp11_ = grid_x;
#line 746 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		(*p).x = _tmp11_;
#line 747 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		result = TRUE;
#line 747 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		return result;
#line 5145 "seed.c"
	} else {
#line 750 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		result = FALSE;
#line 750 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		return result;
#line 5151 "seed.c"
	}
}


gboolean seed_snap_y (Seed* self, Point* p, gdouble scale, gdouble grid_size) {
	gboolean result = FALSE;
	gdouble grid_y = 0.0;
	Point _tmp0_ = {0};
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	Point _tmp5_ = {0};
	gdouble _tmp6_ = 0.0;
	gdouble _tmp7_ = 0.0;
	gdouble _tmp8_ = 0.0;
	gdouble _tmp9_ = 0.0;
	gdouble _tmp10_ = 0.0;
#line 754 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 754 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	g_return_val_if_fail (p != NULL, FALSE);
#line 755 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp0_ = *p;
#line 755 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp1_ = _tmp0_.y;
#line 755 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp2_ = grid_size;
#line 755 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp3_ = round (_tmp1_ / _tmp2_);
#line 755 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp4_ = grid_size;
#line 755 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	grid_y = _tmp3_ * _tmp4_;
#line 756 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp5_ = *p;
#line 756 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp6_ = _tmp5_.y;
#line 756 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp7_ = grid_y;
#line 756 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp8_ = fabs (_tmp6_ - _tmp7_);
#line 756 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp9_ = scale;
#line 756 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp10_ = self->priv->grid_magnetic_range;
#line 756 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	if ((_tmp8_ * _tmp9_) <= _tmp10_) {
#line 5200 "seed.c"
		gdouble _tmp11_ = 0.0;
#line 757 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		_tmp11_ = grid_y;
#line 757 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		(*p).y = _tmp11_;
#line 758 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		result = TRUE;
#line 758 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		return result;
#line 5210 "seed.c"
	} else {
#line 761 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		result = FALSE;
#line 761 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		return result;
#line 5216 "seed.c"
	}
}


/**
 * Among the points returned by points_to_snap, find one that is closest to an x grid,
 * and one that is closest to a y grid. Return the distances to the respective
 * grid via the out parameters.
 */
void seed_distance_to_grid (Seed* self, gdouble scale, gdouble grid_size, gdouble* distance_x, gdouble* distance_y) {
	gdouble _vala_distance_x = 0.0;
	gdouble _vala_distance_y = 0.0;
	Point* ps = NULL;
	gint _tmp0_ = 0;
	Point* _tmp1_ = NULL;
	gint ps_length1 = 0;
	gint _ps_size_ = 0;
	Point* _tmp2_ = NULL;
	gint _tmp2__length1 = 0;
#line 770 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	g_return_if_fail (self != NULL);
#line 772 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_vala_distance_x = (gdouble) 999999;
#line 773 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_vala_distance_y = (gdouble) 999999;
#line 774 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp1_ = seed_points_to_snap (self, &_tmp0_);
#line 774 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	ps = _tmp1_;
#line 774 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	ps_length1 = _tmp0_;
#line 774 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_ps_size_ = ps_length1;
#line 775 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp2_ = ps;
#line 775 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp2__length1 = ps_length1;
#line 5254 "seed.c"
	{
		Point* p_collection = NULL;
		gint p_collection_length1 = 0;
		gint _p_collection_size_ = 0;
		gint p_it = 0;
#line 775 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		p_collection = _tmp2_;
#line 775 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		p_collection_length1 = _tmp2__length1;
#line 775 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		for (p_it = 0; p_it < _tmp2__length1; p_it = p_it + 1) {
#line 5266 "seed.c"
			Point p = {0};
#line 775 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
			p = p_collection[p_it];
#line 5270 "seed.c"
			{
				gdouble delta_x = 0.0;
				Point _tmp3_ = {0};
				gdouble _tmp4_ = 0.0;
				Point _tmp5_ = {0};
				gdouble _tmp6_ = 0.0;
				gdouble _tmp7_ = 0.0;
				gdouble _tmp8_ = 0.0;
				gdouble _tmp9_ = 0.0;
				gdouble _tmp10_ = 0.0;
				gdouble _tmp11_ = 0.0;
				gdouble _tmp12_ = 0.0;
				gdouble _tmp13_ = 0.0;
				gdouble delta_y = 0.0;
				Point _tmp22_ = {0};
				gdouble _tmp23_ = 0.0;
				Point _tmp24_ = {0};
				gdouble _tmp25_ = 0.0;
				gdouble _tmp26_ = 0.0;
				gdouble _tmp27_ = 0.0;
				gdouble _tmp28_ = 0.0;
				gdouble _tmp29_ = 0.0;
				gdouble _tmp30_ = 0.0;
				gdouble _tmp31_ = 0.0;
				gdouble _tmp32_ = 0.0;
#line 776 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp3_ = p;
#line 776 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp4_ = _tmp3_.x;
#line 776 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp5_ = p;
#line 776 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp6_ = _tmp5_.x;
#line 776 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp7_ = grid_size;
#line 776 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp8_ = round (_tmp6_ / _tmp7_);
#line 776 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp9_ = grid_size;
#line 776 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				delta_x = _tmp4_ - (_tmp8_ * _tmp9_);
#line 777 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp10_ = delta_x;
#line 777 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp11_ = fabs (_tmp10_);
#line 777 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp12_ = scale;
#line 777 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp13_ = self->priv->grid_magnetic_range;
#line 777 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				if ((_tmp11_ * _tmp12_) <= _tmp13_) {
#line 5322 "seed.c"
					gboolean _tmp14_ = FALSE;
					gdouble _tmp15_ = 0.0;
					gboolean _tmp20_ = FALSE;
#line 778 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
					_tmp15_ = _vala_distance_x;
#line 778 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
					if (_tmp15_ == ((gdouble) 999999)) {
#line 778 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
						_tmp14_ = TRUE;
#line 5332 "seed.c"
					} else {
						gdouble _tmp16_ = 0.0;
						gdouble _tmp17_ = 0.0;
						gdouble _tmp18_ = 0.0;
						gdouble _tmp19_ = 0.0;
#line 778 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
						_tmp16_ = delta_x;
#line 778 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
						_tmp17_ = fabs (_tmp16_);
#line 778 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
						_tmp18_ = _vala_distance_x;
#line 778 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
						_tmp19_ = fabs (_tmp18_);
#line 778 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
						_tmp14_ = _tmp17_ < _tmp19_;
#line 5348 "seed.c"
					}
#line 778 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
					_tmp20_ = _tmp14_;
#line 778 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
					if (_tmp20_) {
#line 5354 "seed.c"
						gdouble _tmp21_ = 0.0;
#line 779 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
						_tmp21_ = delta_x;
#line 779 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
						_vala_distance_x = _tmp21_;
#line 5360 "seed.c"
					}
				}
#line 782 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp22_ = p;
#line 782 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp23_ = _tmp22_.y;
#line 782 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp24_ = p;
#line 782 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp25_ = _tmp24_.y;
#line 782 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp26_ = grid_size;
#line 782 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp27_ = round (_tmp25_ / _tmp26_);
#line 782 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp28_ = grid_size;
#line 782 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				delta_y = _tmp23_ - (_tmp27_ * _tmp28_);
#line 783 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp29_ = delta_y;
#line 783 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp30_ = fabs (_tmp29_);
#line 783 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp31_ = scale;
#line 783 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				_tmp32_ = self->priv->grid_magnetic_range;
#line 783 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
				if ((_tmp30_ * _tmp31_) <= _tmp32_) {
#line 5389 "seed.c"
					gboolean _tmp33_ = FALSE;
					gdouble _tmp34_ = 0.0;
					gboolean _tmp39_ = FALSE;
#line 784 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
					_tmp34_ = _vala_distance_y;
#line 784 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
					if (_tmp34_ == ((gdouble) 999999)) {
#line 784 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
						_tmp33_ = TRUE;
#line 5399 "seed.c"
					} else {
						gdouble _tmp35_ = 0.0;
						gdouble _tmp36_ = 0.0;
						gdouble _tmp37_ = 0.0;
						gdouble _tmp38_ = 0.0;
#line 784 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
						_tmp35_ = delta_y;
#line 784 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
						_tmp36_ = fabs (_tmp35_);
#line 784 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
						_tmp37_ = _vala_distance_y;
#line 784 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
						_tmp38_ = fabs (_tmp37_);
#line 784 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
						_tmp33_ = _tmp36_ < _tmp38_;
#line 5415 "seed.c"
					}
#line 784 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
					_tmp39_ = _tmp33_;
#line 784 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
					if (_tmp39_) {
#line 5421 "seed.c"
						gdouble _tmp40_ = 0.0;
#line 785 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
						_tmp40_ = delta_y;
#line 785 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
						_vala_distance_y = _tmp40_;
#line 5427 "seed.c"
					}
				}
			}
		}
	}
#line 770 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	ps = (g_free (ps), NULL);
#line 770 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	if (distance_x) {
#line 770 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		*distance_x = _vala_distance_x;
#line 5439 "seed.c"
	}
#line 770 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	if (distance_y) {
#line 770 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
		*distance_y = _vala_distance_y;
#line 5445 "seed.c"
	}
}


/**
 * When dragging the entire shape, which points should be snapped to the grids?
 */
static Point* seed_real_points_to_snap (Seed* self, int* result_length1) {
#line 794 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	g_critical ("Type `%s' does not implement abstract method `seed_points_to_snap'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 794 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	return NULL;
#line 5458 "seed.c"
}


Point* seed_points_to_snap (Seed* self, int* result_length1) {
#line 794 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 794 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	return SEED_GET_CLASS (self)->points_to_snap (self, result_length1);
#line 5467 "seed.c"
}


static void seed_real_draw_icon (Seed* self, cairo_t* cr, gdouble width, gdouble height) {
#line 796 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	g_critical ("Type `%s' does not implement abstract method `seed_draw_icon'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 796 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	return;
#line 5476 "seed.c"
}


void seed_draw_icon (Seed* self, cairo_t* cr, gdouble width, gdouble height) {
#line 796 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	g_return_if_fail (self != NULL);
#line 796 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	SEED_GET_CLASS (self)->draw_icon (self, cr, width, height);
#line 5485 "seed.c"
}


Seed* seed_construct (GType object_type) {
	Seed * self = NULL;
#line 19 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	self = (Seed*) g_object_new (object_type, NULL);
#line 19 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	return self;
#line 5495 "seed.c"
}


static void seed_class_init (SeedClass * klass) {
	gdouble _tmp0_ = 0.0;
#line 19 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	seed_parent_class = g_type_class_peek_parent (klass);
#line 19 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	g_type_class_add_private (klass, sizeof (SeedPrivate));
#line 19 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	SEED_CLASS (klass)->init_default_sub = seed_real_init_default_sub;
#line 19 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	SEED_CLASS (klass)->init_full_sub = seed_real_init_full_sub;
#line 19 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	SEED_CLASS (klass)->serialize_sub = seed_real_serialize_sub;
#line 19 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	SEED_CLASS (klass)->point_raw = seed_real_point_raw;
#line 19 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	SEED_CLASS (klass)->init_distance_to_parametric = seed_real_init_distance_to_parametric;
#line 19 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	SEED_CLASS (klass)->distant_point = seed_real_distant_point;
#line 19 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	SEED_CLASS (klass)->draw_direct = seed_real_draw_direct;
#line 19 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	SEED_CLASS (klass)->draw_controls = seed_real_draw_controls;
#line 19 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	SEED_CLASS (klass)->pressed_control = seed_real_pressed_control;
#line 19 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	SEED_CLASS (klass)->save_drag_context = seed_real_save_drag_context;
#line 19 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	SEED_CLASS (klass)->move_shape = seed_real_move_shape;
#line 19 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	SEED_CLASS (klass)->drag_control = seed_real_drag_control;
#line 19 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	SEED_CLASS (klass)->points_to_snap = seed_real_points_to_snap;
#line 19 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	SEED_CLASS (klass)->draw_icon = seed_real_draw_icon;
#line 19 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	G_OBJECT_CLASS (klass)->finalize = seed_finalize;
#line 22 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	_tmp0_ = DBL_EPSILON;
#line 22 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	seed_epsilon = _tmp0_;
#line 5539 "seed.c"
}


static void seed_instance_init (Seed * self) {
	Tweak _tmp0_ = {0};
	RGBA _tmp1_ = {0};
#line 19 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	self->priv = SEED_GET_PRIVATE (self);
#line 20 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	self->debug = FALSE;
#line 21 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	self->is_affine = FALSE;
#line 32 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	self->role = ROLE_DUAL;
#line 39 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	self->base_offset = 0.5;
#line 43 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	self->flip_even = FLIP_NONE;
#line 44 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	self->flip_odd = FLIP_Y;
#line 45 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	tweak_init (&_tmp0_);
#line 45 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	self->tweak = _tmp0_;
#line 49 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	self->width0 = 0.2;
#line 53 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	self->width1 = 0.2;
#line 57 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	self->num_segment = 4;
#line 61 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	self->level_of_detail = 10;
#line 65 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	rgba_init (&_tmp1_, 0.0, 0.0, 0.0, 1.0);
#line 65 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	self->color = _tmp1_;
#line 69 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	self->color_mix = 0.5;
#line 70 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	self->render_style = RENDER_STYLE_THIN;
#line 605 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	self->priv->control_radius = (gdouble) 5;
#line 606 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	self->priv->control_magnetic_range = (gdouble) 10;
#line 607 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	self->priv->grid_magnetic_range = (gdouble) 10;
#line 608 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	self->selected_control = -1;
#line 5588 "seed.c"
}


static void seed_finalize (GObject* obj) {
	Seed * self;
#line 19 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SEED, Seed);
#line 83 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	self->priv->distance_to_param = (g_free (self->priv->distance_to_param), NULL);
#line 93 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	self->priv->self_intersect = (g_free (self->priv->self_intersect), NULL);
#line 103 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	self->projection = (_vala_array_free (self->projection, self->projection_length1, (GDestroyNotify) projection_unref), NULL);
#line 19 "/home/jaidi/project/mutiara/mutiara-code/src/seed.vala"
	G_OBJECT_CLASS (seed_parent_class)->finalize (obj);
#line 5604 "seed.c"
}


GType seed_get_type (void) {
	static volatile gsize seed_type_id__volatile = 0;
	if (g_once_init_enter (&seed_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (SeedClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) seed_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Seed), 0, (GInstanceInitFunc) seed_instance_init, NULL };
		GType seed_type_id;
		seed_type_id = g_type_register_static (G_TYPE_OBJECT, "Seed", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&seed_type_id__volatile, seed_type_id);
	}
	return seed_type_id__volatile;
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
#line 101 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	if ((array != NULL) && (destroy_func != NULL)) {
#line 5623 "seed.c"
		int i;
#line 101 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
		for (i = 0; i < array_length; i = i + 1) {
#line 101 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
			if (((gpointer*) array)[i] != NULL) {
#line 101 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
				destroy_func (((gpointer*) array)[i]);
#line 5631 "seed.c"
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
#line 101 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	_vala_array_destroy (array, array_length, destroy_func);
#line 101 "/home/jaidi/project/mutiara/mutiara-code/src/pod.vala"
	g_free (array);
#line 5643 "seed.c"
}



